* -*- mode:Mail -*-
	STITLE  ERABLE KERNEL

* This file contains the parts of ERABLE which are build over ALG48
* integer routines. This file is *not* under GNU licence but under the
* ALG48 SOURCE CODE DISTRIBUTION LICENSE 
* (see the file license.txt)
* (c) 1997, 07/1998
* by (Claude-Nicolas Fiechter and Mika Heiskanen) or Bernard Parisse
* IMPORTANT NOTE: 
* All integers routines (arithmetic operations and conversions)
* are (c) by Claude-Nicolas Fiechter and Mika Heiskanen.
* Polynomial assembly routines were extracted from alg48 v4.0
* and modified for complex number handling
	
**********************************************************************
* Desc:		Object conversions with validity checks.
* Stack:	( ob1 .. obn --> Z1 .. Zn / Error )
**********************************************************************

NULLNAME CK1Z
::
  CK&DISPATCH0
	hxs	H>Z
	real	R2Zext
	str	S>Z
;

NULLNAME CK2Z
::
  CK1Z SWAP CK1Z SWAP
;

NULLNAME CK3Z
::
  CK1Z ROT CK1Z ROT CK1Z ROT
;

**********************************************************************
* Desc:		Sort list according to predicate (a>b)
* Stack:	( L pred --> L' )
**********************************************************************
NULLNAME SortList
::
  OVER LENCOMP TWO #< caseDROP		( Ignore {} and {ob} )
  1LAMBIND				( Bind predicate )

  ( Get 1st object into it's place )
  ONESWAP FIVE NEXTCOMPOB DROP 4UNROLL	( Meta {} #off )

  ( Avoid a WHILE loop this way )
  NEXTCOMPOB DROP			( Meta {} #off ob2 )
  BEGIN
	4PICK				( Meta {} #off ob #maxpos )
	BEGIN
		2DUP #6+ PICK		( Meta {} #off ob #maxpos ob ob' )
		1GETABND DUP4UNROLL EVAL ( Meta {} #off ob #maxpos pred flag )
		SWAP 1LAMBIND		( Meta {} #off ob #maxpos flag )
		ITE
		:: #1- DUP#0= ;
		TRUE
	UNTIL				( Meta {} #off ob #pos )
	#4+ UNROLL ROT#1+UNROT		( Meta' {} #off )
	NEXTCOMPOB
  NOT_UNTIL (UNTIL)
  DROP {}N				( {}' )
  ABND
;

**********************************************************************
* Desc:		Factor signed long integer
* Stack:	( Zs --> Lf )
**********************************************************************
NULLNAME ZFactor
::
  DupZIsNeg? NOTcase NFactor	( Lf )
  { HXS 2 1F }
  SWAP RNEGext
  DupZIsOne? caseDROP		( {-1} for -1 )
  NFactor &COMP			( Lf' )
;

**********************************************************************
* Desc:		Factor positive long integer
* Stack:	( Z --> Lf )
**********************************************************************
NULLNAME NFactor
::
* teste la presence de ALG48 (Attention v4.01! romptr 38D 5D pour ALG48 v4.0)
*' ROMPTR 38D 21 ROMPTR@
*casedrop :: ' :: ROMPTR 38D 21 ROMPTR 38D 5E ; TOTEMPOB EVAL ;
* fin de test presence ALG48
* alg48 n'est pas la, a la place on propose une factorisation stupide
num#0=case ONE{}N
num#1=case ONE{}N
ZEROSWAP 
( metaLf Z )
HXS 2 20
BEGIN
	?ATTNQUIT
	DUPDUP RMULText
	( metaLf Z p p^2 )
	3PICKSWAP ZNLT? NOT
WHILE
	( metaLf Z p )
	2DUP ZDIVext
	( metaLf Z p q r )
	HXS 1 0 
	EQUALcase ::	ROTDROPSWAP
			( metaLf q p )
			ROT#1+ ROT 3PICK
			;
	( metaLf Z p q )
	DROP HXS 2 20 EQUALcasedro HXS 2 30
	HXS 2 20 RADDext
REPEAT
( metaLf Z p )
DROP 
( metaLf Z )
HXS 2 10 EQUALcasedro {}N
SWAP#1+ {}N
;

**********************************************************************
**********************************************************************
* Desc:		Convert # to Z
* Stack:	( # --> Z )
**********************************************************************
NULLNAME ZUNCOERCE
CODE
bin2z		A=0	W		Clear high nibbles for sign
		GOSBVL	=POP#
		GOSBVL	=SAVPTR
		P=	5-1
#>Ztrim		?A#0	P
		GOYES	#>Zpsh
		P=P-1
		GONC	#>Ztrim
#>Zpsh		P=P+1			Include sign nibble (or nib1 for 0)
		GOVLNG	=PUSHhxsLoop
ENDCODE

**********************************************************************
* Desc:		Test if Z is one
* Stack:	( Z --> Z flag )
**********************************************************************
NULLNAME DupZIsOne?
CODE
		A=DAT1	A
zisone??	AD1EX
		C=DAT1	12
		AD1EX
		A=C	W
		LCZ1
Zis?exit	?A=C	W
		GOYES	+
+		GOVLNG	=PushT/FLoop
ENDCODE

NULLNAME ZIsOne?
CODE
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		GONC	zisone??
ENDCODE
**********************************************************************
* Desc:		Test if Z is two
* Stack:	( Z --> Z flag )
**********************************************************************
NULLNAME DupZIsTwo?
CODE
		A=DAT1	A
		AD1EX
		C=DAT1	12
		AD1EX
		A=C	W
		LC(N)	12
		CON(5)	=DOHSTR
		CON(5)	7
		CON(2)	2
		GOTO	Zis?exit
ENDCODE

**********************************************************************
* Desc:		Test if Z is even
* Stack:	( Z --> Z flag )
**********************************************************************
NULLNAME DupZIsEven?
CODE
		A=DAT1	A
		AD1EX
		D1=D1+	10
		C=DAT1	B		low nibbles
		D1=A
		?CBIT=0	0
		GOYES	+
+		GOVLNG	=PushT/FLoop
ENDCODE

**********************************************************************
* Desc:		Test if Z is zero.
* Stack:	( Z --> Z flag )
**********************************************************************
NULLNAME QIsZero?		( Q --> flag )
::
NULLNAME DupQIsZero?
CODE
		C=DAT1	A
		CD1EX
		A=DAT1	11
		CD1EX
		C=A	W
		LCZ0
		GOTO	Zis?exit
ENDCODE
SWAPDROP
;

**********************************************************************
* Desc:		Modular addition.	Z = Q1+Q2 (mod Zn)
* Stack:	( Q1 Q2 Zn --> Z )
**********************************************************************
NULLNAME ModAdd
::
  UNROT RADDext SWAP		( Z' Zn )
  QMODSYMext
;
**********************************************************************
* Desc:		Modular substraction.	Z = Q1-Q2 (mod Zn)
* Stack:	( Q1 Q2 Zn --> Z )
**********************************************************************
NULLNAME ModSub
::
  UNROT RSUBext SWAP		( Z' Zn )
  QMODSYMext
;
**********************************************************************
* Desc:		Modular multiplication. Z = Q1*Q2 (mod Zn)
* Stack:	( Q1 Q2 Zn --> Z )	
**********************************************************************
NULLNAME ModMul
::
  UNROT RMULText SWAP		( Z' Zn )
  QMODSYMext
;
**********************************************************************
* Desc:		Modular division.
* Stack:	( Q1 Q2 Zn --> Q1 div Q2, Q1 mod Q2 mod Zn )
* si Q1 et Q2 sont entiers Q1 mod Q2 est toujours nul!
**********************************************************************
NULLNAME ModDiv
::
UNROT
( Zn, Q1, Q2 )
DUPTYPELIST?
ITE ::	PSEUDOPREP
	( Zn, Q1, Q2, a )
	UNROT DIVext
	;
    ::	SWAP HXS 1 0 ;
( Zn, a, Q1 div Q2, Q1 mod Q2 )
2SWAP OVER 
( Q1 div Q2, Q1 mod Q2, Zn, a, Zn )
ModInv
( Q1 div Q2, Q1 mod Q2, Zn, a^-1 )
DupQIsZero? caseSIZEERR
DUP 5ROLL RMULText
( Q1 mod Q2, Zn, a^-1, a^-1*Q1 div Q2 )
3PICK QMODSYMext
4UNROLLROT RMULText SWAP QMODSYMext
;
**********************************************************************
* Desc:		Modular inversion. Z' = INV(Z) (mod Zn)
* Stack:	( Z Zn --> Z' )
* Notes:	Returns 0 if GCD[Z,Zn] <> 1 or if Z = 0
*		(Otherwise the results would be unpredictable.)
**********************************************************************
NULLNAME ModInv
::
( z, n  )
SWAPOVER IEGCDext
( n, d, u, v / zu+nv=d )
DROPSWAP  ZIsOne?
( n, u, d=1? )
NOTcase2drop HXS 1 0
( --> 0 si le pgcd n'est pas 1 )
( n, u )
OVER QMODSYMext
DupZIsNeg? ITE RADDext SWAPDROP
( u=u+n si necessaire )
;


**********************************************************************
**********************************

********************************************************************
***********************************************************
NULLNAME DENOLCMext
CODE
		ST=1	sALG48
		GOSBVL	=SAVPTR
		GOSUBL	toQSKIP
		GOSBVL	=GETPTR
		?ST=1	sALG48
		GOYES	deno=1
		A=PC
		LC(5)	(denolcm!)-(*)
denobr		A=A+C	A
		PC=(A)
deno=1		A=PC
		LC(5)	(deno1!)-(*)
		A=A+C	A
		GOVLNG	=OverWrALoop
ENDCODE
LABEL denolcm!
::
( liste -> ppcm des denos ) 
INNERCOMP
NULLNAME METADENOLCM
LABEL metadenolcm!
::
DUP#0=csedrp	LABEL deno1!
		HXS 2 10
#1-SWAP FXNDext SWAPDROPSWAP
( o1, ..., on-1, res, #n-1 )
DUP#0=csDROP
ZERO_DO (DO)
	( o1, ..., on-1, res )
	SWAP FXNDext SWAPDROP
	( o1, ..., on-2, res, dn-1 )
	2DUP GCDext RDIVext RMULText
	LOOP
	;
;
*******************
NULLNAME SQFFext
LABEL sqffext!
* p -> { facteurs }, il peut y rester des facteurs 1 ou de degre 0
::
CK&DISPATCH1
hxs ::	HXS 1 0 EQUALcasedro { HXS 1 0 %1 }
	CODE
	GOLONG	todzneg
	ENDCODE
	DUPUNROT IT CODE
	GOLONG	torneg
	ENDCODE
	NFactor  
	( negatif?, liste facteurs )
	INNERCOMP 
	( flag, f1, ..., fk, #k )
	%1 NULL{} ROT
	( flag, f1, ..., fk-1, fa, m1, {}, #k )
	BEGIN
		#1- DUP#0<>
	WHILE
		( flag, f1, ..., fk, fa, mi+1, {}, #k )
		5ROLL 5PICK
		( flag, f1, ..., fk-1, fa, mi+1, {}, #k, fk, fa )
		EQUALcasedro ::	ROT %1+ UNROT
				;
		( flag, f1, ..., fk-1, fa, mi+1, {}, #k, fk )
		5UNROLL SWAP
		( flag, f1, ..., fk-1, newfa, fa, mi+1, #k, { } )
		4ROLL >TCOMP ROT >TCOMP
		( flag, f1, ..., fk-1, newfa, #k, { } )
		%1 SWAPROT
		( flag, f1, ..., fk-1, newfa, %1, { }, #k )
	REPEAT
	DROPROT
	( flag, m, { }, fa )
	>TCOMP SWAP >TCOMP
	SWAP NOT?SEMI
	HXS 2 1F >TCOMP %1 >TCOMP
	;

seco ::
DUPLENCOMP #2= NOTcase :: %1 TWO{}N ;
DUP EVAL ZGCDext DUPUNROT RDIVext
( gcd, z/gcd )
DUPDUP RCONJext RMULText
( gcd, z, z*conj[z] )
SQFFext
( facteurs )
INNERCOMP get1 SWAPDUP #2/
ZERO_DO	(DO)
	( p1, m1, ..., pn, mn, z, #2n )
* on teste si pn mod 4 = 3, dans ce cas pn est premier dans Z[i],
	get1 DUP HXS 2 40 ZMODext
	HXS 2 30 EQUAL
	( m1, ..., pn, mn, z, #2n, p1, p1 mod 4=3? )
	ITE ::	UNROT get1 %2 %/ UNROT ;
	    ::	num#1=case :: UNROT get1 UNROT ;
		NULLNAME SUMSQRext
		::	num#1=case SETSIZEERR
			HXS 2 20 EQUALcasedro
			:: HXS 2 20 ' :: HXS 2 10 HXS 2 10 ; ;
* decomposition de p=1 [4] en a^2+b^2
* etape 1: recherche de sqrt[-1] mod p
			( p -> p, i )
			DUP HXS 2 40 ZDIVext
			HXS 2 10 EQUAL NcaseSIZEERR
			( p, [p-1]/4 )
			MINUSONE TWO
			DO
				2DUP INDEX@ ZUNCOERCE
				( p, [p-1]/4, p, [p-1]/4, a )
				SWAPROT ModPow
				( p, [p-1]/4, a^[p-1]/4 )
				DUPDUP 5PICK ModMul
				( p, [p-1]/4, a^[p-1]/4, a^[p-1]/2 )
				::	HXS 2 10 EQUALcasedro DROP
					HXS 2 1F EQUALcase ExitAtLOOP
					( p n'est pas premier )
					SETSIZEERR
					;
				LOOP
			SWAPDROP
* etape 2: reduction du reseau engendre par (1,i=sqrt(-1)) et (0,p)
			( p, i )
			HXS 2 10 IRXCext
			( p , [1,sqrt[-1]] )
			HXS 1 0 3PICK RIXCext 
			( p, u0, v0 )
			[BEGIN]
* calcul des normes de un et vn et test s'il faut echanger un et vn
				2DUP CNORMext SWAP CNORMext
				( p, un, vn, |vn|, |un| )
				2DUP ZNLT?
				( p, un, vn, |vn|, |un|, ?|vn|<|un| )
				ITE_DROP :: SWAPDROP ROTSWAP ;
				( p, un, vn, |vn| )
* calcule m, si m est nul c'est fini
				UNROT 2DUP
				( p, |vn|, un, vn, un, vn )
				CXRIext ROT CXRIext ROT RMULText UNROT RMULText RADDext
				( p, |vn|, un, vn, un.vn )
				DUP 5PICK QMODSYMext
				( p, |vn|, un, vn, un.vn, un.vn mod |vn| )
				RSUBext 4ROLL ZQUOText DUP
				( p, un, vn, m, m )
				HXS 1 0 EQUAL
			NOT_WHILE
				::	OVER RMULText ROTSWAP RSUBext ;
			[REPEAT]
			DROP
			( p, un, vn )
			SWAPDROP
			INCOMPDROP ZABSext SWAP ZABSext SWAP RIXCext
			;
		( ..., z, #n, p, a+ib )
* teste si p divise z*[a+ib], i.e. a-ib divise z
		::	4PICKOVER RMULText
			( ..., z, #n, p, a+ib, z*[a+ib] )
			DUPTYPEHSTR?
			casedrop TRUE
			CXRIext 4PICK ZMODext SWAP4PICK ZMODext RADDext
			num#0=case DROPTRUE DROPFALSE
			;
		( ..., z, #n, p, a+ib, flag )
		IT RCONJext
		SWAPDROP UNROT get1 UNROT
		;
	LOOP
DUPUNROT #2+UNROLL {}N
( gcd , z, liste2 )
DUPINCOMP #2/ %0 SWAP
ZERO_DO (DO)
	( fact1, num1, ..., factk, numk, sigma )
	UNROTSWAP DUPTYPEHSTR? ITE Z>R SECO2CMPext ' x\->NUM EvalNoCK
	' xLN EvalNoCK 'x* EvalNoCK ' x+ EvalNoCK
	LOOP
( gcd, z, liste, sigmalnliste )
ROT DUPTYPEHSTR? ITE Z>R SECO2CMPext
' x\->NUM EvalNoCK ' xLN EvalNoCK SWAP' x- EvalNoCK
( gcd, liste , ln[z]-sigma_ln[liste] )
C>Im% %PI %/ %2 %* %1 RNDXY 
( gcd, liste , Im[ln[z]-sigma_ln[liste]]/[pi/2] )
::	num0=case DROP
	>HCOMP ' :: HXS 2 10 HXS 1 0 ; >HCOMP
	;
( gcd, liste de facteurs )
INNERCOMP get1
( meta, gcd )
3PICK num1=case :: DROP 4ROLL RMULText UNROT {}N ;
DROP %1 ROT #2+ {}N
;

list ::
	pgcdflag TestUserFlag NOTcase :: %1 TWO{}N ;
  ONESWAP			( #1 P )
  DUP DERext			( #1 P P' )
  OVER CODE
	GOLONG	gcd
	ENDCODE			( #1 P R1 )
  SWAPOVER			( #1 R1 P R1 )
  CODE
	GOLONG	quot
	ENDCODE SWAP		( #1 T1 R1 )
  BEGIN				( S1..Si-1 i Ti Ri )
	3PICK UNCOERCE 4UNROLL
	?ATTNQUIT
	DUPTYPELIST? ?SKIP ONE{}N DUPLENCOMP
	#1<>			( S1..Si-1 %i i Ti Ri flag )
  WHILE
  	ROT#1+UNROT		( S1..Si-1 %i i+1 Ti Ri )
	2DUP CODE
	GOLONG	gcd
	ENDCODE			( S1..Si-1 %i i+1 Ti Ri Ti+1 )
	SWAPOVER CODE
	GOLONG	quot
	ENDCODE			( S1..Si-1 %i i+1 Ti Ti+1 Ri+1 )
	ROT 3PICK		( S1..Si-1 %i i+1 Ti+1 Ri+1 Ti Ti+1 )
	CODE
	GOLONG	quot
	ENDCODE			( S1..Si-1 %i i+1 Ti+1 Ri+1 Si )
	5UNROLL			( S1..Si-1 Si %i i+1 Ti+1 Ri+1 )
  REPEAT			( S1..Se-1 %e-1 %e e Te Re )
	( appel recursif de SQFF )
  CARCOMP CODE
	GOLONG	sqff
	ENDCODE
	( S1..Se-1 e-1 e e Te {} )
	( reajustement des profondeurs et retrait des 1 )
	INNERDUP #1-SWAP #2/
	ZERO_DO (DO)
		( f1 m1 ... fk mk #2k-1 )
		get1
		DUPTYPELIST? IT ONE{}N
		SWAP get1 SWAP
		3PICK HXS 2 10 EQUAL IT :: UNROT2DROP #2- ;
		LOOP
	#1+ {}N
	( fin d'appel recursif )
	( S1..Se-1 %e-1 %e e Te {} )
	2SWAP ROTSWAP
	( S1..Se-1 %e-1 Te %e {} e )
	#2* DUPUNROT #2+UNROLL {}N &COMP	( Le )
  ;
any :: %1 TWO{}N ;
;
********************************************************************
*****************************************************************
NULLNAME RREext ( f -> re[f] )
*:: SHALT
CODE
rre		ST=1	sRE
		C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		LC(5)	=DOHXS
		?A#C	A
		GOYES	rre1
rreexit		GOVLNG	=Loop
rre1		LCCMP
		P=	9
		?A#C	WP
		GOYES	rre2
		P=	0
		C=DAT1	A	C=@stk1
		CD1EX		C=@stk, D1=@stk1
		D1=D1+	10
		A=DAT1	A	A=longueur
		CD1EX		C=@stk1+10, D1=@stk
		C=C+A	A
		DAT1=C	A
		GOTO	rreexit
rre2		P=	0
		LC(5)	=DOEREL
		?A=C	A
		GOYES	rreexit
		LC(5)	=DOREAL
		?A=C	A
		GOYES	rreexit
rre/im		GOSBVL	=SAVPTR
		C=DAT1	A
		D0=C		@ stk1
		R0=C.F	A
		B=C	A
		ST=1	sALG48
		GOSUBL	toQSKIP
		?ST=1	sALG48
		GOYES	rrealg48
		GOSBVL	=GETPTR
		?ST=1	sRE
		GOYES	rreext
		A=PC
		LC(5)	(rimext!)-(*)
rrebranch	A=A+C	A
		PC=(A)
rreext		A=PC
		LC(5)	(rreext!)-(*)
		GOTO	rrebranch
rrealg48	D0=D0+	6	link
		C=D0
		C=C-B	A
		GOSBVL	=GETTEMP	D0=debut, D1=fin
		C=D0
		D1=C		D1=target
		CR0EX.F	A	R0=debut target, C= debut origine
		D0=C		D0=origine
		ST=0	sTRIM
		C=0	A
		R4=C.F	A	complevel hxs 1 0
		B=0	A	complevel
rreloop		A=DAT0	A
		LC(5)	=DOHXS
		?A#C	A
		GOYES	rreloop1
rreloop0	?ST=0	sRE
		GOYES	rreloop0i
rreloop0r	GOSUB	rrewhxs
		GOTO	rretest
rreloop0i	?ST=1	sTRIM
		GOYES	+
		LCZ0
		P=	10
		DAT1=C	WP
		P=	0
		D1=D1+	11
+		GOSUB	rreloop0skip
rretest		?B#0	A
		GOYES	rreloop
		GOLONG	tor0exit
rreloop1	LC(5)	=DOCOL
		?A=C	A
		GOYES	rreloopcol
		GOTO	rreloop2
rreloopcol	D0=D0+	5	D0=@im
		?ST=1	sRE
		GOYES	rreloop1r
rreloop1i	GOSUB	rrewhxs
		GOSUB	rreloop0skip
		D0=D0+	5
		GOTO	rretest
rreloop1r	GOSUB	rreloop0skip	
		GOSUB	rrewhxs
		D0=D0+	5
		GOTO	rretest
rreloop2	DAT1=A	A
		D1=D1+	5
		D0=D0+	5
		LC(5)	=DOLIST
		?A=C	A
		GOYES	rreloopl
		B=B-1	A
		?ST=0	sTRIM
		GOYES	rretest
		D1=D1-	10		efface DOLIST SEMI
		CR4EX.F	A
		C=C-1	A
		R4=C.F	A
		?C#0	A
		GOYES	rretest
		ST=0	sTRIM
		LCZ0
		P=	10
		DAT1=C	WP
		P=	0
		D1=D1+	11
		GOTO	rretest
rreloopl	ST=1	sTRIM
		CR4EX.F	A
		C=C+1	A
		CR4EX.F	A
		B=B+1	A
		GOTO	rretest
* recopie d'un entier de D0 vers D1 ou skip un entier nul en D0 selon sTRIM
rrewhxs		?ST=0	sTRIM
		GOYES	rrewhxs0
		D0=D0+	5
		C=DAT0	A
		D0=D0-	5
		LA(5)	6
		?A=C	A
		GOYES	rreloop0skip
		ST=0	sTRIM
		C=0	A
		R4=C.F	A
rrewhxs0	D0=D0+	5
		C=DAT0	A	longueur hxs
		C=C+CON	A,5	+prologue
		D0=D0-	5	
		GOVLNG	=MOVEDOWN
* skip un entier en D0
rreloop0skip	D0=D0+	5
		C=DAT0	A
		AD0EX
		A=A+C	A
		AD0EX
		RTN
ENDCODE
*;

LABEL rreext!
::
CK&DISPATCH1
ecmp    ::	C%%>%% DROP ;
list	::	INNERDUP #1-SWAP
		ZERO_DO	
			( o1, ..., on, #n-1 )
			get1
		CODE
		GOLONG	rre
		ENDCODE
			SWAPLOOP
		#1+
		CODE
		GOLONG	newtrimmeta
		ENDCODE
		;
seco	::	INCOMPDROP
		( x<<, a, b, c, x>> )
		4ROLL
		CODE
		GOLONG	rre
		ENDCODE
		( x<<, b, c, x>>, a )
		4ROLL
		CODE
		GOLONG	rre
		ENDCODE
		( x<<, c, x>>, a, b )
		HXS 1 0
		EQUALcasedro 4UNROLL3DROP
		2SWAP FIVE ::N
		;
symb :: FXNDext
	HXS 2 10 EQUALcasedro SYMRE
	DUPTYPEHSTR? 
	case :: CODE
		GOTO	swaprre
		ENDCODE
		CODE
swapsimpndxf	GOSUBL	swapml
		GOLONG	simpndxf
		ENDCODE
		;
        2DUP
	CODE
		GOTO	rre
	ENDCODE
	CODE
swaprre		GOSUBL	swapml
		GOTO	rre
	ENDCODE
	CODE
		GOLONG	rmult
	ENDCODE
	UNROT
        (  aa' z z')
        DUP4UNROLL
	CODE
		GOTO	rim
	ENDCODE
	SWAP
	CODE
		GOTO	rim
	ENDCODE 
	CODE
		GOLONG	rmult
	ENDCODE
	CODE
		GOLONG	radd
	ENDCODE
        ( z' aa'+bb')
	LABEL rreimext!
	::
	SWAPDUP
	CODE
		GOTO	rre
	ENDCODE
	DUP
	CODE
		GOLONG	rmult
	ENDCODE
	SWAP
	CODE
		GOTO	rim
	ENDCODE
	DUP
	CODE
		GOLONG	rmult
	ENDCODE
	CODE
		GOLONG	radd
	ENDCODE
	CODE
		GOLONG	simpndxf
	ENDCODE
	;
	( fin de rreimext )
        ;
str	NOP
any	NULLNAME xREext
	:: symcomp ' xRE >TCOMP ;
;
***********************************************************
NULLNAME RIMext ( f -> im[f] )
*:: SHALT
CODE
rim		ST=0	sRE
		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOHXS
		?A=C	A
		GOYES	rimhxs
		LC(5)	=DOREAL
		?A#C	A
		GOYES	rim1
		LA(5)	=%0
rim0		GOVLNG	=OverWrALoop
rim1		LCCMP
		P=	9
		?A#C	WP
		GOYES	rim11
		P=	0
		C=DAT1	A	C=@stk1
		C=C+CON	A,5
		DAT1=C	A
		GOTO	rreexit
rim11		P=	0
		LC(5)	=DOEREL
		?A=C	A
		GOYES	rim2
		GOTO	rre/im
rim2		LA(5)	=%%0
		GOTO	rim0
rimhxs		GOLONG	droppushhxs0
ENDCODE
*;

LABEL rimext!
::
CK&DISPATCH1
ecmp	:: C%%>%% SWAPDROP ;
cmp	C>Im%
list	::	INNERDUP #1-SWAP
		ZERO_DO	
			( o1, ..., on, #n-1 )
			get1
		CODE
		GOLONG	rim
		ENDCODE
			SWAPLOOP
		#1+
		CODE
		GOLONG	newtrimmeta
		ENDCODE
		;
seco	::	INCOMPDROP
		( x<<, a, b, c, x>> )
		4ROLL
		CODE
		GOLONG	rim
		ENDCODE
		( x<<, b, c, x>>, a )
		4ROLL
		CODE
		GOLONG	rim
		ENDCODE
		( x<<, c, x>>, a, b )
		HXS 1 0
		EQUALcasedro 4UNROLL3DROP
		2SWAP FIVE ::N
		;
symb :: FXNDext
	HXS 2 10 EQUALcasedro SYMIM
	DUPTYPEHSTR?
	case	::
		CODE
		GOTO	swaprim
		ENDCODE
		CODE
		GOTO	swapsimpndxf
		ENDCODE
		;
        2DUP
	CODE
		GOLONG	rre
	ENDCODE
	CODE
swaprim		GOSUBL	swapml
		GOLONG	rim
	ENDCODE
	CODE
		GOLONG	rmult
	ENDCODE
	UNROT DUP4UNROLL
	CODE
		GOLONG	rim
	ENDCODE
	SWAP
	CODE
		GOLONG	rre
	ENDCODE
	CODE
		GOLONG	rmult
	ENDCODE
	CODE
		GOLONG	rsub
	ENDCODE
	CODE
rreim		A=PC
		LC(5)	(rreimext!)-(*)
		A=A+C	A
		PC=(A)
	ENDCODE
        ;
str	:: DROP "0" ;
any	NULLNAME xIMext
	:: symcomp ' xIM >TCOMP ;
;
***********************************************************
NULLNAME RABSext
::
NEWTRIMext
CK&DISPATCH1
hxs	CODE
		C=DAT1	A
		CD1EX
		D1=D1+	11
		A=DAT1	P
		CD1EX
		?A=0	P
		GOYES	rabsloop
		GOLONG	rneg
rabsloop	GOVLNG	=Loop
	ENDCODE
* ( attention: non teste )
* symb	::	SHALT { x^ x/ x* }
*		OVER DUPLENCOMP NTHCOMPDROP ' EQ POSCOMP
*		( symb, pos )
*		DUP#0=csedrp :: ' xABS EvalNoCK ;
*		#1=
*		NOTcase ::	( x* et x/ )
*				' xOBJ> EvalNoCK DROP
*				( op1, op2, x* ou x/ )
*				UNROT RABSext SWAP RABSext SWAP
*				ROT EQ: x* ITE RMULText RDIVext
*				;
*		( x^: regarder si puissance paire )
*		xABSext
*		;
real	%ABS
cmp	C%ABS
ereal	%%ABS
ecmp	C%%ABS
any	NULLNAME xABSext
	::	TESTINFINI
		case ::	LENCOMP #2<> case ?ext
			SYMBOL x\9F xNEGNEG ;
			;
		absflag TestUserFlag ?SEMI 
		' xABS TWO SYMBN
		;
;
****************************
NULLNAME QABSext
::
THREE NDUP NDXQext 4UNROLL
( result, a, b, c )
UNROT DupZIsNeg?
( result, c, a, b, b<0? )
3PICK ZIsNeg?
( result, c, a, b, b<0?, a<0? )
2DUP AND case :: 5DROP RNEGext ;
OVER XOR NOTcase 4DROP
( result, c, a, b, b<0? )
4UNROLL DUP RMULText ROT RMULText
( result, b<0?, a, b^2*c )
SWAPDUP RMULText RSUBext ZIsNeg?
( result, b<0?, b^2*c<a^2? )
IT NOT NOT?SEMI RNEGext
;
******************************************************
NULLNAME RCONJext ( f -> conj[f] )
LABEL rconjext!
::
CK&DISPATCH1
hxs	NOP
ereal   NOP
ecmp    C%%CONJ
real	NOP
cmp	C%CONJ
list	CODE
qobjconj	A=PC
	LC(5)	(qobjconjext!)-(*)
	A=A+C	A
	PC=(A)
	ENDCODE
seco :: INNERDUP #2=
	casedrop
	::	
		CODE
		GOSUBL	swapml
		GOLONG	rneg
		ENDCODE
		RIXCext
		;
	#5= NcaseTYPEERR
	DROP 4ROLLDROP
	CODE
unrotconj	GOSUBL	unrotml
		GOLONG	rconj
	ENDCODE
	CODE
		GOTO	unrotconj
	ENDCODE
	UNROT
	CODE
	GOLONG	ndxq
	ENDCODE 
	;
symb :: CODE
	GOLONG	fxnd
	ENDCODE 
	:: DUPTYPESYMB? NOTcase CODE
	GOLONG	qconj
	ENDCODE
		' xCONJ EvalNoCK 
	;
        SWAP :: DUPTYPESYMB? NOTcase 
		LABEL qobjconjext!
		::
		QOBJSECext CODE
		GOLONG	rconj
		ENDCODE
		; 
		' xCONJ EvalNoCK 
		;
        SWAP 
	CODE
	GOLONG	ndxf
	ENDCODE
        ;
str	NOP
any 
NULLNAME xCONJext
:: symcomp ' xCONJ >TCOMP ;
;
**************************************
NULLNAME VXXLext ( algebrique ID -> polynome-liste par rapport a ID )
* si le polynome-liste depend encore de ID, le flag 11 est mis a 0
* ATTENTION, prevoir l'equivalent de #1+ NDUP SYMBN 5GETLAM EVAL
LABEL vxxlext!
( algebrique ID -> polynome-liste par rapport a ID )
* si le polynome-liste depend encore de ID, le flag 11 est mis a 0
::
( objet, idnt/symb/lvar -> lvar, liste )
vxxlflag SetUserFlag
internalflag SetUserFlag
DUPTYPELIST? ?SKIP ONE{}N
( o, lvar )
DUPUNROT
( lvar, objet, lvar )
1LAMBIND

CODE
vxxl1	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	LC(5)	=DOREAL
	?A#C	A
	GOYES	vxxl1!1
	A=PC
	LC(5)	(vxxlreal!)-(*)
vxxl1!0	A=A+C	A
	PC=(A)
vxxl1!1	LC(5)	=DOLIST
	?A#C	A
	GOYES	vxxl1!2
	A=PC
	LC(5)	(vxxllist!)-(*)
	GOTO	vxxl1!0
vxxl1!2	LC(5)	=DOHSTR
	?A#C	A
	GOYES	vxxl1!3
	GOLONG	ztrim
vxxl1!3	LC(5)	=DOCMP
	?A#C	A
	GOYES	vxxl1!4
	A=PC
	LC(5)	(vxxlcmp!)-(*)
	GOTO	vxxl1!0
vxxl1!4	LC(5)	=DOSYMB
	?A#C	A
	GOYES	vxxl1!5
	A=PC
	LC(5)	(vxxlsymb!)-(*)
	GOTO	vxxl1!0
vxxl1!5	LC(5)	=DOCOL
	?A#C	A
	GOYES	vxxl1!6
vxxl20	A=PC
	LC(5)	(vxxl20!)-(*)
	GOTO	vxxl1!0
vxxl1!6	LC(5)	=DOCSTR
	?A#C	A
	GOYES	vxxl1!7
	GOTO	s2z
vxxl1!7	LC(5)	=DOIDNT
	?A#C	A
	GOYES	vxxl1!8
vxxl1!9	A=PC
	LC(5)	(vxxlsym!)-(*)
	GOTO	vxxl1!0
vxxl1!8	LC(5)	=DOLAM
	?A=C	A
	GOYES	vxxl1!9
	LC(5)	=DOTAG
	?A=C	A
	GOYES	vxxl1!t
vxxl1lp	GOVLNG	=Loop
vxxl1!t	A=PC
	LC(5)	(vxxltag!)-(*)
	GOTO	vxxl1!0
ENDCODE
ABND
;

LABEL vxxltag!
::
STRIPTAGS
CODE
tovxxl1		GOTO	vxxl1
ENDCODE
;

NULLNAME VXXL1ext
CODE
		GOSUBL	toa=stk1
		LC(5)	=DOREAL
		?A=C	A
		GOYES	tovxxl1
		LC(5)	=DOCMP
		?A=C	A
		GOYES	tovxxl1
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	tovxxl1
		LC(5)	=DOCSTR
		?A=C	A
		GOYES	tovxxl1
		LC(5)	=DOBINT
		?A#C	A
		GOYES	tovxxl1lp
		GOLONG	bin2z
tovxxl1lp	GOTO	vxxl1lp
ENDCODE
	


**********************************************************************
* Desc:		Convert decimal in a string into Z
* Stack:	( String --> Z )
**********************************************************************
NULLNAME S2Zext
NULLNAME S>Z

* Conversion using Horner method

CODE
sPOS	EQU 0		Flag to indicate positive integer
s2z		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		D0=D0+	5
		C=DAT0	A		$len
		C=C-CON	A,5		$nibbles
		?CBIT=1	0
		GOYES	toherr		Error if not even nibbles
		?C=0	A
		GOYES	toherr		Error if empty $
		CSRB.F	A
		R1=C	A		chars
		CSR	A
		C=C+1	A
		R2=C	A		words
		CSL	A
		C=C+1	A		Enough room for certain
		RSTK=C
		GOSBVL	=MAKE$N
		CD0EX
		D1=C
		C=RSTK
		GOSBVL	=WIPEOUT

		GOSBVL	=D1=DSKTOP
		A=DAT1	A
		D0=A
		D0=D0+	10		->1st char

		ST=1	sPOS		Assume +
		A=DAT0	B
		LCASC	'-'
		?A#C	B
		GOYES	tohexpos?
		ST=0	sPOS
		GONC	skpsgn
tohexpos?	LCASC	'+'		Allow "+" too
		?A#C	B
		GOYES	tohloop
skpsgn		D0=D0+	2
		C=R1
		C=C-1	A		chars-- due to sign
		R1=C
		?C#0	A
		GOYES	tohloop		Error if only sign
toherr		LC(5)	=SYNTAXERR
		GOVLNG	=GETPTREVALC

* Loop:
*	Add digit to result
*	If more digits expected result *= 10
*	Loop until no more digits

tohloop		A=0	W
		A=DAT0	B		digit
		D0=D0+	2

		LCASC	'0'		Convert to hex with error checks
		A=A-C	B
		GOC	toherr
		LC(2)	9
		?A>C	B
		GOYES	toherr

		C=R0
		D1=C
		D1=D1+	10		->output

		C=DAT1	W		Add to result - loop WILL terminate
		C=C+A	W
		DAT1=C	W
		GONC	tohex+ok
tohex+loop	D1=D1+	16
		C=DAT1	W
		C=C+1	W
		DAT1=C	W
		GOC	tohex+loop
tohex+ok
		C=R1	A		chars to go--
		C=C-1	A
		R1=C	A
		?C=0	A
		GOYES	tohfinish
* Result *= 10
* Note how 15 is used to simplify carry, this is safe since
* hex integer will be shorten more than that, always
		C=R0
		D1=C
		D1=D1+	10		->output
		C=R2	A
		D=C	A		words
		D=D-1	A
		B=0	W		init carry
tohex*loop	C=0	W
		C=DAT1	15
		C=C+C	W
		A=C	W		2*
		C=C+C	W
		C=C+C	W		8*
		C=C+A	W		10*
		C=C+B	W
		DAT1=C	15
		CSLC			Now get new carry from C[S]
		B=C	P
		D1=D1+	15
		D=D-1	A
		GONC	tohex*loop
		GOTO	tohloop

* Finish up:
*	Strip result, handle zero & sign
*	Shrink & exit

tohfinish	C=R0
		D0=C			->$
		LC(5)	=DOHSTR		Convert to Z
		DAT0=C	A
		GOSBVL	=SKIPOB
tohextrimlp	D0=D0-	1		Stripping loop
		C=DAT0	B
		?C=0	P
		GOYES	tohextrimlp
		D0=D0+	1
		CD0EX			C[A] = ->result tail
		D0=C
		A=R0
		C=C-A	A		result size (w/ prologs)
		C=C-CON	A,10		result size
		GONC	tohexput	No overflow - not zero result
		D0=A
		D0=D0+	11		Just use one nibble of the 0s
		GONC	tohexexit
tohexput	C=0	S		Set sign
		?ST=1	sPOS
		GOYES	tohexsgnput
		C=-C-1	S
tohexsgnput	DAT0=C	S
		D0=D0+	1
tohexexit	GOSBVL	=Shrink$
		GOVLNG	=GPOverWrR0Lp
ENDCODE
*****************


LABEL vxxlreal!
::
real_intflag TestUserFlag NOTcase %>%%
NULLNAME R2Zext
::
NULLNAME R>Z
CODE
r2z		GOSBVL	=POP1%SPLITA
		GOSBVL	=STAB0
		?B#0	W
		GOYES	R2Z<>0
		A=0	A
		GONC	R2Zexit		Exit with P=0
R2Z<>0		R0=A	S		Save sign
		GOSBVL	=CLRFRC
		GONC	R2Zerr		Nonzero fractional part
		?P=	15
		GOYES	R2Zerr		Infinite number
		?P=	1
		GOYES	R2Zerr		One digit is lost
R2Zshiftlp	BSR	W		Shift mantissa down to word start
		P=P-1
		GONC	R2Zshiftlp
		C=B	W
*		P=	0
		GOSBVL	=DCHXW		Convert to hex
* Common small Z push exit
		P=	15		(This could be smaller)
R2Ztrimlp	P=P-1			Strip loop
		?A=0	P
		GOYES	R2Ztrimlp
		P=P+1			Sign nibble
		C=R0	S		Saved sign
		?C=0	S
		GOYES	R2Zexit
		A=-A-1	P		Negative
R2Zexit		SETHEX
		GOVLNG	=PUSHhxsLoop
R2Zerr		P=	0
		GOSBVL	=RCAB0		
		GOVLNG	=PUSH%%LOOP
ENDCODE
DUPTYPEHSTR? ?SEMI
real_intflag ClrUserFlag
;
;

LABEL vxxlcmp!
::
complexflag SetUserFlag
real_intflag TestUserFlag NOTcase C%>C%%
DUP C%>% 
CODE
	GOTO	r2z
ENDCODE
DUPTYPEHSTR? NOTcase2drop 
NULLNAME C%>C%%
	::	real_intflag ClrUserFlag
		C%>%% 
		CODE
		GOLONG	L%%>C%%
		ENDCODE
		;
SWAP CODE
	GOTO	r2z
	ENDCODE
DUPTYPEHSTR? NOTcase2drop C%>C%%
CODE
	GOLONG	irxc!1
ENDCODE
SWAPDROP
;

LABEL vxxllist!
::
DUPNULL{}? ?SEMI
INNERCOMP
( o1, ..., on, #n )
DUP#0_DO
	( o1, ..., on, #n )
	DUP #1+ROLL CODE
	GOLONG	vxxl1
	ENDCODE
	SWAPLOOP
{}N
;


LABEL vxxlsymb!
::
CODE
	GOTO	vxxl5
ENDCODE
?SEMI
simpvxxlflag
UserITE
	INNERCOMP
	::	pgcdflag TestUserFlag
		pgcdflag ClrUserFlag
		SWAPINCOMP
		;
	
CODE
vxxl2st	EQU	9
	ST=1	vxxl2st
	GOTO	vxxl2!0
vxxl2	ST=0	vxxl2st
vxxl2!0	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A
	CD1EX
	LC(5)	1
	?A#C	A
	GOYES	vxxl2!1
	D1=D1+	5
	D=D+1	A
	GOTO	vxxl1
vxxl2!1	?ST=0	vxxl2st
	GOYES	vxxl2!2
	D1=D1+	5
	GOTO	vxxl2b1
vxxl2!2	A=PC
	LC(5)	(vxxl2!)-(*)
vxxla	A=A+C	A
	PC=(A)
ENDCODE
simpvxxlflag TestUserFlag
?SEMI
( flag, objet )
SWAP NOT?SEMI
pgcdflag SetUserFlag
CODE
	GOLONG	fxnd
ENDCODE
CODE
	GOLONG	simpndxf
ENDCODE
;

LABEL vxxlsym!
::
CODE
	GOTO	vxxl5
ENDCODE
?SEMI
CODE
vxxl4	A=PC
	LC(5)	(vxxl4!)-(*)
	GOTO	vxxla
ENDCODE
;

LABEL vxxl20!
::	( LAM20 )
	DUP CARCOMP
	DUPTYPEHSTR? caseDROP
	EQ: x<<
	case :: INNERCOMP #5= NcaseTYPEERR
		4UNROLL THREE
		ZERO_DO (DO) 1GETLAM EVAL UNROT LOOP
		4ROLL FIVE ::N
		;
* EVAL ou EvalNoCK ?
	EvalNoCK
	CODE
	GOLONG	vxxl5
	ENDCODE
	?SEMI
	SYMBOL xi ; 
	EQUALcasedro ::	complexflag SetUserFlag
			real_intflag TestUserFlag
			NOTcase C%% 0 1
			HXS 2 10 HXS 1 0
	CODE
	GOLONG irxc!1
	ENDCODE
				;
	;

LABEL vxxl9!
::	( LAM9 x\v/ )
	sqrtflag TestUserFlag NOTcase
	::	XSQRext
		DUPTYPESYMB? NOT?SEMI
		DUPDUP LENCOMP NTHCOMPDROP
		EQ: xABS NOT?SEMI
		ZEROSWAP 1GETLAM VAL2ext
		vxxlflag ClrUserFlag
		CODE
		GOTO	vxxl4
		ENDCODE
		;
	HXS 1 0 HXS 2 10 ROT NDXQext
	;

*LABEL vxxl8!
*::	( LAM8 x= )
*	CODE
*	GOLONG	rsub
*	ENDCODE
*	ZEROSWAP 1GETLAM VAL2ext
*	%0 ' x= EvalNoCK
*	vxxlflag ClrUserFlag 
*	CODE
*	GOLONG	vxxl4
*	ENDCODE
*	;

LABEL vxxl7!
::	( LAM7 xINV ) 
	CODE
	GOLONG	fxnd
	ENDCODE
	SWAP 
	CODE
	GOLONG	rdiv
	ENDCODE 
	;

LABEL vxxl5!
::	( LAM5 objet -> objet, false ou liste, true )
	1GETLAM OVER EQUALPOSCOMP
	DUP#0=csedrp FALSE
	SWAPDROP
	( #pos )
	{ HXS 2 10 HXS 1 0 } SWAP
	DUP#1= casedrop TRUE
	ONE_DO (DO) ONE{}N LOOP TRUE
	;

LABEL vxxl4!
::	( LAM4 : objet -> objet dans des listes )
	1GETLAM LENCOMP
	DUP#0=csDROP
	ZERO_DO (DO) ONE{}N LOOP
	;

LABEL vxxl3!
::	
( LAM3 o1,..., on-1, x^, #n -> liste ou objet )
3PICK DUPTYPEREAL?
NOTcasedrop	CODE
vxxl3nr		A=PC
		LC(5)	(vxxl3nr!)-(*)
vxxlbranch	A=A+C	A
		PC=(A)
		ENDCODE
DUPDUP %FLOOR %=
( o1, ..., on-1, x^, #n, on-1, ?on-1=bint )
NOTcasedrop	CODE
		GOTO	vxxl3nr
		ENDCODE
( o1, ..., on-1, x^, #n, on-1 )
%0< OVER#2+UNROL SWAPDROPSWAP %ABSCOERCE
( ?negatif, o1, ..., on-2, #n, #exposant )
OVER UNROLL
( ?negatif, #exposant, o1, ..., on-2, #n )
#2-
( stk=?negatif, #exposant, meta )
DUP#1+ NDUP DUP#1= ITE_DROP SYMBN
( stk= ?negatif, #exposant, meta, symb )
1GETLAM NTHOF
( ?negatif, #exposant, o1, ..., on-2, #n-2, #pos )
CODE
		A=DAT1	A
		LC(5)	=ZERO
		?A#C	A
		GOYES	vxxl3idnt
		D=D+1	A
		D1=D1+	5
		A=PC
		LC(5)	(vxxl3nidnt!)-(*)
		GOTO	vxxlbranch
vxxl3idnt	A=PC
		LC(5)	(vxxl3idnt!)-(*)
		GOTO	vxxlbranch
ENDCODE
( ?negatif, objet )
SWAP NOT?SEMI
CODE
		GOLONG	fxnd
ENDCODE
CODE
		GOSUBL	swapml
		GOLONG	rdiv
ENDCODE
;

LABEL vxxl3nr!
::
( o1, ..., on-1, on=x^, #n )
SYMBN vxxlflag ClrUserFlag 
CODE
	GOLONG	vxxl4
ENDCODE 
;

LABEL vxxl3nidnt!
::
( ?negatif, #exposant, o1, ..., on-2, #n-2 )
CODE
		GOLONG	vxxl2
ENDCODE 
CODE
		GOSUBL	swapml
		GOLONG	rp 
ENDCODE	
;

LABEL vxxl3idnt!
::	
( ?negatif, #exp, meta, #pos )
OVER#2+UNROL NDROP
( ?negatif, #exp, #pos )
real_intflag
UserITE ::	HXS 2 10 HXS 1 0  ;
	::	%%1 %%0 ;
4ROLL NDUPN #1+ {}N
( #pos, {} )
SWAPDUP #1= caseDROP
ONE_DO (DO) ONE{}N LOOP
;


LABEL vxxl2!
( meta -> liste ou objet )
::	( teste si le meta compose en un symb est dans la liste )
	DUP#1+ NDUP SYMBN 
	CODE
vxxl5	A=PC
	LC(5)	(vxxl5!)-(*)
	GOTO	vxxlb
	ENDCODE
	case :: OVER#2+UNROL NDROP ;             
	CODE
	D=D+1	A	( detruit le symbolique au niveau 1 )
vxxl2b	D1=D1+	10	( teste l'oprateur x^  au niveau 2 )
vxxl2b1	A=DAT1	A
	D1=D1-	5
	LC(5)	=x^
	?A#C	A
	GOYES	vxxl2c
vxxl3	A=PC
	LC(5)	(vxxl3!)-(*)
vxxlb	A=A+C	A
	PC=(A)
vxxl2c	LC(5)	=x+
	?A#C	A
	GOYES	vxxld
vxxlc	A=PC
	LC(5)	(vxxl21!)-(*)
	GOTO	vxxlb
vxxld	LC(5)	=x*
	?A=C	A
	GOYES	vxxlc
	LC(5)	=x-
	?A=C	A
	GOYES	vxxlc
	LC(5)	=x/
	?A=C	A
	GOYES	vxxlc
	LC(5)	=x=
	?A=C	A
	GOYES	vxxlc
	LC(5)	=x\v/
	?A#C	A
	GOYES	vxxlf
vxxle	A=PC
	LC(5)	(vxxl22!)-(*)
	GOTO	vxxlb
vxxlf	LC(5)	=xNEG
	?A=C	A
	GOYES	vxxle
	LC(5)	=xSQ
	?A=C	A
	GOYES	vxxle
	LC(5)	=xINV
	?A=C	A
	GOYES	vxxle
	A=PC
	LC(5)	(vxxl23!)-(*)
	GOTO	vxxlb
	ENDCODE
;

LABEL vxxl21!
::	( LAM21 )
	( o1, ..., on, #n )
	#1-SWAP OVER#2+UNROL
	( oper, o1, ..., on-1, #n-1 )
*	pshzerpsharg
	larg
	( oper, meta1, meta2 )
	CODE
	GOLONG	vxxl2
	ENDCODE
	( oper, meta1, liste2 )
	OVER#2+UNROL 
	CODE
	GOLONG	vxxl2
	ENDCODE
	( oper, list2, list1 )
*	ROT
	SWAPROT
	CODE
	A=DAT1	A
	D1=D1+	5
	D=D+1	A
	LC(5)	=x+
	?A#C	A
	GOYES	vxxlm
	GOLONG	radd
vxxlm	LC(5)	=x*
	?A#C	A
	GOYES	vxxln
	GOLONG	rmult
vxxln	LC(5)	=x-
	?A#C	A
	GOYES	vxxlo
vxxlp	GOLONG	rsub
vxxlo	LC(5)	=x/
	?A#C	A
	GOYES	vxxlp
	GOLONG	rdiv
*vxxlp	A=PC
*	LC(5)	(vxxl8!)-(*)
*	GOTO	vxxlb
	ENDCODE
	;

LABEL vxxl23!     
::	( o1, ..., on, #n )
	complexflag TestUserFlag 
	case	CODE
		GOTO	vxxl24
		ENDCODE
	CODE
	D1=D1+	5
	A=DAT1	A
	D1=D1-	5
	LC(5)	=xRE
	?A=C	A
	GOYES	tovxxle
	LC(5)	=xIM
	?A=C	A
	GOYES	tovxxle
	LC(5)	=xCONJ
	?A=C	A
	GOYES	tovxxle
vxxl24	A=PC
	LC(5)	(vxxl24!)-(*)
	GOTO	vxxlb
tovxxle	GOLONG	vxxle
	ENDCODE
        ;
LABEL vxxl22!
::	( o1, ..., on, #n )
	#1-SWAP OVER#2+UNROL
	( oper, meta2 )
	CODE
	GOLONG	vxxl2
	ENDCODE
	( oper unaire, liste1 )
	SWAP
	CODE
	A=DAT1	A
	D1=D1+	5
	D=D+1	A
	LC(5)	=x\v/
	?A#C	A
	GOYES	vxxlq0
	A=PC
	LC(5)	(vxxl9!)-(*)	
	GOTO	vxxls
vxxlq0	LC(5)	=xNEG
	?A#C	A
	GOYES	vxxlq
	GOLONG	rneg
vxxlq	LC(5)	=xSQ
	?A#C	A
	GOYES	vxxlr
	A=DAT1	A
	D1=D1-	5
	D=D-1	A
	DAT1=A	A
	GOLONG	rmult	
vxxlr	LC(5)	=xINV
	?A#C	A
	GOYES	vxxlt
	A=PC
	LC(5)	(vxxl7!)-(*)
vxxls	A=A+C	A
	PC=(A)
vxxlt	LC(5)	=xRE
	?A#C	A
	GOYES	vxxlu
	GOLONG	rre
vxxlu	LC(5)	=xIM
	?A#C	A
	GOYES	vxxlv
	GOLONG	rim
vxxlv	GOLONG	rconj
	ENDCODE
	;
LABEL vxxl24!
::	( o1, ..., on, #n )
	( operateur non reconnu )
	SYMBN
	( symb )
	( teste si symb est dans la liste LAM22 )
	CODE
	GOLONG	vxxl5
	ENDCODE
	( symb, false ou liste, true )
	?SEMI
	vxxlflag ClrUserFlag
	CODE
	GOLONG	vxxl4
	ENDCODE
	;
***************************************************************
LABEL simpcmp!
::
* 1ere etape: si o1 est un irrquad ou un complexe -> * conjugue
DUP
CODE
	GOLONG	rconj
ENDCODE
DUPUNROT
CODE
	GOLONG	rmult
ENDCODE
( z1, conj[z2], |z2|^2 )
UNROT
CODE
	GOLONG	rmult
ENDCODE
SWAP
CODE
	GOLONG	simp!1
ENDCODE
;

LABEL simpirrq!
::
CODE
	GOLONG	qconj
ENDCODE
DUP
CODE
	GOLONG	qnorm
ENDCODE
UNROT
CODE
	GOLONG	rmult
ENDCODE
SWAP
CODE
	GOLONG	simp!1
ENDCODE
;

LABEL simpext!
::
CODE
	GOSUBL	swapml
	GOLONG	newtrim
ENDCODE
CODE
	GOSUBL	swapml
	GOLONG	newtrim
ENDCODE
pgcdflag TestUserFlag
case	CODE
	A=PC
	LC(5)	(simpextok!)-(*)
	A=A+C	A
	PC=(A)
	ENDCODE
;

LABEL simpextok!
::
* 3eme etape: simplification
::
CK&DISPATCH1
# BB :: 2DUP CODE
	GOLONG	zgcd
	ENDCODE ROTOVER CODE
	GOLONG	zquot
	ENDCODE
	UNROT CODE
	GOLONG	zquot
	ENDCODE
	;
# 8B :: OVER CARCOMP TYPEHSTR? NOTcase
	CODE
	GOLONG	simplist
	ENDCODE
	2DUPSWAP
	( c1, z2, z2, c1 )
	EVAL
	CODE
	GOLONG	zgcd
	ENDCODE
	CODE
	GOLONG	zgcd
	ENDCODE
	( c1, z2, z )
	ROT CXRIext 
	( z2, z, r1, i1 )
	3PICK CODE
	GOLONG	zquot
	ENDCODE
	( z2, z, r1, i1/z )
	SWAP3PICK CODE
	GOLONG	zquot
	ENDCODE
	CODE
	GOLONG	irxc
	ENDCODE
	( z2, z, r1/z+i*i1/z )
	UNROT CODE
	GOLONG	zquot
	ENDCODE
	;
2LIST	::	GCDHEUext 
		( a b pgcd A/G' B/G' flag )
		4ROLLDROP
		?SKIP
		CODE
		GOTO	simplist
		ENDCODE
		( a b A/G' B/G' )
		2SWAP
		CODE
		GOLONG	simp
		ENDCODE
		ROT
		CODE
		GOLONG	rmult
		ENDCODE
		UNROT
		CODE
		GOLONG	rmult
		ENDCODE
		SWAP
		CODE
		GOLONG	newtrim
		ENDCODE
		;
any		CODE
simplist	A=PC
		LC(5)	(simplistext!)-(*)
		A=A+C	A
		PC=(A)
		ENDCODE
;

* 3eme etape: o1 est-il negatif?
CODE
	GOLONG	positif
ENDCODE 
( o1, o2, o2<0? )
?SKIP	::	CODE
		GOLONG	rneg
		ENDCODE
		SWAP
		CODE
		GOLONG	rneg
		ENDCODE
		SWAP
		;

* 4eme etape: si o1 est complexe, on multiplie par son conjugue
DUPTYPECOL? NOT?SEMI
DUP CARCOMP TYPEHSTR?
NOT?SEMI
DUP CODE
	GOLONG	rconj
ENDCODE DUPUNROT CODE
	GOLONG	rmult
ENDCODE
( z1, conj[z2], |z2|^2 )
UNROT CODE
	GOLONG	rmult
ENDCODE
SWAP
;


LABEL simplistext!
::	2DUP
	CODE
	GOLONG	gcd
	ENDCODE
	( o1, o2, gcd )
	HXS 2 10 EQUALcasedro NOP
	ROTOVER
	CODE
	GOLONG	quot
	ENDCODE
	CODE
	GOLONG	newtrim
	ENDCODE
	UNROT
	CODE
	GOLONG	quot
	ENDCODE
	CODE
	GOLONG	newtrim
	ENDCODE
	;
**************************************************************************
NULLNAME LPGCDext ( liste -> liste, pgcd de la liste )
LABEL lpgcdext! ( LAM1: liste -> liste, lpgcd )
::
NOTLISTcase DUP
pgcdflag TestUserFlag NOTcase HXS 2 10
DUPINCOMP
DUP#0=csedrp HXS 2 10
::	DUP#1= caseDROP
	ONE_DO (DO)
		CODE
		C=DAT1	A
		CD1EX
		A=DAT1	12
		CD1EX
		C=A	W
		LCZ1
		?A=C	W
		GOYES	lpgcdis1
lpgcd2		A=PC
		LC(5)	(gcdext!)-(*)
gcdbr		A=A+C	A
		PC=(A)
lpgcdis1	A=PC
		LC(5)	(lpgcdexit!)-(*)
		GOTO	gcdbr
lpgcd		A=PC
		LC(5)	(lpgcdext!)-(*)
		GOTO	gcdbr
		ENDCODE
		LOOP
	;
HXS 1 0 EQUALcasedro HXS 2 10
;

LABEL lpgcdexit!
( o1, ..., ok -> 1 )
::
ISTOP-INDEX #1+NDROP ExitAtLOOP HXS 2 10
;
***************************************
NULLNAME GCDext
LABEL gcdext! ( LAM2: GCDext obj1, obj2 -> pgcd )
::	
CODE
swapnewtrim	GOSUBL	swapml
		GOLONG	newtrim
ENDCODE
CODE
		GOTO	swapnewtrim
ENDCODE
CK&DISPATCH1
	# BB	CODE
		GOLONG	zgcd
		ENDCODE

	2LIST	CODE
lpgcd3		A=PC
		LC(5)	(lpgcd3!)-(*)
lpgcdb		A=A+C	A
		PC=(A)
		ENDCODE

	EIGHTY	CODE
lpgcd8		A=PC
		LC(5)	(lpgcd8!)-(*)
		GOTO	lpgcdb
		ENDCODE

	list	CODE
		GOSUBL	swapml
		GOTO	lpgcd8
		ENDCODE

	# 88	CODE
lpgcd9		A=PC
		LC(5)	(lpgcd9!)-(*)
		GOTO	lpgcdb
		ENDCODE

	seco	CODE
lpgcd5		A=PC
		LC(5)	(lpgcd5!)-(*)
		GOTO	lpgcdb
		ENDCODE

	BINT80h	CODE
		GOSUBL	swapml
		GOTO	lpgcd5
		ENDCODE
	any	::	2DROP HXS 2 10
			;
	;
LABEL lpgcd3! ( LAM3: list1, list2 -> pgcd )
::	( l1, l2 )
	GCDHEUext
	( a, b, c, l1/c, l2/c, FALSE | a, b, pgcd, l1/pgcd, l2/pgcd, TRUE ] )
	5ROLLDROP 5ROLLDROP
*	DROPFALSE	( test du pgcd normal seulement )
	case2drop
	::
		CODE
		GOLONG	newtrim
		ENDCODE
		{ "GCDHeu success" DISPROW2 }
		User1IT
		;
	{ "GCDHeu failure" DISPROW2 }
	User1IT
	DUPLENCOMP
	( c, l1, l2, #l2 )
	3PICK LENCOMP
	( c, l1, l2, #l2, #l1 )
	2DUP #MIN 5UNROLL
	( c, #min, l1, l2, #l2, #l1 )
	#>ITE SWAPROT ROT
	( c, l1, l2 avec l1 plus long que l2, #min )
	#1=case
	::	&COMP
		CODE
		GOLONG	lpgcd
		ENDCODE
		SWAPDROP
		ONE{}Next
		CODE
		GOLONG	rmult
		ENDCODE
		;
	( c, l1, l2 )
	CODE
	GOLONG	lpgcd
	ENDCODE
	DUP4UNROLL 
	CODE
	GOLONG	lopd
	ENDCODE
	( c, pgcd[l2] / autres var, l1, l2' )
	SWAP
	CODE
	GOLONG	lpgcd
	ENDCODE
	( c, pgcd[l2] / autres var, l2', l1, pgcd[l1] )
	DUP4UNROLL
	CODE
	GOLONG	lopd
	ENDCODE
	( c, pgcd[l2], pgcd[l1], l2', l1' )
	2SWAP
	CODE
	GOLONG	lpgcd2
	ENDCODE
	4ROLL CODE
	GOLONG	rmult
	ENDCODE
	ONE{}N UNROTSWAP
	( pgcd[l1,l2] par rapport aux autres var, l1', l2' )
	HXS 2 10 DUP 2SWAP
	BEGIN
		( lpgcd, g, h, l1, l2 )
		DUPLENCOMP #1<>
	WHILE
		( multiplication du numerateur par un inversible )
		DUPDUP CARCOMP SWAP LENCOMP
		( lpgcd, g, h, l1, l2, a2.1, #l2 )
		4PICK LENCOMP SWAP#-
		( lpgcd, g, h, l1, l2, a2.1, #l1-#l2 )
		DUPUNROT #1+
		CODE
		GOLONG	rp
		ENDCODE
		( lpgcd, g, h, l1, l2, #l1-l2, a2.1^ )
		4ROLL
		CODE
		GOLONG	lopm
		ENDCODE
		( lpgcd, g, h, l2, #l1-l2, l1' )
		( division de l1' par l2 )
		{ HXS 1 0 } SWAP4PICK
		CODE
		GOLONG	div2list
		ENDCODE
		( lpgcd, g, h, l2, #l1-l2, l1 div l2, l1 mod l2 )
		SWAPDROP
		( lpgcd, g, h, l2, #l1-l2, l1 mod l2 )
		DUPTYPELIST? ?SKIP ONE{}N
		DUPLENCOMP #1=case SWAPDROP
		( lpgcd, g, h, l2, #l1-l2, l1 mod l2 )
		5ROLL 5PICK
		( lpgcd, h, l2, #l1-l2, l1 mod l2, g, h )
		4PICK 
		CODE
		GOLONG	rp
		ENDCODE
		( lpgcd, h, l2, #l1-l2, l1 mod l2, g, h^# )
		DUP4UNROLL
		CODE
		GOLONG	rmult
		ENDCODE
		CODE
		GOLONG	divobj
		ENDCODE
		( lpgcd, h, l2, #l1-l2, h^#, l1 mod l2/[g*h^#] )
		UNROT 4PICK CARCOMP
		( lpgcd, h, l2, l1 mod l2/[g*h^#], #l1-l2, h^#, g )
		DUP 7UNROLL ROT
		CODE
		GOLONG	rp
		ENDCODE
		( lpgcd, g, h, l2, l1 mod l2/[g*h^#], h^#, g^# )
		5ROLL
		CODE
		GOLONG	rmult
		ENDCODE
		SWAP
		CODE
		GOLONG	quot
		ENDCODE
		( lpgcd, g, l2, l1 mod l2/[g*h^#], h^1-# * g^# )
		UNROT
		( lpgcd, g, h', l1'=l2, l2'=l1 mod l2 )
	REPEAT
	( lpgcd,  g', h', l1, l2 avec degre=0 )
	2SWAP 2DROP
	( lpgcd,  l1, l2 avec degre=0 )
	CARCOMP
	HXS 1 0 EQUAL
	::	NOTcasedrop HXS 2 10
		CODE
		GOLONG	lpgcd
		ENDCODE 
		CODE
		GOLONG	lopd
		ENDCODE
		;
	CODE
	GOLONG	rmult
	ENDCODE
	;
LABEL lpgcd5! ( LAM5: obj, seco -> pgcd )
::	INNERCOMP #2=
	ITE :: 	SWAPROT DUPTYPEHSTR? NOT?SEMI
		RDROP UNROT RIXCext
		CGCDext
		;
	     :: 2DROP ROTDROP
		;
	CODE
	GOLONG	lpgcd2
	ENDCODE CODE
	GOLONG	lpgcd2
	ENDCODE
	;

LABEL lpgcd8! ( LAM 8 TCOMPLPGCD )
::	CODE
	GOLONG	num#0case 
	ENDCODE DROP 
	>TCOMP CODE
	GOLONG	lpgcd
	ENDCODE SWAPDROP
	;

LABEL lpgcd9!
::	DUPLENCOMP #2= 3PICK LENCOMP #2=
	ANDcase
	NULLNAME CGCDext
	::
	( C#PGCD, C#, C# -> C# )
	( a, b )
	[BEGIN]
		DUP HXS 1 0 EQUAL
	NOT_WHILE
		::
		( a, b )
		DUP
		CODE
		GOLONG	rconj
		ENDCODE
		( a, b, conj )
		2DUP
		( a, b, conj, b, conj )
		CODE
		GOLONG	rmult
		ENDCODE
		( a, b, conj, |b|^2 )
		4ROLLROT
		( b, |b|^2, a, conj )
		CODE
		GOLONG	rmult
		ENDCODE
		OVER
		( b, |b|^2, a*conj, |b|^2 )
		QMODSYMext
		( a'=b, |b|^2, a*conj mod |b|^2 )
		3PICK RMULText SWAP ZQUOText
		( a'=b, b*[a*conj mod |b|^2]/|b|^2 )
		;
	[REPEAT]
	( b, r=0 )
	DROP
	DUPTYPEHSTR?
	case	CODE
		GOLONG	zabs
		ENDCODE
	INCOMPDROP
	( im, re )
	HXS 1 0 EQUALcasedro CODE
	GOLONG	zabs
	ENDCODE
	( im, re )
	CODE
	GOLONG	todzneg
	ENDCODE
	SWAP
	CODE
	GOLONG	zabs
	ENDCODE
	SWAPROT 
	( re, re<0, im )
	CODE
	GOLONG	todzneg
	ENDCODE
	SWAP
	CODE
	GOLONG	zabs
	ENDCODE
	UNROT
	( re, im, re<0?, im<0? )
	XOR ?SKIP SWAP IRXCext
	;
	CODE
	GOLONG	qxnd
	ENDCODE
	DROPROT
	CODE
	GOLONG	qxnd
	ENDCODE
	DROP FOUR {}N
	CODE
	GOLONG	lpgcd
	ENDCODE
	SWAPDROP
	;
*****************************************************
NULLNAME QUOText ( o2, o1 -> o2 div o1 )
* quotient euclidien de 2 objets
LABEL quotext!
::
CK&DISPATCH1
# BB ::	integerflag UserITE 
	CODE
	GOLONG	zquot
	ENDCODE
	CODE
	GOLONG	rdiv
	ENDCODE
        ;
2LIST :: TEN ClrUserFlag
         2DUPEQ case2drop { HXS 2 10 }
         ( l1, l2 )
         DUPLENCOMP
         DUP#1=
         casedrop :: ( list1, { elem2 } )
                     CARCOMP num#1=case DROP 
	CODE
	GOLONG	divobj
	ENDCODE
                     ( { elems1/elem2 } )
                     ;
         ( l1, l2, #l2 )
         3PICK LENCOMP
         ( l1, l2, #l2, #l1 )
         #> case2drop { HXS 1 0 }
         ( l1, l2 )
	 SWAPINCOMP get1 INNERCOMP get1 
	 ( a_a-1, ..., a0, bb_1, ..., b0, #b, #a )
	 FALSE 
	CODE
	GOLONG	quotobj
	ENDCODE
	 ( r, q )
	 SWAPDROP
         ;
EIGHTY ( liste, objet ) 
	CODE
	GOLONG	divobj
	ENDCODE
list :: ( objet, liste )
        2DROP { HXS 1 0 }
        ;
any	CODE
	GOLONG	rdiv
	ENDCODE
;

**************************
NULLNAME ZQUOText
* :: SHALT ( test )
CODE
zquot		GOSBVL	=SAVPTR
* First test for division by 1
		C=DAT1	A
		D0=C			->Q2
		A=DAT0	12
		C=A	W
		LCZ1
		?A=C	W
		GOYES	qdiv1
* Then test for division by -1
		P=	12-1
		C=-C-1	P
		P=	0
		?A=C	W
		GOYES	qdiv-1
* Then test for equality
		D1=D1+	5
		C=DAT1	A
		CD0EX			->Q1
		D1=C			->Q2
		GOSUBL	EQUAL?		CC: Equal Q's
		GOC	qdivdispatch	Different Q's - dispatch

qdivequ		GOSBVL	=GETPTR		Q/Q = 1
		D1=D1+	10
		D=D+1	A		Drop Q2
		D=D+1	A		Drop Q1
		GOSBVL	=SAVPTR
		A=0	W
		A=A+1	A
		P=	1
		GOVLNG	=PUSHhxsLoop

qdiv1		GOSBVL	=GETPTR		Q1/1 = Q1
		GOVLNG	=DropLoop

qdiv-1		GOSBVL	=GETPTR		Q1/-1 = -Q1
		D1=D1+	5		Drop -Z1
		D=D+1	A
		GOLONG	rneg		Negate Q1

qdivdispatch	LC(5)	=DOHSTR
		A=DAT0	A
		?A=C	A
		GOYES	zdivz
		GOTO	pdivz

**********************************************************************
* Calculate Z1/Z2
* Special cases:	- Z known not to be 1 or -1 in here
*			- Z1 <> Z2 known
*			- If |Z1| < |Z2| then Z1/Z2 = 0 ???
*			- If |Z1| = |Z2| then Z1/Z2 = 1 ???
**********************************************************************

zdivz		D0=D0+	5
		A=DAT1	A		Z1size
		A=A+A	A		2xZ1size
		LC(5)	10+6+20		2xPrologs + link + safety
		C=C+A	A
		GOSBVL	=GETTEMP	D0 ->tempobj

		GOSBVL	=D1=DSKTOP
		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		AD0EX			D0 = ->Z1
		R0=A	A		R0[A] = ->output
		D1=C			D1 = ->Z2

		GOSUBL	ZQUO		Divide into output

		C=R0	A		->Quotient
		C=C+CON	A,5		Skip prolog
		D0=C
		A=DAT0	A		QUOsize
		C=C+A	A
		D0=C			->Quotient tail
		A=A+CON	A,11		link = QUOzise+prolog+link+GCnib
		DAT0=A	A		write link
		D0=D0+	5		skip link

		GOSBVL	=recover	Shrink allocated memory
		GOSBVL	=GETPTR
		D1=D1+	5		Drop Z2
		D=D+1	A
		A=R0	A		return Quotient
		GOVLNG	=OverWrALoop


* Here:	Z2 is not 1 or -1, and Q1<>Z2
*	D0 = ->Q1	D1 = ->Z2
**********************************************************************
* Calculate P/Z
* Special cases:	- Z known not to be 1 or -1 in here
*
* Algorithm:
*	Simply allocate sufficient memory and divide elements one by one
**********************************************************************

* IRAMBUFF storage for loop pointers/variables is
* needed because ZQUO uses so many registers

Z2PTR	EQU #100		Pointer into Z2 running pointer
CDEPTH	EQU #105		Composite depth
DIV$	EQU #10A		Start address of output object

pdivz		ST=1	sALG48
		GOSUBL	toQSIZE		C[A] = Qsize
		?ST=1	sALG48
		GOYES	dopdivz
		GOSBVL	=GETPTR
		GOLONG	divobj
dopdivz		C=C+C	A		2 * Qsize
		LA(5)	10+6+100	2xPrologs + link + safety
		C=C+A	A
		GOSBVL	=GETTEMP	D0 ->tempobj

* Now init the loop variables

		AD0EX			->tempobj
		D0=(5)	(=IRAM@)-4
		C=DAT0	A
		LC(4)	DIV$		->storage
		D0=C
		DAT0=A	A		->output object

		R0=A	A		->output pointer
		B=0	A		cdepth = 0
		
		GOSBVL	=D1=DSKTOP
		A=DAT1	A		->Z
		D1=D1+	5
		C=DAT1	A		->P
		D0=C			->P
		D1=A			->Z
		GOSUB	pdivztrimreset

pdivzloop	A=DAT0	A
		LC(5)	=DOHSTR
		?A#C	A
		GOYES	pnotzdivz
pzdivz		GOSUB	pdivznow	Execute Zi/Z2
		GOTO	pdivznext
pnotzdivz	C=R0	A		->output ptr
		CD1EX
		DAT1=A	A		Copy DOLIST/SEMI
		D0=D0+	5
		D1=D1+	5
		CD1EX
		R0=C	A		->output ptr'
		LC(5)	=DOCOL
		?A#C	A
		GOYES	pnotcdivz
		C=0	S
		?ST=0	sTRIM
		GOYES	pcdivz1
		C=C+1	S
		ST=1	sTRIM
pcdivz1		R0=C.F	S
		GOSUB	pdivznow
		?ST=0	sTRIM
		GOYES	pcdivz3
		C=R0.F	A		im=0, overwrite DOCOL in output
		C=C-CON	A,5
		R0=C.F	A
		C=R0.F	S
		?C=0	S
		GOYES	pcdivz2
		ST=0	sTRIM
pcdivz2		GOSUB	pdivznow
		D0=D0+	5		skip SEMI in c
		GOTO	pdivznext
pcdivz3		GOSUB	pdivznow
		A=DAT0	A
		C=R0	A
		CD1EX
		DAT1=A	A		Copy SEMI
		D0=D0+	5
		D1=D1+	5
		CD1EX
		R0=C	A		->output ptr'
		GOTO	pdivznext
		
pnotcdivz	LC(5)	=SEMI
		?A=C	A
		GOYES	pdivzsemi
		B=B+1	A		cdepth++
		ST=1	sTRIM		
		P=	6
		AR0EX.F	WP
		P=	5
		A=A+1	P
		GONC	pdivztrim
		P=	6
		A=A+1	P
pdivztrim	P=	6
		AR0EX.F	WP
		P=	0
		GOTO	pdivznext

pdivzsemi	?ST=0	sTRIM
		GOYES	pdivzsemi1
		P=	6		-> trimming en cours
		C=R0.F	WP		-> TRIM complevel -- et adresse -10
		P=	5
		C=C-1	P
		GONC	+
		P=	6
		C=C-1	P
+		P=	6
		C=C-CON	A,10		on enleve { SEMI
		R0=C.F	WP
		C=0	A
		?C#0	WP
		GOYES	pdivzsemi1
		P=	0
		GOSUB	pdivztrimreset
		C=R0.F	A
		CD1EX			write 0
		LCZ0
		DAT1=C	11
		D1=D1+	11
		CD1EX
		R0=C.F	A
		
pdivzsemi1	P=	0
		B=B-1	A		cdepth--
pdivznext	?B=0	A
		GOYES	pdivzdone
		GOTO	pdivzloop

* Done - shrink output & push result

pdivzdone	D0=(5)	(=IRAM@)-4
		C=DAT0	A
		LC(4)	DIV$
		D0=C
		A=DAT0	A		->output
		C=R0	A		->output tail
pdivznot0	R0=A	A		->output
		GOSUBL	toShrinkQ	A[A]=->output
		D1=D1+	5		Drop Z2
		D=D+1	A
		DAT1=A	A
		GOLONG	newtrim

*---------------------------------------------------------------------
pdivznow	AD0EX			->Zi
		D0=(5)	(=IRAM@)-4
		C=DAT0	A
		LC(4)	Z2PTR
		D0=C
		DAT0=A	A		Save ->Zi
		D0=(2)	CDEPTH
		C=B	A
		DAT0=C	A		Save cdepth
		D0=A
		GOSUBL	ZQUO		Divide into output

		C=R0	A		Update ->output'
		C=C+CON	A,5		skip prolog
		D0=C
		A=DAT0	A		QUOsize
		?ST=0	sTRIM
		GOYES	pdivznownotrim
		A=A-CON	A,6		si longueur=6, QUO est nul
		?A=0	A
		GOYES	pdivznowtrim
		A=A+CON	A,6
pdivznownotrim	C=C+A	A
		R0=C	A		->output'
		GOSUB	pdivztrimreset
		
pdivznowtrim	GOSBVL	=D1=DSKTOP	Restore ->Z
		C=DAT1	A
		D1=C			->Z

		D0=(5)	(=IRAM@)-4
		C=DAT0	A
		LC(4)	CDEPTH
		D0=C
		A=DAT0	A		Restore CDEPTH
		B=A	A
		D0=(2)	Z2PTR
		A=DAT0	A		Restore ->Zi
		A=A+CON	A,5		And skip it to continue
		D0=A
		C=DAT0	A		Zisize
		A=A+C	A
		D0=A			->Zi+1
		RTN

pdivztrimreset	ST=0	sTRIM		Autorise la sortie de HXS 1 0
		P=	6
		CR0EX.F	WP
		C=0	P		TRIM complevel ( de 0 a 255 )
		P=	5
		C=0	P
		P=	6
		CR0EX.F	WP
		P=	0
		RTN
ENDCODE
*;
**********************************************************************
NULLNAME LOPDext
* List Operation Quotient
CODE
lopd		C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		LC(5)	=DOHXS
		?A#C	A
		GOYES	lopdnothxs
		GOTO	zquot
lopdnothxs	D1=D1+	5
		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		D1=D1-	5
		LC(5)	=DOLIST
		?A#C	A
		GOYES	lopdquot
		A=PC
		LC(5)	(lopdext!)-(*)
		A=A+C	A
		PC=(A)
* si stk2 n'est pas une liste -> quot
lopdquot	GOLONG	quot
ENDCODE

LABEL lopdext!
::
SWAPINCOMP get1 OVER
ZERO_DO (DO)
        ( o1, ..., on , #n, o )
        ROTOVER 
	CODE 
	GOLONG	quot
	ENDCODE
	CODE
	GOLONG	newtrim
	ENDCODE
	3PICK #2+UNROLL
        LOOP
DROP {}N
;

*********************************************************************
NULLNAME LOPMext ( objet, liste -> { objet * elements de liste } )
* List Operation Multiplication
LABEL lopmext!
::
SWAP
CODE
	GOLONG	num#1case 
ENDCODE
DROP
OVER TYPELIST? NOTcase 
CODE
	GOLONG	rmult
ENDCODE
SWAPINCOMP get1 OVER
ZERO_DO (DO)
        ( o1, ..., on , #n, o )
        ROTOVER 
	CODE 
	GOLONG	rmult
	ENDCODE
	3PICK #2+UNROLL
        LOOP
DROP
{}N
;
********************************************************************
NULLNAME num0case
* comme num0=case mais accepte aussi les polynome-listes nuls
LABEL num0ext!
::
NOTLISTcase 
CODE
	GOLONG	num#0case
ENDCODE
CODE
	GOLONG	trimobj
ENDCODE
DUP HXS 1 0 EQUAL COLAcase
;
*******************************************************************
NULLNAME NDXQext
( a, b, c -> seco )
CODE
ndxq		GOSUBL	a=stkwc1
		P=	11
		?A#C	WP
		GOYES	ndxqnot1
		P=	0
		D=D+1	A
		D1=D1+	5
		GOLONG	radd
ndxqnot1	P=	0
		A=PC
		LC(5)	(ndxqext!)-(*)
ndxqbranch	A=A+C	A
		PC=(A)
ENDCODE
LABEL ndxqext!
::
( a, b, c -> seco )
OVER 
CODE
	GOLONG num0
ENDCODE 3DROP
( a, b, c, b )
CODE
		GOSUBL	a=stk1
		LC(5)	=DOCOL
		?A#C	A
		GOYES	ndxq!1
		LA(5)	=DUPLENCOMP
		PC=(A)
ndxq!1		GOSUBL	semiml	( b n'est pas un irrquad -> DROP et << >> )
		A=DAT1	A
		D=D+1	A
		D1=D1+	10
		DAT1=A	A
		D1=D1-	5
ndxqbuilt	D=D-CON	A,3
		GONC	ndxq!2
		GOSBVL	=GARBAGE1
ndxq!2		C=DAT1	15
		LA(5)	=x<<
		D1=D1+	10
		DAT1=A	A
		D1=D1-	15
		DAT1=C	15
		D1=D1-	5
		LA(5)	=x>>
		DAT1=A	A
		D1=D1-	5
		LA(5)	=FIVE
		DAT1=A	A
		LA(5)	=::N
		PC=(A)
ENDCODE
#2= sqrtflag TestUserFlag OR
( a, b, c, b, ?not_seco )
CODE
		GOSBVL	=popflag
		GOC	tondxq!1
		GOLONG	qxnd
tondxq!1	GOTO	ndxq!1
ENDCODE
ROT 
( a, b, c, e, f, d )
CODE
	GOLONG	num0
ENDCODE 
	::	( a, b, c, e, f, 0 )
		DROPROT 4ROLLDROP 
		CODE
		GOLONG	rmult
		ENDCODE
		( a, e, c*f )
*		iuflag TestUserFlag 
*		case
		CODE
		GOTO	ndxqbuilt
		ENDCODE
*		iuflag SetUserFlag
*		SIMPEVALext XSQRext
*		( a, e, sqrt[c*f] )
*		CODE
*		GOLONG	rmult
*		ENDCODE
*		CODE
*		GOLONG	radd
*		ENDCODE
*		( a+e*sqrt[c*f] )
*		iuflag ClrUserFlag
		;
( 3DROP -> << >> )
CODE
		D=D+CON	A,3
		D1=D1+	15
		GOTO	ndxqbuilt
ENDCODE

;
********************************************************************
NULLNAME CNORMext
::
EVAL
DUP
CODE
	GOLONG	rmult
ENDCODE
SWAPDUP
CODE
	GOLONG	rmult
ENDCODE
CODE
	GOLONG	radd
ENDCODE
;
******************************************************************
NULLNAME QNORMext 
* pour des irraquads. Il faudra rajouter le test pgcd[c1,c2]<>0 
LABEL qnormext!
::
CODE
	GOLONG	qxnd
ENDCODE 
SWAPDUP 
CODE
	GOLONG	rmult
ENDCODE
CODE
	GOLONG	rmult
ENDCODE 
SWAPDUP 
CODE
	GOLONG	rmult
ENDCODE 
SWAP 
CODE
	GOLONG	rsub
ENDCODE
;
*******************************************************************
NULLNAME NEWDIVext ( obj2, obj1 -> obj2 div obj1, obj2 mod obj1 )
* comme DIVext ci-dessous, mais renvoie des fractions valides
::
FXNDext ROT FXNDext
( n1, d1, n2, d2 )
ROT RDIVext
( n1, n2, d1/d2 )
UNROTSWAP
( d1/d2, n2, n1 )
NULLNAME PSEUDOPREP
CODE
* o2, o1 -> o2*a1.n^, o1, a1.n^
* teste si obj1 est une liste
		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	12
		R0=A
		D1=D1-	5
		A=DAT1	A
		CD1EX
		LC(5)	=DOLIST
		?A=C	A
		GOYES	newdiv1
newdiv0		GOLONG	hxs1
newdiv1		A=R0
		C=A	W
		LCZ1
		?A=C	W
		GOYES	newdiv0
		D1=D1+	5
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOLIST
		?A#C	A
		GOYES	newdiv0
		A=PC
		LC(5)	(pseudoprep!)-(*)
		A=A+C	A
		PC=(A)
ENDCODE
( d1/d2, o2*a1.n^, o1, a1.n^ )
4ROLL RMULText UNROT
( d1/d2*a1.n^, o2*a1.n^, o1 )
DIVext
( d1/d2*a1.n^, quot, mod )
SWAP3PICK RDIVext
SWAPROT RDIVext
;

LABEL pseudoprep!
::
OVER LENCOMP OVER LENCOMP
( l1, l2, #l1, #l2 )
2DUP#< case2drop HXS 2 10
#-+1 OVER CARCOMP SWAP RPext
( l1, l2, a1.n^ )
DUP ONE{}Next
4UNROLLROT
CODE
	GOLONG	lopm
ENDCODE
SWAPROT
( l1, l2, a1.n^ )
;
***************************************************************
NULLNAME DIVext ( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
* Division euclidienne de 2 polynomes-listes ou de 2 reels
* calcule le quotient et le reste
* Note: il faudrait aussi faire symb div symb
LABEL divext!
::
{ HXS 1 0 } UNROT
CK&DISPATCH1
# BB	:: ROTDROP integerflag TestUserFlag
         case 
	CODE
	GOLONG	zdiv
	ENDCODE
	CODE
	GOLONG	rdiv
	ENDCODE
         HXS 1 0
         ;
2LIST 	CODE
	GOLONG	div2list
	ENDCODE
EIGHTY ::	( { HXS 1 0 }, liste, objet )
	CODE
	GOLONG	fxnd
	ENDCODE
		( { HXS 1 0 }, liste, obj-n, obj-d )
		DUP 4ROLL 
	CODE
	GOLONG	rmult	
	ENDCODE
		( { HXS 1 0 }, obj-n, obj-d, liste*obj-d )
		ROT
		( { HXS 1 0 }, obj-d, liste*obj-d, obj-n )
		NOTLISTcase :: 
	CODE
	GOLONG	divobj
	ENDCODE
				SWAPDROPSWAP ;
		4ROLLDROP 
	CODE
	GOLONG	div
	ENDCODE
		( obj-d, liste*obj-d/obj-n, mod )
		ROT 
	CODE
	GOLONG	divobj
	ENDCODE
		;
list :: ( { HXS 1 0 }, objet, liste )
	SWAP 
	CODE
	GOLONG	fxnd
	ENDCODE
        ( { HXS 1 0 }, liste, obj-n, obj-d )
	DUP 4ROLL 
	CODE
	GOLONG	rmult
	ENDCODE
        ( { HXS 1 0 }, obj-n, obj-d, liste )
	3PICK TYPELIST? 
	case :: ( { HXS 1 0 }, obj-n, obj-d, liste )
		4ROLLDROP ROTSWAP 
		( obj-d, obj-n, liste )
	CODE
	GOLONG	div
	ENDCODE 
		ROT
* modif avril 97, divobj -> rdiv
	CODE
	GOLONG	rdiv
	ENDCODE
		;
        ( { HXS 1 0 }, obj-n, obj-d, liste )
	DUPLENCOMP #1=
	NOTcasedrop
	CODE
	GOLONG ndxf
	ENDCODE 
* modif 11/97: plus de ONE{}N qui donne des profondeurs fausses
	SWAPDROP
	CODE
	GOLONG	newtrim
	ENDCODE
	CODE
	GOLONG	ndxf
	ENDCODE
        ( le probleme vient de 0 sur liste -> recursion avec SIMPNDXFext )
        SWAP
        ;
any :: ROTDROP CODE
	GOLONG	rdiv
	ENDCODE
	DUP HXS 1 0 
	CODE
	GOLONG	rmult
	ENDCODE  
	;
;
********************************************************************
NULLNAME DIV2LISText
( { HXS 1 0 }, l1, l2 -> l1 div l2, l1 mod l2 )
* comme DIVext mais pour 2 listes, 
CODE
* on commence par tester l'egalite
div2list	GOSBVL	=SAVPTR
		A=DAT1	A
		D1=D1+	5
		C=DAT1	A
		D0=A
		D1=C
		GOSUBL	EQUAL?
		GOC	div2listneq
		A=PC
		LC(5)	(div2listeq!)-(*)
		GOTO	div2listbranch
div2listneq	A=PC
		LC(5)	(div2listext!)-(*)
div2listbranch	A=A+C	A
		GOSBVL	=GETPTR
		PC=(A)
ENDCODE

LABEL div2listeq!
:: 2DROP { HXS 2 10 }  SWAP ;

LABEL div2listext!
::		
( { HXS 1 0 }, A, B )
* integerflag ClrUserFlag
( { HXS 1 0 }, A, B -> A div B, A mod B  si len A >= len B >= 2 )
OVER INNERCOMP get1 INNERCOMP
( { HXS 1 0 }, A, a_a-1, ..., a0, #a, bb_1, ..., b0, #b )
CODE
		A=DAT1	A
		LC(5)	=ONE
		?A=C	A
		GOYES	div2list1
		GOVLNG	=Loop
div2list1	D1=D1+	5	( casedrop )
		D=D+1	A
		GOSUBL	semiml
* ( { HXS 1 0 }, A, a_a-1, ..., a0, #a, b0 )
		GOSUBL	a=stkwc1
		P=	11
		?A#C	WP
		GOYES	div2list2
		P=	0
* { HXS 1 0 }, A, a_a-1, ..., a0, #a, bb_0: on recupere #a pour NDROP
		D=D+1	A
		D1=D1+	5
		GOSBVL	=POP#
		GOSUBL	ndropml
* { HXS 1 0 }, A
		LA(5)	=SWAP
		PC=(A)
div2list2	P=	0
* { HXS 1 0 }, A, a_a-1, ..., a0, #a, bb_0
		A=PC
		LC(5)	(divmetaunrot!)-(*)
		A=A+C	A
		PC=(A)
ENDCODE
get1 
( { HXS 1 0 }, A, a_a-1, ..., a0, bb_1, ..., b0, #b, #a )
2DUP#> case :: #+ NDROP ;
TRUE 
CODE
quotobj	A=PC
	LC(5)	(quotobjext!)-(*)
	A=A+C	A
	PC=(A)	
ENDCODE
( {HXS 1 0 }, A, r, q )
ROTDROP ROTDROPSWAP
( q, r )
;

LABEL	divmetaunrot!
::
		CODE
divmetaobj	A=PC
		LC(5)	(divmetaobj!)-(*)
		A=A+C	A
		PC=(A)
		ENDCODE
		UNROTDROP
		;

*******************************************************************
NULLNAME DIVOBJext ( f, obj  -> f/obj )
LABEL divobjext!
::
CODE
	GOLONG	num#1case 
ENDCODE
DROP
OVER TYPELIST? NOTcase 
CODE
	GOLONG	rdiv
ENDCODE
SWAPINCOMP get1
( o1, ..., on, #n, o )
LABEL divmetaobj!
::
OVER
ZERO_DO (DO)
        ( o1, ..., on , #n, o )
        ROTOVER 
	CODE 
	GOLONG	rdiv
	ENDCODE
	CODE
	GOLONG	newtrim
	ENDCODE
	DUPTYPESYMB?
	ITE ::	divflag TestUserFlag ;
	    ::  DUPZERO EQ ;
	ITE ::	ExitAtLOOP ROT#1+ NDROP ZERO ONEONE ;
	    ::	3PICK #2+UNROLL ;
        LOOP
DROP {}N
;
;
********************************************************************
NULLNAME TRIMext ( liste -> liste )
* Enleve les zeros en tete de liste
LABEL trimext!
::
:: CK&DISPATCH1
   list TWO
   seco ONE
   symb ONE
   any ZERO
   ;
DUP#0=csDROP
SWAP
NULLNAME TRIMOBJext ( obj -> obj )
* comme TRIM mais sans rendre forcement une liste
CODE
trimobj	C=DAT1	A	( adresse sommet de la pile )
	CD1EX		( mise dans D1 )
	P=	9
	A=DAT1	WP	( A= prologue etendu du 1er objet )
	P=	0
	CD1EX
	LC(5)	=DOHXS
	?A#C	A
	GOYES	nothxs
	GOVLNG	=Loop
nothxs	LC(5)	=DOLIST
	?A#C	A
	GOYES	notlist
* c'est une liste, est-elle vide?
trimlist	P=	5
		LC(5)	=SEMI
		P=	9
		?A#C	WP
		GOYES	trimlist!11
		P=	0
droppushhxs0	D=D+1	A
		D1=D1+	5
		A=PC
		LC(5)	(hxs0!)-(*)
		GOTO	trimrpl
trimlist!11	P=	0
		A=PC
		LC(5)	(trimlist!)-(*)
trimrpl		A=A+C	A
		PC=(A)
notlist		LC(5)	=DOSYMB
		?A#C	A
		GOYES	notsymb
		A=PC
		LC(5)	(trimsymb!)-(*)
		GOTO	trimrpl
notsymb		LC(5)	=DOECMP
		?A#C	A
		GOYES	notecmp
trimecmp	A=PC
		LC(5)	(trimecmp!)-(*)
		GOTO	trimrpl
notecmp		LC(5)	=DOEREL
		?A#C	A
		GOYES	notereal
		A=PC
		LC(5)	(trimereal!)-(*)
		GOTO	trimrpl
notereal	LC(5)	=DOREAL
		?A#C	A
		GOYES	notreal
		A=PC
		LC(5)	(trimreal!)-(*)
		GOTO	trimrpl
notreal		LC(5)	=DOCMP
		?A#C	A
		GOYES	notcmp
		A=PC
		LC(5)	(trimnumcmp!)-(*)
		GOTO	trimrpl
notcmp		LC(5)	=DOCOL
		P=	5
		LC(5)	=x<<
		P=	9
		?A#C	WP
		GOYES	notirrq
		P=	0
trimirrq	A=PC
		LC(5)	(trimirrq!)-(*)
		GOTO	trimrpl
notirrq		P=	5
		LC(5)	=DOHSTR
		P=	9
		?A#C	WP
		GOYES	trimnot
		P=	0
		A=PC
		LC(5)	(trimcmp!)-(*)
		GOTO	trimrpl
trimnot		P=	0
		GOVLNG	=Loop
ENDCODE
SWAP#1- #0=?SEMI
NOTLISTcase ONE{}N
;

LABEL trimlist!
::	
INNERCOMP

LABEL trimmeta!
::
( o1, ..., on, #n )
#1- 
* on teste si le 1er element est nul -> drop et trimmeta!, sinon SWAP
get1
CODE
		GOLONG	trimobj
ENDCODE
( o2, ..., on, #n-1, o1 )
* si #n-1=0, alors on renvoie o1 ou { o1 } selon la nature de o1
CODE
		D1=D1+	5
		A=DAT1	A
		D1=D1-	5
		LC(5)	=ZERO
		?A#C	A
		GOYES	trimlist!12
* #n-1=0: #n-1, o1 -> swapdrop
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		DAT1=A	A
* o1
		GOSUBL	=semiml
returno1	C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		LC(5)	=DOLIST
		?A#C	A
		GOYES	trimlist!1
trimlist!0	P=	0
		LA(5)	=ONE{}N
		PC=(A)
trimlist!1	LC(5)	=DOSYMB
		?A=C	A
		GOYES	trimlist!0
		LC(N)	10
		CON(5)	=DOCOL
		CON(5)	=x<<
		P=	9
		?A=C	WP
		GOYES	trimlist!0
		P=	0
		GOVLNG	=Loop
* ( o2, ..., on, #n-1, o1 )
trimlist!12	GOSUB	a=stkwc0
		P=	10
		?A=C	WP
		GOYES	trimlist!10
		P=	0
		LA(5)	=SWAPDUP
		PC=(A)
trimlist!10	P=	0
		GOSUBL	semiml
		D=D+1	A
		D1=D1+	5	( drop )
trimmeta	A=PC		
		LC(5)	(trimmeta!)-(*)
		GOTO	trimrpl
a=stkwc0	C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		LCZ0
		RTN
ENDCODE
( o2, ..., on, o1, #n-1, #n-1 )
ZERO_DO	
	get1 
	CODE
		GOLONG	trimobj
	ENDCODE
	SWAPLOOP
#1+  {}N
; ( trimmeta!)
; ( trimlist!)

LABEL trimsymb!
::	INNERDUP
	#1-SWAP
	ZERO_DO 
		get1
		CODE
		GOLONG	trimobj
		ENDCODE
		SWAPLOOP
	#1+ SYMBN
	CODE
	GOLONG	fxnd
	ENDCODE
	CODE
	GOLONG	simpndxf
	ENDCODE
	;
LABEL trimecmp!
::	( ecomplex -> ecomplex / ereal )
	DUP C%%>%% %%0= NOTcaseDROP SWAPDROP
	;
LABEL trimereal!
::	%%0 EQUALcasedro HXS 1 0
	;

LABEL trimreal!
::	%0 EQUALcasedro HXS 1 0
	;

LABEL trimnumcmp!
::	C%0 EQUALcasedro HXS 1 0
	;

LABEL trimirrq!
::	INNERCOMP #5= NcaseTYPEERR 
	DROP 4ROLLDROP
	THREE
	ZERO_DO (DO)
		CODE
	GOTO	trimobj
	ENDCODE
		UNROT
	LOOP 
	CODE
	GOLONG	ndxq
	ENDCODE
	;
LABEL trimcmp!
::	INNERCOMP #2= NcaseTYPEERR
	CODE
	GOLONG	irxc
	ENDCODE
	;

*******************************************************************
NULLNAME QUOTOBJext
LABEL quotobjext!
::
( a_a-1, ..., a0, bb_1, ..., b0, #b, #a , flag -> r, q )
* r est correct si flag est true, sinon r n'est pas calcule
UNROT 2DUPSWAP #-+1 TOTEMPOB ONE TOTEMPOB HXS 1 0
( a_a-1, ..., a0, bb_1, ..., b0, false, #b, #a, #a-b=i, #0=j, q  -> r, q )
LABEL divdeb!
CODE
* on decremente j, -> si necessaire i, ?fini, sinon calcul de q et j=#b
	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A=#j )
	A=A-1	A
	?A=0	A
	GOYES	div0
	DAT1=A	A
	D1=C
	GOTO	div10
* q_a-b-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q
div0	R0=C	A
	CD1EX
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	CD1EX
	DAT1=A	A	( #j=#b )
	R1=A	A	( R1=#b )
	C=R0	A
	D1=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A	( #i decremente )
	D1=C
	GONC	div2
	A=D0
	LC(5)	(divfin!)-(divdiv!)
div1	A=A+C	A
	D0=A
	GOVLNG	=Loop
* calcul de q=a/b
* q_a-b-1, ..., q_i+1, a_i+b, ..., a0, b_b-1, ..., b0, flag, #b, #a, #i, #j, q
div2	C=R1	A	( R1=#b )
	C=C+C	A	( C=2*#b )
	C=A+C	A	( C=2*#b+#i )
	C=C+CON	A,5
	GOSUB	divpick	( pick a )
	C=R1	A
	C=C+CON	A,6
	GOSUB	divpick	( pick b )
	GOLONG	rdiv

* rappelle a, b, q sur la pile
* q_a-b-1, ..., q_i, a_i+b-1, ..., a0, b_b-1, ..., b0, flag, #b, #a, #i, #j, q
div10	GOSUB	div?c
	C=C+CON	A,5
	GOSUB	divpick	( pick a )
	C=R0	A	( c=#j )
	C=C+CON	A,6
	GOSUB	divpick	( pick b )
	LC(5)	=sFLUSH
	GOSUB	divpick	( pick q )
	A=D0
	LC(5)	(divmul!)-(divdiv!)
	GOTO	div1
divpick	D=D-1	A
	GONC divp1
	GOSBVL	=GARBAGE1
divp1	A=C	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	( A= 5*c )
	C=D1
	C=C+A	A
	CD1EX		( D1 pointe sur c_c, C sur le sommet de la pile )
	A=DAT1	A	( A= @c_c )
	CD1EX
	D1=D1-	5
	DAT1=A	A	( copie de c_c au sommet de la pile )
	RTN
* #b, #a, #i, #j, q -> semblable; r0=#j, r1=#b, c=#i+#j+#b
div?c	C=D1
	D1=D1+	5	( calcul i+j+b )
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( r0= #j )
	D1=C
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R1=A	A	( r1=#b )
	D1=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( a=#i )
	D1=C
	C=R0	A
	A=A+C	A
	C=R1	A
	C=A+C	A	( c=#i+#j+#b )
	RTN
ENDCODE

LABEL divdiv!
( q_q-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q, newq )
CODE
		A=DAT1	A
		LC(5)	=ZERO
		?A#C	A
		GOYES	divdiv!1
divdiv!0	A=PC
		LC(5)	(divzero!)-(*)
		A=A+C	A
		PC=(A)
divdiv!1	GOSUBL	a=stk1
		LC(5)	=DOSYMB
		?A=C	A
		GOYES	divdiv!0
divdiv!2	A=DAT1	A
		D1=D1+	5
		DAT1=A	A	( q=newq )
		D1=D1-	5
* on teste si flag=false et i=1 -> fini
		C=D1
		D1=D1+	15
		D1=D1+	15
		A=DAT1	A
		D1=C
		LC(5)	=FALSE
		?A#C	A
		GOYES	div19
		C=D1
		D1=D1+	15
		A=DAT1	A
		D1=A
		D1=D1+	5
		A=DAT1	A
		D1=C
		?A=0	A
		GOYES	div20
div19		A=D0
		LC(5)	(divmul!)-(divdeb!)
		A=A-C	A
		D0=A
		GOTO	divrep	( newq -> a_i+j=a_i+b )
div20		A=D0
		LC(5)	(divfin!)-(divmul!)
		A=A+C	A
		D0=A
		GOTO	divrep
ENDCODE
( q_q-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q, newq )


LABEL divmul!
CODE
	GOLONG	rmult
ENDCODE
CODE
	GOLONG	rsub
ENDCODE
* q_q-1, ..., q_i+1, a_i+b-1, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q, a
CODE
	A=D0
	LC(5)	(divfin!)-(divdeb!)
	A=A-C	A
	D0=A
* on remplace stk_i+j+b+4 par le sommet de pile qu'on detruit
divrep	D1=D1+	5
	GOSUB	div?c
	C=C+CON	A,5
	A=C	A
	C=C+C	A
	C=C+C	A
	A=A+C	A
	C=D1
	C=C+A	A
	D1=D1-	5
	A=DAT1	A
	D1=D1+	5
	CD1EX
	DAT1=A	A
	CD1EX
	D=D+1	A
	GOVLNG	=Loop
ENDCODE
* q_q-1, ..., q_i+1, a_i+b-1, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q
LABEL divfin!
( q_q-1, ..., q_0, a_b-1, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q )
3DROP ROTDROP
( q_q-1, ..., q_i+1, a_i+b-1, ..., a0, bb_1, ..., b0, #b, #a )
OVER#2+UNROL DUPDUP #2+UNROLL NDROP
( q_q-1, ..., q_0, a_b-1, ..., a0, #a, #b )
#1- DUPUNROT #- OVER#2+UNROL
* {}N
CODE
	GOLONG	newtrimmeta
ENDCODE
OVER#2+UNROL {}N
( r, q )
;

LABEL divzero!
* division impossible, on renvoie un quotient symbolique et un reste nul
::
divflag TestUserFlag
NOTcase
CODE
		GOTO	divdiv!2
ENDCODE
RDROP 4DROP #+ NDROP DROP
{ ZERO } { HXS 1 0 }
* ZERO { HXS 1 0 }
;

********************************************************************
NULLNAME RDIVext
* division o1, o2 -> o1/o2
*:: SHALT ( test )
CODE
* teste si o1=1, resultat=o2
* si o1=0, renvoyer infini ou undef selon o2
* si o2=0 et o1<> +/-infini et undef -> resultat=o2
rdiv	GOSUBL	raddrcl
* tester si stk2=infini ou ?
	LC(5)	=DOROMP
	?A=C	A
	GOYES	tox/ext
	C=A	W
	LC(N)	10
	CON(5)	=DOSYMB
	CON(5)	=DOROMP
	?A=C	W
	GOYES	tox/ext
* tester si stk1=0, infini ou ?
	A=R0
	LCZ0
	P=	10
	?A=C	WP
	GOYES	tox/ext
	P=	0
	LC(5)	=DOROMP
	?A=C	A
	GOYES	tox/ext
	C=A	W
	LC(N)	10
	CON(5)	=DOSYMB
	CON(5)	=DOROMP
	?A=C	W
	GOYES	tox/ext
* test si stk2=0
	A=R1
	LCZ0
	P=	10
	?A#C	WP
	GOYES	rdivn0
* division de 0 par stk1
	GOLONG	pdroploop
tox/ext	P=	0
	A=PC
	LC(5)	(x/ext!)-(*)
	GOTO	rdivfin
rdivn0	P=	0
	A=R0
	LCZ1
	P=	11
	?A#C	WP
	GOYES	rdivn1
	P=	0
	D=D+1	A
	D1=D1+	5
	GOLONG	newtrim
* teste si o1 et o2 sont des hxstr ou des complexes
rdivn1	C=C-1	P
	?A#C	WP
	GOYES	rdivn-1
	P=	0
	D=D+1	A
	D1=D1+	5
	GOLONG	rneg
rdivn-1 P=	0
	A=R1
	LC(5)	=DOHSTR
	?A#C	A
	GOYES	rdiv1
	A=R0	A
	?A=C	A
	GOYES	rdiv#
	GOTO	rdiv2
tordiv1	GOTO	rdiv1
* hexstr/hexstr
rdiv#	A=PC
	LC(5)	(hxstr/!)-(*)
	GOTO	rdivfin
rdiv1	LC(5)	=DOCOL
	P=	5
	LC(5)	=DOHSTR
	P=	9
	A=R1.F	WP
	?A#C	WP
	GOYES	rdivobj
* stk2=complex; ?stk1=hxstr
	P=	0
	A=R0	A
	LC(5)	=DOHSTR
	?A#C	A
	GOYES	rdiv2
rsimpndxf	P=	0
	A=PC
	LC(5)	(r15simp!)-(*)
rdivfin	A=A+C	A
	PC=(A)
* stk2=complex|hxstr; ?stk1=complex 
rdiv2	P=	0
	LC(5)	=DOCOL
	P=	5
	LC(5)	=DOHSTR
	P=	9
	A=R0.F	WP
	?A=C	WP
	GOYES	rsimpndxf
* hxstr|complex / hxstr|complex exclus, test irrquad
rdivobj	P=	0
	LC(5)	=DOCOL
	P=	5
	LC(5)	=x<<
	P=	9
	A=R0.F	WP
	?A#C	WP
	GOYES	rdiv4
rdiv3	P=	0
	A=PC
	LC(5)	(qdivext!)-(*)
	GOTO	rdivfin
rdiv4	A=R1.F	WP
	?A=C	WP
	GOYES	rdiv3
* test symbolique
	P=	0
	LC(5)	=DOSYMB
	?A#C	A
	GOYES	rdiv6
rdiv5	A=PC
	LC(5)	(rrdivext!)-(*)
	GOTO	rdivfin
rdiv6	A=R0	A
	?A=C	A
	GOYES	rdiv5
* test liste
	LC(5)	=DOLIST
	?A#C	A
	GOYES	rdiv7
	A=R1	A
	?A#C	A
	GOYES	rdiv71
	A=PC
	LC(5)	(robjl!)-(*)
	GOTO	rdivfin
rdiv7	A=R1	A
	?A#C	A
	GOYES	rdiv8
rdiv71	A=PC
	LC(5)	(rlobj!)-(*)
	GOTO	rdivfin
rdiv8	LC(5)	=DOEREL
	?A#C	A
	GOYES	rdiv9
	A=R0	A
	?A#C	A
	GOYES	rdiv9
	LA(5)	=%%/
	PC=(A)
rdiv9	A=R0	A
	LC(5)	=DOBINT
	?A#C	A
	GOYES	rdiv10
	A=R1	A
	?A#C	A
	GOYES	rdiv10
	A=PC
	LC(5)	(rbint!)-(*)
	GOTO	rdivfin
rdiv10	A=PC
	LC(5)	(EvalNoCKx/!)-(*)
	GOTO	rdivfin
ENDCODE
*; ( test ) 

LABEL hxstr/!
::	2DUP
	CODE
	GOTO	zmod
	ENDCODE
	( z1, z2, z1 mod z2 )
	HXS 1 0
	EQUALcase
	CODE
	GOLONG	zquot
	ENDCODE
	CODE
	GOLONG	simpndxf
	ENDCODE
	;
LABEL robjl!
::	pgcdflag TestUserFlag NOTcase NDXFext
	2DUP
	NULLNAME DIVISIBLE?
	::
	( a, b -> a/b, TRUE ou FALSE )
	divflag TestUserFlag
	divflag SetUserFlag
	{ HXS 1 0 } 2SWAP
	CODE
	GOLONG	div2list
	ENDCODE
	( flag, a/b, a mod b )
	divflag 4ROLL ITE_DROP ClrUserFlag
	CODE
	GOLONG	newtrim
	ENDCODE
	HXS 1 0 EQUAL
	NOTcaseFALSE
	{ ZERO } EQUALcasedro ZEROFALSE 
	DUPTYPESYMB? caseFALSE
	DUPZERO EQ NOT
	;
*	*************************************************************
	case UNROT2DROP
	( n, d, q )
	DROP 
	LABEL rlobj!
	CODE
	GOLONG	simpndxf
	ENDCODE
        ;
LABEL qdivext!
::
	CODE
	GOLONG	qconj
	ENDCODE 
	DUP 
	CODE
	GOLONG	qnorm
	ENDCODE 
	UNROT 
	CODE
	GOLONG	rmult
	ENDCODE
	CODE
	GOLONG	qxnd
	ENDCODE
	( norme, a, b, c )
	ROT 4PICK 
	CODE
	GOLONG	rdiv
	ENDCODE
	UNROTSWAP 4ROLL 
	CODE
	GOLONG	rdiv
	ENDCODE
	SWAP
	CODE
	GOLONG	ndxq
	ENDCODE
	;
LABEL rbint!
::	2DUP #/ #0=case UNROT2DROP
	DROP 
	CODE
	GOLONG	ndxf1
	ENDCODE
	;
LABEL rrdivext!
::
CODE
	GOLONG	fxnd
ENDCODE
ROT 
CODE
	GOLONG	fxnd
ENDCODE
( n2, d2, n1, d1 )
4UNROLL SWAP
( d1, n2, n1, d2 )
CODE
	GOLONG	rmult
ENDCODE 
UNROTSWAP 
CODE
	GOLONG	rmult
ENDCODE
	LABEL r15simp!
	::
	DUPTYPESYMB? case x/ext
	OVER TYPESYMB? case x/ext
	CODE
	GOLONG	num#0case 
	ENDCODE
	x/ext
	DUPTYPECOL? real_intflag TestUserFlag
	ORcase
	CODE
	GOLONG	simpndxf
	ENDCODE
	CODE
	GOLONG	rdiv10
	ENDCODE
	;
;

LABEL EvalNoCKx/! 
::
CK&DISPATCH1
# 3F3F  %%/
# 4F4F	C%%C/C
# 3F4F	C%%R/C
# 4F3F	C%%C/R
2REAL	%/
realcmp C%R/C
cmpreal C%C/R
cmpcmp	C%C/C
# 3FB	::	CODE
		GOLONG	z2r
		ENDCODE
		%>%% %%/ 
		;
# 3F8	::	CODE
		GOLONG	zz2c%%
		ENDCODE
		C%%R/C
		;
# 4FB	::	CODE
		GOLONG	z2r
		ENDCODE
		%>%% C%%C/R 
		;
# 4F8	::	CODE
		GOLONG	zz2c%%
		ENDCODE
		C%%C/C 
		;
# 83F	::	SWAP
		CODE
		GOLONG	zz2c%%
		ENDCODE
		SWAP C%%C/R
		;
# 84F	::	SWAP
		CODE
		GOLONG	zz2c%%
		ENDCODE
		SWAP C%%C/C
		;
# B3F	::	SWAP
		CODE
		GOLONG	z2r
		ENDCODE
		%>%% SWAP %%/
		;
# B4F	::	SWAP
		CODE
		GOLONG	z2r
		ENDCODE
		%>%% SWAP C%%R/C
		;
any	x/ext
;

***********************************************************
NULLNAME ZGCDext
CODE
zgcd	A=PC
	LC(5)	(zgcdext!)-(*)
	A=A+C	A
	PC=(A)

ENDCODE
LABEL zgcdext!
::
  CODE
	GOLONG	toFastGcd?
  ENDCODE
  ?SEMI					( Done already )

* Atleast one integer too big for a register. Use slow division
* until both integers fit in

CODE
	GOLONG	zabs
ENDCODE SWAP 
CODE
	GOLONG	zabs
ENDCODE			( N2 N1 )
  BEGIN
*	DupQIsZero? NOT
	DUP HXS 1 0 EQUALNOT
  WHILE					( A B )
	SWAPOVER 
CODE
	GOLONG	zdiv
ENDCODE
	( B A/B AmodB )
	SWAPDROP			( B AmodB )
	CODE
		GOLONG	toFastGcd?
	ENDCODE
	case :: 2RDROP ;		( FastGcd finished )
  REPEAT
  DROP
;

**********************************************************************
NULLNAME ZMODext
* z1, z2 -> z1 mod z2
CODE
zmod		GOSBVL	=SAVPTR

* Fetch arguments

		A=DAT1	A
		D1=D1+	5
		C=DAT1	A
		D0=C			->Q1
		D1=A			->Q2

* First test for division by 1
		A=DAT1	12
		C=A	W
		LCZ1
		?A#C	W
		GOYES	zrem0

* NOTE: Code elsewhere assumes results are not trimmed.
*	Thus we must not check for the special case
*	of equal input

		GOSBVL	=GETPTR		Q1/1 = Q1, 0
		D1=D1+	10		Drop 2
		D=D+1	A
		GOSBVL	=SAVPTR
		A=0	W
		GOVLNG	=PUSHhxsLoop	Push Z0

zrem0		D0=D0+	5
		A=DAT1	A		Z1size
		A=A+A	A		2xZ1size
		LC(5)	10+6+20		2xPrologs + link + safety
		C=C+A	A
		GOSBVL	=GETTEMP	D0 ->tempobj

		GOSBVL	=D1=DSKTOP
		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		AD0EX			D0 = ->Z1
		R0=A	A		R0[A] = ->output
		D1=C			D1 = ->Z2

		GOSUB	ZQUO		Divide into output

		C=R0	A		->Quotient
		C=C+CON	A,5		Skip prolog
		D0=C
		A=DAT0	A		QUOsize
		C=C+A	A
		D0=C			->Quotient tail
		A=A+CON	A,11		link = QUOzise+prolog+link+GCnib
		DAT0=A	A		write link
		D0=D0+	11		skip link+GCnib+remprolog

		C=C+CON	A,6
		R1=C			R1[A] = ->Remainder

		A=DAT0	A		REMsize
		CD0EX
		C=C+A	A		->Remainder tail
		CD0EX
		A=A+CON	A,11		link = QUOsize+prolog+link+GCnib
		DAT0=A	A		write link
		D0=D0+	5		skip link

		GOSBVL	=recover	shrink allocated memory

		GOSBVL	=GETPTR
		D1=D1+	5
		D=D+1	A
		A=R1
		GOVLNG	=OverWrALoop	stack level 1 = ->Remainder

*---------------------------------------------------------------------
* Modular math preparation
* Stack:	( Q Zn )
* Exit:		sSHORTMOD=1	R4[W]=Zn	D0=->Q
*		sSHORTMOD=0	R4[A]=->Zn	D0=->Q
*---------------------------------------------------------------------

ModPrepare	GOSBVL	=SAVPTR
		A=DAT1	A		->Zn
		D1=D1+	5
		R4=A	A		R4[A] = ->Zn
		ST=0	sSHORTMOD	Assume Zn is long
		D0=A
		GOSUBL	toSHORTPOP?	A[W]C[S] = Zn
		GOC	+		It was long - continue
		ST=1	sSHORTMOD	It wasn't - flag so and save Zn
		R4=A	W
+		A=DAT1	A
		D0=A			D0 = ->Q
		RTN

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Compute symmetric modulo Z1 mod Z2 where Z2 is short
* In:		D0	->Z1
*		C[W]	Z2
* Out:		D0	->Z1tail
*		A[W]	Zmod
*		D[S]	Zmodsign
*		C[W]	Z2
* Alters:	D0 A[W] B[W] C[W] D[S,14,A]
* Stack:	3
* Note:		This always returns the symmetric modulo, not the
*		antisymmetric modulo as the old system RPL code would
*		when Z2 is negative.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ZMODSHORT	GOSUB	ZREMSHORT	A[W]=remainder	C[W]=Z2
		GOSUB	ZMODSYM
		?A=0	W		Ignore next if rem is negative
		RTNYES
		B=C	S		Negate modulo of Z1 is negative
		D0=D0-	1
		C=DAT0	S		C[S] = Z1sign
		D0=D0+	1
		CBEX	S
		?B=0	S
		RTNYES
		D=-D-1	S
		RTN

* Little utility to convert MODP to MOD

ZMODSYM		D=0	S		Assume modulo is positive
		?A=0	W
		RTNYES			It is if remainder is zero
		B=A	W		B[W] = remainder
		B=B+B	W
		GOC	+
		?B<=C	W		If 2*rem <= Zn then is symmetric
		RTNYES
+		A=A-C	W
		A=-A	W
		D=-D-1	S
		RTN


*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Compute remainder in Z1/Z2 calculation.
* In:		D0	->Z1
*		C[W]	Z2		Z2 is short and unsigned
* Out:		D0	->Z1tail
*		A[W]	Zrem
*		C[W]	Z2
* Alters:	D0 A[W] B[W] C[W] D[S,A]
* Stack:	2
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

ZREMSHORT	B=C	W		B[W] = divisor
		D0=D0+	5
		A=DAT0	A		Z1size

		C=C-1	W
		GOC	z1rem1		Handle Z1 REM 0
		C=C-1	W
		GOC	z1rem1		Handle Z1 REM 0
		C=C-1	W
		GOC	z1rem2		Handle Z1 REM 2

		LC(5)	5+16+1
		?A>C	A
		GOYES	zremlong

* The integer in D0 is short - we can do the entire calculation in registers

		GOSUBL	toshortpop	A[W]C[S] = Z1
		CBEX	W		A[W]B[S] = Z1
		GOSUBL	BDIV		C[W]=divisor
		A=B	W		A[W]=remainder
		RTN

z1rem1		CD0EX
		C=C+A	A		Skip Z1
		CD0EX
		C=B	W		C[W] = Z2
		A=0	W		A[W] = remainder = 0
		RTN
z1rem2		D0=D0+	5
		C=DAT0	B		C[0] = low nibble in Z1 (0 for Z0)
		CD0EX
		C=C+A	A		Skip Z1
		CD0EX
		D0=D0-	5		->Z1tail
		A=0	W		A[W] = remainder = 0
		?CBIT=0	0
		GOYES	+
		A=A+1	A		A[W] = remainder = 1
+		C=B	W		C[W] = divisor
		RTN

* The integer in D0 is too long to fit into a register, but the
* remainder can be calculated in registers. (See ZQUO for comparison)
		
zremlong	A=A-CON	A,7		A[A]=nibbles-1
		CD0EX
		C=C+A	A
		CD0EX
		D0=D0-	17-7		->Z1 high 16 nibbles
		C=A	A
		D=C	A		D[A]=nibbles-1
		D=D-CON	A,16		D[A]=nibbles to go
		A=DAT0	W		A[W]=quo1
		C=B	W		C[W]=z2
		GOSUBL	BDIV		B[W]=rem1	C[W]=z2
		A=B	W		A[W]=rem1
		

* Now loop to add the remaining nibbles into the result

zremlonglp	D0=D0-	1		->Z1[i]
		?A#0	S		Handle the bad case of a 64-bit rem
		GOYES	zrembad
		ASL	W
		A=DAT0	1
		?A<C	W
		GOYES	zremlongcont	Avoid BDIV if possible
		GOSUBL	BDIV
		A=B	W		A[W] = rem[i]
zremlongcont	D=D-1	A
		GONC	zremlonglp
		B=C	A		B[A]=Z2[A]
		D0=D0-	5		->Z1size
		C=DAT0	A
		AD0EX
		A=A+C	A		A[A]=->Z1tail
		AD0EX
		C=B	A		C[W]=Z2
		RTN
* Here we need the remainder of Z[17]/Z[16]
zrembad		B=A	S
		A=DAT0	S
		ABEX	S		B[S] = new low nibble
		P=	16-4		Loop 4 times
		
zrembadlp	A=A+A	W
		GOC	zremoverflow	Handle overflow
		B=B+B	S
		GONC	+
		A=A+1	A		New low bit
+		A=A-C	W		Take remainder
		GONC	+
		A=A+C	W		Fix back - was already valid
+		P=P+1
		GONC	zrembadlp
		GOC	zremlongcont

zremoverflow	B=B+B	S
		GONC	+
		A=A+1	A		New low bit
+		A=A-C	W		Always valid here
		P=P+1
		GONC	zrembadlp
		GOC	zremlongcont

ENDCODE
*****************************************************************************
NULLNAME ZDIVext
* z1, z2 -> z1 div z2, z1 mod z2
CODE
zdiv		GOSBVL	=SAVPTR

* Fetch arguments

		A=DAT1	A
		D1=D1+	5
		C=DAT1	A
		D0=C			->Q1
		D1=A			->Q2

* First test for division by 1
		A=DAT1	12
		C=A	W
		LCZ1
		?A#C	W
		GOYES	zremz

* NOTE: Code elsewhere assumes results are not trimmed.
*	Thus we must not check for the special case
*	of equal input

qrem1		GOSBVL	=GETPTR		Q1/1 = Q1, 0
		D1=D1+	5		Drop 1
		D=D+1	A
		GOSBVL	=SAVPTR
		A=0	W
		GOVLNG	=PUSHhxsLoop	Push Z0


* Here:	Q2 is not 1, and Q1<>Q2 [ point a verifier ]
*	D0 = ->Q1	D1 = ->Q2

**********************************************************************
* Calculate Z1/Z2 with remainder
* Special cases:	- Z known not to be 1
*			- Z1 <> Z2 known
**********************************************************************

zremz		D0=D0+	5
		A=DAT1	A		Z1size
		A=A+A	A		2xZ1size
		LC(5)	10+6+20		2xPrologs + link + safety
		C=C+A	A
		GOSBVL	=GETTEMP	D0 ->tempobj

		GOSBVL	=D1=DSKTOP
		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		AD0EX			D0 = ->Z1
		R0=A	A		R0[A] = ->output
		D1=C			D1 = ->Z2

		GOSUB	ZQUO		Divide into output

		C=R0	A		->Quotient
		C=C+CON	A,5		Skip prolog
		D0=C
		A=DAT0	A		QUOsize
		C=C+A	A
		D0=C			->Quotient tail
		A=A+CON	A,11		link = QUOzise+prolog+link+GCnib
		DAT0=A	A		write link
		D0=D0+	11		skip link+GCnib+remprolog

		C=C+CON	A,6
		R1=C			R1[A] = ->Remainder

		A=DAT0	A		REMsize
		CD0EX
		C=C+A	A		->Remainder tail
		CD0EX
		A=A+CON	A,11		link = QUOsize+prolog+link+GCnib
		DAT0=A	A		write link
		D0=D0+	5		skip link

		GOSBVL	=recover	shrink allocated memory

		GOSBVL	=GETPTR
		D1=D1+	5
		A=R0
		DAT1=A	A		stack level 2 = ->Quotient
		D1=D1-	5
		A=R1
		GOVLNG	=OverWrALoop	stack level 1 = ->Remainder


**********************************************************************
* Name:		ZQUO
*
* Desc:		Compute Z1/Z2 and Z1 mod Z2
*
* In:		D0	->Z1
*		D1	->Z2
*		R0[A]	->Output
*
* Out:		D0	->Z1tail
*		D1	->Z2tail
*		R0[A]	->Output
*		
*  		----------------------------------------
*               | Zquotient | xx 6nibs xx | Zremainder |
*  		----------------------------------------
*
*
* Requires:	Z2 must be trimmed (last nib of mantissa <> 0)
*		P=0	
*
* Alters:	A[W], B[W], C[W], D[W], R1, R2, R3, R4, SB
*
* Calls:	BDIV, SHORTOUT, BMULCRY, MOVEDOWN
*
* Stack Level:	3
*
**********************************************************************

ZQUO		D0=D0+	5
		D1=D1+	5
		A=DAT0	A		Z1size
		C=DAT1	A		Z2size
		?A<C	A
		GOYES	ZQUOis0		Z1len<Z2len -> Quo=0 Rem=Z1
		C=C-CON	A,7
		GONC	ZQUOnormal

* Quotient=0, Remainder=Z1

ZQUOis0		A=DAT1	A		Z2size
		C=R0
		CD1EX			D1 -> Output
		C=C+A	A		C[A] -> Z2tail
		RSTK=C			save it
		LCZ0
		DAT1=C	11		output 0
		D1=D1+	11
		D1=D1+	6		skip link space
		C=DAT0	A		Z2size
		C=C+CON	A,5
		D0=D0-	5
		GOSBVL	=MOVEDOWN	copy Z1 to output; D0 -> Z1tail
		C=RSTK			
		D1=C			D1 ->Z2tail
		RTNCC

* Not a special case

ZQUOnormal	

* First check whether calc can be done in register

		A=DAT0	A		
		A=A-CON	A,7		A = Z1 mantissa len
		A=0	P
		?A=0	A		
		GOYES	ZQUOB		no longer than 16 nibs -> fast div
		GOTO	ZQUOX		

* Z1 (and thus Z2 since Z1len >= Z2len) is no longer than 16 nibs 
* Do fast division in register

ZQUOB

* Pop the integers

		GOSUBL	toshortpopd1
		B=A	W
		D=C	S		D[S] = sign2
		GOSUBL	toshortpop	A[W] = Z1
		CBEX	W		C[W] = Z2	B[S] = sign1

* Divide A[W]B[S] / C[W]D[S] --> A[W]=quo B[W]=rem D[S]=sign

		GOSUBL	SHORT/
		C=D	S		C[S] = sign
		
* output quotient and remainder

		C=R0.F	A
		CD1EX			D1 ->Output
		RSTK=C			save ->Z2tail
		GOSUBL 	toSHORTOUT	output quotient 
		D1=D1+	6		skip link space
		A=B	W
		D0=D0-	1
		C=DAT0	S		sign(rem) = sign(Z1)
		D0=D0+	1
		GOSUBL	toSHORTOUT	output remainder
		C=RSTK
		D1=C			D1 ->Z2tail
		RTNCC

* Must do div in memory - check first if the divisor is short

ZQUOX		A=DAT1	A		Z2size
		A=A-CON	A,15		Z2 mantissa <= 8 nibs ?
		GOC	ZQUOS		yes -> short division
		GOTO	ZQUOL		no  -> long division

* Divisor is no longer than 8nibs 
* use short division, with 8nibs blocks (b=2^32)

ZQUOS

* Get divisor (Z2) in B[W] 

		GOSUBL	toshortpopd1
		B=A	W		B[W] = Z2 mantissa
		D=C	S		D[S] = Z2sign

* Special entry to do division with a short divisor
* In:		D0	->Z1size
*		B[W]	divisor
*		D[S]	divisor sign
*		R0[A]	->Output
* Out:		D0	->Z1tail
*		B[W]	remainder
*		D[S]	divisor sign
*		R0[A]	->Output
* Alters:	

ZQUOint		C=R0
		CD1EX			D1 ->Output
		RSTK=C			save ->Z2tail

* Copy Z1 (including prolog but excluding sign) to output

		C=DAT0	A
		D=C	A		D[A]=Z2size
		C=C+CON	A,4		size incl. prolog but not sign
		D0=D0-	5
		GOSBVL	=MOVEDOWN	copy Z1 to output; D0 ->Z1sign
		C=0	W
		DAT1=C	W		pad with 0's to fill last block

* Compute size and # of blocks (n) :
* 
*	m = #nibs of Z2 mantissa = Z2size-6
*	n = #blocks = m+7 DIV 8
*	d = #zero nibs to fill last block = n*8-m = 7-(m+7 MOD 8)
*
		D=D+1	A		D[A]=m+7
		C=D	A
		LA(5)	7
		C=C&A	A		C[A]=m+7 MOD 8 
		A=A-C	A		A[A]=d
		CD1EX
		C=C+A	A
		CD1EX			D1 ->past last block of result
		DSRB.F	A
		DSRB.F	A
		DSRB.F	A		
		D=D-1	A		D[A]=n-1

* Init division

		C=B	W		C[W]=divisor
		B=0	W		initial r=0

* Compute quotient block by block

ZQUOSlp1	A=B	W		A[W]=r
		ASL	W
		ASL	W
		ASL	W
		ASL	W
		ASL	W
		ASL	W
		ASL	W
		ASL	W		A[W]=b*r
		D1=D1-	8		->next block
		A=DAT1	8		A[W]=b*r+Ui
		GOSUBL	BDIV		Division A[W]/C[W] -> A[W]=Qi B[W]=r
		DAT1=A	8		Write quotient block
		D=D-1	A		More blocks ?
		GONC	ZQUOSlp1	yes -> repeat

* Now D1 ->Quotient and B[W]=final remainder
* Trim quotient
		
		D1=D1-	5
		A=DAT1	A		A[A]=Z1size (incl. sign)
		CD1EX
		RSTK=C			save ->QUOsize
		C=C+A	A
		C=C-1	A
		CD1EX			D1 ->QUO(untrimmed)-tail
ZQUOStlp	D1=D1-	1
		C=DAT1	S
		?C#0	S
		GOYES	ZQUOStdn
		A=A-1	A
		GONC	ZQUOStlp
ZQUOStdn	C=RSTK			recover ->QUOsize
		CD1EX
		DAT1=A	A		write adjusted QUOsize
		CD1EX
		D1=D1+	1		D1 ->QUOsign

* Compute and write quotient sign

		C=DAT0	S
		CDEX	S		D[S]=sign(Z1)=sign(rem)  C[S]=sign(Z2)
		D0=D0+	1		D0 ->Z1tail
		C=C+D	S
		GONC	ZQUOSs
		C=0	S
ZQUOSs		DAT1=C	S		write quotient sign
		D1=D1+	1+6		skip sign + link space

* Output remainder

		A=B	W		A[W]=remainder
		C=D	S		C[S]=remainder sign
		GOSUBL	toSHORTOUT	trim and write remainder
		C=RSTK	
		D1=C			D1 ->Z2tail
		RTNCC

* Dividend has more than 16nibs and divisor has more than 8nibs
* Do long division. 
*
* Use Knuth's algo with 8nibs blocks (b=2^32):
*
*   Z1 mantissa = Um Um-1 .. U3 U2 U1 | U0
*   Z2 mantissa = Vn Vn-1 .. V2 V1
*   Q  mantissa = Qm-n .. Q1 Q0
*
*   compute Qj-guess = min( b-1 , Uj'Uj+1' DIV V1' )     
*
*   where V1'        = normalised V1 so that b>V1'>=b/2
*		     = leading block of 2^(4e+f)(V1 V2) 
*         Ui'Ui'-1   = leading two blocks of 2^(4e+f)(Uj Uj+1 Uj+2)
*
*   Always have:  Qj-guess - 2 =< Qj-true =< Qj-guess 
*
* Scratch registers:
*
*   R0[A]  ->Output = base quotient - 10
*   R1[A]  = length (nibs) of Z2 mantissa
*   R1[S]  = f (0 =< f =< 3)
*   R2[A]  = #nibs left to calc in quotient; start with 8(m-n).
*   R2[S]  = sign Z1
*   R3[W]  = current Qi
*   R4[W]  = V1' 

ZQUOL		

* Get sizes and prepare quotient in output

		A=DAT1	A		Z2size
		D1=D1+	5		->Z2mantissa
		B=A	A
		B=B+1	A		B[A]=#nibs in Z2 mantissa + 7
		A=A-CON	A,6
		R1=A			R1[A]=length (nibs) of Z2 mantissa
		C=R0
		CD1EX			D1 ->Output
		RSTK=C			save ->Z2mantissa
		LC(5)	=DOHSTR
		DAT1=C	A		write quotient prolog
		D1=D1+	5
		C=DAT0	A		Z1size
		C=C+1	A		C[A]=#nibs in Z1 mantissa + 7
		LAHEX	FFFF8		A[A]=mask 3 LS bits
		C=C&A	A		C[A]=8*m
		A=A&B	A		A[A]=8*n
		C=C-A	A
		R2=C			R2[A]=8(m-n)
		C=C+CON	A,14		length quo = 8(m-n+1)+sign+5
		DAT1=C	A		write length quotient
		AD1EX
		A=A+C	A		skip quotient space
		A=A+CON	A,6		skip link space
		B=A	A		B[A] ->OutputRem
		AD1EX			D1   ->OutputRem

* Copy Z1 (incl. prolog but not sign) to output

		C=DAT0	A		Z1size
		C=C+CON	A,4		size incl. prolog but not sign
		D0=D0-	5
		GOSBVL	=MOVEDOWN	copy Z1 to output; D0 ->Z1sign
		C=0	W
		DAT1=C	W		pad with zeros

* Get Z1sign and slider start position

		A=R2			A[A]=8(n-m)
		A=DAT0	S		Z1sign
		D0=D0+	1		D0 ->Z1tail
		R2=A			R2[S]=sign Z1
		B=B+CON	A,10		B[A] ->Um
		A=A+B	A		A[A] ->(Um+(m-n))=->Un
		AD0EX			D0 ->Un = slider start pos
		C=RSTK
		CAEX	A		A[A] ->Z2mantissa
		RSTK=C			save ->Z1tail
		
* Compute V1'
		C=R1			
		A=A+C	A
		D1=A			D1 ->Z2sign
		D1=D1-	9
		C=DAT1	S		C[S]=4 MSBits of 2nd block 2^4e(V1V2)
		D1=D1+	1
		A=DAT1	8		A[1..7] = 1st block of 2^4e(V1V2)
		D1=D1+	8		D1 ->Z2sign
		D=0	S		D[S]=f counter
		P=	7
ZQUOLln1	B=A	WP		B[1..7] = 1st block of 2^(4e+f)(V1V2)
		A=A+A	WP		is B[1..7]>=b/2 ?
		GOC	ZQUOLn1dn	yes -> normalization done
		D=D+1	S		no  -> increment f
		C=C+C	S		       and shift V1V2 left 1bit	
		GONC	ZQUOLln1
		A=A+1	WP
		GONC	ZQUOLln1
ZQUOLn1dn	A=0	W
		A=B	WP
		P=	0
		R4=A			R4[W]=V1'
		C=D	S
		R1=C.F	S		R1[S]=f

* Loop on quotient block Qj
*
* At this point:  D0 ->slider = ->Ui	(i=j+n)
*		  D1 ->Z2sign 

ZQUOLljbeg	

* First compute Uj'Uj+1 = leading two blocks of 2^(4e+f)(Uj Uj+1 Uj+2)

		A=R1			A[A]=length Z2 mantissa
		C=A	S		
		D=C	S		D[S]=f
		CD0EX
		RSTK=C			save ->slider
		C=C+A	A
		D0=C
		D0=D0-	9
		C=DAT0	S		4 MSBits of 3rd blk of 2^4e(Uj..Uj+2)
		D0=D0+	1
		A=DAT0	W		First 2blks of 2^4e(Uj..Uj+2)
		C=RSTK
		D0=C			D0 ->slider

* Shift 2^4e(Uj..Uj+2) left f bits to get Uj'Uj+1'

ZQUOLln2	D=D-1	S		
		GOC 	ZQUOLn2dn
		A=A+A	W
		C=C+C	S
		GONC 	ZQUOLln2
		A=A+1	W
		GONC 	ZQUOLln2

* Now A[W]=Uj'Uj+1' - compute Qj-guess = min( b-1 , Uj'Uj+1' DIV V1' )

ZQUOLn2dn	C=R4			C[W]=V1'
		GOSUBL	BDIV		A[W]=Uj'Uj+1' DIV V1'
		C=0	W
		LCHEX	FFFFFFFF	C[W]=b-1
		?A<C	W
		GOYES	ZQUOLguess
		A=C	W
ZQUOLguess	R3=A			R3[W]=Qj-guess

* save ->slider = ->Uj+n

		CD0EX
		RSTK=C			save ->slider 
		CD0EX			D0 ->Uj+n

* if Qj=0 skip rest of current iteration

		?A#0	W
		GOYES   ZQUOLlm0
		GOTO	ZQUOLljnxt

* Compute [Uj .. Uj+n] - Qj-guess * [0 V1 .. Vn]

ZQUOLlm0	C=R1			
		D=C	A		D[A]=#nibs Z2 mantissa
		AD1EX
		A=A-C	A
		AD1EX			D1 ->Z2mantissa
		D=0	S		D[S]    = borrow from substraction
		B=0	W		B[7-15] = carry from multiplication
		P=	7
ZQUOLlm1	D=D-CON	A,8		Try using 8nibs from Z2
		GONC	ZQUOLlm2	
		C=D	B		Not that much left
		C=C+CON B,7		Use what's left
		P=C	0		
		D=0	A
ZQUOLlm2	A=0	W
		A=DAT1	WP		A=Vk (block k of Z2)
		CD1EX
		C+P+1
		CD1EX			D1 -> next block of Z2
		C=R3
		BCEX	W		B[W]=Qj  C[8-15]=carry
		GOSUBL	toBMULCRY		A[W]=Vk*Qj + carry
		B=A	W		B[8-15]=new carry
		?D#0	A		last block of Z2 ?
		GOYES	ZQUOLlm3	no  -> do single block Uj+k
		P=	15		yes -> do last two blocks Uj Uj+1
ZQUOLlm3	C=DAT0	WP		get block(s) of U 
		?D=0	S		borrow from previous block ?
		GOYES	ZQUOLlm4
		C=C-1	WP		yes -> substract it
		GOC	ZQUOLlm4	new borrow ?
		D=0	S		no -> clear borrow
ZQUOLlm4	C=C-A	WP		substract Vk*Qj (mod b)
		GONC	ZQUOLlm5	borrow ?
		D=D+1	S		yes -> set borrow
ZQUOLlm5	DAT0=C	WP		write block(s) of U
		D0=D0+	8		D0 ->next block
		?D#0	A		more blocks in Z2
		GOYES	ZQUOLlm1	yes -> repeat
		P=	0
		?D#0	S		is there a final borrow ?
		GOYES	ZQUOLadj	yes -> Qj-guess was too big, adjust
		GOTO	ZQUOLljnxt	no -> Qj-guess was good, continue
		
* Current Qj is too big. Adjust it and add back

ZQUOLadj	A=R3			Qj <- Qj-1
		A=A-1	W
		R3=A			
		
* Add [0 V1 .. Vn] back to [Uj .. Uj+n]

		C=RSTK
		RSTK=C
		D0=C			D0 ->slider
		C=R1			
		D=C	A		D[A]=#nibs Z2 mantissa
		AD1EX
		A=A-C	A
		AD1EX			D1 ->Z2mantissa
		D=0	S		D[S] = carry
		P=	7
ZQUOLla1	D=D-CON	A,8		Try using 8nibs from Z2
		GONC	ZQUOLla2	
		C=D	B		Not that much left
		C=C+CON B,7		Use what's left
		P=C	0		
		D=0	A
ZQUOLla2	A=0	W
		A=DAT1	WP		A=Vk (block k of Z2)
		CD1EX
		C+P+1
		CD1EX			D1 -> next block of Z2
		?D#0	A		last block of Z2 ?
		GOYES	ZQUOLla3	no  -> do single block Uj+k
		P=	15		yes -> do last two blocks Uj Uj+1
ZQUOLla3	C=DAT0	WP		get block(s) of U 
		?D=0	S		carry from previous block ?
		GOYES	ZQUOLla4
		C=C+1	WP		yes -> add it 
		GOC	ZQUOLla4	new carry ?
		D=0	S		no -> clear carry
ZQUOLla4	C=C+A	WP		add Vk
		GONC	ZQUOLla5	carry ?
		D=D+1	S		yes -> set carry
ZQUOLla5	DAT0=C	WP		write block(s) of U
		D0=D0+	8		D0 ->next block
		?D#0	A		more blocks in Z2
		GOYES	ZQUOLla1	yes -> repeat
		P=	0
		?D=0	S		is there a final carry ?
		GOYES	ZQUOLadj	no -> Qj still 1 too big, repeat	

* Current Qj is ok and so is Uj..Uj+n and D1 ->Z2sign
* Write quotient block Qj - increment j - and repeat if j<=m-n

ZQUOLljnxt	C=R0
		C=C+CON	A,10		C[A] ->Quotient start (->Qm-n)
		A=R2			A[A] = #nibs left to calc in quotient
		C=C+A	A
		D0=C			D0 ->Qj location
		C=R3
		DAT0=C	8		write Qj
		C=RSTK
		D0=C			D0 ->old slider position (->Uj+n)
		A=A-CON	A,8		more quotient blocks ?
		GOC	ZQUOLljdone	no -> done with main loop
		R2=A			R2[A] = remaining #nibs in quotient
		D0=D0-	8		D0 ->new slider start
		GOTO	ZQUOLljbeg	repeat

* Main loop done. At this point:
*
*	D0 	  ->Remainder mantissa
*	D1        ->Z2sign
*	top[RTSK] ->Z1tail  
*	A[S]      = Z1sign

ZQUOLljdone

* Compute signs

		B=A	S		B[S] = sign Z1 = sign remainder
		C=DAT1	S		Z2sign
		D1=D1+	1		D1 ->Z2tail
		C=C+B	S
		GONC	ZQUOLs
		C=0	S
ZQUOLs		D=C	S		D[S] = sign quotient
		
* Trim remainder "in place" and set its sign

		A=R1			A[A] = Z2len >= length remainder
		CD0EX
		D0=C
		D0=D0-	5		D0 -> remainder size
		C=C+A	A
		CD1EX			D1 -> remainder tail
		RSTK=C			save ->Z2tail
ZQUOLtrlp	A=A-1	A		
		GOC	ZQUOLtrdn	remainder=0 -> no sign to set
		D1=D1-	1
		C=DAT1	S
		?C=0	S
		GOYES	ZQUOLtrlp
		D1=D1+	1
		C=B	S
		DAT1=C	S		write remainder sign
ZQUOLtrdn	A=A+CON	A,7		remainder size
		DAT0=A	A		write remainder size
		B=A	A		B[A] = remainder size

* Trim quotient and set its sign

		C=R0
		C=C+CON	A,5
		D=C	A		D[A] -> quotient size
		D1=C
		C=DAT1	A		quotient size
		A=C	A
		A=A-CON	A,6		A[A] = length quotient mantissa
		C=C+D	A		-> quotient tail (after sign)
		C=C-1	A		
		D1=C			D1 ->quotient mantissa tail
ZQUOLtqlp	A=A-1	A		
		GOC	ZQUOLtqdn	quotient=0 -> no sign to set
		D1=D1-	1
		C=DAT1	S
		?C=0	S
		GOYES	ZQUOLtqlp
		D1=D1+	1
		C=D	S
		DAT1=C	S		write quotient sign
ZQUOLtqdn	A=A+CON	A,7		quotient size
		C=D	A
		CD1EX
		DAT1=A	A		write quotient size
		CD1EX			D1 ->quotient sign
		
* Move remainder down, after trimmed quotient

		D1=D1+	7		skip quo sign + link space
		D0=D0-	5		D0 ->remainder prolog
		C=B	A
		C=C+CON	A,5		C[A]=rem size (incl. prolog)
		GOSBVL	=MOVEDOWN	move remainder down

* restore D1 and D0

		C=RSTK
		D1=C			D1 ->Z2tail
		C=RSTK
		D0=C			D0 ->Z1tail
		RTNCC


**********************************************************************
* Desc:		Divide small integers with overflow checks (never!)
* Entry:	A[W] B[S] = signed dividend
*		C[W] D[S] = signed divisor
* Output:	A[W] = quotient
*		B[W] = remainder
*		C[W] = divisor
*		D[S] = quotient sign	!!! differs from the rest !!!
*		CS if division by zero
* Modifies:	A[W] B[W] D[S]
* Stack:	1 (D[A] save)
**********************************************************************

SHORT/		CDEX	S		Calculate quotient sign
		C=C+B	S
		GONC	+
		C=0	S
+		CDEX	S		D[S] = quotient sign

* Special unsigned division entry.

BDIV		B=A	W		B[W] = dividend
		A=C	W		C[W] = divisor
		?C=0	W
		RTNYES			CS: Division by zero
		CDEX	A		Save D[A]
		RSTK=C
		CDEX	A
		D=0	B		D[B]=#bits of quotient
bdivloop1	?A>B	W		Align divisor
		GOYES	+
		D=D+1	B		bits++
		C=A	W
		A=A+A	W
		GONC	bdivloop1
+		A=0	W		A[W]=quotient
		D=D-1	B
		GOC	bdivdone
bdivloop2	?C>B	W
		GOYES	+
		B=B-C	W
		A=A+1	B
+		D=D-1	B
		GOC	bdivdone
		CSRB
		A=A+A	W
		GONC	bdivloop2
bdivdone	CDEX	A		Restore D[A]
		C=RSTK
		CDEX	A
		RTNCC			CC: Not division by zero



**********************************************************************
* Desc:		Fast equality test for objects
* Entry:	D0 = ->ob1
*		D1 = ->ob2
* Exit:		D0/D1 unchanged
*		CC: Equal
*		CS: Not equal
* Modifies:	A[W] C[W] B[A] D[A] ST[1]
* Stack:	3 (SKIPOB call)
**********************************************************************

EQUAL?

* First try to resolve the matter quickly by comparing addresses

		AD0EX
		D0=A
		CD1EX
		D1=C
		?A#C	A
		GOYES	+
		RTNCC			CC: Equal address

* Then by comparing first 7 nibbles (DOCHAR size)

+		A=DAT0	7
		C=A	W		Avoid WP test this way
		C=DAT1	7
		?A#C	W
		RTNYES			CS: First 10 nibbles different

* Then compare sizes

		AD0EX
		B=A	A		->ob1
		D0=A
		GOSBVL	=SKIPOB
		CD0EX
		C=C-B	A		size1
		CBEX	A		B[A]=size1
		CD1EX
		D0=C			->ob2
		D=C	A		->ob2
		GOSBVL	=SKIPOB
		AD0EX			->ob2 tail
		C=D	A		->ob2
		A=A-C	A		size2
		CD1EX			->ob2
		D0=C			->ob1
		?A#B	A
		RTNYES			CS: Different size

* Finally compare the equal length bodies

		CD0EX			Save start addresses
		RSTK=C			->ob1
		D0=C
		CD1EX
		RSTK=C			->ob2
		D1=C

		C=B	A		nibbles
		BSR	A		words
		P=C	0		nibbles&15

equalWloop	A=DAT0	W
		C=DAT1	W
		B=B-1	A		Compare words
		GOC	equalWP?
		D0=D0+	16
		D1=D1+	16
		?A=C	W
		GOYES	equalWloop
equalnot	P=	0		Restore regs and return CS
		C=RSTK
		D1=C
		C=RSTK
		D0=C
		RTNSC
equalWP?	P=P-1
		GOC	isequal		we had even words - test done
		?A#C	WP
		GOYES	equalnot
isequal		P=	0		restore regs and return CC
		C=RSTK
		D1=C
		C=RSTK
		D0=C
		RTNCC
	
ENDCODE
***************************************************************

******************************************************************************
NULLNAME RMULText
*:: SHALT
CODE
rmult		GOSUBL	rsubrcl
		LCZ0
		P=	10
		?A#C	WP
		GOYES	rmult1
* stk1 = 0 -> P=0, SWAPDROP sauf si stk2=? ou +/-infini
		P=	0
		A=R2
		LC(5)	=DOROMP
		?A=C	A
		GOYES	tox*ext
		C=A	W
		LC(N)	10
		CON(5)	=DOSYMB
		CON(5)	=DOROMP
		?A#C	W
		GOYES	pswapdroploop
tox*ext		A=PC
		LC(5)	(x*ext!)-(*)
		GOTO	mfin
pswapdroploop	P=	0
		LA(5)	=SWAPDROP
		PC=(A)
rmult1		A=R2
		?A#C	WP
		GOYES	rmult2
* stk2=0 -> P=0, DROP sauf si stk1=? ou infini
		P=	0
		A=R1
		LC(5)	=DOROMP
		?A=C	A
		GOYES	tox*ext
		C=A	W
		LC(N)	10
		CON(5)	=DOSYMB
		CON(5)	=DOROMP
		?A=C	W
		GOYES	tox*ext
topdroploop	GOLONG	pdroploop
rmult2		P=	0
		LCZ1
		P=	11
		?A=C	WP
		GOYES	pswapdroploop	stk2=1 -> P=0, swapdrop, loop
		A=R1
		?A=C	WP
		GOYES	topdroploop	stk1=1 -> P=0, drop, loop
		C=C-1	P		C=-1 (HXS)
		?A#C	WP
		GOYES	rmult3
		P=	0
		D=D+1	A
		D1=D1+	5
		GOLONG	rneg
rmult3		A=R2
		?A#C	WP
		GOYES	rmult4
		P=	0
		GOSUBL	swapdropml
		GOLONG	rneg
rmult4		P=	0
* test si stk2 et stk1 admissibles, sinon test types
		GOSBVL	=SAVPTR
		ST=1	sALG48
		D1=D1+	5
		A=DAT1	A		->Q1
		D0=A
		GOSUBL	QSKIP
		?ST=0	sALG48
		GOYES	mobj1invalide
		D1=D1-	5
		A=DAT1	A		->Q2
		D0=A
		GOSUBL	QSKIP
mobj1invalide	GOSBVL	=GETPTR
		?ST=0	sALG48
		GOYES	mdispatch
*mobjtest	A=PC				test
*		LC(5)	(doslow!)-(*)		test
*		GOTO	mfin			test
todoslow*	ST=0	sGARB		Flag garbage collection not done
		ST=0	sTRIM
		ST=0	sQSWAP
		ST=0	sQSWAP*
		ST=0	sQMULREG
		ST=0	sQSUB
		GOLONG	doslow*

* on teste si stk2 ou stk1 est un seco (irrquad) puis un symb (fraction)
mdispatch	P=	0
		LCIRRQ
		P=	9
		A=R1.F	WP
		?C=A	WP
		GOYES	m?seco
		A=R2.F	WP
		?C#A	WP
		GOYES	mnotseco
		P=	0
msecoany	A=PC
		LC(5)	(multqany!)-(*)
		GOTO	mfin
m?seco		A=R2.F	WP
		?C=A	WP
		GOYES	mseco
manyseco	P=	0
		GOSUBL	swapml
		GOTO	msecoany
mseco		P=	0
		GOSUBL	testquad
		GOC	msecon
		A=PC
		LC(5)	(qmultequal!)-(*)
		GOTO	mfin
msecon		A=PC
		LC(5)	(qmultext!)-(*)
		GOTO	mfin
mnotseco	P=	0
		LC(5)	=DOSYMB
		?C=A	A		A=stk2
		GOYES	msymb
		A=R1	A
		?C#A	A
		GOYES	mtlist
msymb		A=PC
		LC(5)	(rrmult!)-(*)
		GOTO	mfin
mtlist		LC(5)	=DOLIST
		?C#A	A	
		GOYES	mobj
* stk1 est une liste, ?stk2
mobj10		A=R2	A
		?C#A	A
		GOYES	mobjlist
mlistlist	A=PC
		LC(5)	(mobjlist!)-(*)
		GOTO	mfin
mobjlist	GOSUBL	swapml
		GOTO	mlistobj
mobj		A=R2
		?C#A	A
		GOYES	mobjobj
mlistobj	A=PC
		LC(5)	(mlstobj!)-(*)
		GOTO	mfin
mobjobj		A=PC
		LC(5)	(rmultext!)-(*)
mfin		A=A+C	A
		PC=(A)
swapml		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		DAT1=C	A
		D1=D1-	5
		DAT1=A	A
		RTN
unrotml		A=DAT1	A
		D1=D1+	5
		C=DAT1	10
		D1=D1+	5
		DAT1=A	A
		D1=D1-	10
		DAT1=C	10
		RTN
raddrcl		C=DAT1	A	( adresse sommet de la pile )
		CD1EX		( mise dans D1 )
		A=DAT1	W	( A= prologue etendu du 1er objet )
		R0=A	W	( RO sauvegarde prologue stk1 )
		D1=C		( restaure D1 )
		D1=D1+	5
		A=DAT1	A	( meme chose mais avec niveau 2 )
		D1=A
		A=DAT1	W
		R1=A	W	( R1=prol. etendu stk2 )
		D1=C
		RTN
ENDCODE
*;

*LABEL doslow! ( test )
*::
*SHALT
*CODE
*		GOSBVL	=SAVPTR
*		ST=0	sGARB		Flag garbage collection not done
*		GOTO	todoslow*
*ENDCODE
*;

LABEL rrmult!
::
CODE
	GOLONG	fxnd
ENDCODE
ROT 
CODE
	GOLONG	fxnd
ENDCODE
( n2, d2, n1, d1 )
ROT 
CODE
	GOTO	rmult
ENDCODE
( n2, n1, d1*d2 )
UNROTSWAP
( d1*d2, n1, n2 )
CODE
		GOSUBL	rsubrcl
		A=R1.F	A
		LC(5)	=DOSYMB
		?A=C	A
		GOYES	rrmult1
		A=R2.F	A
		?A=C	A
		GOYES	rrmult2
		GOTO	rmult		non symb + non symb
rrmult1		A=R2.F	A
		LC(5)	=DOLIST
		?A=C	A
		GOYES	rrmult11	list+symb
rrmult10	GOTO	mobjobj		obj+symb/symb+symb/symb+obj
rrmult11	GOTO	mlistobj
rrmult2		A=R1.F	A
		LC(5)	=DOLIST
		?A#C	A
		GOYES	rrmult10	symb+obj
		GOTO	mobjlist		symb+list
ENDCODE
CODE
	GOSUBL	swapml
	GOLONG	simpndxf
ENDCODE
;


LABEL multqany!
::
SWAPINCOMP
( a', <<, a, b, c, >>, #5 )
7PICK 6ROLL
CODE
	GOLONG	rmult
ENDCODE
5UNROLL
( a', <<, a, b, c, >>, #5 )
7ROLL 5ROLL
CODE
	GOLONG	rmult
ENDCODE
4UNROLL ::N
;

LABEL qmultequal!
::
INNERCOMP 3DROP
( q, <<, a1, b1 )
4ROLL INNERCOMP 2DROP 4ROLLDROP
( <<, a1, b1, a2, b2, c )
5UNROLL
4PICKOVER 
CODE
	GOLONG	rmult
ENDCODE
( <<, c, a1, b1, a2, b2, a1*b2 )
2OVER 
CODE
	GOLONG	rmult
ENDCODE
CODE
	GOLONG	radd
ENDCODE 
5UNROLL
( <<, c, a1*b2+a2*b1, a1, b1, a2, b2 )
ROT 
CODE
	GOLONG	rmult
ENDCODE
5PICK 
CODE
	GOLONG	rmult
ENDCODE
UNROT
( <<, c, a1*b2+a2*b1, b1*b2*c, a1, a2 )
CODE
	GOLONG	rmult
ENDCODE
CODE
	GOLONG	radd
ENDCODE	
( <<, c, a1*b2+a2*b1, b1*b2*c+a1*a2 )
SWAP
( <<, c, b1*b2*c+a1*a2, a1*b2+a2*b1 )
HXS 1 0 EQUALcasedro UNROT2DROP
ROT ' x>> FIVE ::N
;


LABEL qmultext!
* pour des irraquads. Il faudra rajouter le test pgcd[c1,c2]<>0 
::
PREPARext
( a1, b1, c1, a2, b2, c2 )
:: HXS 2 10
   EQUALcasedro :: 
	CODE
	GOLONG	radd
	ENDCODE
                   ( a1, b1, c1, a2+b2 )
                   4ROLLOVER 
	CODE
	GOLONG	rmult
	ENDCODE
                   ( b1, c1, a2+b2, a1*[a2+b2] )
                   4UNROLLROT 
	CODE
	GOLONG	rmult
	ENDCODE	
		   SWAP
                   ;
   4ROLL HXS 2 10
   EQUALcasedro :: ( a1, b1, a2, b2, c2 )
                   5UNROLL 2SWAP 
	CODE
	GOLONG	radd
	ENDCODE
                   ( c2,  a2, b2, a1+b1 )
                   DUPROT 
	CODE
	GOLONG	rmult
	ENDCODE
			UNROT 
	CODE
	GOLONG	rmult
	ENDCODE
                   ( c2,  b2*[a1+b1], a2*[a1+b1] )
                   UNROTSWAP
                   ;
   ( a1, b1, a2, b2, c2, c1 )
* test c1=c2 enleve, deja fait!
   COMPext
   ( a1, b1, a2, b2, c2, c1, c2<c1? )
   ITE 4ROLL 
       :: SWAP 5ROLL UNROT 6ROLL          
          ( a2, b2, b1, c1, c2, a1 )
          ;
   ( a1, b1, b2, c2, c1, a2 )
   DUP 7PICK 
   ( a1, b1, b2, c2, c1, a2, a2, a1 )
CODE
	GOLONG	rmult
ENDCODE 
	UNROT
   ( a1, b1, b2, c2, a1*a2, c1, a2 )
   6PICK 
CODE
	GOLONG	rmult
ENDCODE SWAPDUP 8UNROLL
   ( c1, a1, b1, b2, c2, a1*a2, b1*a2, c1 )
   HXS 1 0 UNROT 
CODE
	GOLONG	ndxq
ENDCODE
CODE
	GOLONG	radd
ENDCODE
6UNROLL
   ( a1*a2+b1*a2sqrt[c1], c1, a1, b1, b2, c2 )
   SWAPDUP
   ( a1*a2+b1*a2sqrt[c1], c1, a1, b1, c2, b2, b2 )
   5ROLL 
CODE
	GOLONG	rmult
ENDCODE
   ( a1*a2+b1*a2sqrt[c1], c1, b1, c2, b2, a1*b2 )
   4UNROLLROT 
CODE
	GOLONG	rmult
ENDCODE
   ( a1*a2+b1*a2sqrt[c1], c1, a1*b2, c2, b1*b2 )
   ROTSWAP 4ROLL 
   ( a1*a2+b1*a2sqrt[c1], c2, a1*b2, b1*b2, c1 )
   HXS 1 0 HXS 2 10 ROT 
CODE
	GOLONG	ndxq
ENDCODE
CODE
	GOLONG	rmult
ENDCODE
CODE
	GOLONG	radd
ENDCODE
SWAP
   ( a1*a2+b1*a2sqrt[c1], a1*b2+b1*b2*sqrt[c1], c2 )
   ;
CODE
	GOLONG	ndxq
ENDCODE
;

LABEL rmultext!
::	CK&DISPATCH1
	# 3F3F	%%*
	# 4F4F	C%%C*C
	# 3F4F	C%%R*C
	# 4F3F	C%%C*R
	# 1F1F #*
	2REAL	%*
	realcmp C%R*C
	cmpreal C%C*R
	cmpcmp	C%C*C
	# 1F1 :: COERCE #* ;
	# 3F1 :: %>%% %%* ;
	# 3FB	:: CODE
	GOLONG	z2r
	ENDCODE %>%% %%* 
		;
	# 3F8	:: CODE
	GOLONG	zz2c%%
	ENDCODE C%%R*C 
		;
	# 4FB	:: CODE
	GOLONG	z2r
	ENDCODE %>%% C%%C*R 
		;
	# 4F8	:: CODE
	GOLONG	zz2c%%
	ENDCODE C%%C*C 
		;
	# 83F	CODE
swapmul	GOSUBL	swapml
	GOLONG	mobjobj
	ENDCODE
	# 84F	CODE
	GOTO	swapmul
	ENDCODE
	# B3F	CODE
	GOTO	swapmul
	ENDCODE
	# B4F	CODE
	GOTO	swapmul
	ENDCODE
	any 
		NULLNAME x*ext ( execute x* )
		LABEL x*ext!
		::
		num#1=case DROP
		SWAP num#1=case DROP
		2DUP symcomp INNERCOMP get1 symcomp INNERCOMP 
		( symb1, symb2, meta1, meta2 )
		get1 #+ 'x* SWAP#1+ SYMBN
		( symb1, symb2, symb )
		DUP' x? EQUALPOSCOMP #0<> case :: 3DROP ?ext ;
		( symb1, symb2, symb )
		SPECIALext 
		DUP#0=csedrp ::	( symb1, symb2, symb )
				UNROT
				( symb, symb1, symb2 )
				num#0=case UNROT2DROP
				SWAP num#0=case UNROT2DROP
				2DROP
				;
		( symb1, symb2, #arg1, #arg2 )
* si l'un des arg est 0 alors undef
		TWELVE EQUALcasedro :: 3DROP ?ext ;
		SWAP TWELVE EQUALcasedro :: 3DROP ?ext ;
		( symb1, symb2, arg2, arg1 )
		THREE EQUALcasedro 2DROP
		SWAP 
		( symb1, symb2, arg1, arg2 )
		THREE EQUALcasedro DROPSWAPDROP
		#+ TWO #/ DROP
		( symb1, symb2, # )
		UNROT2DROP 
		#0=case SYMBOL x\9F xNEGNEG ;
		SYMBOL x\9F xNEG ;
		;
	;

LABEL mlstobj!
( liste, objet non nul et non = a 1 -> liste*objet )
::
DUPEQ: %%0 case SWAPDROP
SWAP 
CODE
inner#1	A=DAT1	A
	CD1EX
	D1=A
	A=DAT1	A
	CD1EX
	LC(5)	=DOLIST
	?C#A	A
	GOYES	push#1
	LA(5)	=INNERCOMP
	PC=(A)
push#1	LA(5)	=ONE
	PC=(A)
ENDCODE
get1
CODE
metaobj		GOSUB	a=stkwc1
		P=	11
		?A#C	WP
		GOYES	metaobj!1
		P=	0
		GOTO	mobjlist!5	( DROP {}N )
metaobj!1	P=	0
		LCZ0
		P=	10
		?A#C	WP
		GOYES	metaobj1
		P=	0		( NDROP )
		A=DAT1	A		( sauvegarde de @ HXS 1 0 )
		R0=A	A
		D1=D1+	5
		D=D+1	A
		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	A
		CD1EX
		GOSUB	ndropml
		A=R0	A
		DAT1=A	A
		GOVLNG	=Loop
metaobj1	P=	0
		A=PC
		LC(5)	(metaobj!)-(*)
		GOLONG	mfin
ndropml		C=A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A
		CD1EX
		C=C+A	A
		CD1EX
		D=D+C	A
		RTN
a=stkwc1	C=DAT1	A
		CD1EX		( @D1=stk1 )
		A=DAT1	W
		CD1EX		( restaure D1 )
		LCZ1		( C=HXS 2 10 )
		RTN
ENDCODE
;

LABEL metaobj!
::	( b1, ..., bb, #b, OBJ -> list d'[OBJ* element] )
	OVER
	TOTEMPOB
	LABEL ml!
	( bb-1, ..., b0, #b, a, #j )
	CODE
* decremente j et decremente la memoire libre de 2* 5 quartets
	D=D-CON	A,2
	GONC	ml1
	GOSBVL	=GARBAGE1
ml1	C=D1
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A
	D1=C
	GONC	ml2
* fin de boucle
	D=D+CON	A,4
	D1=D1+	10
	A=D0
	LC(5)	(mlf!)-(mlm!)
	A=A+C	A
	D0=A
	LA(5)	={}N		
	PC=(A)
* rappel a et bj sur la pile
ml2	A=A+CON	A,3
	C=A	A
	GOSUB	cpick
	D1=D1+	10
	A=DAT1	A
	D1=D1-	15
	DAT1=A	A
	GOLONG	rmult
	ENDCODE
	( bb-1, ..., b0, #b, a, #j, bj*a )
	LABEL mlm!
	CODE
* replace bj*a a la place de bj
	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	A=A+CON	A,4	( A=j+3 )
	D1=C
	C=C+A	A
	A=A+A	A
	A=A+A	A
	C=C+A	A
	A=DAT1	A
	CD1EX
	DAT1=A	A
	CD1EX
* ajuste D0 pour retour en debut de boucle
	A=D0
	LC(5)	(mlf!)-(ml!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop	
	ENDCODE
	LABEL mlf!
	;

LABEL mobjlist!
::
( list, list ou objet, list  -> list*list )
		CODE
		goto inner#1
		ENDCODE
		( l2, m1 )
* teste si meta1 a 0 ou 1 elements, sinon execute get1
		CODE
		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	A
		CD1EX
		?A#0	A
		GOYES	mobjlist!1
		GOSUBL	semiml		( 0 elements -> DROP et SEMI )
		LA(5)	=DROP
		PC=(A)
mobjlist!1	A=A-1	A
		?A=0	A
		GOYES	mobjlist!2
		LA(5)	=get1
		PC=(A)
mobjlist!2	GOSUBL	semiml		( 1 element -> DROP et list/obj*obj )
		D=D+1	A
		D1=D1+	5
		GOLONG	mlistobj
		ENDCODE
( meta1, obj ou liste )
		CODE
		goto inner#1
		ENDCODE
( meta1, meta2 )
		CODE
		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	A
		CD1EX
		?A#0	A
		GOYES	mobjlist!3
		GOSUBL	semiml
mobjlist!5	D=D+1	A
		D1=D1+	5
		LA(5)	={}N
		PC=(A)
mobjlist!3	A=A-1	A
		?A=0	A
		GOYES	mobjlist!4
		LA(5)	=get1
		PC=(A)
mobjlist!4	GOSUBL	semiml	( 1 element ->  meta * obj )
		D=D+1	A
		D1=D1+	5
		GOTO	metaobj
		ENDCODE
( a_a-1, ..., a0, b_b-1, ..., b0, #b, #a )
* creation des ck
2DUP#+ HXS 1 0 SWAP#1- NDUPN
( a_a-1, ..., a0, b_b-1, ..., b0, #b, #a, HXS 1 0, ..., HXS 1 0, #a+b-1 )
get1 #1- TOTEMPOB
( a_a-1, ..., a0, b_b-1, ..., b0, #b, HXS 1 0, ..., HXS 1 0, #a+b-1, #i )
SWAP#1+ get1
( a_a-1, ..., a0, b_b-1, ..., b0, HXS 1 0, ..., HXS 1 0, #i, #a+b, #b )
ROTOVER TOTEMPOB
* calcul des indices: i varie de a-1 a 0 et j de b-1 a 0
* i est l'indice de boucle exterieur, j interieur
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j )
	LABEL mloopb!
	CODE
* decremente j
	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A
	D1=C
	GONC	loop2
* decremente i
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A
	D1=C
	GONC	loop1
	GOTO	loopf
* j=b-1
loop1	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	R0=A	A
	D1=C
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=R0
	DAT1=A	A
	D1=C
* rappel de c_i+j sur la pile
* ( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j )
loop2	D=D-CON	A,3
	GONC	loop5
	GOSBVL	=GARBAGE1	
loop5	RSTK=C
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=DAT1	A
	D1=C
	D1=D1+	5
	C=DAT1	A
	A=A+C	A   ( A=i+j )
	C=RSTK
	D1=C
	C=A	A
	C=C+CON	A,4
	GOSUB	cpick
* ( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c )
* rappel de a_i
	C=D1
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( R0=i )
	D1=C
	D1=D1+	15
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=R0	A
	A=A+C	A
	R0=A	A	( R0=i+b )
	C=D1
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=R0	A
	C=A+C	A	( A=i+a+b+b )
	C=C+CON	A,4
	GOSUB	cpick
* ( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c, a )
* rappel de b_i
	C=D1
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( R0=j )
	D1=C
	D1=D1+	15
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=R0	A
	C=A+C	A	( C=j+a+b )
	C=C+CON	A,5
	GOSUB	cpick
*	GOVLNG	=Loop
	GOLONG	rmult
* routine C pick
cpick	A=C	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	( A= 5*[i+j+4] )
	C=D1
	C=C+A	A
	CD1EX		( D1 pointe sur c_i+j, C sur le sommet de la pile )
	A=DAT1	A	( A= @c_i+j )
	CD1EX
	D1=D1-	5
	DAT1=A	A	( copie de c_i+j au sommet de la pile )
	RTN
* ajuste D0 pour sauter la boucle
loopf	A=D0
	LC(5)	(mloopf!)-(mloopm!)
	A=A+C	A
	D0=A
	GOVLNG	=Loop
	ENDCODE
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c, a*b )
	LABEL mloopm!
	CODE
	GOLONG	radd
	ENDCODE
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c+a*b )
	CODE
* on recopie c a sa place
	C=D1
	RSTK=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	D1=D1+	5
	C=DAT1	A
	D1=C
	D1=D1+	5
	C=DAT1	A
	A=A+C	A
	A=A+CON	A,5
	C=A	A
	C=C+C	A
	C=C+C	A
	A=A+C	A
	C=RSTK	( A=i+j )
	D1=C
	C=C+A	A
	A=DAT1	A
	CD1EX
	DAT1=A	A
	CD1EX
* modifie D0 pour revenir en debut de boucle
	A=D0
	LC(5)	(mloopf!)-(mloopb!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	LABEL mloopf!
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j )
	3DROP
	DUP#1-
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #a+b-1 )
	DUPUNROT #2+UNROLL {}N
	( a_a-1, ..., a0, b_b-1, ..., b0, #a+b, C )
	OVER#2+UNROL NDROP
	;

******************************************************************************
NULLNAME NEWTRIMext
CODE
newtrim		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOSYMB
		?A#C	A
		GOYES	newtrim+
		A=PC
		LC(5)	(newtrimsymb!)-(*)
		GOTO	newtrimbranch
newtrim+	LC(5)	=DOLIST
		?A=C	A
		GOYES	newtrimlist0
		LC(5)	=DOCOL
		?A=C	A
		GOYES	newtrimseco
		LC(5)	=DOECMP
		?A#C	A
		GOYES	newtrimlist1
		GOLONG	trimecmp
newtrimlist1	GOVLNG	=Loop
newtrimlist0	A=DAT1	A	( test si length=1 )
		AD0EX
		R0=A	A	( R0=sauvegarde de D0 )
		D0=D0+	5	( skip list prolog )
		GOSBVL	=SKIPOB
		C=DAT0	A
		A=R0	A	
		AD0EX		( restaure D0 )
		LA(5)	=SEMI
		?A#C	A
		GOYES	newtrimlist1
		A=PC
		LC(5)	(newtrimlist!)-(*)
newtrimbranch	A=A+C	A
		PC=(A)
newtrimseco	GOLONG	trimobj
ENDCODE

LABEL newtrimsymb!
::
DUPLENCOMP #1= NOT?SEMI
CARCOMP
CK&DISPATCH1
real	NOP
hxs	NOP
any	symcomp
;


LABEL newtrimlist!	
::
CARCOMP
CODE
	GOLONG	newtrim
ENDCODE
CODE
	GOLONG	returno1
ENDCODE
;
************************************
*LABEL QAdd/Sub!
*::
*SHALT
*CODE
*	ST=0	sQSUB
*	GOLONG	QAdd/Sub
*ENDCODE
*;
*********************************************************

NULLNAME RSUBext
*:: SHALT
CODE
rsub		ST=1	sQSUB
radd/sub	GOSUB	rsubrcl
		LCZ0
		P=	10
		?A#C	WP
		GOYES	rsub!1
* stk1 = 0 -> P=0, drop, loop
pdroploop	P=	0
		GOVLNG	=DropLoop
rsub!1		A=R2
		?A#C	WP
		GOYES	rsub!2
* stk2=0 -> SWAPDROP  [RNEG]
		P=	0
		GOSUB	swapdropml
		?ST=0	sQSUB
		GOYES	subloop
		GOLONG	rneg
subloop		GOVLNG	=Loop
* stk1 et stk2 !=0,  
rsub!2		P=	0
* test si stk2 et stk1 admissibles, sinon test types
QAdd/Sub	GOSUBL	AttnAbort?
		GOSBVL	=SAVPTR
		ST=1	sALG48
		D1=D1+	5
		A=DAT1	A		->Q1
		D0=A
		GOSUBL	QSKIP
		?ST=0	sALG48
		GOYES	+
		A=DAT1	A		-> Q1
		CD0EX
		C=C-A	A		Q1size
		D=C	A
		D1=D1-	5
		A=DAT1	A		->Q2
		D0=A
		GOSUBL	QSKIP
		?ST=1	sALG48
		GOYES	Qadd/Sub3
+		GOSBVL	=GETPTR
		GOTO	rdispatch
Qadd/Sub3	A=DAT1	A		->Q2
		CD0EX
		C=C-A	A		Q2size
		C=C+D	A		Q1+Q2size
		GOSBVL	=GETTEMP
		CD0EX
		R3=C	A		->output
		R4=C	A		->output
		GOSBVL	=D1=DSKTOP
		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		D0=A			->Q1
		D1=C			->Q2
		GOSUBL	QADD/SUB
		A=R4	A		->Q
		GOLONG	QMULexit	Push result, shrink & exit
* on teste si stk2 ou stk1 est un seco (irrquad) puis un symb (fraction)
rdispatch	P=	0
		LCIRRQ
		P=	9
		A=R1.F	WP
		?C=A	WP
		GOYES	s?seco
		A=R2.F	WP
		?C=A	WP
		GOYES	ssecoany
		GOTO	snotseco
ssecoany	P=	0
		A=PC
		LC(5)	(addsubqany!)-(*)
		GOTO	sfin
s?seco		A=R2.F	WP
		?C=A	WP
		GOYES	sseco
sanyseco	P=	0
		?ST=1	sQSUB
		GOYES	sanyseco2
		GOSUBL	swapml
		GOTO	ssecoany
sanyseco2	A=PC
		LC(5)	(subanyq!)-(*)
		GOTO	sfin
sseco		P=	0
		?ST=1	sQSUB
		GOYES	sseco2
sseco1		GOSUB	testquad
		GOC	sseco1n
		A=PC
		LC(5)	(qaddequal!)-(*)
		GOTO	sfin
sseco1n		A=PC
		LC(5)	(qadd!)-(*)
		GOTO	sfin
sseco2		GOSUB	testquad
		GOC	sseco2n
		A=PC
		LC(5)	(qsubequal!)-(*)
		GOTO	sfin
sseco2n		A=PC
		LC(5)	(qsub!)-(*)
		GOTO	sfin
snotseco	P=	0
		LC(5)	=DOSYMB
		?C=A	A		A=stk2
		GOYES	ssymb?
		A=R1	A
		?C#A	A
		GOYES	stlist
sanysymb	A=PC
		LC(5)	(sanysymb!)-(*)
		GOTO	sfin
ssymb?		A=R1	A
		?C=A	A
		GOYES	ssymb
ssymbany	A=PC
		LC(5)	(ssymbany!)-(*)
		GOTO	sfin
ssymb		?ST=1	sQSUB		symb+-symb
		GOYES	ssymb2
		A=PC
		LC(5)	(rradd!)-(*)
		GOTO	sfin
ssymb2		A=PC
		LC(5)	(rrsub!)-(*)
		GOTO	sfin
stlist		LC(5)	=DOLIST
		?C#A	A	
		GOYES	sobj
* stk1 est une liste, ?stk2
sobj10		A=R2	A
		?C#A	A
		GOYES	sobjlist
slistlist	?ST=1	sQSUB
		GOYES	slistlist2
slistlist1	A=PC
		LC(5)	(rlistlist!)-(*)
		GOTO	sfin
slistlist2	A=PC
		LC(5)	(slistlist!)-(*)
		GOTO	sfin
sobjlist	?ST=1	sQSUB
		GOYES	sobjlist2
sobjlist1	GOSUBL	swapml
		GOTO	slistobj
sobjlist2	A=PC
		LC(5)	(sobjlist!)-(*)
		GOTO	sfin
sobj		A=R2
		?C#A	A
		GOYES	sobjobj
slistobj	A=PC
		LC(5)	(slistobj!)-(*)
		GOTO	sfin
sobjobj		?ST=1	sQSUB
		GOYES	sobjobj2
sobjobj1	A=PC
		LC(5)	(raddext!)-(*)
		GOTO	sfin
sobjobj2	A=PC
		LC(5)	(rsubext!)-(*)
sfin		A=A+C	A
		PC=(A)
* SWADROP en ML
swapdropml	A=DAT1	A
		D=D+1	A
		D1=D1+	5
		DAT1=A	A
		RTN
* A=R1=prologue stk1, R2=prologue stk2
rsubrcl		D1=D1+	5
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	W
		R2=A		-> stk2
		CD1EX
		C=DAT1	A
		CD1EX
		A=DAT1	W	
		R1=A		-> stk1
		CD1EX
		RTN
swapsub		GOSUBL	swapml
		A=PC
		LC(5)	(swapsub!)-(*)
		GOTO	sfin
* test si 2 irrquad sont egaux, SAVPTR doit avoir ete fait
testquad	A=DAT1	A
		D0=A			D0=@stk1
		D0=D0+	10		skip :: <<
		GOSBVL	=SKIPOB		skip a
		GOSBVL	=SKIPOB		skip b
		D1=D1+	5
		A=DAT1	A
		AD0EX			D0=@stk2
		AD1EX			D1=@c1, 
		D0=D0+	10
		GOSBVL	=SKIPOB
		GOSBVL	=SKIPOB
		GOSUBL	EQUAL?		CC=equal, CS= not equal
		GOC	tortncs
		GOSBVL	=GETPTR
		RTNCC
tortncs		GOSBVL	=GETPTR
		RTNSC
ENDCODE
*;

LABEL rrsub!
* soustraction avec au moins une fraction
::
CODE
		GOLONG	rasop
ENDCODE
( d1*d2, n2*d1, n1*d2 )
CODE
		ST=1	sQSUB
rradd/sub	GOSUB	rsubrcl
		A=R1.F	A
		LC(5)	=DOSYMB
		?A=C	A
		GOYES	rrsub1
		A=R2.F	A
		?A=C	A
		GOYES	rrsub2
		GOTO	radd/sub	non symb + non symb
rrsub1		A=R2.F	A
		LC(5)	=DOLIST
		?A=C	A
		GOYES	rrsub11		list+symb
rrsub10		GOTO	sobjobj		obj+symb/symb+symb/symb+obj
rrsub11		GOTO	slistobj
rrsub2		A=R1.F	A
		LC(5)	=DOLIST
		?A#C	A
		GOYES	rrsub10		symb+obj
		GOTO	sobjlist	symb+list
ENDCODE
CODE
		GOSUBL	swapml
		GOLONG	simpndxf
ENDCODE
;


LABEL swapsub!
::    
	CODE
	GOTO	sobjobj2
	ENDCODE
	CODE
	GOLONG	rneg
	ENDCODE
	;
LABEL rsubext!
::	CK&DISPATCH1
	# 3F3F	%%-
	# 4F4F	C%%C-C
	# 3F4F	C%%R-C
	# 4F3F	C%%C-R
	2REAL	%-
	realcmp C%R-C
	cmpreal C%C-R
	cmpcmp	C%C-C
	# 1F1F #-
	SIXTYEIGHT x- ( matrice + matrice )
	SIXTYFOUR ::	ADDMATOBJext MSUBext
			;
	FOUR ::		ADDMATOBJext MSUBext
			;
	realhxs :: Z2Rext %- ;
	hxsreal :: SWAP Z2Rext %- %CHS ;
	# 3FB	:: CODE
	GOLONG	z2r
	ENDCODE %>%% %%- 
		;
	# 3F8	:: CODE
	GOLONG	zz2c%%
	ENDCODE C%%R-C 
		;
	# 4FB	:: CODE
	GOLONG	z2r
	ENDCODE %>%% C%%C-R 
		;
	# 4F8	:: CODE
	GOLONG	zz2c%%
	ENDCODE C%%C-C 
		;
	# 83F	CODE
	GOTO	swapsub
	ENDCODE
	# 84F	CODE
	GOTO	swapsub
	ENDCODE
	# B3F	CODE
	GOTO	swapsub
	ENDCODE
	# B4F	CODE
	GOTO	swapsub
	ENDCODE
	any 
	NULLNAME x-ext
	::	( o1, o2 )
		num#0=case DROP
		SWAP num#0=case 
	CODE
	D=D+1	A
	D1=D1+	5
	GOLONG	rneg
	ENDCODE
		( o2, o1 )
		2DUP symcomp INNERCOMP get1 symcomp INNERCOMP 
		( symb1, symb2, meta1, meta2 )
		get1 #+ ' x- SWAP#1+ SYMBN
		( symb1, symb2, symb )
		SPECIALext
		DUP#0=csedrp
		::	( symb1, symb2, symb )
			UNROT EQUAL NOT?SEMI
			( symb )
			?ext OVER EQUAL NOTcasedrop HXS 1 0
			;
		( symb1, symb2, #arg1, #arg2 )
* un arg non infini
		DUP FOUR #>case :: 3DROP RNEGext ;
		OVER FOUR #> case2drop SWAPDROP
		( symb1, symb2, #arg1, #arg2 )
* les 2 sont infini, -> ? ou symb1 si one, two ou two, one
		#+ #3= NOTcase2drop ?ext
		( symb1, symb2 )
		SWAPDROP
		;
	;

LABEL qaddequal!
::
( q, q' )
INCOMPDROP DROP
( q', <<, a, b, c )
5ROLL INNERCOMP DROPSWAPDROP
( <<, a, b, c, <<, a', b', >> )
4ROLLDROP
( <<, a, b, c, a', b', >> )
6ROLL 4ROLL
CODE
	GOLONG	radd
ENDCODE
( <<, b, c, b', >>, a+a' )
5ROLL 4ROLL
CODE
	GOLONG	radd
ENDCODE
( <<, c, >>, a+a', b+b' )
HXS 1 0 EQUALcasedro 4UNROLL3DROP
2SWAP FIVE ::N
;

LABEL qsubequal!
::
( q, q' )
SWAPINCOMP 2DROP
( q', <<, a, b, c )
5ROLL INNERCOMP DROPSWAPDROP
( <<, a, b, c, <<, a', b', >> )
4ROLLDROP
( <<, a, b, c, a', b', >> )
6ROLL 4ROLL
CODE
	GOLONG	rsub
ENDCODE
( <<, b, c, b', >>, a+a' )
5ROLL 4ROLL
CODE
	GOLONG	rsub
ENDCODE
( <<, c, >>, a+a', b+b' )
HXS 1 0 EQUALcasedro 4UNROLL3DROP
2SWAP FIVE ::N
;


LABEL qsub!
::
CODE
	GOLONG	rneg
ENDCODE
CODE
qadd		A=PC
		LC(5)	(qadd!)-(*)
		GOTO	sfin
ENDCODE
;


LABEL addsubqany!
::
( << >>, a' )
SWAPINCOMP
( a', << , a , b, c , >>, #5 )
5ROLL 7ROLL
CODE
	GOLONG	radd/sub
ENDCODE
5UNROLL ::N
;

LABEL subanyq!
::
INNERCOMP
( a', <<, a, b, c, >>, #5 )
7ROLL 6ROLL
CODE
	GOLONG	rsub
ENDCODE
( <<, b, c, >>, #5, a'-a )
5UNROLL 4ROLL
CODE
	GOLONG	rneg
ENDCODE
4UNROLL ::N
;

LABEL ssymbany!
::
( n/d, a -> n+-a*d/d )
CODE
	GOSUBL	swapml
	GOLONG	fxnd
ENDCODE
( a, n, d )
HXS 2 10
EQUALcasedro	CODE
		GOSUBL	swapml
		GOTO	sobjobj
		ENDCODE
CODE
pushtf		?ST=1	sQSUB
		GOYES	pushf
		GOVLNG	=PushTLoop
pushf		GOVLNG	=PushFLoop
ENDCODE
4UNROLL SWAPOVER 4ROLL
CODE
	GOLONG	rmult
ENDCODE
( flag, d, n, a*d )
4ROLL
CODE
	D=D+1	A
	A=DAT1	A
	D1=D1+	5
	LC(5)	=TRUE
	?A=C	A
	GOYES	toradd
	GOLONG	rsub
toradd	GOLONG	radd
ENDCODE
CODE
	GOSUBL	swapml
	GOLONG	ndxf
ENDCODE
;

LABEL sanysymb!
::
( a, n/d -> a*d+-n/d )
CODE
	GOLONG	fxnd
ENDCODE
( a, n, d )
HXS 2 10
EQUALcasedro	CODE
		GOLONG	sobjobj
		ENDCODE
CODE
	GOTO	pushtf
ENDCODE
( a, n, d, flag )
4UNROLL DUP 4ROLL
( flag, n, d, d, a )
CODE
	GOLONG	rmult
ENDCODE
( flag, n, d, a*d )
ROT
( flag, d, a*d, n )
4ROLL
CODE
	D=D+1	A
	A=DAT1	A
	D1=D1+	5
	LC(5)	=TRUE
	?A=C	A
	GOYES	sradd
	GOLONG	rsub
sradd	GOLONG	radd
ENDCODE
CODE
	GOSUBL	swapml
	GOLONG	ndxf
ENDCODE
;

LABEL slistobj!
::
( list, o -> )
SWAPINCOMP DUP#0=csDROP
get1 ROTSWAP 
CODE 
	GOLONG	radd/sub
ENDCODE
SWAP 
CODE
	GOLONG	newtrimmeta
ENDCODE
;

LABEL sobjlist!
::
( objA, list B )
INNERCOMP get1
( bb-1, ..., b0, #b, a )
ROT
CODE
	GOLONG	rsub
ENDCODE
( bb-1, ..., b1, #b, a-b0 )
OVER #1+UNROLL DUP#1-
	LABEL subrneg!
	::
	DUP#0=csedrp 
	CODE
	GOLONG	newtrimmeta
	ENDCODE
	ZERO_DO (DO)
		( ck+1,...,ca, b1,...,bk, #b )
		CODE
		GOSUBL	swapml
		GOLONG	rneg
		ENDCODE
		OVER #1+UNROLL
		LOOP
	CODE
	GOLONG	newtrimmeta
	ENDCODE
	;
;

LABEL slistlist!
::	( list A, list B ->  )
	SWAPINCOMP
	DUP#0= caseDROP
	get1
	( a1, ..., aa, #a, B )
	INNERCOMP
	DUP#0= 
	casedrop {}N
	get1
	( a1, ..., aa, b1,...,bb, #b, #a )
	SWAP2DUP #MIN TOTEMPOB
	( a1, ..., aa, b1, ..., bb, #a, #b, #min+2 )
LABEL sbegloop!
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b+2, index )
	CODE
* test si index=FFFFF
	C=D1	
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	GONC	ssloop
	GOTO	sfinloop
ssloop	DAT1=A	A
	D1=C
* rappeler ak sur la pile
	D=D-1	A	
	GONC	sdsuite
sdgarb	GOSBVL	=GARBAGE1
sdsuite	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	C=C+A	A	( C=pointeur sommet de pile )
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	( C pointe sur ak )
	CD1EX
	C=DAT1	A
	CD1EX
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	CD1EX
	D1=D1-	5
	DAT1=C	A	
* rappeler bk sur la pile ( 5ROLL )
	RSTK=C
	D1=D1+	5
	C=DAT1	15
	D1=D1+	15
	A=DAT1	A
	D1=D1-	10
	DAT1=C	15
	D1=D1-	5
	C=RSTK
	DAT1=C	A
	D1=D1-	5
	DAT1=A	A
	GOLONG	rsub
sfinloop	D1=C
	A=D0
	LC(5)	(sendloop!)-(smilieu!)
	A=A+C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b, index, ak+bk )
LABEL smilieu!
	CODE
	C=DAT1	A	( C contient un pointeur sur ck )
	R0=C
	C=D1		( C sauvegarde la valeur de D1 )
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	C=C+A	A	( C=pointeur sommet de pile )
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	( C pointe sur l'objet #b+2 )
	D1=C
	C=R0
	DAT1=C	A	( ecrit la valeur du sommet de pile en stk#b+2 )
	C=D1
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	D1=C
* on modifie l'adresse du prochain objet RPL a executer
	A=D0
	LC(5)	(sendloop!)-(sbegloop!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop
ENDCODE

	( a1, ..., ak-1, ck, ck+1, ..., cb, b1, ..., bk, #a, #b )
LABEL sendloop!
	( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b+1 )
	( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b+1 )
	( si #a<#b, il faut continuer en appelant rneg )
	2DUP#= casedrop
		CODE
		GOLONG	newtrimmeta
		ENDCODE
	2DUP#< NOTcasedrop ( #b=#a ) {}N
	( #a < #b : c[b-a]+1,...,ca, b1,...,b[b-a],#a, #b )
	DUPROT #-
	( c[b-a]+1,...,ca, b1,...,b[b-a], #b, #b-a )
	CODE
	A=PC
	LC(5)	(subrneg!)-(*)
irbranch	A=A+C	A
	PC=(A)
	ENDCODE
;

*****************************************************************************
NULLNAME CXRIext
::
EVAL SWAP
;
*****************
NULLNAME CXIRext
::
EVAL
;
*****************
NULLNAME RIXCext
CODE
rixc	GOSUBL	swapml
	GOTO	irxc
ENDCODE
*****************
NULLNAME IRXCext
( im, re -> complex )
CODE
irxc	D1=D1+	5
	C=DAT1	A
	D1=D1-	5
	CD1EX
	A=DAT1	11
	CD1EX
	LCZ0
	P=	10
	?A#C	WP
	GOYES	irxc!0
	P=	0
	LA(5)	=SWAPDROP
	PC=(A)
irxc!0	P=	0
	LA(5)	=2Ob>Seco
	PC=(A)
irxc!1	A=PC
	LC(5)	(irxcext!)-(*)
	GOTO	irbranch
ENDCODE
*****************************************************************
LABEL irxcext!
::
SWAP iuflag TestUserFlag
NOTcase CODE
	GOTO	rixc
	ENDCODE
HXS 2 1F 
	CODE
	GOLONG	ndxq
	ENDCODE 
;
********************************************************************
NULLNAME RADDext
*:: SHALT
CODE
radd		ST=0	sQSUB
		GOLONG	radd/sub
ENDCODE
*;

LABEL raddext!
::	CK&DISPATCH1
	# 3F3F	%%+
	# 4F4F	C%%C+C
	# 3F4F	C%%R+C
	# 4F3F	C%%C+R
	2REAL	%+
	realcmp C%R+C
	cmpreal C%C+R
	cmpcmp	C%C+C
	# 1F1F	#+
	SIXTYEIGHT x+ ( matrice + matrice )
	SIXTYFOUR ::	ADDMATOBJext MADDext
			;
	FOUR	::	ADDMATOBJext MADDext
			;
	realhxs :: Z2Rext %+ ;
	# 3FB	:: CODE
	GOLONG	z2r
	ENDCODE %>%% %%+ 
		;
	# 3F8	:: CODE
	GOLONG	zz2c%%
	ENDCODE C%%R+C 
		;
	# 4FB	:: CODE
	GOLONG	z2r
	ENDCODE %>%% C%%C+R 
		;
	# 4F8	:: CODE
	GOLONG	zz2c%%
	ENDCODE C%%C+C 
		;
	# 83F	CODE
swapadd	GOSUBL	swapml
	GOLONG	sobjobj1
	ENDCODE
	# 84F	CODE
	GOTO	swapadd
	ENDCODE
	# B3F	CODE
	GOTO	swapadd
	ENDCODE
	# B4F	CODE
	GOTO	swapadd
	ENDCODE
	any 
	NULLNAME x+ext
	::	( DUPTYPECOL? IT SWAP )
		num#0=case DROP
		SWAP num#0=case DROP
		2DUP symcomp INNERCOMP get1 symcomp INNERCOMP 
		( symb1, symb2, meta1, meta2 )
		get1 #+ ' x+ SWAP#1+ SYMBN
		( symb1, symb2, symb )
		SPECIALext DUP#0=csedrp UNROT2DROP
		( symb1, symb2, #arg1, #arg2 )
* un arg non infini
		DUP FOUR #>case 3DROP
		OVER FOUR #> case2drop SWAPDROP
		( symb1, symb2, #arg1, #arg2 )
* les 2 sont infini, -> ? ou symb1 si egalite avec ONE et TWO
		#= NOTcase2drop ?ext
		( symb1, symb2 )
		LENCOMP #2= ?SEMI 
		DROP ?ext
		;
	;
LABEL qadd!
::	PREPARext
	( a1, b1, c1, a2, b2, c2 )
	6ROLL 4ROLL 
	CODE
	GOLONG	radd
	ENDCODE
	UNROT
	( b1, c1, a1+a2, b2, c2 )
	::	HXS 2 10 EQUALcasedro ( b1, c1, a1+a2, b2 ) 
	CODE
	GOLONG	radd
	ENDCODE
		( b1, c1, a1+a2, b2, c2 )
		4ROLL
		( b1, a1+a2, b2, c2, c1 )
		HXS 2 10 EQUALcasedro 
		:: ( b1, a1+a2, b2, c2 ) 2SWAP 
	CODE
	GOLONG	radd
	ENDCODE 
		;
		OVER EQUALcasedro 
		:: ( b1, a1+a2, b2, c2 ) 4ROLLROT 
	CODE
	GOLONG	radd
	ENDCODE
	SWAPROT  
		;
		( b1, a1+a2, b2, c2, c1 )
		COMPext
		ITE ::	5UNROLL 2SWAP SWAP 5ROLL ;
			4UNROLL 
		( b2, c2, a1+a2, b1, c1 avec c2>c1 )
		HXS 1 0 UNROT 
	CODE
	GOLONG	ndxq
	ENDCODE
	CODE
	GOLONG	radd
	ENDCODE
		( b2, c2, a1+a2+b1*sqrt[c1] )
		;
	( b, c, a )
	UNROT 
	CODE
	GOLONG	ndxq
	ENDCODE
	;

LABEL rradd!
::
CODE
	GOLONG	rasop
ENDCODE
CODE
	ST=0	sQSUB
	GOLONG	rradd/sub
ENDCODE
CODE
	GOSUBL	swapml
	GOLONG	simpndxf
ENDCODE
;


ASSEMBLE
RPL

LABEL rlistlist!
::
( list B, list A -> listA+listB )
INNERCOMP
( B, a1, ..., aa, #a )
* teste si meta1 a 0 ou 1 elements, sinon execute get1
CODE
		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	A
		CD1EX
		?A#0	A
		GOYES	aobjlist!1
		GOSUBL	semiml		( 0 elements -> DROP et SEMI )
		LA(5)	=DROP
		PC=(A)
aobjlist!1	A=A-1	A
		?A=0	A
		GOYES	aobjlist!2
		LA(5)	=get1
		PC=(A)
aobjlist!2	GOSUBL	semiml		( 1 element -> DROP et list/obj*obj )
		D=D+1	A
		D1=D1+	5
		ST=0	sQSUB
		GOLONG	slistobj
ENDCODE
( a1, ..., aa, #a, B )
INNERCOMP
DUP#0= casedrop {}N
get1
( a1, ..., aa, b1,...,bb, #b, #a )
SWAP2DUP #MIN TOTEMPOB
( a1, ..., aa, b1, ..., bb, #a, #b, #min+2 )

LABEL rbegloop!
( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b+2, index )
CODE
* test si index=FFFFF
	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	GONC	sloop
	GOTO	finloop
sloop	DAT1=A	A
	D1=C
* rappeler ak sur la pile
	D=D-1	A	
	GONC	dsuite
dgarb	GOSBVL	=GARBAGE1
dsuite	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	RSTK=C		( sauvegarde de D1 )
	C=A+C	A	
	A=A+A	A	
	A=A+A	A	
	C=A+C	A	( A=5*(#b+3) )
	CD1EX
	A=DAT1	A
	C=RSTK		( restaure D1 )
	D1=C
* rappeler bk sur la pile ( 5ROLL )
	C=A	A
	RSTK=C
	C=DAT1	15
	D1=D1+	15
	A=DAT1	A
	D1=D1-	10
	DAT1=C	15
	D1=D1-	5
	C=RSTK
	DAT1=C	A
	D1=D1-	5
	DAT1=A	A
	GOLONG	radd
finloop	D1=C
	AD0EX
	LC(5)	(rendloop!)-(rmilieu!)
	A=A+C	A
	AD0EX
	GOVLNG	=DropLoop
ENDCODE

( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b, index, ak+bk )
LABEL rmilieu!
CODE
	A=DAT1	A	
	R0=A	A	( R0=@ak+bk )
	D1=D1+	10
	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A	( A= #b )
	CD1EX
	D1=D1-	10
	A=A+CON	A,3	
	C=A	A	
	C=C+C	A	
	C=C+C	A	
	A=C+A	A	( A=5*(#b+3))
	CD1EX
	RSTK=C		( sauvegarde de D1 )
	C=C+A	A	( C pointe sur l'objet #b+2 )
	CD1EX
	A=R0	A	( A=@ak+bk )
	DAT1=A	A	( ecrit la valeur du sommet de pile en stk#b+2 )
	C=RSTK
	CD1EX		( restaure D1 )
* on modifie l'adresse du prochain objet RPL a executer
	AD0EX
	LC(5)	(rendloop!)-(rbegloop!)
	A=A-C	A
	AD0EX
	GOVLNG	=DropLoop
ENDCODE
( a1, ..., ak-1, ck, ck+1, ..., cb, b1, ..., bk, #a, #b )

LABEL rendloop!
( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b )
( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b )
( si #a<#b, il faut continuer avec HXS 1 0 comme operande )
2DUP#= casedrop
NULLNAME TRIM{}Next
CODE
newtrimmeta	A=DAT1	A
		AD1EX		( D1=@#n )
		D1=D1+	5
		C=DAT1	A	( C=#n )
		D1=D1-	5
		AD1EX
		LA(5)	0
		?A#C	A
		GOYES	newtrim1
		GOLONG	droppushhxs0	
newtrim1	LA(5)	1
		?A#C	A
		GOYES	newtrim11
		D1=D1+	5
		D=D+1	A
		GOLONG	returno1
newtrim11	A=C	A
		A=A+A	A
		A=A+A	A
		A=A+C	A	( A= 5*C )
		C=D1
		C=C+A	A
		CD1EX		( D1= @@stkn, C=@sommet de la pile )
		A=DAT1	A	( A= @@stkn )
		AD1EX		( D1 = @stkn )
		A=DAT1	W	( A= stkn )
		CD1EX		( D1= @ sommet pile )
		LC(5)	=DOEREL
		?A#C	A
		GOYES	newtrim13
newtrim12	A=PC
		LC(5)	(newtrimfloat!)-(*)
		GOTO	newtrimbr
newtrim13	LC(5)	=DOECMP
		?A=C	A
		GOYES	newtrim12
		LCZ0
		P=	10
		?A=C	WP
		GOYES	newtrim2
		P=	0
		LA(5)	={}N
		PC=(A)
newtrim2	P=	0
		A=PC
		LC(5)	(newtrim3!)-(*)
newtrimbr	A=A+C	A
		PC=(A)
ENDCODE
2DUP#< NOTcasedrop ( #a >= #b ) {}N
( #a < #b : c[b-a]+1,...,cb, b1,...,b[b-a],#a, #b )
OVER#-
( c[b-a]+1,...,cb, b1,...,b[b-a], #a, #b-a )
DUPUNROT #2+UNROLL
( c[b-a]+1,...,cb, #a, b1,...,b[b-a], #b-a )
psh get1 #+
{}N
;

LABEL newtrim3!
::	( o1, ..., on, #n!=#0 )
	#1- get1
	CODE
		D1=D1+	5
		D=D+1	A
		GOLONG	newtrimmeta
	ENDCODE
	;

LABEL newtrimfloat!
::	{}N TRIMOBJext
	;

*************************************************************************
ASSEMBLE
mp		A=PC
		LC(5)	(mpext!)-(*)
mpbranch	A=A+C	A
		PC=(A)
RPL

NULLNAME RPext
LABEL rpext!
::
' CODE
	GOLONG	rmult
ENDCODE

NULLNAME MPext ( objet, #entier, prg de multiplication -> objet^#entier )
LABEL mpext!
::
( obj1, obj2, prg de multiplication -> obj1^obj2 )
UNROT 
CODE
		GOSUBL	a=stk1
		LC(5)	=DOHXS
		?A#C	A
		GOYES	mp!1
		LA(5)	=HXS>#
		PC=(A)
mp!1		LC(5)	=DOREAL
		?A#C	A
		GOYES	mp!2
		A=PC
		LC(5)	(mpreal!)-(*)
		GOTO	mpbranch
mp!2		GOVLNG	=Loop
ENDCODE
( prg, obj1, obj2 ou #entier )
DUPTYPEBINT? NOTcase :: ROTDROP x^ext ;
( prg, objet, #entier )
DUP#0=csedrp :: ::	CK&DISPATCH1
			hxs HXS 2 10
			seco HXS 2 10
			list :: DTYPENDO? ITE HXS 2 10 { HXS 2 10 } ;
			symb :: %0 x^ext ;
			THIRTYONE ONE
			SIXTYTHREE %%1
			any %1
			;
		UNROT2DROP
                ;
ONESWAP
( prg, A, #1, # )
( par convention #1 comme rsultat signifie l'identit )
( ce qui vite de faire la premire multiplication identit* A^[2^k] )
[BEGIN]
( prg, A^[2^k], result , # )
DUP#0<>WHILE
:: 
	TWO #/
	( prg, A^[2^k], result, remainder, quotient )
	4UNROLL
	( prg, quotient, A^[2^k], result, remainder )
	#0=?SKIP 
	( prg, quotient, A^[2^k], result )
		CODE
		C=DAT1	A
		LA(5)	=ONE
		?A#C	A
		GOYES	mp!10
		LA(5)	=DROPDUP
		PC=(A)
mp!10		D=D-CON	A,2
		GONC	mp!11
		GOSBVL	=GARBAGE1
mp!11		D1=D1+	15
		A=DAT1	A
		D1=D1-	10
		C=DAT1	A
		D1=D1-	10
		DAT1=C	A
		D1=D1-	5
		DAT1=A	A
		LA(5)	=EVAL
		PC=(A)
		ENDCODE
	( prg, quotient, A^[2^k], result )
	CODE
		D1=D1+	10
		A=DAT1	A
		D1=D1-	10
		LC(5)	=ZERO
		?A#C	A
		GOYES	mp!20
* inutile de calculer A^[2^k+1] si le quotient est nul
		GOSUBL	semiml
		LA(5)	=ROT
		PC=(A)
mp!20		LA(5)	=SWAPDUP
		PC=(A)
	ENDCODE
	( prg, quotient, result, A^, A^ )
	5PICK EVAL SWAPROT
	;
[REPEAT]
DROP UNROT2DROP
; ( MPext )

; ( RPext )

LABEL mpreal!
:: 
( real -> #ip ou real )
DUPDUP %FLOOR %= NOT?SEMI
( prg, objet, reel entier )
DUP %0< NOTcase COERCE
( prg, objet, entier negatif )
%ABSCOERCE SWAP MADJext
( prg, #puissance, determinant, inverse, polynome adjoint, poly car )
2DROP SWAP num0case SETIVLERR
DROPSWAP
( prg, #puissance, inverse )
;

ASSEMBLE
toa=stk1	GOLONG	a=stk1
toQSKIP		GOLONG	QSKIP
todzneg		GOLONG	dzneg
torneg		GOLONG	rneg
toSHORTOUT	GOLONG	SHORTOUT
RPL

NULLNAME x^ext
::
( obj, puissance -> obj^puissance )
DUPTYPEHSTR?
IT	CODE
	GOLONG	z2r
	ENDCODE
DUPROT symcomp SWAP symcomp ' x^ EvalNoCK
( puissance, obj^pui )
DUP' x\9F EQUALPOSCOMP #0= NOTcase2drop ?ext
DUP' x? EQUALPOSCOMP #0= NOTcase2drop ?ext
SWAPDUP dREALNcase 2DROP
%0= case2drop %1
%1 %= NOT?SEMI
INNERCOMP UNROT2DROP #2- SYMBNext
;


**********************************************************************
* Desc:		TRUE if |Z1|<|Z2|
* Stack:	( Z1 Z2 --> flag )
**********************************************************************
NULLNAME ZNLT?
CODE
		GOSBVL	=SAVPTR
		C=DAT1	A		
		D1=D1+	5
		A=DAT1	A		
		D0=A			D0 ->Z1
		D1=C			D1 ->Z2

		GOSUBL	ZNCMP

		GOSBVL	=GETPTR
		D1=D1+	5		DROP Z2
		D=D+1	A
		A=A+1	P		Set carry if |Z1|<|Z2|
		GOVLNG	=OverWrT/FLp	return TRUE/FALSE

ENDCODE
**********************************************************************

**********************************************************************
* Desc:		Return Z with max absolute value in Z1,Z2
*		( return Z1 if |Z1|<=|Z2| ; return Z2 if |Z1|>|Z2| )
* Stack:	( Z1 Z2 --> NormMin[Z1,Z2] )
**********************************************************************
NULLNAME ZMAXext
CODE
zmax		GOSBVL	=SAVPTR
		C=DAT1	A		
		D1=D1+	5
		A=DAT1	A		
		D0=A			D0 ->Z1
		D1=C			D1 ->Z2

		GOSUB	ZNCMP	

		GOSBVL	=GETPTR
		C=DAT1	A		->Z2
		D1=D1+	5		DROP one from stack
		D=D+1	A
		A=A+1	P		is |Z1|<|Z2| ? (carry set)
		GONC	ZNMaxOk		no  -> return Z1
		DAT1=C	A		yes -> return Z2
ZNMaxOk		GOVLNG	=Loop
ENDCODE


**********************************************************************
* Desc:		Return Z with min absolute value in Z1,Z2
*		( return Z1 if |Z1|<=|Z2| ; return Z2 if |Z1|>|Z2| )
* Stack:	( Z1 Z2 --> NormMin[Z1,Z2] )
**********************************************************************
NULLNAME ZMINext
CODE
zmin		GOSBVL	=SAVPTR
		C=DAT1	A		
		D1=D1+	5
		A=DAT1	A		
		D0=A			D0 ->Z1
		D1=C			D1 ->Z2

		GOSUB	ZNCMP

		GOSBVL	=GETPTR
		C=DAT1	A		->Z2
		D1=D1+	5		DROP one from stack
		D=D+1	A
		A=-A	P		
		A=A+1	P		is |Z1|>|Z2| ? (carry set)
		GONC	ZNMinOk		no  -> return Z1
		DAT1=C	A		yes -> return Z2
ZNMinOk		GOVLNG	=Loop



**********************************************************************
* Name:		ZNCMP
*
* Desc:		Compare Z1 to Z2 in absolute value (norm)
*
* In:		D0	->Z1
*		D1	->Z2
*
* Out:		P=0
*			/ +1	if |Z1|>|Z2|
*		A[P]   =   0 	if |Z1|=|Z2|
*			\ -1	if |Z1|<|Z2|
*		
*
* Requires:	Z1, Z2 must be trimmed 
*
* Alters:	A[W], C[W], D[A], D0, D1, P
*
* Stack Level:	0
*
**********************************************************************

ZNCMP		D0=D0+	5
		D1=D1+	5
		A=DAT0	A		Z1size
		C=DAT1	A		Z2size
		?A=C	A
		GOYES	ZNCMPeqlen	same length -> compare mantissa
		?A>C	A
		GOYES	ZNCMPgt		

* |Z1|<|Z2| - return -1

ZNCMPlt		P=	0
		LAHEX	F
		RTN

* |Z1|>|Z2| - return +1

ZNCMPgt		P=	0
		LAHEX	1
		RTN

* Z1size=Z2size - compare mantissae, starting with MS nibs

ZNCMPeqlen	A=A-1	A		A[A]=len mantissa + 5
		CD0EX
		C=C+A	A
		CD1EX			D1 -> Z1sign
		C=C+A	A
		CD0EX			D0 -> Z2sign
		D=C	A
		D=D-CON	A,7		D[A]=len mantissa - 1 
		GOC	ZNCMPeq		Z1=Z2=0 -> return equal
		P=	15
ZNCMPlp1	C=0	A		
		C+P+1			Try using 16 nibs
		?D>=C	A
		GOYES	ZNCMPlp2
		C=D	B		No more than 16 nibs lefts
		P=C	0		Use what's left
		C=C+1	B		
ZNCMPlp2				C[A]=P+1=#nibs for next block
		AD0EX
		A=A-C	A
		AD0EX			D0 ->next block of Z2
		AD1EX
		A=A-C	A
		AD1EX			D1 ->next block of Z1
		
		A=DAT1	WP		A[WP] = block of Z1
		C=DAT0	WP		C[WP] = block of Z2
		
		?A<C	WP
		GOYES	ZNCMPlt		|Z1|<|Z2|
		?A>C	WP
		GOYES	ZNCMPgt		|Z1|>|Z2|

		D=D-CON	A,16		blocks are equal 
		GONC	ZNCMPlp1	repeat if more blocks

* |Z1|=|Z2| - return 0

ZNCMPeq		P=	0
		A=0	P
		RTN		

ENDCODE

NULLNAME ZZ2C%%ext
CODE
zz2c%%	A=PC
	LC(5)	(zz2c%%ext!)-(*)
	A=A+C	A
	PC=(A)
ENDCODE
LABEL zz2c%%ext!
::
CXRIext
CODE
	GOLONG	z2r
ENDCODE 
%>%%
SWAP 
CODE
	GOLONG	z2r
ENDCODE
%>%% SWAP 
CODE
	GOLONG	L%%>C%% 
ENDCODE 
;

*********************************************************************
* %%>C%%
*********************************************************************

NULLNAME %%>C%%
CODE
L%%>C%%	GOSBVL	=SAVPTR
	C=DAT1	A
	D0=C
	D0=D0+	5
	A=DAT0	W
	R0=A
	D1=D1+	5
	C=DAT1	A

	D0=D0+	16
	A=DAT0	A
	R1=A
	D0=C
	D0=D0+	5
	A=DAT0	W
	R2=A
	D0=D0+	16
	A=DAT0	A
	R3=A
	LC(5)	#2F
	GOSBVL	=GETTEMP
	LC(5)	=DOECMP
	DAT0=C	A
	AD0EX
	D1=A
	D1=D1+	5
	C=R2
	DAT1=C	W
	C=R3
	D1=D1+	16
	DAT1=C	A
	D1=D1+	5
	C=R0
	DAT1=C	W
	D1=D1+	16
	C=R1
	DAT1=C	A
	GOSBVL	=GETPTR
	D1=D1+	5
	D=D+1	A
	DAT1=A	A
	A=DAT0	A
	D0=D0+	5
	PC=(A)
ENDCODE

ASSEMBLE
toQSIZE		GOLONG	QSIZE
toShrinkQ	GOLONG	ShrinkQ
gcd		GOLONG	lpgcd2
tolopd		GOLONG	lopd
tozdiv		GOLONG	zdiv
toFastGcd?	GOLONG	FastGcd?
toBMULCRY	GOLONG	BMULCRY
torsub		GOLONG	rsub
toModPrepare	GOLONG	ModPrepare
toZMODSHORT	GOLONG	ZMODSHORT
toshortpopd1	GOLONG	shortpopd1
toshortpop	GOLONG	shortpop
toSHORTPOP?	GOLONG	SHORTPOP?
tor0exit	GOLONG	r0exit
listseco	A=PC
		LC(5)	(listsecoext!)-(*)
		GOTO	branch
rp		A=PC
		LC(5)	(rpext!)-(*)
		GOTO	branch
positif		A=PC
		LC(5)	(positif!)-(*)
		GOTO	branch
sqff		A=PC
		LC(5)	(sqffext!)-(*)
		GOTO	branch
rconj		A=PC
		LC(5)	(rconjext!)-(*)
		GOTO	branch
vxxl		A=PC
		LC(5)	(vxxlext!)-(*)
		GOTO	branch
quot		A=PC
		LC(5)	(quotext!)-(*)
		GOTO	branch
lopm		A=PC
		LC(5)	(lopmext!)-(*)
		GOTO	branch
div		A=PC
		LC(5)	(divext!)-(*)
branch		A=A+C	A
		PC=(A)
divobj		A=PC
		LC(5)	(divobjext!)-(*)
		GOTO	branch
trim		A=PC
		LC(5)	(trimext!)-(*)
		GOTO	branch
simpndxf	A=PC
		LC(5)	(simpndxf!)-(*)
		GOTO	branch
rasop		A=PC
		LC(5)	(rasopext!)-(*)
		GOTO	branch
qnorm		A=PC
		LC(5)	(qnormext!)-(*)
		GOTO	branch
num0		A=PC
		LC(5)	(num0ext!)-(*)
		GOTO	branch
RPL

**********************************************************************
* Desc:		Strip Z from unnecessary leading nibbles
* Stack:	( Z --> Z' )
* Algorithm:	Count nibbles required for representation
*		If equals used nibbles then quick exit
*		Else allocate new object, copy significant mantissa
*		nibbles and apend original sign.
**********************************************************************
NULLNAME ZTRIMext
NULLNAME H>Z
CODE
ztrim		GOSBVL	=SAVPTR
		A=DAT1	A		->Z
		A=A+CON	A,5
		D0=A
		C=DAT0	A		Zlen
		A=A+C	A
		D0=A			->Ztail
		D0=D0-	1		->Zsign
		A=DAT0	S		Zsign
		C=C-CON	A,7		Zlen-7
		GONC	ZTrimDo		No jump if NULLHXS or Z0
ZTrimOK		GOVLNG	=GETPTRLOOP
* First check how many nibbles should be used so we don't necessarily
* have to allocate a new object if the Z is already trimmed
ZTrimDo		D=C	A		Save for later comparison
ZTrimLoop	D0=D0-	1
		C=DAT0	S
		?C#0	S
		GOYES	ZTrimGotHi
		C=C-1	A
		GONC	ZTrimLoop
		A=0	W		Stripped down to Z0. Easy way out
		GOSBVL	=PUSHhxs
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		GOVLNG	=OverWrALoop
ZTrimGotHi	?C=D	A		Now see if Z was already trimmed
		GOYES	ZTrimOK
* Have to trim, A[S] = sign, C[A] = nibbles-1 to use
		R4=A
		RSTK=C
		C=C+CON	A,5+5+2
		GOSBVL	=GETTEMP	D0 = ->Z'
		GOSBVL	=D1=DSKTOP
		A=DAT1	A		->Z
		AD0EX
		R0=A			->Z'
		D0=D0+	10		->Zmantissa
		D1=A			->Z'
		LC(5)	=DOHSTR
		DAT1=C	A
		D1=D1+	5
		C=RSTK			Znibbles-1
		C=C+CON	A,7		Zlen = Znibbles + 1
		DAT1=C	A
		D1=D1+	5
		C=C-CON	A,6		Znibbles
		GOSBVL	=MOVEDOWN	Copy mantissa
		A=R4
		DAT1=A	S		Zsign
		GOVLNG	=GPOverWrR0Lp
ENDCODE
***********************************************
**********************************************************************
* Desc:		Test if Z is negative
* Stack:	( Z --> Z flag )
**********************************************************************
NULLNAME DupZIsNeg?
CODE
dzneg
		C=DAT1	A
zisneg??	CD1EX
		D1=D1+	5
		A=DAT1	A		Zlen
		CD1EX
		C=C+A	A		->Ztail
		CD1EX
		D1=D1-	1		->Zsign
		C=DAT1	S		Zsign
		D1=C
		?C#0	S		Test if sign <> 0 and push flag
		GOYES	+
+		GOVLNG	=PushT/FLoop
ENDCODE

NULLNAME ZIsNeg?
CODE
		C=DAT1	A
		D1=D1+	5
		D=D+1	A
		GONC	zisneg??
ENDCODE

**********************************************************************
* Desc:		Take the absolute value of Z
* Stack:	( Z --> |Z| )
* Algorithm:	If Z is already positive then do nothing
*		Else duplicate object & change sign
**********************************************************************
NULLNAME ZABSext
CODE
zabs		A=DAT1	A		->Z
		AD1EX
		D1=D1+	5
		C=DAT1	A		Zlen
		AD1EX
		A=A+C	A		->Ztail
		AD1EX
		D1=D1-	1		->Zsign
		A=DAT1	S		This works for Z0 & NULLHXS too
		AD1EX
		?A#0	S
		GOYES	ZAbsYes
		GOVLNG	=Loop		Already positive

ZAbsYes		GOSBVL	=SAVPTR
		A=DAT1	A		->Z
		D0=A
		D0=D0+	5
		C=DAT0	A		Zlen
		C=C+CON	A,5
		GOSBVL	=GETTEMP	D0 = ->Z'
		RSTK=C			Zsize
		GOSBVL	=D1=DSKTOP
		A=DAT1	A
		AD0EX
		DAT1=A	A		OverWrite Z'
		D1=A
		C=RSTK
		C=C-1	A		Don't copy the sign nibble
		GOSBVL	=MOVEDOWN
		A=0	A		Clear sign
		DAT1=A	1
		GOVLNG	=GETPTRLOOP
ENDCODE
************************************************************************
LABEL rasopext!
::
( n1/d1, n2/d2 )
CODE
	GOLONG	fxnd
ENDCODE
ROT 
CODE
	GOLONG	fxnd
ENDCODE
( n2, d2, n1, d1 )
ROTOVER
( n2, n1, d1, d2, d1 )
2DUP EQUAL case2drop UNROTSWAP
*CODE
*	GOLONG	simp
*ENDCODE
( n2, n1, d1, d2', d1' )
ROT 3PICK
CODE
	GOLONG	rmult
ENDCODE
5UNROLL
( d1*d2', n2, n1, d2', d1' )
UNROT
CODE
	GOLONG	rmult
ENDCODE
( d1*d2', n2, d1', n1*d2' )
UNROT 
CODE
	GOLONG	rmult
ENDCODE
( d1*d2', n1*d2', n2*d1' )
;

************************************************************
********************************************
* MARQUEUR
******************************************************************
ASSEMBLE
qconj	A=PC
	LC(5)	(qconjext!)-(*)
	GOTO	branch1
RPL
***********************************************************
NULLNAME QCONJext
LABEL qconjext!
::
CODE
	GOLONG	qxnd
ENDCODE
SWAP 
CODE
	GOLONG	rneg
ENDCODE
SWAP 
CODE
	GOLONG	ndxq
ENDCODE
;
************************************************************
***********************************************************
NULLNAME RNEGext ( f -> -f )
*:: SHALT
CODE		
rneg		GOSBVL	=SAVPTR
		A=DAT1	A		->Q1
		R0=A.F	A
		B=A	A
		D0=A
		ST=1	sALG48
		GOSUBL	QSKIP		D0=@end
		?ST=0	sALG48
		GOYES	rneg!notalg
		D0=D0+	6	link
		C=D0
		C=C-B	A
		GOSBVL	=GETTEMP	D0=debut, D1=fin
		A=D0
		D1=A		D1=target
		AR0EX.F	A	R0=debut target, A= debut origine
		D0=A		D0=origine
		GOSBVL	=MOVEDOWN	recopie de l'objet avant appel NEG
		A=R0.F	A
		D0=A
		GOSUBL	QNEG
		C=D0
		GOSUBL	ShrinkQ
		GOVLNG	=OverWrALoop		
rneg!notalg	GOSBVL	=GETPTR
		GOSUBL	a=stk1
rneg!1		LC(5)	=DOLIST
		?A#C	A
		GOYES	rneg!2
		A=PC
		LC(5)	(rneglist!)-(*)
rneg!0		A=A+C	A
		PC=(A)
rneg!2		LC(5)	=DOCOL
		?A#C	A
		GOYES	rneg!3
		A=PC
		LC(5)	(rnegseco!)-(*)
		GOTO	rneg!0
rneg!3		LC(5)	=DOSYMB
		?A#C	A
		GOYES	rneg!4
		A=PC
		LC(5)	(rnegsymb!)-(*)
		GOTO	rneg!0
rneg!4		LC(5)	=DOCSTR
		?A#C	A
		GOYES	rneg!5
		A=PC
		LC(5)	(rnegstr!)-(*)
		GOTO	rneg!0
rneg!5		A=PC
		LC(5)	(rnegck!)-(*)
		GOTO	rneg!0
ENDCODE
*;

LABEL rneglist!
::
INNERDUP #1-SWAP
ZERO_DO
	get1
	CODE
	GOLONG	rneg
	ENDCODE
	SWAPLOOP
#1+ {}N
;

LABEL rnegseco!
::
INNERCOMP
( <<, a, b, c, >>, FIVE )
5ROLL
CODE
	GOLONG	rneg
ENDCODE
5UNROLL
4ROLL
CODE
	GOLONG	rneg
ENDCODE
4UNROLL ::N
;

LABEL rnegsymb!
::
DUPLENCOMP #1=case ::	CARCOMP { x\9F x? } OVER EQUALPOSCOMP
			#0<> case symcomp
			' xNEG TWO SYMBN
			;
DUP' x\9F EQUALPOSCOMP
#0<> case ::	DUPLENCOMP #2= NOTcase xNEG
		{ xNEGNEG xNEG } SWAPINCOMP 
		( {}, infini, neg ou negneg, #2 )
		4ROLLROT EQ: xNEG
		( infini, #2, {}, ? )
		ITE ONE TWO NTHCOMPDROP
		SWAP SYMBN
		;
CODE
	GOLONG	fxnd
ENDCODE 
SWAP
DUPTYPESYMB?
ITE	::	INNERCOMP
		( o1, ..., on, #n )
		' xNEG 
		3PICK EQUALcasedro :: SWAPDROP #1- SYMBNext ;
		SWAP#1+ SYMBN
		;
	CODE
	GOLONG	rneg
	ENDCODE
( d, num )
SWAP
( num, d )
x/ext
;

LABEL rnegstr!
::
CHR_- OVER CAR$ EQUALcasedro CDR$ >H$
;

LABEL rnegck!
::
CK&DISPATCH1
real	%CHS
cmp	C%CHS
ereal	%%CHS
ecmp    C%%CHS
any	NULLNAME xNEGext
	:: symcomp ' xNEG >TCOMP ;
;
*********************************************************************
NULLNAME SIMPNDXFext
LABEL simpndxf!
::
NULLNAME SIMPext ( o1, o2 -> o1' o2' )
* Simplifie o1/o2 en o1'/o2' par division par le PGCD de o1 et o2
CODE
simp	GOSUBL	a=stk1
	LC(5)	=DOCOL
	?A#C	A
	GOYES	simp!1
	GOSUBL	a=stk5
	LC(5)	=x<<
	?A=C	A
	GOYES	simp!0
	A=PC
	LC(5)	(simpcmp!)-(*)
	GOTO	simp!2
simp!0	A=PC
	LC(5)	(simpirrq!)-(*)
	GOTO	simp!2
simp!1	A=PC
	LC(5)	(simpext!)-(*)
simp!2	A=A+C	A
	PC=(A)
ENDCODE
*******************************************
NULLNAME NDXFext ( numerateur, denominateur -> algebrique )
* inverse de FXND
( o2, o1 )
* o1 est-il 1, -1 ou o2 est-il 0?
CODE
ndxf		C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		LC(5)	=DOHSTR
		?A#C	A
		GOYES	ndxfstk2
		LCZ1
		P=	11
		?A#C	WP
		GOYES	hstrnot#1
* o1=1 -> DROP
hstr#0		P=	0
		LA(5)	=DROP
		PC=(A)
hstrnot#1	C=C-1	P
		?A#C	WP
		GOYES	ndxfstk2
		P=	0
		D=D+1	A
		D1=D1+	5
		GOLONG	rneg
ndxfstk2	P=	0
		D1=D1+	5
		C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		D1=D1-	5
		LCZ0
		P=	10
		?A=C	WP
		GOYES	hstr#0
ndxfnot#0	P=	0
ndxf1		A=PC
		LC(5)	(ndxfext!)-(*)
		GOTO	simp!2
ENDCODE
; ( end SIMPNDXFext )

LABEL ndxfext!
::
( o2, o1 )
CK&DISPATCH1
symb	SYM/
SYMOB	SYM/O
any	CODE
	D=D-CON	A,2
	GONC	ndxf3
	GOSBVL	=GARBAGE1
ndxf3	D1=D1-	5
	LA(5)	=x/
	DAT1=A	A
	D1=D1-	5
	LA(5)	=THREE
	DAT1=A	A
	LA(5)	=SYMBN
	PC=(A)
	ENDCODE
; 
**************************************************************
NULLNAME num#0=case
( teste la nullite )
LABEL num#0=case!
::
CODE
	GOLONG	newtrim
ENDCODE
CK&DISPATCH0
hxs :: DUP HXS 1 0 EQUAL COLAcase ;
real %0=case
TWO C%0=case
ereal :: DUP %%0= COLAcase ;
ecmp :: DUP C%%0= COLAcase ;
any SKIP
; ( end num#0=case ) 2DROP
********************************************************
NULLNAME num#1=case
( teste l'egalite a 1 )
LABEL num#1=case!
::
CODE
	GOLONG	newtrim
ENDCODE
CK&DISPATCH0
hxs :: DUP HXS 2 10 EQUAL COLAcase ;
real %1=case
TWO C%1=case
ereal :: DUP %%1 EQUAL COLAcase ;
ecmp :: DUP C%%1 EQUAL COLAcase ;
any SKIP
; ( end num#1=case )
****************************************************************
NULLNAME QXNDext
CODE
qxnd		C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		LC(N)	10
		CON(5)	=DOCOL
		CON(5)	=x<<
		P=	9
		?A#C	WP
		GOYES	qxndnotirrq
		P=	0
		A=PC
		LC(5)	(qxndext!)-(*)
		GOTO	branch1
qxndnotirrq	P=	0
		A=PC
		LC(5)	(qxndnotirrq!)-(*)
branch1		A=A+C	A
		PC=(A)
ENDCODE

LABEL qxndext!
::
( obj -> a, b, c )
INNERCOMP #5= NcaseTYPEERR
DROP 4ROLLDROP
;

LABEL qxndnotirrq!
:: HXS 1 0 HXS 2 10 ;
********************************************************************
ASSEMBLE
num#0case	A=PC
	LC(5)	(num#0=case!)-(*)
	GOTO	branch1
RPL
*****************************************************************
*****************************************************************
ASSEMBLE
num#1case	A=PC
	LC(5)	(num#1=case!)-(*)
	GOTO	branch1
RPL
*****************************************************************
NULLNAME POSITIFext ( obj -> obj, flag )
LABEL positif!
::
( obj -> obj, flag )
DUP
( obj, obj )
( obj -> flag )
CODE
positif0	C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOSYMB
		?A#C	A
		GOYES	positifext
positifsym1	A=PC
		LC(5)	(positifsym1!)-(*)
positifbr	A=A+C	A
		PC=(A)
positifext	C=DAT1	A
		CD1EX
		A=DAT1	W
		CD1EX
		C=A	W
		LC(5)	=DOHSTR
		?A#C	A
		GOYES	positif1
positifz	A=PC
		LC(5)	(positifz!)-(*)
		GOTO	positifbr
positif1	LC(5)	=DOLIST
		?A#C	A
		GOYES	positif2
		A=PC
		LC(5)	(positiflist!)-(*)
		GOTO	positifbr
positif2	LC(5)	=DOSYMB
		?A#C	A
		GOYES	positif3
		A=PC
		LC(5)	(positifsym2!)-(*)
		GOTO	positifbr
positif3	LCIRRQ
		?A#C	W
		GOYES	positif4
		A=PC
		LC(5)	(positifirrq!)-(*)
		GOTO	positifbr
positif4	?A#C	A
		GOYES	positif5
		A=PC
		LC(5)	(positifcmpl!)-(*)
		GOTO	positifbr
positif5	LC(5)	=DOTAG
		?A=C	A
		GOYES	positif6
		A=PC
		LC(5)	(positifconv!)-(*)
		GOTO	positifbr
positif6	A=PC
		LC(5)	(positiftag!)-(*)
		GOTO	positifbr
ENDCODE
;

LABEL positifsym1!
::
FXNDext
CODE
	GOTO	positifext
ENDCODE
SWAP
CODE
	GOTO	positifext
ENDCODE
XOR
;

LABEL positifsym2!
::
DUPLENCOMP NTHCOMPDROP EQ: xNEG
;

LABEL positifcmpl!
::
TWO NTHCOMPDROP
DUPTYPEHSTR? case
    LABEL positifz!
    ::    ZIsNeg? NOT ;
DROPTRUE
;

LABEL positifirrq!
::
TWO NTHCOMPDROP
CODE
	GOTO	positifext
ENDCODE
;

LABEL positiflist!
::
positifflag TestUserFlag
NOTcase	CODE
		A=DAT1	A
		A=A+CON	A,5
		DAT1=A	A
		GOTO	positifext
	ENDCODE
INNERCOMP
DUP#1=
casedrop CODE
		GOTO	positifext
	 ENDCODE
ONE_DO	(DO)
	::	num#0=case DROP
		ISTOP-INDEX SWAPOVER #2+UNROLL
		NDROP ExitAtLOOP 
		;
	LOOP
CODE
	GOTO	positifext
ENDCODE
;

LABEL positiftag!	
::
'EvalNoCK: xOBJ> 
( obj, tagged )
OVER %0 EQUAL
( obj, tagged, ?=0 )
NOTcasedrop CODE
		GOTO	positifext
	    ENDCODE
SWAPDROP "+" EQUAL
;

LABEL positifconv!
::
VXXL1ext
CODE
	GOTO positifext
ENDCODE
;
************************************************************
NULLNAME FXNDext ( objet -> numerateur, denominateur )
* Decompose une fraction
CODE
fxnd	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	LC(5)	=DOSYMB
	?A=C	A
	GOYES	fxnd1
hxs1	A=PC
	LC(5)	(hxs1!)-(*)
	GOTO	branch1
fxnd1	A=PC
	LC(5)	(fxndext!)-(*)
	GOTO	branch1	
ENDCODE
LABEL fxndext!
::
( o -> num, deno )
LABEL hxs1!
HXS 2 10
OVER
( symb, 1, symb )
INNERCOMP
( symb, 1, meta )
CODE
fxndPOS	EQU	9		Flag to indicate non NEG
	ST=1	fxndPOS	( non NEG )
	D1=D1+	5
	A=DAT1	A
	D1=D1-	5
	LC(5)	=xNEG
	?A=C	A
	GOYES	fxndneg
	D1=D1+	5
	A=DAT1	A
	D1=D1-	5
	GOTO	fxndegal
fxndneg	ST=0	fxndPOS	( NEG )
	D1=D1+	10
	A=DAT1	A
	D1=D1-	10
* stk= symb, 1, meta
* teste si l'operateur est x/ si non -> NDROP
fxndegal	LC(5)	=x/
	?A#C	A
	GOYES	fxndn=
	A=DAT1	A
	?ST=0	fxndPOS
	GOYES	fxndegn
	D1=D1+	5
	D=D+1	A
	DAT1=A	A	A contient le nombre d'elements du symbolique
	LA(5)	=#1-
	PC=(A)
fxndegn	D1=D1+	10
	D=D+1	A
	D=D+1	A
	DAT1=A	A
	LA(5)	=#2-
	PC=(A)
fxndn=	GOSUB	semiml
	LA(5)	=NDROP
	PC=(A)
semiml	C=B	A
	CD0EX
	D0=D0-	5
	A=DAT0	A
	AD0EX
	B=A	A
	D=D+1	A
	RTN
ENDCODE
pshzerpsharg
( symb, 1, meta_sans_x/ )
CODE
	GOLONG	symn
ENDCODE
CODE
	?ST=0	fxndPOS
	GOYES	fxndrneg
	GOVLNG	=Loop
fxndrneg	GOLONG	rneg
ENDCODE
OVER#2+UNROL
************************************************
CODE
symn	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A
	CD1EX
	A=A-CON	A,2
	GOC	symnext
	LA(5)	=SYMBN
	PC=(A)
symnext	D=D+1	A
	D1=D1+	5
	A=DAT1	A
symn1	LC(5)	=xi
	?A=C	A
	GOYES	symncmp
symn2	LC(5)	=xe
	?A=C	A
	GOYES	symncmp
	LC(5)	=x\pi
	?A=C	A
	GOYES	symncmp
symnlp	GOVLNG	=Loop
symncmp	LA(5)	=symcomp
	PC=(A)
ENDCODE
**************************************************
( symb, 1, num, deno )
2SWAP 2DROP
;
*****************************************************
ASSEMBLE
raddend
RPL

************************************************************************
NULLNAME VAL2ext ( #depth, poly-liste, { x1 ... xn } -> poly-symb )
::
( #, P, lvar )
DEFINE valprof	1GETLAM
DEFINE valprof!	1PUTLAM
DEFINE valvar	2GETLAM
ROTSWAP
( P, #, lvar )
ZERO ' NULLLAM DUPTWO DOBIND
CODE
val1	A=DAT1	A
	LC(5)	=ZERO
	?A=C	A
	GOYES	val1.0
	A=PC
	LC(5)	(val1!)-(*)
val1b	A=A+C	A
	PC=(A)
val1.0	D1=D1+	5
	D=D+1	A
val2	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	LC(5)	=DOHSTR
	?A#C	A
	GOYES	val2!2
val8	A=PC
	LC(5)	(valhxs!)-(*)
	GOTO	val1b
val2!2	LC(5)	=DOLIST
	?A#C	A
	GOYES	val2!3
	A=PC
	LC(5)	(vallist!)-(*)
	GOTO	val1b
val2!3	LC(5)	=DOSYMB
	?A#C	A
	GOYES	val2!4
	A=PC
	LC(5)	(valsymb!)-(*)
	GOTO	val1b
val2!4	LC(5)	=DOCOL
	?A#C	A
	GOYES	val2!5
	A=PC
	LC(5)	(valseco!)-(*)
	GOTO	val1b
val2!5	LC(5)	=DOEREL
	?A#C	A
	GOYES	val2!6
	LA(5)	=%%>%
	PC=(A)
val2!6	LC(5)	=DOECMP
	?A#C	A
	GOYES	val2!7
	LA(5)	=C%%>C%
	PC=(A)
val2!7	LC(5)	=DOTAG
	?A#C	A
	GOYES	val2!8
	A=PC
	LC(5)	(valtag!)-(*)
	GOTO	val1b
val2!8	GOVLNG	=Loop
ENDCODE

ABND

NULLNAME CLEANUPext
::
DUPTYPESYMB? NOT?SEMI
* cleanup de xNEG x+ -> x-
CODE
		GOSBVL	=SAVPTR
		C=DAT1	A
		D0=C		@ stk1
		R0=C.F	A
		B=C	A
		GOSBVL	=SKIPOB
		D0=D0+	6	link
		C=D0
		C=C-B	A
		GOSBVL	=GETTEMP	D0=debut, D1=fin
		C=D0
		D1=C		D1=target
		CR0EX.F	A	R0=debut target, C= debut origine
		D0=C		D0=origine
		A=DAT0	A	
		DAT1=A	A	DOSYMB
		D0=D0+	5
		D1=D1+	5
symbnloop	A=DAT0	A
		LC(5)	=SEMI
		?A#C	A
		GOYES	symbncont
		DAT1=A	A
		D1=D1+	5
r0exit		C=D1
		GOSUBL	ShrinkQ
		GOVLNG	=OverWrALoop
symbncont	LC(5)	=xNEG
		?A=C	A
		GOYES	symbnneg
		C=D0
		D=C	A	sauvegarde 
		GOSBVL	=SKIPOB
		C=D	A	recupere adresse debut
		A=D0
		D0=C
		C=A-C	A	taille objet
		GOSBVL	=MOVEDOWN	copie de l'objet
		GOTO	symbnloop
symbnneg	D0=D0+	5
		A=DAT0	A
		LC(5)	=x+
		?A=C	A
		GOYES	symbnneg+
		LA(5)	=xNEG
symbnneg1	DAT1=A	A
		D1=D1+	5
		GOTO	symbnloop
symbnneg+	D0=D0+	5
		LA(5)	=x-
		GOTO	symbnneg1
ENDCODE
; ( end CLEANUPext )

; ( end partie principale de VAL2ext )

LABEL val1!
::
( val1 liste, # -> liste )
#1-SWAP
DUPTYPETAG?
( #, liste, flag )
DUP4UNROLL
IT :: ' xOBJ> EvalNoCK 4UNROLL ;
DUPTYPELIST? ITE INNERCOMP ONE
( tagged?, #, meta )
DUP#0= case2drop :: DROP NULL{} ;
get1 OVER
ZERO_DO (DO)
	( ak, ..., an, a1,...,ak-1, #n, # )
	OVER #2+ROLL OVER
	( ak+1, ..., an, a1,...,ak-1,#n, #, ak,#)
	CODE
	GOLONG	val1
	ENDCODE
	UNROT
	LOOP
DROP {}N
( [tag,] flag, liste )
SWAP NOT?SEMI
SWAP >TAG
;

LABEL valseco!
( val7: seco -> seco ou symb )
::
POSITIFext DUPUNROT ?SKIP RNEGext
( signe, obj )
DUP CARCOMP DUPTYPEHSTR?
( signe, obj, 1er element, ?hxs )
casedrop 
::	NULLNAME SECO2CMPext
	::	( signe, obj )
		CXIRext H2RSext SWAP H2RSext
		( signe, re, im )
		SYMBOL xi ; 'x* EvalNoCK ' x+ EvalNoCK
		;
	SWAP ?SKIP RNEGext
	;
( signe, obj, 1er element )
EQ: x<< NOTcase SWAPDROP
INNERCOMP #5= NcaseTYPEERR
DROP 4ROLLDROP
( a, b, c )
THREE
ZERO_DO (DO)
	CODE
	GOTO	val2
	ENDCODE
	UNROT
	LOOP
' x\v/ OVER TYPESYMB? ITE EvalNoCK :: TWO SYMBN ;
::     SWAP num-1=case :: DROP' x- EvalNoCK ;
       SWAP x*ext ' x+ EvalNoCK
       ;
SWAP ?SKIP RNEGext
;

LABEL valtag!
( val6: tagged -> tagged )
::
' xOBJ> EvalNoCK SWAP
CODE
	GOTO	val2
ENDCODE
SWAP >TAG
;

LABEL valsymb!
( val5: symb -> symb )
::
INNERDUP #1-SWAP
ZERO_DO (DO)
	( meta )
	SWAP
	CODE
	GOTO	val2
	ENDCODE
	( o1, ..., on-1, #n-1, on )
	DUPTYPESYMB?
	::	NOTcase OVER#2+UNROL
                INNERCOMP psh get1 #+-1
                ;
	LOOP
#1+
* pour eviter numerateur/1
CODE
		D1=D1+	5
		A=DAT1	A
		LC(5)	=x/
		?A#C	A
		GOYES	valsymb!1
* stk2=/, stk1=1 ou -1?
		D1=D1+	5
		A=DAT1	A
		D1=D1-	10
		LC(5)	=%1
		?A#C	A
		GOYES	valsymb!0
		ST=0	sALG48
valsymblp	GOVLNG	=Loop
valsymb!0	LC(5)	=%-1
		?A#C	A
		GOYES	valsymb!2
		ST=1	sALG48
		GOTO	valsymblp
valsymb!1	D1=D1-	5
valsymb!2	GOSUBL	semiml
		LA(5)	=SYMBN
		PC=(A)
ENDCODE
UNROT2DROP #2- SYMBNext
CODE
		?ST=0	sALG48
		GOYES	valsymblp
		GOLONG	rneg
ENDCODE
;

LABEL vallist!
::
( val3: liste -> objet )
CODE
	GOLONG	newtrim
*	GOLONG	trimobj
ENDCODE
NOTLISTcase CODE
	GOTO	val2
	ENDCODE
POSITIFext DUPUNROT
?SKIP	RNEGext
( ?+, liste )
valvar valprof #1+DUP valprof!
NTHELCOMP
CODE
	GOSBVL	=popflag
	GOC	val3!1
	GOTO	val2!8	( -> Loop )
val3!1	GOSUB	val3!4
	LC(5)	=DOIDNT
	?A#C	A
	GOYES	val3!3
val3!2	A=PC
	LC(5)	(vallistsym!)-(*)
	GOTO	val1b
val3!3	LC(5)	=DOSYMB
	?A=C	A
	GOYES	val3!2
	LC(5)	=DOLAM
	?A=C	A
	GOYES	val3!2
	A=PC
	LC(5)	(valany!)-(*)
	GOTO	val1b
a=stk1
val3!4	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	RTN
ENDCODE
valprof #1- valprof!
SWAP ?SEMI
RNEGext
;

LABEL vallistsym!
::
( list, idnt/sym -> symb )
SWAPINCOMP DUP#0<> NcaseSIZEERR
( X, an,...,a0, #n+1)
DUP#1=
casedrop	CODE
swpdrpval2	A=DAT1	A	( SWAPDROP )
		D=D+1	A
		D1=D1+	5
		DAT1=A	A
		GOLONG	val2
		ENDCODE 
( X, an,...,a0, #n+1)
positifflag TestUserFlag
CODE
		GOSBVL	=popflag
		GONC	decroissant
croissant	A=PC
		LC(5)	(croissant!)-(*)
		GOTO	val1b
decroissant	A=PC
		LC(5)	(decroissant!)-(*)
		GOTO	val1b
ENDCODE
SYMBNext
;

LABEL decroissant!
::
( code donnant les monomes dans l'ordre decroissant )
get1 SWAPDUP
( an,...,a0, X, #n+1, #n+1 )
ONE_DO (DO)
	( meta, X, length[meta] )
	get1
	CODE
	GOLONG	val2
	ENDCODE
* test si le resultat est nul -> DROP#1-
	CODE
valdec	A=DAT1	A
	LC(5)	=%0
	?A#C	A
	GOYES	vallsn0
	LA(5)	=DROP#1-
	PC=(A)
vallsn0	A=PC
	LC(5)	(vallsn0!)-(*)
	GOTO	val1b
	ENDCODE
	LOOP

( meta, X, length[meta] )
get1
CODE
	GOLONG	val2
ENDCODE
ROTDROP
( meta, length[meta], a0 )
num0=case DROP#1-
DUP DUPTYPEREAL? ITE %0< DROPFALSE
case :: %CHS SWAP' x- SWAP#1+ ;
( meta, length[meta], a0 )
SWAP' x+ SWAP#1+
( meta, a0, x+, length )
3PICK DUPTYPESYMB? NOTcaseDROP
( meta, a0, x+, length, a0 )
DROPROT TWO SWAPINCOMP psh
DROPROT #+-1
;

LABEL vallsn0!
::
( meta, X, length[meta]+1, ak  -> meta, X , newlength: rajoute ak*x^k a meta )
CODE
		GOSUB	val3!4
		LC(5)	=DOSYMB
		?A#C	A
		GOYES	valls1m1
		A=PC
		LC(5)	(vallss!)-(*)
		GOLONG	val1b
valls1m1	LC(5)	=DOREAL
		?A#C	A
		GOYES	vallnr
valls1m0	A=DAT1	A
		LC(5)	=%1
		?A#C	A
		GOYES	valls1m2
		D1=D1+	5
		D=D+1	A
		LA(5)	=TRUEFALSE
		PC=(A)
valls1m2	LC(5)	=%-1
		?A#C	A
		GOYES	valls1m3
		D1=D1+	5
		D=D+1	A
		LA(5)	=FalseFalse
		PC=(A)
valls1m3	AD1EX		( on teste le signe du reel )
		D1=D1+	5
		C=DAT1	W
		AD1EX
		P=	15
		?C=0	P
		GOYES	vallnr
		P=	0
		A=PC
		LC(5)	(valls1m3!)-(*)
		A=A+C	A
		PC=(A)
vallnr		P=	0
		GOSUBL	unrotml
		LA(5)	=TrueTrue
		PC=(A)
ENDCODE
( meta, ak, X, length, flag?x-, flag?x* )
4PICK
( meta, ak, X, length, flag?x-, flag?x*, X )
CODE
		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOSYMB
		?A=C	A
		GOYES	valls90
		GOTO	val2!8	( -> Loop )
valls90		A=PC
		LC(5)	(valls90!)-(*)
		GOLONG	val1b
ENDCODE
( meta, ak, X, length+1, flag?x-, flag?x*, X )
UNROT 'x* OVER
( meta, ak, X, length+1, X, flag?x-, flag?x*, 'x*, flag?x* )
ITE 5UNROLL DROP
( meta, ak, X, x*, length+1, X, flag?x-, flag?x* )
positifflag UserITE INDEX@ ISTOP-INDEX
( meta, ak, X, x*, length+1, X, flag?x-, flag?x*, #k )
CODE
		A=DAT1	A
		LC(5)	=ONE
		?A#C	A
		GOYES	valls91
valls98		D1=D1+	5
		D=D+1	A
valls99		A=DAT1	A
		LC(5)	=TRUE
		?A=C	A
		GOYES	valls101
		LA(5)	=ONE
valls100	DAT1=A	A
		LA(5)	=4ROLL
		PC=(A)
valls101	LA(5)	=THREE
		GOTO	valls100
valls102	A=DAT1	A
		LC(5)	=TRUE
		?A#C	A
		GOYES	valls101
		LA(5)	=FIVE
		GOTO	valls100
valls91		D1=D1+	5
		A=DAT1	A
		D1=D1-	5
		LC(5)	=TRUE
		?A=C	A
		GOYES	valls92
		A=PC
		LC(5)	(valls91!)-(*)
valls9b		A=A+C	A
		PC=(A)
valls92		A=PC
		LC(5)	(valls92!)-(*)
		GOTO	valls9b
ENDCODE
( meta, ak, X, x*, X, flag?x-, #1 / #3 / #5, length+1 )
#+SWAP
( meta, ak, X, x*, X, newlength, flag?x- )
positifflag UserITE ISTOP-INDEX INDEX@ 
CODE
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		LC(5)	=ONE
		?A#C	A
		GOYES	val94
		A=DAT1	A
		LC(5)	=TRUE
		?A#C	A
		GOYES	val93
		D1=D1+	5
		D=D+1	A		
		LA(5)	=#1-
		PC=(A)
val93		D1=D1+	5
		A=DAT1	10
		D1=D1+	5
		LC(5)	=xNEG
		DAT1=C	A
		D1=D1-	10
		DAT1=A	10
		GOLONG	val2!8	( Loop )
* si flag = true -> x+, sinon x- puis UNROT
val94		A=DAT1	A
		LC(5)	=TRUE
		?A#C	A
		GOYES	valfalse
		LC(5)	=x+
valend		DAT1=C	A
		LA(5)	=UNROT
		PC=(A)
valfalse	LC(5)	=x-
		GOTO	valend
ENDCODE
;

LABEL valls1m3!
::
%CHS UNROT FALSETRUE
;

LABEL valls90!
::
( meta, ak, X, length, flag?x-, flag?x*, X )
5ROLL FOUR SWAPINCOMP psh
( meta, ak, metaX, length, flag?x-, flagx*, X, #4 )
DROP 4ROLL 5ROLL
( meta, ak, X, ak, flag?x-, flag?x*, length, length_X )
#+-1 4UNROLL
;

LABEL valls91!
::
UNCOERCE 5UNROLL ' x^ 5UNROLL
CODE
		GOTO	valls102
ENDCODE
;

LABEL valls92!
::
UNCOERCE 6UNROLL ' x^ 6UNROLL
CODE
		GOTO	valls102
ENDCODE
;


LABEL vallss!
::
TWO SWAPINCOMP psh
( meta, meta_ak, X, length, #2 )
DROPROT
( meta, meta_ak, X, length, length_meta_ak )
#+-1 TrueTrue
;

LABEL croissant!
::
get1 ROT
( an,..., a1, #n+1, X, a0 )
CODE
	GOLONG	val2
ENDCODE
::	num0=case DROPZERO
	DUPTYPESYMB?
	case INNERCOMP
	ONE
	;
( an,..., a1, #n+1, X, metaa0 )
get1 SWAP#1+ DUP #2+ROLL
( an,..., a1, metaa0, X, length[meta], #n+1 )
ONE_DO	(DO)
	( ak, ..., a1, meta, X, length[meta] )
	get1
	CODE
		GOLONG	val2
	ENDCODE
	( ak, ..., a2, meta, X, length[meta], a1 )
* si lenght[meta]=1 -> ST=1,  puis si le resultat est nul -> DROP, sinon update
	CODE
val0pos	EQU	11
	ST=0	val0pos
	D1=D1+	5
	A=DAT1	A
	D1=D1-	5
	LC(5)	=ONE
	?A#C	A
	GOYES	+
	ST=1	val0pos
+	GOTO	valdec
	ENDCODE
	( ak, ..., a1, meta, X, length[meta] )
	CODE
	A=DAT1	A
	LC(5)	=ZERO
	?A=C	A
	GOYES	valnot0
	?ST=0	val0pos
	GOYES	valnot0
	D1=D1+	10
	A=DAT1	A
	LC(5)	=x-
	?A#C	A
	GOYES	valnot-
	LA(5)	=xNEG
	DAT1=A	A
	D1=D1-	10
	GOTO	valnot0
valnot-	D1=D1-	10
	LC(5)	=x+
	?A#C	A
	GOYES	valnot0
	A=DAT1	10	( rotdrop: supprime x+ )
	D1=D1+	5
	D=D+1	A
	DAT1=A	10
valloop	GOLONG	val2!8	( -> Loop )
valnot0	LA(5)	=#1+
	PC=(A)
	ENDCODE
	LOOP
' x+ ROTDROPSWAP
( o1, o2, ..., on, #n )
CODE
	?ST=0	val0pos
	GOYES	valloop
	ST=0	val0pos
	GOSUBL	swapml
	LA(5)	=DROP#1-
	PC=(A)
ENDCODE
;

LABEL valany!
::
( list, any )
SWAPINCOMP
DUP#0=csDROP
DUP#1= casedrop CODE
		GOTO	swpdrpval2
		ENDCODE
reversym SWAP
CODE
	GOLONG	val2
ENDCODE
SWAP
get1 SWAP
( a0,..., an, x , #n+1)
ONE_DO
	( a0, ..., ak, res, x )
	DUP4UNROLL RMULText SWAP
	CODE
		GOLONG	val2
	ENDCODE
	RADDext
	SWAPLOOP
( res, x )
DROP
;


LABEL	valhxs!
NULLNAME H2RSext
( lvar8: HXS# -> reel ou string )
::	DUP 

NULLNAME Z2Rext
NULLNAME Z>R
**********************************************************************
* Desc:		Convert Z to real
* Stack:	( Z --> % )
**********************************************************************
CODE
z2r		GOSBVL	=PopASavptr
		D1=A			->Z
		D1=D1+	5
		A=DAT1	A		Zlen
		A=A-CON	A,7
		GONC	Z2R<>0
		LC(5)	=%0
Z2Rpushob	A=C	A
		GOVLNG	=GPPushALp

Z2R<>0		R1=A	A		R1[A] = nibbles-1

		CD1EX
		C=C+A	A
		D1=C
		D1=D1+	7-1		->Zsign

		C=DAT1	S		Convert sign to DEC
		?C=0	S
		GOYES	Z2Rsignok
		P=	16-1
		LCHEX	9
		P=	0
Z2Rsignok	R2=C	S		R2[S] = result sign

		A=0	W		Init result
		B=0	W

* Add mantissa nibble into the result

zrloop		D=0	W
		P=	15-1
		D1=D1-	1
		C=DAT1	P
		D=C	P		mantissa
		C=0	S		sign = +
		C=0	A		exponent = 0

		LCHEX	A		Convert to decimal
		?D<C	P
		GOYES	Z2Rdigok

		D=D-C	P		A->0  B->1 ..
		DSR	WP
		LCHEX	1
		D=C	P		10 11 ..
		C=C+1	A		exponent = 1

Z2Rdigok	P=	0
		SETDEC
		GOSBVL	=ADDF		result += digit	(USES D0!!)
		P=	0
		SETHEX

* Mantissa done - or *16

		C=R1	A		counter
		C=C-1	A
		GOC	zrsign
		R1=C	A

		C=0	W
		P=	14-1
		LCHEX	16
		D=C	W
		P=	0
		C=C+1	A		exponent = 1
		SETDEC
		GOSBVL	=MULTF
		P=	0
		SETHEX

* Check if overflow

		LCHEX	00499
		?A<=C	A
		GOYES	zrloop

		LC(5)	=%MAXREAL	Assume 9.999..E499
		A=R2	S		Sign
		?A=0	S
		GOYES	Z2Rmaxok
		LC(5)	=%-MAXREAL	Return -9.999..E499
Z2Rmaxok	GOTO	Z2Rpushob

zrsign		A=R2.F	S		Set sign
		GOSBVL	=PACK
		GOVLNG	=PUSH%LOOP
ENDCODE

( #z, %r )
DUP %ABS % 999999999999 %< case SWAPDROP
DROP
( #z )
NULLNAME Z2Sext
NULLNAME Z>S
::
LABEL hxs0!
 HXS 1 0 EQUALcasedro "0"
**********************************************************************
* Desc:		Convert Z into decimal in a string
* Stack:	( Z --> String )
**********************************************************************
* Converstion using Horner method
 CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		D0=D0+	5
		A=DAT0	A
		A=A-CON	A,7
		R2=A	A		mantissa nibbles -1
		ASRB.F	A
		ASRB.F	A
		ASRB.F	A
		R1=A	A		number of 8-nibble units -1
		A=A+1	A
		C=A	A
		CSL	A
		C=C+C	A		enough for certain
		RSTK=C
		GOSBVL	=MAKE$N		R0[A] = ->output
		CD0EX
		D1=C
		C=RSTK
		GOSBVL	=WIPEOUT
	
		GOSBVL	=D1=DSKTOP
		A=DAT1	A
		D0=A
		GOSBVL	=SKIPOB

		D0=D0-	1		Setup sign flag
		A=DAT0	S
		ST=1	sPOS		Assume positive
		?A=0	S
		GOYES	todecsignok
		ST=0	sPOS		Negative
todecsignok

* Loop:
*	Add nibble to result
*	If more nibbles expected then result *= 16
*	Loop until no nibbles expected

todeclp		D0=D0-	1
		A=0	W
		A=DAT0	1		nibble to add
		LC(1)	9
		?A<=C	P
		GOYES	todecdigok
		A=A+CON	B,6		A-F to 10-15
todecdigok	C=R0	A
		D1=C
		D1=D1+	10		->output
		SETDEC			Addition loop, finishes eventually
		C=DAT1	W		since sufficient space is guaranteed
		C=C+A	W
		DAT1=C	W
		GONC	todec+ok
todec+loop	D1=D1+	16
		C=DAT1	W
		C=C+1	W
		DAT1=C	W
		GOC	todec+loop
todec+ok	SETHEX

		C=R2	A
		C=C-1	A		nibbles--
		R2=C	A
		GOC	todecfin	No more - finish up

		C=R0	A
		D1=C
		D1=D1+	10		->output
		C=R1	A
		D=C	A		number of 8-nibble units

		C=R2	A		nibs left
		CSRB.F	A		Decrement since result isn't full yet
		CSRB.F	A		(eg high nibbles are known to be zero)
		CSRB.F	A
		D=D-C	A		cntr
		B=0	W		Init last carry
todec*lp	A=0	B		Init new carry
		SETDEC
		C=DAT1	W		Multiply word by 16 with carry in A[B]
		C=C+C	W
		GONC	todec*2
		A=A+1	B
todec*2		A=A+A	B
		C=C+C	W
		GONC	todec*4
		A=A+1	B
todec*4		A=A+A	B
		C=C+C	W
		GONC	todec*8
		A=A+1	B
todec*8		A=A+A	B
		C=C+C	W
		GONC	todec*16
		A=A+1	B
todec*16	C=C+B	W		Add old carry
		GONC	todec*cry
		A=A+1	B
todec*cry	B=A	B		Set new old carry
		DAT1=C	W
		D1=D1+	16	
		SETHEX
		D=D-1	A
		GONC	todec*lp	Loop until only 0-nibbles to come
		GOTO	todeclp
* Finish up:
*	Reverse nibbles in the result
*	Respace into characters
*	Add sign
*	Shrink & exit

todecfin	C=R0
		D1=C
		D1=D1+	10
		D0=C
		GOSBVL	=SKIPOB		->output end
todectrimlp	D0=D0-	1		Stripping loop
		C=DAT0	B
		?C=0	P
		GOYES	todectrimlp
		CD0EX
		D0=C
		C=C+1	A
		D=C	A		->result tail
todecrevlp	C=DAT0	B		Reversing loop
		A=DAT1	B
		DAT1=C	1
		DAT0=A	1
		D1=D1+	1
		D0=D0-	1
		AD0EX
		D0=A
		CD1EX
		D1=C
		?A>C	A
		GOYES	todecrevlp	Loop until pointers cross

		C=D	A		->result tail
		A=R0	A
		C=C-A	A		size of result + prologs
		C=C-CON	A,10		size of result
		CDEX	A
		D0=C			->result tail
		C=C+D	A		->result tail in chars
		?ST=1	sPOS
		GOYES	todecroomok
		C=C+1	A		add room for minus sign
		C=C+1	A
todecroomok	R1=C	A		->result tail (full)
		D1=C
		A=R0	A
		A=A+CON	A,10		->output
		LCASC	'0'		Init #30 for character digits
		CD0EX	
todecasclp	CD0EX
		D0=D0-	1
		D1=D1-	2
		C=DAT0	1
		DAT1=C	B
		CD0EX
		?C>A	A
		GOYES	todecasclp

		?ST=1	sPOS		And add sign if negative
		GOYES	todecexit
		D1=D1-	2
		LCASC	'-'
		DAT1=C	B
todecexit	C=R1	A
		D0=C			->result tail (full)
		GOSBVL	=Shrink$
		GOVLNG	=GPOverWrR0Lp
		ENDCODE
		ONE SYMBN
		;
	
	;

************************************************
NULLNAME ADDMATOBJext ( array,obj -> array,obj | obj, array -> obj, array )
* Prepare une operation entre un array et un objet
::
DTYPEARRY?
' :: ( obj, array -> array, obj )
     DUP xIDN ROT
     ( array, idn, objet )
     CK&DISPATCH1
     real x*
     TWO x*
     any :: ROT AXLext UNROT
            ( array, idn, objet )
            DTYPFMAT? case SWAPDROP
            SWAP AXLext SWAP 'x* LOPAext
            ;
     ;
( obj, array , TRUE, prg | array, obj, FALSE, prg )
SWAP case :: EVAL SWAP ;
ROTSWAP EVAL
;
******************************************************************************
NULLNAME AXLext ( array -> liste )
* Transforme un tableau en liste
::
DUPTYPETAG? IT STRIPTAGS
DUPTYPEARRY? NOT?SEMI
' xARRY\-> EvalNoCK INNER#1=
SWAP COERCESWAP
case {}N
SWAP COERCE NULL{} SWAP
ZERO_DO (DO)
        OVER#2+UNROL {}N DUPLENCOMP
        UNROT >HCOMP
        LOOP
SWAPDROP
;
**************
NULLNAME DERext ( polynome-liste -> derivee )
::
INNERDUP
#1= case2drop HXS 1 0
DUP #2= case2drop ONE{}N
UNROTDROP OVER UNROLL DUPTWO
    DO
    SWAPINDEX@ ZUNCOERCE RMULText OVER UNROLL
    LOOP
#1-{}N
;
*************
NULLNAME COMPext ( obj1, obj2 -> obj1, obj2, true or false )
( teste si obj1 < obj2: tri par type puis par chaine de caracteres )
( longueur de chaine puis ordre alphabetique )
::
SWAP XEQTYPE ROT XEQTYPE
( o1, t1, o2, t2 )
ROT
( o1, o2, t2, t1 ) 
2DUP %> case2drop TRUE
%< caseFALSE
( o1, o2 )
* 2DUPSWAP DO>STR DUPLEN$ ROT DO>STR DUPLEN$ 
* ( o1, o2, s1, l1, s2, l2 )
* ROTSWAP 
* ( o1, o2, s1, s2, l1, l2 )
* 2DUP#= case2drop :: ' x<? EvalNoCK %0<> ;
* #< UNROT2DROP
( tri par longueur et checksum )
2DUPSWAP OCRC ROT OCRC
( o1, o2, n1, c1, n2, c2 )
4ROLLROT
( o1, o2, c1, c2, n1, n2 )
2DUP#= case2drop :: HXS<HXS %0<> ;
#< UNROT2DROP
;
*************************************************
NULLNAME DTYPENDO? ( objet -> objet TRUE ou FALSE )
* Teste si objet est la matrice d'un endomorphisme (matrice carre)
::
AXLext DTYPFMAT? NOTcaseFALSE
DUPLENCOMP OVER CARCOMP LENCOMP #=
;
**************
NULLNAME LISTSECOext ( list, seco ou symb -> list, seco, symb )
* Execute 1GETLAM sur les composants de list ou de seco
LABEL listsecoext!
::
DUPINCOMP
( liste, o1, ..., on, #n )
DUP#0=csDROP
DUP#0_DO
       ( liste, o1, ..., on, #n )
       DUP #1+ROLL 1GETLAM EVAL
       SWAPLOOP
get1 DTYPELIST? casedrop {}N
TYPESYMB? case SYMBN ::N
;
**************************************
NULLNAME MADJext ( matrice M -> M^-1, P[M], P[lambda] )
* Calcule le polynome caracteristique et le polynome matrice adjoint
* d'une matrice donnee.
::
CK&DISPATCH1
list ::	( matrice-liste )
	DTYPENDO? 
	NOTcase :: TRIMOBJext HXS 2 10 OVER NDXFext NULL{} DUP ;
	( A )
	DUP idnext DUPUNROT DUPLENCOMP
	( I_n, A, I_n, #n )
	MADJOBJext
	( [-1]^n*det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
	;
arry :: ( array )
       DUP MDIMS NcaseSIZEERR
       OVER#= NcaseSIZEERR
       ( A, #n )
       SWAPDUP xIDN
       ( #n, A, I_n )
       DUPUNROT 4ROLL
       ( I_n, A, I_n, #n )
       MADJOBJext
       ( det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
       ;
any :: HXS 2 10 OVER NDXFext NULL{} DUP ;
;
*******************
NULLNAME MADJOBJext
::
( I_n, A, I_n, #n )
NULL{} 5UNROLL { HXS 2 10 } 5UNROLL
( {}, { HXS#1 }, I_n, A, I_n, #n )
#1+_ONE_DO (DO)
           ( [lvar],  pmadj , pcar , I_n, A, A_k-1 )
           ( complete pmadj )
           5ROLL OVER AXLext
           >TCOMP 5UNROLL
           ( [lvar], pmadj , pcar , I_n, A, A_k-1 )
           OVER MMULText DUP TRext NEWTRIMext
           ( [lvar], pmadj , pcar , I_n, A, A_k-1*A, tr[A_k-1*A] )
           INDEX@ #>HXS ZTRIMext RNEGext RESOROMP RDIVext LOPAext
           ( [lvar], pmadj , pcar , I_n, A, A_k-1*A, -tr[A_k-1*A]/k )
           ( complete pcar )
           5ROLL OVER
           >TCOMP 5UNROLL
           ( [lvar], pmadj , pcar , I_n, A, A_k-1*A, -tr[A_k-1*A]/k )
           4PICKSWAP MPMULText MADDext
           ( [lvar], pmadj , pcar , I_n, A, A_k=A_k-1*A-tr[A_k-1*A]/k*I_n )
           LOOP
( [lvar], pmadj , pcar , I_n, A, A_n=det[A]*I_n )
3DROP 2DUPSWAP
( [lvar], pmadj, pcar, pcar, pmadj )
DUPLENCOMP NTHCOMPDROP AXLext
( [lvar], pmadj, pcar, pcar, com[A] )
SWAP DUPLENCOMP NTHCOMPDROP
( [lvar], pmadj, pcar, com[A], -det[A] )
DUP 5UNROLL RNEGext
( [lvar], [-1]^n*det[A], pmadj, pcar, com[A], det[A] )
RESOROMP RDIVext TWO MLAM1LAM2ext UNROT
( [-1]^n*det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
;
**************************
NULLNAME MLAM1LAM2ext ( obj1, obj2, prg1, #lev -> matrice )
* effectue obj2 prg1 sur tous les elements de obj1
* situee au niveau 1, le schema de pile de prg1
* doit etre obj obj2 -> obj
* par exemple obj2=%5 et prg1=RMULText
* ou obj2='X' et prg1=VALext
* #lev designe le niveau de recursion
::
( obj1, obj2, op, # -> obj1 op obj2: recursion liste au niveau # )
( LAM4: obj2 )
( LAM3: operateur )
( LAM2: # )
' ::	( LAM1: obj -> obj )
	2GETLAM DUP#0=csedrp :: 4GETLAM 3GETLAM EVAL ;
	#1- 2PUTLAM 
	INNERDUP #1-SWAP
	ZERO_DO
		get1 1GETLAM EVAL
	SWAPLOOP
	#1+ {}N
	2GETLAM #1+ 2PUTLAM
	;
4NULLLAM{} BIND
1GETLAM EVAL
ABND
;
****************************
NULLNAME PREPARext ( o1, o2 -> a1, b1, c1, a2, b2, c2 )
* avec c1=c2 ou c1 et c2 premiers entre eux 
::
SWAP QXNDext 4ROLL QXNDext
( a1, b1, c1, a2, b2, c2 )
4PICKOVER 
( a1, b1, c1, a2, b2, c2, c1, c2 )
EQUALcasedro NOP 
TWO{}N SIMPEVALext LPGCDext
NEWTRIMext HXS 2 10 EQUALcasedro CARCOMP
( a1, b1, c1, a2, b2, { c2 c1 }, d )
5ROLLDROP DUPDUP 
( a1, b1, a2, b2, { c2 c1 }, d, d, d )
6UNROLL UNROT LOPDext
( a1, b1, d, a2, b2, d, { c2' c1' } )
INCOMPDROP 5UNROLL 
( a1, b1, d, c1', a2, b2, d, c2' )
NEWTRIMext COMPext IT SWAP 
:: HXS 2 10 EQUALcasedro NOP
   4UNROLL
   ( a1, b1, d, c1', c2', a2, b2, d )
   HXS 1 0 UNROT NDXQext ROT
   ;
( a1, b1, d, c1', a2', b2', c2' )
7UNROLL 7UNROLL 7UNROLL
( a2', b2', c2', a1, b1, d, c1'  )
NEWTRIMext COMPext IT SWAP 
:: HXS 2 10 EQUALcasedro NOP
   4UNROLL
   ( a1, b1, d, c1', c2', a2, b2, d )
   HXS 1 0 UNROT NDXQext ROT
   ;
( a2', b2', c2', a1', b1', c1'  )
6UNROLL 6UNROLL 6UNROLL
;
******************************************************
NULLNAME QOBJSECext ( objet [ runstream: programme ] -> objet )
* Ex\'exute programme sur les \'el\'ements de objet (pour des objets
* de type liste, alg\'ebrique,  ou array en les d\'ecomposant)
::
'R
CK1TONOext
' :: CK&DISPATCH1
     ELEVEN 2GETEVAL
     list LISTSECOext
     ereal 2GETEVAL
     real 2GETEVAL
     ecmp 2GETEVAL
     TWO 2GETEVAL
     sym 2GETEVAL
     seco 2GETEVAL
     TAGGED :: ' xOBJ\-> EvalNoCK SWAP 1GETLAM EVAL SWAP >TAG ;
     arry :: AXLext 1GETLAM EVAL ;
     any NOP
     ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL
ABND
;
**********************************************
NULLNAME SXSQRext ( obj -> racine carree au signe pres )
::
absflag TestUserFlag
SWAP
absflag SetUserFlag
CODE
xsqr		A=PC
		LC(5)	(xsqr!)-(*)
		A=A+C	A
		PC=(A)
ENDCODE
absflag ROT ITE_DROP ClrUserFlag
; ( end SXSQRext )
***************************************************
NULLNAME XSQRext ( objet -> racine carree de l'objet )
LABEL xsqr!
::
( obj -> sqrt[obj] )
* modifier la recherche pour des seco, afin de donner la priorite aux complexes
TRIMOBJext
CK&DISPATCH1
ereal	::	DUP %%0< NOTcase %%SQRT
		%%CHS %%SQRT %%0 SWAP %%>C%%
		;
ecmp	NULLNAME C%%SQRT
	:: C%%>%% %%R>P %%.5 %%* SWAP %%SQRT SWAP %%P>R %%>C%% ;
real	%SQRT
TWO	C%SQRT
ELEVEN	::	HXS 1 0 EQUALcasedro HXS 1 0
		DupZIsNeg?
		DUPUNROT IT RNEGext
		NFactor
		( negatif?, liste facteurs )
		HXS 1 0 HXS 2 10 DUP 4ROLL
	        ( flag, hxs#1, rac_s, rac_d, liste_rac )
		[BEGIN]
			DUPNULL{}?
		NOT_WHILE
		::	( rac_s, rac_d, liste_rac )
			NEXTPext
	                ( rac_s, rac_d, reste_rac, racine_act )
		        DUPLENCOMP TWO #/ ROT CARCOMP
			( rac_s, rac_d, reste_rac, mult_s, mult_d, rac )
			DUPROT RPext
			( rac_s, rac_d, reste_rac, mult_s, rac, rac_d )
			5ROLL RMULText 4UNROLL
			( liste_rac_s, liste_rac_d, reste_rac, mult_s, rac )
			SWAP #0=case DROP
			( liste_rac_s, liste_rac_d, reste_rac, rac )
			4ROLLSWAP RMULText UNROT
			;
		[REPEAT]
		( flag, hxs#1, liste_rac_s, liste_rac_d, null{} )
		DROP
		( flag, hxs#1, simples, doubles )
		ROT 4ROLL
		ITE
		CODE
		GOLONG	irxc!1
		ENDCODE
		DROP
		( simples, doubles )
		SWAP
		( doubles, simples )
		HXS 2 10 EQUALcasedro NOP
		internalflag TestUserFlag
		case ::	HXS 1 0 UNROT NDXQext ;
		' x\v/ 'x* FOUR SYMBN
		;
seco :: DUPLENCOMP #2= case
	::	CXRIext SWAP2DUP DUP RMULText 
		( y, x, y, x^2 )
		SWAPDUP RMULText RADDext XSQRext
		( y, x, rho )
		2DUP RADDext HXS 2 20 RDIVext XSQRext 
		( y, x, rho, sqrt[ [x+rho]/2] )
		UNROTSWAP RSUBext HXS 2 20 RDIVext XSQRext
		( y, sqrt[ [x+rho]/2], sqrt[ [ rho -x]/2 ] )
		' :: HXS 2 10 HXS 1 0 ;
		4ROLL ZIsNeg? IT RNEGext
		RMULText RADDext
		;
	DUP QNORMext 
        ( x, |x| )
        DUP SXSQRext
        ( x, |x|, sqrt[|x|] )
	:: ( teste si |x| est un carre parfait )
           ( si sqrt|x| est un seco, alors il doit avoir le meme radical que x)
           CK&DISPATCH1
           ELEVEN TRUE
           list TRUE
           seco ::	DUPLENCOMP #2= NOTcaseFALSE
			OVER DUPTYPECOL? NOTcase DROPFALSE
			FOUR NTHCOMPDROP OVER FOUR NTHCOMPDROP EQUAL
			;
	   any	FALSE
           ;
        ROTDROP
        NOTcasedrop :: HXS 1 0 HXS 2 10 ROT NDXQext ; 
        ( x, sqrt[|x|] )
        SWAP QXNDext 
        ( sqrt, d, e, c )
        2SWAP
        ( e, c, sqrt, d )
        2DUPSWAP RSUBext HXS 2 20 RDIVext SXSQRext
        ( e, c, sqrt, d, a )
        :: ( le test n'est probablement le meilleur! )
           NOTSECOcase UNROT2DROP
           DROP RADDext HXS 2 20 RDIVext SXSQRext
           ;
        ( e, c, a )
        ROTSWAP DUP4UNROLL
        ( a, c, e, a )
        HXS 2 20 RMULText RDIVext 
        ( a, c, b )
	SWAP
	( a, b, c )
        ( teste la positivit\'e pour des r\'eels ) 
	CK&DISPATCH1
	# BBB	QABSext
*	any	NDXQext
        any	::	NDXQext xABSext ;
        ;
list :: SQFFext
	INNERCOMP HXS 2 10 DUPROT #2/
	ZERO_DO (DO)
		( l1, m1, ..., lk, mk, rac_s, rac_d )
		2SWAP
		( ..., rac_s, rac_d, lk, mk )
		DUPTYPEREAL? IT COERCE TWO #/
		( ..., rac_s, rac_d, lk, pair/impair, mk/2 )
		::	SWAP DUP#0=csDROP
			DROPOVER 5ROLL RMULText
			4UNROLL
			;
		( ..., rac_s, rac_d, lk, mk/2 )
		RPext RMULText
		LOOP
        ( rac_s, rac_d )
	( change le signe si n\'ecessaire ) 
	POSITIFext ?SKIP RNEGext 
	absflag TestUserFlag ?SKIP RABSext
	( fin du changement de signe )
        SWAP
        ( sym=doubles, simples )
        ' :: ( obj -> symf = sqrt[objet] )
             TRIMOBJext NOTLISTcase XSQRext
             internalflag TestUserFlag
             case :: HXS 1 0 HXS 2 10 ROT NDXQext ;
             ' x\v/ TWO SYMBN
             ;
        UNROT LPGCDext DUPUNROT LOPDext
        ( prg, doubles, lpgcd[simples], simples/lpgcd[simples] )
        4PICK EVAL 4UNROLL ONE{}N ROT EVAL
        ( symf_simples, doubles, symf_lpgcd )
        ROT NOSIMPEVALext 
	::	RMULText SWAP
	        ( symf, doubles )
		RMULText
		;
        ;
sym ::  FXNDext 
        HXS 2 10 EQUALcasedro SYMSQRT
        DUPUNROT RMULText XSQRext SWAP RDIVext
        ;
; ( end XSQRext )
**********************************************************
NULLNAME NOSIMPEVALext
* evalue l'objet suivant du runstream sans faire de simplifications
::
'R pgcdflag TestUserFlag 2Ob>Seco pgcdflag ClrUserFlag EVAL
NOT?SEMI pgcdflag SetUserFlag
;
*****************************************************************
NULLNAME SIMPEVALext
* evalue l'objet suivant du runstream en simplifiant
::
'R pgcdflag TestUserFlag 2Ob>Seco pgcdflag SetUserFlag EVAL
?SEMI pgcdflag ClrUserFlag
;
******************************
NULLNAME DTYPFMAT? ( objet -> objet TRUE ou -> objet FALSE )
* Teste si on a affaire  une matrice formelle
::
( obj -> matrice formelle, true ou obj, false )
NOTLISTcase FALSE
CKFPOLYext
INNERDUP #1-SWAP
ZERO_DO	 
	 get1 DUPTYPETAG? IT STRIPTAGS
	 SWAPLOOP
#1+ {}N
DUP CARCOMP
NOTLISTcase DROPFALSE
OVERSWAP LENCOMP
( liste, liste, longueur de la 1re liste de liste )
' :: ( obj, longueur -> false si obj est une liste de longueur #= )
     SWAP DUPTYPELIST? NOTcase2drop TRUE
     LENCOMP #<>
     ;
POSCOMP
( liste, 1re occurence )
#0=
( liste, flag )
;
**************
NULLNAME CK1TONOext ( prg -> prg en remplacant CK1&Dispatch par CK&DISPATCH1 )
::
DUPTYPECOL?
NOT?SEMI
DUP CARCOMP
{ CK1&Dispatch CK2&Dispatch }
matchob?
( seco, [ first, FALSE ] | TRUE )
NOTcaseDROP
( o1, ..., on, #n )
CDRCOMP
' CK&DISPATCH1
>HCOMP
;
**************************************
NULLNAME NEXTPext ( liste -> liste1, liste2 )
* liste=liste1+liste2, liste2 est formee d'elements identiques
( { o1 o2 ... } -> { liste1 }, { o1 ... o1 } )
( liste1=liste-{o1 ... o1 } )
::
NULL{} SWAPDUP LENCOMP #>1 NOT?SEMI
SWAPDROP
( liste )
INNERDUP
( o1, ..., on, #n, #n )
get1 ONE
( o2, ..., on, #n, #n, o1, #1 )
ROT #1-
ZERO_DO (DO)
	( o2, ..., on, #n, o1, #m )
	ROT
	( o2, ..., on, o1, #m, #n )
	get1
	( o3, ..., on, o1, #m, #n, o2 )
	4PICKOVER
	( o3, ..., on, o1, #m, #n, o2, o1, o2 )
	::	EQUALcasedrp #1-UNROT ( o3, ..., on, #n-1,o1,#m)
		( o3, ..., on, o1, #m, #n, o2 )
		4UNROLL 
		( o3, ..., on, o2, o1, #m, #n )
		UNROT #1-
		( o3, ..., on, o2, #n, o1, #m-1 )
		;
	( o3, ..., on, o2, #n, o1, #m )
	#1+
	LOOP
( o2, ..., on, #n, o1, #m )
NDUPN {}N SWAP#1-SWAP OVER#2+UNROL {}N SWAP
;
**************
NULLNAME TRext ( matrice -> trace )
*
::
CK&DISPATCH1
list :: INNERCOMP reversym SWAP CARCOMP SWAP
        #1+DUP #2=
        caseDROP
        TWO DO
            SWAPINDEX@ NTHCOMPDROP RADDext
            LOOP
        ;
arry :: xARRY\-> INCOMPDROP DROP COERCEDUP
        #1=case DROP
        DUP1LAMBIND
        ( a11, ..., a1n, ..., an1, ..., ann, #n )
        ONE_DO (DO)
               1GETLAM DUPUNROT #2+UNROLL NDROP x+
               LOOP
        ABND
        ;
;
**************
ASSEMBLE
toBDIV		GOLONG	BDIV
tormult		GOLONG	rmult
toZQUO		GOLONG	ZQUO
RPL
*******************************************************
NULLNAME MMULText ( matrice 1, matrice 2 -> produit des 2 matrices )
::
MMULTOBJext NOTcase :: 'x* EvalNoCK ;
( A et B doivent etre des matrices listes valides )
( teste compatibilite #colonnes de A=#lignes de B )
DUPLENCOMP 3PICK CARCOMP LENCOMP #= NcaseSIZEERR
( A, B )
TRANext INNERCOMP get1
( vecteurs colonnes de B b1, ..., bc, #c, A )
INNERCOMP get1
( b1, ..., bc, a1, ..., an, #n, #c )
RESOROMP RMULText
RESOROMP RADDext
' NULLLAM DUPDUP THREE DOBIND
( b1, ..., bc, a1, ..., an, #n )
DUP #3+ THREE
           [DO]
           DUPDUP 3GETLAM #+ INDEX@ #+SWAP
           ( b1, ..., bc, a1, .., an, ..., ck-1, #n, #n+#c+k+3, #n)
           #2+PICK
           ( b1, ..., bc, a1, ..., an, ..., ck-1, )
           ( #n, #n+#c+3+k, ak )
           SWAP 3GETLAM
           ZERO_DO (DO)
                   ( b1, ..., bc, a1, ..., an, ..., ck-1, )
                   ( #n, ak, #n+#c+k+3 )
                   DUPPICK 3PICK
                   ( XYext )
		   pgcdflag TestUserFlag UNROT
		   pgcdflag ClrUserFlag
                   :: INNERCOMP #1+ROLL INNERCOMP
                      DUP#1= casedrop 2GETEVAL
                      get1
                      ( y1, ..., yn-1, x1, ..., xn, #n, yn )
                      ROTSWAP 2GETEVAL
                      ( y1, ..., yn-1, x1, ..., xn-1, #n, xn*yn )
                      OVER
                      ONE_DO (DO)
                             ROT 3PICK #2+PICK 2GETEVAL 1GETLAM EVAL
                             LOOP
                      ( y1, ..., yn-1, #n, X.Y )
                      OVER #1+UNROLL #1- NDROP
                      ;
                   pgcdflag ROT ITE SetUserFlag DROP
                   TRIMOBJext
                   ( fin de XYext )
                   UNROT
                   LOOP
           ( b1, ..., bc, an, ..., a1, ..., ck-1, )
           ( #n, ak.b1, ..., ak.bc, ak, #2n+3+k )
           2DROP 3GETLAM {}N
           ( apres swap avant loop: b1, ..., bn, an, ..., a1, ...,ck , #n )
           SWAPLOOP
( b1, ..., bc, an, ..., a1, c1, ..., cn, #n )
DUP 3GETLAM #+ OVER#2+UNROL {}N
( b1, ..., bc, an, ..., a1, #n+#c, C )
OVER#2+UNROL NDROP
ABND
;
**************
NULLNAME MPMULText ( matrice, scalaire -> matrice )
::
SMULTOBJext NOTcase :: 'x* EvalNoCK ;
RESOROMP RMULText TWO MLAM1LAM2ext
;
***************
NULLNAME idnext ( cre la matrice identite)
* liste, arry, real ou # -> identite
::
DUPTYPELIST? IT LENCOMP
DUPTYPEBINT? IT UNCOERCE
' xIDN EvalNoCK AXLext
internalflag TestUserFlag NOT?SEMI
' ::	DUPTYPELIST? 
	ITE LISTSECOext R2Zext 
	;
1LAMBIND LISTSECOext ABND
;
**************
NULLNAME CKFPOLYext
::
( obj -> obj ou ERROR )
DUP
DUPTYPECOL? caseSIZEERR
DUPTYPELIST? NOTcaseDROP
' :: DUPTYPECOL? caseSIZEERR
     DUPTYPELIST? NOTcaseDROP
     DUPNULL{}? caseSIZEERR
     INNERCOMP
     ZERO_DO (DO) 1GETLAM EVAL
                  LOOP
     ;
DUP1LAMBIND EVAL ABND
;
**********************************
NULLNAME LOPAext ( liste, objet, oprateur binaire -> liste )
* List Operation All
::
' :: dLISTcase LISTSECOext
     3GETLAM 2GETEVAL
     ;
' NULLLAM DUPDUP THREE DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME MMULTOBJext ( o1, o2 -> o1, o2, flag )
* Prpare un produit matrice/matrice ou matrice/vecteur symbolique
* flag = true pour resulat symbolique
* flag = false pour numerique
::
CK&DISPATCH1
2LIST TRUE
FIVEFOUR :: AXLext TRUE ;
SIXTYEIGHT FALSE
FOURFIVE :: SWAP AXLext SWAPTRUE ;
;
***********************************
NULLNAME SYMBNext
( meta -> sym ou obj )
::
DUP#1=
NOTcase SYMBN
DROP
{ xe xi x\pi } OVER EQUALPOSCOMP
#0=?SEMI
EvalNoCK
;
*******************************
NULLNAME SMULTOBJext  ( matrice/vecteur, scalaire -> m,s, flag )
* Prpare un produit matrice ou vecteur par un scalaire
* flag=false pour resultat numerique, True pour symb
::
CK&DISPATCH1
BINT_65d FALSE ( matrice num * reel -> matrice num )
FOURTWO FALSE ( matrice num * complexe  -> matrice num )
SIXTYFOUR ::	( matrice num * objet -> matrice symb )
		SWAP AXLext SWAPTRUE
		;
EIGHTY TRUE
;
***********************************
NULLNAME TRANext ( matrice -> matrice transposee )
*
::
CK&DISPATCH1
list :: INNERCOMP OVER LENCOMP
        ( l1, l2, ..., lm, #m, #n )
        DUP
        #1+_ONE_DO (DO)
                INDEX@ 3PICKOVER #2+ #+
                ( l1, ..., lm, ..., tk-1 ,#m, #n, #1+k, #m+3+k )
                4PICK
                ZERO_DO (DO)
                        DUP#1+PICK 3PICK NTHCOMPDROP UNROT
                        LOOP
                SWAPDROP
                ( l1, ..., lm , .., tk-1, #m, #n, e1, ..., em, #m+3+k)
                INDEX@#- #2- {}N
                ( l1, ..., lm, #m, #n , tk )
                UNROT
                LOOP
        ( l1, ..., lm, t1, ..., tn, #m, #n)
        DUPUNROT
        ( l1, ..., lm, t1, ..., tn, #n, #m, #n)
        #2+UNROLL {}N
        ( l1, ..., lm, #m, At )
        OVER#2+UNROL NDROP
     ;
arry :: MATTRN xCONJ ;
;
**************
NULLNAME IEGCDext
::
( a, b  )
integerflag TestUserFlag
integerflag SetUserFlag
RESOROMP RMULText
' ::	( LAM1 : a, b  -> d, u, v )
	( avec d=au+bv )
	( a, b )
	num#0=case :: DROP HXS 2 10 HXS 1 0 ;
	( a, b )
	DUPUNROT DIVext
	(  B, A div B, A mod B )
	ROTSWAP
	( A div B, B, A mod B )
	1GETLAM EVAL 
	( A div B, d, u1, v1 )
	( avec : d= B*u1+[A mod B]*v1 )
	( [A mod B]=A-[A div B]*B )
	( donc: d= A*v1+ B*[u1-[A div B]*v1] )
	( v=v1, u=u1-[A div B]*v1 )
	( A div B, d, u1, v1 )
	4ROLL OVER 2GETEVAL
	( d, u1, v1, [A div B]*v1 )
	ROTSWAP RSUBext
	( d, v1, u1-v1*A div B )
	;
' NULLLAM DUPDUP THREE DOBIND
1GETLAM EVAL 
( d, u, v )
3GETLAM ABND
?SEMI integerflag ClrUserFlag
;
******************************
NULLNAME LISTMAXext
( poly-liste -> poly-liste, max, true, depth ou poly-liste, ?, false, #0 )
* etape 1 de gcdheu: algo s'applique? si oui calcul du plus grand coeff
::
ZEROZERO 
( poly-l, #0, #0 )
* modifie de PNMax (alg48) pour traiter les complexes
CODE
lmaxst		EQU	9	indique la presence d'un complexe
* First check that stk1 is a list, if not then leave it unchanged
		GOSBVL	=SAVPTR
		ST=0	lmaxst
		D1=D1+	10
		C=DAT1	A
		CD0EX
		A=DAT0	A		prolog
		D0=C
		LC(5)	=DOLIST
		?A=C	A
		GOYES	dopnmax
exitfalse	GOSBVL	=GETPTR
		ST=0	lmaxst
		LA(5)	=FALSE
		DAT1=A	A
		A=0	A
		GOVLNG	=PUSH#ALOOP

dopnmax		A=DAT1	A
		D0=A			->list
		D0=D0+	5		->ob1
		B=0	A		complevel
		A=0	A
		R2=A	A		maxcomplevel

* Now scan for the first Z

pnmaxZ1lp	LC(5)	=DOHSTR
		A=DAT0	A
		?A=C	A
		GOYES	pnmaxgotZ1
		LC(5)	=DOLIST
		?A=C	A
		GOYES	pnmaxZ1!1
		LC(5)	=DOCOL		Must be DOLIST
		?A=C	A
		GOYES	pnmaxZ1!0
		GOTO	exitfalse
pnmaxZ1!0	ST=1	lmaxst
pnmaxZ1!1	GOSUB	listmaxb++
		D0=D0+	5		
		GONC	pnmaxZ1lp

pnmaxgotZ1	AD0EX
		R0=A			->Zmax
		D0=A

* Now scan the remaining list, comparing the Z's to the max in R0

pnmaxLOOP	D0=D0+	5
		C=DAT0	A		Zmaxlen
		AD0EX
		A=A+C	A		->Zmaxtail
		D0=A
pnmaxloop	A=DAT0	A
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	pnmaxcmp
		LC(4)	=SEMI
		?A=C	A
		GOYES	pnmaxsemi
		LC(5)	=DOLIST
		?A=C	A
		GOYES	pnmaxlist
		LC(5)	=DOCOL
		?A=C	A
		GOYES	pnmaxseco
		GOTO	exitfalse
pnmaxseco	ST=1	lmaxst
pnmaxlist	GOSUB	listmaxb++
pnmax05		D0=D0+	5
		GONC	pnmaxloop
pnmaxsemi	B=B-1	A
		GONC	pnmax05
		CDEX	A
		GOSBVL	=GETPTR
		LA(5)	=TRUE
		DAT1=A	A		write TRUE
		D1=D1+	5
		A=R0	A
		DAT1=A	A		write Zmax
		D1=D1-	5
		A=R2	A
		GOVLNG	=PUSH#ALOOP	write macomplevel

pnmaxcmp	C=R0
		CD0EX			D0 ->Zmax
		R1=C			R1 ->Z
		D1=C			D1 ->Z
		GOSUBL	ZNCMP		A[0]={1:Zmax>Z 0:Zmax=Z F:Zmax<Z
		C=R1
		D0=C			->Z
		?ABIT=0	3
		GOYES	pnmaxtoloop	Zmax>=Z, keep looking
		R0=C			->Zmax (new)
pnmaxtoloop	GOTO	pnmaxLOOP

listmaxb++	B=B+1	A		complevel++ et ajuste maxcomplevel
		A=R2	A
		?A>=B	A
		GOYES	listmaxb++1
		A=B	A
		R2=A	A
listmaxb++1	RTN
ENDCODE
* teste s'il y a des complexes -> max=max*2
CODE
		?ST=1	lmaxst
		GOYES	lmax*2
		GOSUBL	semiml
lmax*2		GOVLNG	=Loop	
ENDCODE
ROT HXS 2 20 RMULText UNROT
;
*************************
**************
NULLNAME ERR$EVALext ( seco  -> action )
* Pour un # effectue :: SWAP NOTcase :: # 31400 #+ DO#EXIT ; DROP ;
* Donc on peut faire un test puis # ERR$EVALext, ou # dsigne
* le numro d'erreur a executer si le test est false,
* Pour un % effectue teste le flag utilisateur %, si le test
* est ngatif, depile l'objet situ au niveau 2, sinon revient
*  l'excution normale, ceci permet un programme du type
* { ONE TWO &$ DISPROW1 } %1 ERR$EVALext qui affiche la concatnation
* des messages 1 et 2 lorsque le flag 1 est arm.
* Sinon excute le programme, la liste ou le symbolique
* (EVAL de chaque objet) mais pour les entiers
* systmes non taggus, remplace ces entiers par #31400+# et
* excute JstGETTHEMESG (rappelle le message d'erreur # de ALGB)
* Exemple { ONE TWO &$ DISPROW1 } ERR$EVALext
* rappelle les messages 1,2 les concatne et affiche le rsultat
* en ligne 1.
* Attention, les NULLLAM sont decales de 2 et les compteurs de
* boucles de 1
::
DUPTYPEREAL? IT :: COERCE TestUserFlag ?SEMI DROP RDROP ;
DUP TYPEBINT? case :: SWAP caseDROP # 31400 #+ DO#EXIT ;
DUP1LAMBIND LENCOMP
#1+_ONE_DO (DO)
           1GETLAM INDEX@ NTHCOMPDROP DUPTYPEBINT?
           ITE :: # 31400 #+ JstGETTHEMSG ; EVAL
           LOOP
ABND
;
*************************************************************
NULLNAME User1IT
* Execute l'objet au niveau 1 a la maniere de ERR$EVALext si UF1 est arme.
::
displayflag UNCOERCE ERR$EVALext
;
*****************************************************************
NULLNAME LVARDext 
( objet, liste d'operateurs -> objet, liste des idnt globaux )
::
( obj, liste d'operateurs )
ZERO ( LAM2 profondeur actuelle )
NULL{} ( LAM1 liste des identificateurs )
' NULLLAM DUPDUP THREE DOBIND
DEFINE lvarop		3GETLAM
DEFINE lvarlist		1GETLAM		( # )
DEFINE lvarlist!	1PUTLAM
DEFINE profact		2GETLAM		( # )
DEFINE profact!		2PUTLAM
( obj -> obj )
DUP
CODE
lvar1	GOSUB	lvar1s
	?C#A	A
	GOYES	lvar1!1
lvar2	A=PC
	LC(5)	(lvarsymb!)-(*)
lvar1!0	A=A+C	A
	PC=(A)
lvar1!1	LC(5)	=DOLIST
	?C#A	A
	GOYES	lvar1!2
lvar3	A=PC
	LC(5)	(lvarlst!)-(*)
	GOTO	lvar1!0
lvar1!2	LC(5)	=DOCOL
	?C#A	A
	GOYES	lvar1!3
lvar4	GOSUB	a=stk5
	LC(5)	=x<<
	?A#C	A
	GOYES	lvar4!1
	A=PC
	LC(5)	(lvarirrq!)-(*)
	GOTO	lvar1!0
lvar4!1	LC(5)	=DOHSTR
	?A=C	A
	GOYES	lvar1!6
	A=PC
	LC(5)	(lvarseco!)-(*)
	GOTO	lvar1!0
lvar1!3	LC(5)	=DOIDNT
	?C#A	A
	GOYES	lvar1!5
lvar5	A=PC
	LC(5)	(lvaridnt!)-(*)
	GOTO	lvar1!0
lvar1!5	LC(5)	=DOLAM
	?C=A	A
	GOYES	lvar5
lvar1!6	GOVLNG	=DropLoop
lvar1s	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	LC(5)	=DOSYMB
	RTN
a=stk5	C=DAT1	A
	CD1EX
	D1=D1+	5
	A=DAT1	A	A=@obj1 du seco
	CD1EX
	RTN
	ENDCODE
1GETABND
( profondeur, objet, liste des idnt globaux )
;

LABEL lvarlst!
:: ( lvar3 liste ->  )
profact #1+ profact!
	LABEL	lvarsymb!
	::	( lvar2 comp ->  )
	DUP' x? EQUALPOSCOMP #0<> caseDROP
	INNERCOMP
	( o1, ..., on, #n )
	DUP#0=csDROP
	ZERO_DO (DO)
		( o1, ..., on )
		CODE
		GOTO	lvar1
		ENDCODE
		LOOP
	;
profact #1- profact!
;

LABEL lvarexp!
::	( o1, ..., on-1=%, on= x^ )
	OVERDUP %FLOOR %=
	caseDROP
	CODE
	GOTO	eqlksecon
	ENDCODE
	;

LABEL lvarseco!
:: ( lvar4 seco d'un meta ->  )
lvarop
CODE
		D1=D1+	5	( drop lvarop )
		D=D+1	A
		A=D1
		R1=A	A	R1=sauvegarde D1
		A=DAT1	A
		R0=A	A	R0=seco
		D1=D1-	5
		A=DAT1	A
		AD1EX
eqlkloop	D1=D1+	5	D1-> liste d'operateurs
		C=DAT1	A
		LA(5)	=SEMI
		?A#C	A
		GOYES	eqlk1
		C=R1	A
		CD1EX		restaure D1
eqlksecon	A=PC
		LC(5)	(lvarsecon!)-(*)
eqlkb		A=A+C	A
		PC=(A)
eqlk1		A=R0	A
		?A#C	A
		GOYES	eqlkloop
		LC(5)	=x^
		?A#C	A
		GOYES	eqtoloop
		C=R1	A
		CD1EX		restaure D1
		D1=D1+	5	on regarde si le niveau 2 est reel
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOREAL
		?A#C	A
		GOYES	eqlksecon	(exposant non reel -> lvarsecn!)
		A=PC
		LC(5)	(lvarexp!)-(*)
		GOTO	eqlkb	-> teste si l'exposant est entier
eqtoloop	C=R1	A	operateur reconnu
		CD1EX		restaure D1
		GOTO	lvar1!6
ENDCODE
;

LABEL lvarsecon!
::
( o1, ..., ok-1, ok=seco )
ISTOP-INDEX
( o1,...,ok, #k )
pZpargSWAPUn
( o1, ..., oj, #j, oj+1,...,ok, #k-j )
SYMBN
( o1,...,oj, #j, "seco[idnt]" )
SWAP#1+ ISTOPSTO ZERO INDEXSTO
( o1,...,oj, "seco[idnt]" )
	LABEL lvaridnt!
	:: ( lvar5 sym -> )
	lvarlist
	( sym, lvarlist )
	CODE
* si la liste est null{} -> drop ONE{}N
		A=DAT1	A
		LC(5)	=NULL{}
		?A#C	A
		GOYES	lvaridnt!1
		D=D+1	A
		D1=D1+	5
		LA(5)	=ONE{}N
		PC=(A)
lvaridnt!1	GOSUB	matchob
		GONC	lvaridnt!2
* carry set -> not found
		A=PC
		LC(5)	(insert!)-(*)
		GOTO	eqlkb
* carry clear -> swapdrop
lvaridnt!2	LA(5)	=SWAPDROP
		PC=(A)
matchob		GOSBVL	=SAVPTR
		A=DAT1	A	A=@stk1
		D1=D1+	5
		C=DAT1	A	C=@stk2
		AD0EX
		CD1EX
		D0=D0+	5	D1= @sym, D0=@ 1er objet de list
* teste si on est en fin de liste
lvaridnt!l	A=DAT0	A
		LC(5)	=SEMI
		?A#C	A
		GOYES	lvaridnt!t
		GOSBVL	=GETPTR
		RTNSC
* on n'est pas en fin de liste: @D1 EQUAL @D0?
lvaridnt!t	GOSUBL	EQUAL?	* carry clear=EQUAL
		GONC	lvaridnt!true
* @D1 <> @D0 -> skipob
		GOSBVL	=SKIPOB
		GOTO	lvaridnt!l
lvaridnt!true	GOSBVL	=GETPTR
		RTNCC
	ENDCODE
	( lvarlist )
	lvarlist!
	;
;

LABEL insert!
::
( pour mise a jour de lvar )
( sym, liste -> liste )
( sym, liste )
SWAP2DUP 
CODE
lvar8		GOSUB	lvar1s
		?A#C	A
		GOYES	lvar8!1
		LA(5)	=symb
		PC=(A)
lvar8!1		LC(5)	=DOIDNT
		?A#C	A
		GOYES	lvar8!2
		LA(5)	=idnt
		PC=(A)
lvar8!2		LC(5)	=DOLAM
		?A#C	A
		GOYES	lvar8!3
		LA(5)	=SEVEN
		PC=(A)
lvar8!3		LA(5)	=TEN
		PC=(A)
ENDCODE
( list, sym, list, sym, #type )
SWAP DO>STR DUPLEN$ THREE{}N
( list, objet, list, { #type str len$ } )
'		CODE
lvar7		A=PC
		LC(5)	(lvarcomp!)-(*)
		GOTO	lvar1!0
		ENDCODE
POSCOMP INSERT{}N
;


LABEL lvarirrq!
::
INNERCOMP #5= NcaseTYPEERR
DROP 4ROLLDROP THREE
ZERO_DO (DO)
	CODE
	GOTO	lvar1
	ENDCODE
	LOOP
;

LABEL lvarcomp!
::
( lvar7 objet1, { type length crc } -> flag )
( teste si type[objet1]>type, si =, teste )
( la longueur de objet1 / length )
( si encore =, fait un tri par CRC )
( obj1, { type2, str2, len2 } )
INCOMPDROP 4ROLL
CODE
	GOTO	lvar8
ENDCODE
( type2, str2, len2, obj1, type1 )
5ROLL
( str2, len2, objet1, type1, type2 )
2DUP#=
case2drop ::	( str2, len2, obj1 )
		DO>STR DUPLEN$
		( str2, len2, str1, len1 )
		ROTSWAP
		( str2, str1, len2, len1 )
		2DUP#=
		case2drop ::	' x>? EvalNoCK
				orderflag UserITE %0= %0<> 
				;
		#> UNROT2DROP
		;
#< 4UNROLL3DROP
;
***************************************
NULLNAME DEPTHext ( objet -> # )
* renvoie la profondeur maximale d'un objet
CODE
depth		GOSUB	depth0
		LC(5)	=DOREAL
		?A#C	A
		GOYES	depth0!1
depth0!0	LA(5)	=DROPZERO
		PC=(A)
depth0!1	LC(5)	=DOIDNT
		?A=C	A
		GOYES	depth0!0
		GOTO	depthobj0
ENDCODE
******************************************
NULLNAME DEPTHOBJext
( objet, # -> profondeur )
CODE
depthst		EQU	9
depthobj	ST=0	depthst
		GOSBVL	=POP#
		LC(5)	1
		?A#C	A
		GOYES	depthobj1
depthobj0	ST=1	depthst
depthobj1	A=PC
		LC(5)	(depthobj!)-(*)
		GOTO	depth1!0
ENDCODE
LABEL	depthobj!
::
ZEROZERO ( LAM2 et 1 profondeur maxi et actuelle )
DEFINE action		3GETLAM		( # )
DEFINE pmaxi		1GETLAM		( # )
DEFINE pmaxi!		1PUTLAM
DEFINE pact		2GETLAM		( # )
DEFINE pact!		2PUTLAM
' NULLLAM DUPTWO DOBIND
CODE
depth1		GOSUB	depth0
		LC(5)	=DOSYMB
		?A#C	A
		GOYES	depth1!1
depth9		?ST=0	depthst
		GOYES	depth1!4
		A=PC
		LC(5)	(depthcomp!)-(*)
depth1!0	A=A+C	A
		PC=(A)
depth1!1	LC(5)	=DOLIST
		?A#C	A
		GOYES	depth1!2
depth5		A=PC
		LC(5)	(depthlist!)-(*)
		GOTO	depth1!0
depth1!2	LC(5)	=DOCOL
		?A#C	A
		GOYES	depth1!3
		A=PC
		LC(5)	(depthseco!)-(*)
		GOTO	depth1!0
depth1!3	LC(5)	=DOARRY
		?A#C	A
		GOYES	depth1!4
		A=PC
		LC(5)	(deptharry!)-(*)
		GOTO	depth1!0
depth1!4	D=D+1	A	( DROP )
		D1=D1+	5
		GOVLNG	=Loop
depth0		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		RTN
ENDCODE
1GETABND
( fin de DEPTH )
;

LABEL depthlist!
::	( depth5 liste -> )
pact #1+DUP pact!
pmaxi #MAX pmaxi!
	LABEL depthcomp!
	::	( comp -> )
	INNERCOMP DUP#0=csDROP
	ZERO_DO (DO)
		CODE
		GOTO	depth1
		ENDCODE
		LOOP
	;
pact #1- pact!
;

LABEL deptharry!
::	( arry -> )
MDIMS SWAPDROP ITE DROPONE ZERO #1+
pact #+ pmaxi #MAX pmaxi!
;

LABEL depthseco!
::	( depth7 seco -> )
DUP CARCOMP EQ: x<< NOTcaseDROP
INNERCOMP #5= NcaseTYPEERR
DROP 4ROLLDROP THREE
ZERO_DO (DO)
	CODE
	GOTO	depth1
	ENDCODE
LOOP
;

**********************
NULLNAME INSERT{}N ( liste, obj, # pos -> liste )
* insre objet dans la liste  la position # pos,
* # pos doit etre infrieur au nombre d'lments de liste
* si # pos est nul, l'lment est rajout en FIN de liste
::
DUP#0=csedrp >TCOMP
ROT INNERCOMP get1
( obj, v1,...,vk,#k, #pos )
SWAP#1+
( obj, v1,...,vk, #pos, #k+1 )
DUPROT #-SWAP
( obj, v1,..., vk, #k+1-pos, #k+1 )
get1
( v1,...,vk, #k+1-pos, #k+1, obj )
ROT #2+UNROLL {}N
;
***************************
NULLNAME MADDext
::
RESOROMP VADDext VASOPext
;
**************************
NULLNAME MSUBext
::
RESOROMP VSUBext VASOPext
;
*************************
NULLNAME VADDext
::
' CODE
	GOLONG	radd
ENDCODE
VASOPext
;
*************************
NULLNAME VSUBext
::
' CODE
	GOLONG	rsub
ENDCODE
VASOPext
;
*************************
NULLNAME VASOPext
* vect1, vect2, op -> vec
::
1LAMBIND
INNERCOMP
get1
INNERCOMP
get1
( a1, ..., aa, b1,...,bb, #a, #a )
ZERO_DO (DO)
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a )
	get1 ROTSWAP 1GETLAM EVAL OVER #1+UNROLL
	LOOP
( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a )
{}N ABND
;
**************************
ASSEMBLE

**********************************************************************
* Desc:		Add Q1+Q2 to output
* Entry:	D0    = ->Q1
*		D1    = ->Q2
*		R3[A] = ->output (with sufficient free memory)
* Exit:		R3[A] = ->output'
* Algorithm:	Modif B. Parisse pour resultat trimmed
*		utilise R4 quartets 5 et 6
*		juste apres ecriture de DOLIST, on augmente R4.5-6 de 1 et
*		on execute ST=1	sTRIM
*		lorsque on doit ecrire un HXS, on teste si ST=1 sTRIM
*		si c'est le cas, on regarde si c'est HXS 1 0
*		dans ce cas on n'ecrit rien, sinon on ecrit et on met R4 a 0
*		ainsi que ST=0 sTRIM
*		lorsque on doit ecrire SEMI, on teste si ST=1, si ce n'est
*		pas le cas on ecrit normalement SEMI, si c'est le cas
*		on decremente R3[A] de 5*R4. Il faut tester
*		si complevel=0, alors il faut quand meme ecrire un HXS 1 0
*
*		For each Z1,Z2 pair
*			output Z1+Z2
*		For each Z1,P2 pair
*			complevel2++
*			copy DOLIST & all but last element of P2 to output
*		For each P1,Z2 pair
*			complevel1++
*			copy DOLIST & all but last element of P1 to output
*		For each P1,P2 pair
*			complevel1++, complevel2++
*			copy DOLIST & leading elements from the longer
*			polynomial to output.
*		For each SEMI SEMI pair
*			complevel1--m complevel2--, output SEMI
*		For each ob SEMI pair
*			complevel2--, output SEMI
*		For each SEMI ob pair
*			complevel1--, output SEMI
**********************************************************************
QSUB		ST=1	sQSUB
		GOTO	QADD/SUB

QADD		ST=0	sQSUB

QADD/SUB	C=0	A
		R0=C.F	A		comp1 = 0
		R1=C.F	A		comp2 = 0
		ST=0	sQSWAP		Start in normal order
		ST=0	sTRIM		Autorise la sortie de HXS 1 0
		P=	6
		CR4EX.F	WP
		C=0	P		complevel pour hxs 1 0 ( de 0 a 255 )
		P=	5
		C=0	P
		P=	6
		CR4EX.F	WP
		P=	0
* Main Q1+Q2 addition loop

Qaddloop	A=DAT1	A
		B=A	A		Q2type
		A=DAT0	A		Q1type
		LC(5)	=SEMI
		?A=C	A
		GOYES	Qaddsemi?
		?B=C	A
		GOYES	Qadd?semi
		LC(4)	=DOHSTR
		?A=C	A
		GOYES	toQaddz?	z+z, z+p ou z+c -> meme code
		?B=C	A
		GOYES	Qadd?z		p+z ou c+z -> meme code Qaddpz
		LC(5)	=DOCOL
		?A#C	A
		GOYES	Qaddp?
		?B=C	A
		GOYES	toQaddcc	c+c 
		GOSUB	QaddSwap	c+p
		GOTO	Qaddpz
toQaddcc	GOTO	Qaddcc		
toQaddpp	GOTO	Qaddpp		
Qaddp?		?B#C	A
		GOYES	toQaddpp	p+p
toQaddpz	GOTO	Qaddpz		p+c
toQaddz?	GOTO	Qaddz?
Qadd?z		LC(5)	=DOCOL
		?A#C	A	
		GOYES	toQaddpz	p+z
		GOTO	Qaddcz

Qaddsemi?	D0=D0+	5		Skip SEMI
		A=R0.F	A
		A=A-1	A		comp1--
		R0=A.F	A
		?B#C	A		SEMIs in both polys?
		GOYES	Qaddsemi	No - just output SEMI
Qadd?semi	D1=D1+	5		Skip SEMI
		A=R1.F	A
		A=A-1	A		comp2--
		R1=A.F	A
Qaddsemi	A=R3.F	A		->output
		?ST=0	sTRIM
		GOYES	Writesemi
		P=	6		-> suppression d'un {
		C=R4.F	WP		-> complevel0 --
		P=	5
		C=C-1	P
		GONC	+
		P=	6
		C=C-1	P
+		P=	6
		R4=C.F	WP
		C=0	A
		?C#0	WP
		GOYES	++
		ST=0	sTRIM		complevel0=0, -> ST=0 et ecriture 0
		A=R3.F	A
		AD0EX
		D0=D0-	5		on enleve {
		P=	0
		LCZ0
		P=	10
		DAT0=C	WP		ecriture de 0
		P=	0
		D0=D0+	11
		AD0EX			restaure D0
		R3=A.F	A
		GOTO	Qaddnext
++		C=R3.F	A
		C=C-CON	A,5		on enleve {
		R3=C.F	A
		P=	0
		GOTO	Qaddnext
Writesemi	AD1EX
		DAT1=C	A		Write SEMI
		D1=D1+	5
		AD1EX
		R3=A.F	A
		GONC	Qaddnext	Continue loop

Qaddzz		GOSUB	ZADD		Add Z1 & Z2 to output

Qaddnext	A=R0.F	A		Done if 1 complevel = 0
		C=R1.F	A
		?A=0	A
		GOYES	Qaddok
		?C=0	A
		GOYES	Qaddok
toQaddloop	GOTO	Qaddloop
Qaddok		GOTO	Qaddfinish	Finish up result

Qaddcz		ST=0	sTRIM		c+z
		P=	6
		A=0	WP
		A=R4.F	A
		P=	6
		AR4EX.F	WP
		P=	0
		B=0	A		
		B=B+1	A
		GOSUB	QaddCopy	Copy all but last to output
		GOSUB	ZADD		add re[c]+z
		D0=D0+	5		skip c.SEMI
		A=R3.F	A
		LC(5)	=SEMI
		GOTO	Writesemi


Qaddz?		?B=C	A
		GOYES	Qaddzz
* ici on teste z+c -> different de z+p car on ajoute un SEMI final
		LC(5)	=DOCOL
		?B#C	A
		GOYES	Qaddzp
		GOSUB	QaddSwap
		GOTO	Qaddcz

* Add P+Z by copying all but last element of P to output, then
* reloop immediately with no complevel checks!

Qaddzp		GOSUB	QaddSwap
Qaddpz		C=R0.F	A
		C=C+1	A		comp1++
		R0=C.F	A
		GOSUBL	QLEN		Count elements in the list in D0
		B=B-1	A		
		?B#0	A
		GOYES	Qaddpznotrim
		ST=1	sTRIM		Si B=0, trimming
		P=	6
		AR4EX.F	WP
		P=	5
		A=A+1	P
		GONC	Qaddpztrim
		P=	6
		A=A+1	P
		GOTO	Qaddpztrim
Qaddpznotrim	ST=0	sTRIM
		P=	6
		A=0	WP
		A=R4.F	A
Qaddpztrim	P=	6
		AR4EX.F	WP
		P=	0
Qaddpz1		GOSUB	QaddCopy	Copy all but last to output
		GOTO	Qaddloop	Loop immediately!

Qaddcc		D0=D0+	5	
		D1=D1+	5	skip DOCOL
		LC(5)	=DOCOL
		AR3EX.F	A
		AD1EX
		DAT1=C	A	ecrit DOCOL -> output
		D1=D1+	5
		AD1EX
		AR3EX.F	A
		P=	6
		D=0	P		D[6] sert de flag trim?
		?ST=0	sTRIM
		GOYES	Qaddccnot
		D=D+1	P
Qaddccnot	P=	0
		ST=1	sTRIM
		GOSUB	ZADD
		P=	5
		D=0	P		D[5] sert de flag
		?ST=0	sTRIM
		GOYES	Qaddcc1
		AR3EX.F	A		le resultat est reel -> on recule
		A=A-CON	A,5
		AR3EX.F	A
		P=	6
		?D#0	P		retablit sTRIM en fonction de D[6]
		GOYES	+
		ST=0	sTRIM
+		P=	0
		GOTO	Qaddcc2
Qaddcc1		D=D+1	P
Qaddcc2		P=	0
		GOSUB	ZADD
		D0=D0+	5		skip SEMI0
		D1=D1+	5		skip SEMI1
		?ST=1	sTRIM
		GOYES	Qaddcc4		resultat nul, rien d'ecrit
Qaddcc3		P=	5
		?D=0	P
		GOYES	Qaddcc4
		P=	0
		LA(5)	=SEMI		result. complexe -> ecrire SEMI
		CR3EX.F	A
		CD1EX
		DAT1=A	A
		D1=D1+	5
		CD1EX
		CR3EX.F	A
Qaddcc4		P=	0
		GOTO	Qaddnext
		
* Add P+P by copying the lading elements of the longer P to output,
* then reloop to add the equal number of elements (whatever they are)

Qaddpp		C=R0.F	A
		C=C+1	A		comp1++
		R0=C.F	A
		C=R1.F	A
		C=C+1	A		comp2++
		R1=C.F	A
		GOSUBL	QLEN		Count P1
		R2=A.F	A		N1
		GOSUB	QaddSwap
		GOSUBL	QLEN		A = N2
		C=R2.F	A		N2
		?A#C	A		
		GOYES	Qaddpp0
		ST=1	sTRIM		N1=N2, il faut peut-etre trimmer
		P=	6
		AR4EX.F	WP
		P=	5
		A=A+1	P
		GONC	+
		P=	6
		A=A+1	P
+		P=	6
		AR4EX.F	WP
		P=	0
		GOTO	Qaddpp1
Qaddpp0		ST=0	sTRIM
		P=	6
		AR4EX.F	WP
		A=0	P
		P=	5
		A=0	P
		P=	6
		AR4EX.F	WP
		P=	0
Qaddpp1		?A>=C	A		N2 >= N1 ?
		GOYES	Qaddpp10
		GOSUB	QaddSwap
		ACEX	A
Qaddpp10	A=A-C	A		Difference in lenght
		B=A	A
		GOSUB	QaddCopy	Copy the lead
		D1=D1+	5		Skip DOLIST in the shorter P too
		GOTO	Qaddloop

* Here atleast one of the complevels is zero, but we must output the
* trailing SEMIs from the other P too
Qaddfinish	A=A+C	A		comp1 + comp2 = needed SEMIs
		?ST=0	sTRIM
		GOYES	+
		P=	6		retrait de R4.5/6 SEMIs
		C=R4.F	WP
		P=	0
		CSR	W
		CSR	W
		CSR	A
		CSR	A
		CSR	A		C= nombre de { en trop
		B=C	A
		B=B+B	A
		B=B+B	A
		B=B+C	A
		CR3EX.F	A
		C=C-B	A
		CR3EX.F	A
		A=A-C	A
+		CD0EX
		CR3EX.F	A
		CD0EX
		LC(5)	=SEMI
Qaddsemilp	A=A-1	A
		GOC	Qadddone
		DAT0=C	A
		D0=D0+	5
		GONC	Qaddsemilp
Qadddone	CD0EX
		CR3EX.F	A
		CD0EX
		RTNCC

****************************************
* Swap addition polynomial order
****************************************
QaddSwap	CD0EX
		CD1EX			Swap P1&P2
		CD0EX
		CR0EX.F	A
		CR1EX.F	A		Swap comp1&comp2
		CR0EX.F	A
		?ST=1	sQSWAP		Flag new order
		GOYES	Qaddswap10
		ST=1	sQSWAP
		RTN
Qaddswap10	ST=0	sQSWAP
		RTN

****************************************
* Copy first N elements of a polynomial
* to output (including DOLIST/DOCOL).
* If substract is flagged and P is 
* the substracted P then also
* negate all the copied integers.
* Entry:	D0 = ->P
*		B[A] = N
*		R3[A] = ->output
* Exit:		D0 = ->P'
*		R3[A] = ->output'
* Alters:	A[W] C[W] B[A] D[W] R3[A]
* Stack:	2
****************************************
QaddCopy	?ST=0	sQSUB
		GOYES	QaddCopy+
		?ST=0	sQSWAP
		GOYES	QaddCopy+

* P is being substracted, copy and negate. First copy all elements

		C=R3.F	A
		GOSBVL	=CSLW5
		D=C	W			D[A1] = ->output save
		GOSUB	QaddCopy+
* Then traverse and negate all copied elements
		C=D	W
		GOSBVL	=CSRW5			->output
		CD1EX
		D=C	A			->P2
Qaddcpneglp	A=DAT1	A
		D1=D1+	5
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	Qaddcpnegz
Qaddcpnegnext	AD1EX
		D1=A
		C=R3.F	A			->output'
		?A<C	A
		GOYES	Qaddcpneglp
		C=D	A
		D1=C
		RTNCC
Qaddcpnegz	A=DAT1	A
		CD1EX
		C=C+A	A
		CD1EX
		A=A-CON	A,7			CS if Z0
		GOC	Qaddcpnegnext
		D1=D1-	1
		A=DAT1	S
		A=-A-1	S
		DAT1=A	S
		D1=D1+	1
		GONC	Qaddcpnegnext

* Straight copy of the elements

QaddCopy+	GOSUBL	QSKIPN			D0=->Q[N]	C[A]=->Q
		AD0EX
		D0=C				->P
		C=A-C	A			size to copy
		CD1EX
		CR3EX.F	A
		CD1EX
		GOSBVL	=MOVEDOWN
		CD1EX
		CR3EX.F	A
		CD1EX
		RTNCC

**********************************************************************
* Add Z1+Z2 to output
* In:		D0  ->Z1 (level2!)
*		D1  ->Z2 (level1!)
*		R3  ->output
*		sQSUB		Indicates substraction
*		sQSWAP		Indicates arguments ar reversed
* Out:		D0  ->Z1tail	\ possibly
*		D1  ->Z2tail	/ swapped
*		R3  ->output'
* Uses:		A[W] C[W] B[S] D[S]
* Stack:	2 (WIPEOUT + RSTK save)
**********************************************************************
ZADD

* See if addition can be done in registers

		D0=D0+	5		->Z1len
		D1=D1+	5		->Z2len
		A=DAT0	A		Z1len
		C=DAT1	A		Z2len
		?ST=0	sTRIM
		GOYES	toz+
* test si Z1+-Z2=0 (Z1=Z2 et sQSUB=1 ou Z1=-Z2 et sQSUB=-1)
		?A#C	A
		GOYES	toz+		longueur identique, on teste le corpus
		LA(5)	6		si longueur=6 alors 0+-0 donc res=0
		?A#C	A
		GOYES	+
		CD0EX
		C=C+A	A
		CD0EX
		CD1EX
		C=C+A	A
		CD1EX
		RTN
+		D=C	A		D=sauvegarde,
		C=C-1	A		C=longueur-1 a cause du signe
		B=C	A		B,P=compteur
		BSR	A		words
		P=C	0		nibbles&15

zaddloop	A=DAT0	W
		C=DAT1	W
		B=B-1	A		Compare words
		GOC	zequalWP?
		D0=D0+	16
		D1=D1+	16
		?A=C	W
		GOYES	zaddloop
zequalnot	P=	0		Restore regs et addition normale
		C=D	A
		C=C-1	A
		CSR	A
		C=C-B	A		C-B= nbre d'incrementation de D0/D1
		CSL	A
		AD0EX
		A=A-C	A
		AD0EX
		AD1EX
		A=A-C	A
		AD1EX
		C=D	A
		A=C	A
toz+		GOTO	z+
zequalWP?	B=B+1	A
		P=P-1
		GOC	zisequal	we had even words - test done
		?A#C	WP
		GOYES	zequalnot
zisequal	P=P+1			on teste les signes et sQSUB
		?A#C	P
		GOYES	signediff
		?ST=0	sQSUB
		GOYES	zequalnot
		GOTO	zaddis0
signediff	?ST=1	sQSUB
		GOYES	zequalnot
zaddis0		BSL	A		res=0, on ajuste D0 et D1
		C=0	A
		C=P	0
		B=B+C	A
		B=B+1	A
		AD0EX
		A=A+B	A
		AD0EX
		AD1EX
		A=A+B	A
		AD1EX
		P=	0		restore regs
		RTN
z+		P=	6
		CR4EX.F	WP
		P=	5		somme non nulle 
		C=0	P		-> 0 significatifs dans la suite
		P=	6
		C=0	P
		CR4EX.F	WP
		P=	0
		ST=0	sTRIM
		A=A-CON	A,5
		C=C-CON	A,5
		A=0	P
		C=0	P
		?A#0	A
		GOYES	goZaddSlow
		?C=0	A
		GOYES	ZaddFast
goZaddSlow	GOTO	ZaddSlow

* Fast addition

ZaddFast	GOSUB	shortpopd1	A[W] = mantissa2	C[S]=sign2
		B=A	W		B[W] = mantissa2
		D=C	S					D[S]=sign2
		GOSUB	shortpop	A[W] = mantissa1	C[S]=sign1
		CBEX	W		C[W] = mantissa2	B[S]=sign1

		?ST=0	sQSUB		No need to change signs if addition
		GOYES	+
		D=-D-1	S		Negate Z2 for addition call
		?ST=0	sQSWAP		Signs ok if not reversed args
		GOYES	+
		B=-B-1	S		Else negate both
		D=-D-1	S
+		GOSUB	SHORT+		A[W]=result	C[S]=sign

		CD1EX	
		CR3EX.F	A		->output
		CD1EX
		GOSUB	SHORTOUT
		CD1EX
		CR3EX.F	A		->output'
		CD1EX
		P=	0
		RTNCC

* Slow addition. First fetch the signs

ZaddSlow	A=DAT0	A		Z1len
		CD0EX
		A=A+C	A
		D0=A
		D0=D0-	1
		A=DAT0	S
		B=A	S		Z1sign
		D0=C			->Z1len

		A=DAT1	A		Z2len
		CD1EX
		A=A+C	A
		D1=A
		D1=D1-	1
		C=DAT1	S
		D=C	S		Z2sign
		D1=C			->Z2len

* Modify for SUB if necessary

		?ST=0	sQSUB
		GOYES	Zaddslow10
		D=-D-1	S	Add -D1 to D0
		?ST=0	sQSWAP
		GOYES	Zaddslow10
		B=-B-1	S	Vice versa if arguments are swapped
		D=-D-1	S
Zaddslow10

* First get the shorter one to Z1
		A=DAT0	A		Z1len
		C=DAT1	A		Z2len
		D0=D0-	5
		D1=D1-	5
		?A<=C	A
		GOYES	Zaddslow20	Get shorter to Z1
		GOSUB	QaddSwap
		CBEX	S		Swap signs too
		CDEX	S
		CBEX	S
* Copy Z1 (shorter now) to output
Zaddslow20	C=R3.F	A		->output
		CD1EX
		B=C	A		->Z2
		D0=D0+	5
		C=DAT0	A		Z1len
		D0=D0-	5
		C=C+CON	A,5		Z1size
		D=C	A		Z1size
		GOSBVL	=MOVEDOWN
* Add zero nibbles to get equal sizes
		C=B	A		->Z2
		CD0EX
		RSTK=C			->Z1tail
		D0=D0+	5
		C=DAT0	A		Z2len
		C=C+CON	A,5		Z2size
		C=C-D	A		Z2size-Z1size = missing zero nibbles
		D1=D1-	1		Start over the old sign
		C=C+1	A		1 extra for clearing the sign
		GOSBVL	=WIPEOUT	D1 = ->Z'sign
* Now add the equal size hexes
		C=R3.F	A
		D1=C
		D1=D1+	10		->Z'mantissa
		C=DAT0	A		Z2size
		C=C-CON	A,7		Z2nibs (cannot be 0 in slow addition!)
		D0=D0+	5		->Z2mantissa
* Dispatch on signs
		?B#0	S
		GOYES	ZaddslowN?
		?D=0	S
		GOYES	ZaddslowPP

* Positive argument was shorter. Thus assume result will be negative
* and calculate D0-D1 (longer-shorter). If no overflow occurs then the
* result really is negative.

ZaddslowPN

* Negative argument was shorter. Thus assume result will be positive
* and calculate D0-D1 (longer-shorter). If no overflow occurs then the
* result really is positive

ZaddslowNP	GOTO	Zaddslow2

ZaddslowN?	?D=0	S
		GOYES	ZaddslowNP

* Same signs, add the mantissas. Return sign in D[S]
ZaddslowPP
ZaddslowNN	B=0	W		Carry
		P=C	0
		CSR	A
		D=C	A
		D=D-1	A
		GOC	ZaddslppWP
ZaddslLP1	A=DAT0	W
		A=A+B	W
		GOC	Zaddslpp20
		B=0	B		Clear carry
Zaddslpp20	C=DAT1	W
		A=A+C	W
		GONC	Zaddslpp30
		B=B+1	B
Zaddslpp30	DAT1=A	W
		D0=D0+	16
		D1=D1+	16
		D=D-1	A
		GONC	ZaddslLP1
ZaddslppWP	A=DAT0	WP
		A=A+B	WP
		GOC	Zaddslpp40
		B=0	B
Zaddslpp40	C=DAT1	WP
		A=A+C	WP
		GONC	Zaddslpp50
		B=B+1	B
Zaddslpp50	DAT1=A	WP
		CD0EX
		C+P+1
		CD0EX
		D0=D0+	1		Skip sign too
		CD1EX
		C+P+1
		CD1EX
		P=	0
		C=B	B
		DAT1=C	B
		GOTO	Zaddslstrip	Check the result

* Substract D1 from D0 to output, if no overflow use sign in D[S]
* Else negate & use negate of sign in D[S]

Zaddslow2	B=0	W		Carry
		P=C	0
		CSR	A
		D=C	A
		D=D-1	A
		GOC	ZaddslnpWP
ZaddslLP2	A=DAT0	W
		A=A-B	W
		GOC	Zaddslnp20
		B=0	B		Clear carry
Zaddslnp20	C=DAT1	W
		A=A-C	W
		GONC	Zaddslnp30
		B=B+1	B
Zaddslnp30	DAT1=A	W
		D0=D0+	16
		D1=D1+	16
		D=D-1	A
		GONC	ZaddslLP2
ZaddslnpWP	A=DAT0	WP
		A=A-B	WP
		GOC	Zaddslnp40
		B=0	B
Zaddslnp40	C=DAT1	WP
		A=A-C	WP
		GONC	Zaddslnp50
		B=B+1	B
Zaddslnp50	DAT1=A	WP
		CD0EX
		C+P+1
		CD0EX
		D0=D0+	1		Skip sign too
		CD1EX
		C+P+1
		CD1EX
		P=	0
		C=0	B
		C=C-B	B
		DAT1=C	B
		GONC	Zaddslstrip	Got expected result, check it
* Got unexpected result, negate mantissa & sign before exit
		D=-D-1	S
		D1=D1+	1		->tail
		A=R3.F	A
		A=A+CON	A,10		->mantissa
		CD1EX			->tail
		D1=A			->mantissa
		C=C-A	A		nibbles to negate
		C=C-1	A
		P=C	0
		CSR	A
		C=C-1	A
		GOC	Zaddslneg10
Zaddslneglp	A=DAT1	W
		A=-A	W
		GOC	Zaddslneg20
		DAT1=A	W
		D1=D1+	16
		C=C-1	A
		GONC	Zaddslneglp
Zaddslneg10	A=DAT1	WP
		A=-A	WP
		GOTO	Zaddslneg30
Zaddslneglp2	A=DAT1	W
		A=-A-1	W
Zaddslneg20	DAT1=A	W
		D1=D1+	16
		C=C-1	A
		GONC	Zaddslneglp2
		A=DAT1	WP
		A=-A-1	WP
Zaddslneg30	DAT1=A	WP
		CD1EX
		C+P+1
		D1=C
		P=	0
		D1=D1-	1
*		GOTO	Zaddslstrip
		
* Strip result of slow addition, then fix lenght & append sign from D[S]
Zaddslstrip	A=DAT1	S
		D1=D1-	1
		?A=0	S
		GOYES	Zaddslstrip
		D1=D1+	2		->Z'sign
		C=D	S
		DAT1=C	S
		D1=D1+	1		->Z'tail
		AD1EX
		D1=A
		C=R3.F	A		->output
		A=A-C	A		size (with sign)
		LC(5)	11
		?A<=C	A
		GOYES	Zaddslzero	Too short, must be zero!
		C=R3.F	A
		CD1EX
		D1=D1+	5
		A=A-CON	A,5
		DAT1=A	A		Z'len
Zaddsldone	R3=C.F	A		->output'
		C=RSTK
		CD0EX			->Z1tail
		D1=C			->Z2tail
		RTNCC
Zaddslzero	C=R3.F	A
		D1=C
		LCZ0
		DAT1=C	11
		D1=D1+	11
		CD1EX
		GONC	Zaddsldone

**********************************************************************
* Desc:		Negate polynomial
* Entry:	D0 = ->Q
* Output:	D0 = ->Qtail
* Alters:	A[A] C[A] D[A]
**********************************************************************
QNEG		D=0	A		complevel = 0

Qnegloop	A=DAT0	A
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	Qnegz
		LC(2)	=DOLIST
		?A=C	A
		GOYES	Qnegp
		LC(5)	=DOCOL
		?A=C	A
		GOYES	Qnegp
		D=D-1	A
		D=D-1	A
Qnegp		D=D+1	A		complevel++
		D0=D0+	5
Qnegnext	?D#0	A
		GOYES	Qnegloop	Lop until complevel = 0
		RTNCC
Qnegz		D0=D0+	5		Skip Z even if it is Z0
		A=DAT0	A
		CD0EX
		C=C+A	A
		CD0EX
		LC(5)	6
		?A<=C	A
		GOYES	Qnegnext	Continue if was Z0
		D0=D0-	1
		A=DAT0	B
		A=-A-1	P		0 <--> F
		DAT0=A	B
		D0=D0+	1
		GONC	Qnegnext

**********************************************************************



**********************************************************************
* Desc:		Calculate elements in two polynomials
* Entry:	D0 = ->list1	A[A] = len1
*		D1 = ->list2	C[A] = len2
* Exit:		D0 = ->list1
*		D1 = ->list2
* Modifies:	A[A] B[A] C[W] D[A]
* Stack:	2 (PLEN call + save)
**********************************************************************

QLEN2		CD1EX			Swap list1 and list2
		CD0EX
		CD1EX
		GOSUB	QLEN		C[A] = len2
		RSTK=C			RSTK = len2
		CD1EX			Swap list1 and list2 back
		CD0EX
		CD1EX
		GOSUB	QLEN		C[A] = len1
		A=C	A		A[A] = len1
		C=RSTK			C[A] = len2
		RTNCC

**********************************************************************
* Desc:		Calculate number elements in polynomial
* Entry:	D0 = ->P
* Exit:		D0 = ->P
*		A[A]=B[A]=C[A] = length
* Modifies:	A[A] B[A] C[W] D[A]
* Stack:	0
**********************************************************************

QLEN		B=0	A		N=0
		CD0EX
		D0=C
		CSL	W
		CSL	W
		CSL	W
		CSL	W
		CSL	W		C[A1] = ->P
		D0=D0+	5		Skip DOLIST
		D=0	A		complevel = 0
plenloop	A=DAT0	A
		D0=D0+	5
		LC(5)	=SEMI
		?A=C	A
		GOYES	plensemi
		?D#0	A		elements++ if not embedded
		GOYES	+
		B=B+1	A
+		LC(4)	=DOLIST		Skip done if list
		?A=C	A
		GOYES	plenlist
		LC(4)	=DOCOL		Skip done if complex
		?A=C	A
		GOYES	plenlist
		C=DAT0	A
		AD0EX
		A=A+C	A		Skip Z
		AD0EX
		GONC	plenloop
plenlist	D=D+1	A		complevel++
		GONC	plenloop
plensemi	D=D-1	A		complevel--
		GONC	plenloop
		CSR	W
		CSR	W
		CSR	W
		CSR	W
		CSR	W
		D0=C			->P
		A=B	A		elements
		C=A	A		elements
		RTNCC

**********************************************************************
* Desc:		Return size of Q
* Entry:	D0 ->object
* Exit:		D0 ->object
*		A[A] ->object tail
*		C[A] obsize
* Modifies:	A[W] C[A]
* Stack:	2 (QSKIP call+save)
**********************************************************************

QSIZE		CD0EX
		RSTK=C			C[A] = ->Q
		D0=C
		GOSUB	QSKIP		D0 = ->Qtail
		C=RSTK			C[A] = ->Q
		AD0EX			A[A] = ->Qtail
		D0=C
		C=A-C	A		C[A] = Qsize
		RTNCC

**********************************************************************
* Desc:		Copy Q to output
* Entry:	D0 = ->Q
*		D1 = ->output
* Exit:		D0 = ->Qtail
*		D1 = ->output tail
* Modifies:	A[W] C[A] D0 D1
* Stack:	2 (QSKIP call + save)
**********************************************************************

QCOPY		CD0EX
		RSTK=C
		D0=C
		GOSUB	QSKIP		D0 = ->Qtail
qcopycont	C=RSTK
		AD0EX			->Qtail
		D0=C			->Q
		C=A-C	A		Qsize
		GOVLNG	=MOVEDOWN

**********************************************************************
* Desc:		Copy remainder of Q to output
* Entry:	D0 = ->element in Q
*		D1 = ->output
* Exit:		D0 = ->Qtail
*		D1 = ->output tail
* Modifies:	A[W] C[W] D0 D1
* Stack:	2 (QSKIPREM call + save)
**********************************************************************

QCOPYREM	CD0EX
		RSTK=C
		D0=C
		GOSUB	QSKIPREM	D0 = ->Qtail
		GOTO	qcopycont	Same code as for QCOPY continues

**********************************************************************
* Desc:		Skip to Nth element in Q
* Entry:	B[A] = N-1
*		D0   = ->Q
* Exit:		D0   = ->Q[N]
*		C[A] = ->Q
* Modifies:	A[A] B[A] C[W] D[A]
* Stack:	0
**********************************************************************

QSKIPN		CD0EX
		D0=C
		CSL	W		Save D0 in C[A1]
		CSL	W
		CSL	W
		CSL	W
		CSL	W
		D0=D0+	5		Skip DOLIST
		D=0	A		complevel=0
qskipnloop	?D#0	A
		GOYES	qskipn+
		B=B-1	A		N--
		GOC	qskipnok	Found Nth element - finish up
qskipn+		A=DAT0	A
		D0=D0+	5
		LC(5)	=SEMI
		?A=C	A
		GOYES	qskipnsemi
		LC(4)	=DOLIST
		?A=C	A
		GOYES	qskipnlist
		LC(4)	=DOCOL
		?A=C	A
		GOYES	qskipnlist
		C=DAT0	A		Zlen
		AD0EX
		A=A+C	A
		AD0EX
		GONC	qskipnloop
qskipnlist	D=D+1	A		complevel++
		GONC	qskipn+
qskipnsemi	D=D-1	A
		GONC	qskipnloop
		RTNSC			CS: Too big N

qskipnok	CSR	W		Restore D0 from C[A1]
		CSR	W
		CSR	W
		CSR	W
		CSR	W
		RTNCC			CC: N was ok

**********************************************************************
* Desc:		Skip remainder of Q in D0
* Entry:	D0 = ->element in Q
*		D0 = ->Qtail
* Modifies:	A[A] C[A] D0
* Stack:	0
**********************************************************************

QSKIPREM	P=	10-1		Save D[A] in D[A1]
		DSL	WP
		DSL	WP
		DSL	WP
		DSL	WP
		DSL	WP
		D=D+1	A		complevel=1
		GONC	+

**********************************************************************
* Desc:		Skip Q in D0
* Entry:	D0 = ->Q
* Exit:		D0 = ->Qtail ou position d'erreur si ST=0 sALG48
* Modifies:	A[A] C[A] D[A1] D0
* Stack:	0
**********************************************************************

QSKIP		P=	10-1		Save D[A] in D[A1]
		DSL	WP
		DSL	WP
		DSL	WP
		DSL	WP
		DSL	WP		D[A]=complevel=0
+		P=	0
qskiploop	A=DAT0	A
		D0=D0+	5
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	qskiphstr
		LC(5)	=DOCOL		pour l'instant i n'est pas reconnu
		?A=C	A
		GOYES	qskipcol
		LC(5)	=DOLIST
		?A#C	A
		GOYES	qskipsemi
qskipcol	D=D+1	A		complevel++
		GONC	qskiploop
qskiphstr	A=DAT0	A
		CD0EX
		C=C+A	A
		CD0EX
		?D#0	A
		GOYES	qskiploop
qskipend	P=	10-1		Restore D[A] from D[A1]
		DSR	WP
		DSR	WP
		DSR	WP
		DSR	WP
		DSR	WP
		P=	0
		RTNCC
qskipsemi	LC(5)	=SEMI
		?A=C	A
		GOYES	qskipsemi1
		ST=0	sALG48
		GOTO	qskipend
qskipsemi1	D=D-1	A
		?D#0	A
		GOYES	qskiploop
		GONC	qskipend

**********************************************************************
* Desc:		Skip Q in D1
* Entry:	D1 = ->Q
* Exit:		D1 = ->Qtail
* Modifies:	A[A] C[A] D[A1] D1
* Stack:	0
**********************************************************************

QSKIPD1		P=	10-1
		DSL	WP
		DSL	WP
		DSL	WP
		DSL	WP
		DSL	WP		D[A]=complevel=0
		P=	0
qskip1loop	A=DAT1	A
		D1=D1+	5
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	qskip1hstr
		LC(2)	=DOLIST
		?A=C	A
		GOYES	qskip1list
		LC(5)	=DOCOL
		?A#C	A
		GOYES	qskip1semi
qskip1list	D=D+1	A		complevel++
		GONC	qskip1loop
qskip1hstr	A=DAT1	A
		CD1EX
		C=C+A	A
		CD1EX
		?D#0	A
		GOYES	qskip1loop
		GOTO	qskipend
qskip1semi	D=D-1	A
		?D#0	A
		GOYES	qskip1loop
		GOTO	qskipend

**********************************************************************
* Desc:		Pop signed small integer with size check from stack
* Entry:	D1 = ->stack level
* Exit:		CS: Too big integer
*		CC: Integer fits into register
*			D0 = ->Ztail
*			A[W] C[S] = Z
* Modifies:	A[W] C[A] D0 D1
* Stack:	0
**********************************************************************
SHORTPOPZ?	A=DAT1	A
		D1=D1+	5
		D0=A
SHORTPOPCK?	A=DAT0	A
		LC(5)	=DOHSTR
		?A#C	A
		RTNYES
**********************************************************************
* Desc:		Pop signed small integer with size check
* Entry:	D0 = ->integer
* Exit:		CS: Too big integer
*		CC: Integer fits into register
*			D0 = ->Ztail
*			A[W] C[S] = Z
* Modifies:	A[W] C[A] D0
* Stack:	0
**********************************************************************

SHORTPOP?	D0=D0+	5		Skip DOHSTR
shortpop?	A=DAT0	A		Zlength
		D0=D0+	5
		LC(5)	5+16+1		prolog + word + sign
		?A>C	A
		RTNYES			CS: Too long integer
		C=A	A		Zlength
		A=0	W		Init high nibbles
		C=C-CON	B,7
		GONC	shortpop#	Nonzero - continue at common code
		GOC	shortpop=	Zero - skip 1 nibble

**********************************************************************
* Desc:		Pop signed small integer (no size checks!)
* Entry:	D1 = ->integer
* Exit:		A[W] C[S] = signed integer
*		D1 = ->integer tail
*		CS: integer is zero
*		CC: integer is nonzero
* Modifies:	A[W] C[A] D1
* Stack:	0
**********************************************************************

SHORTPOPD1	D1=D1+	5		Skip DOHSTR
shortpopd1	A=0	W		Initialize high nibbles
		C=DAT1	A		Zlength
		D1=D1+	5
		C=C-CON	A,7
		GONC	shortpopd1#
		D1=D1+	1
		RTNSC			CS: Z is zero

shortpopd1#	P=C	0
		A=DAT1	WP		Pop mantissa
		CD1EX
		C+P+1			Skip mantissa
		CD1EX
		P=	0
		C=DAT1	S		Pop sign
		D1=D1+	1
		RTNCC			CC: Z is nonzero

**********************************************************************
* Desc:		Pop signed small integer (no size checks!)
* Entry:	D0 = ->integer
* Exit:		A[W] C[S] = signed integer
*		D0 = ->integer tail
*		CS: integer is zero
*		CC: integer is nonzero
* Modifies:	A[W] C[A] D0
* Stack:	0
**********************************************************************

SHORTPOP	D0=D0+	5		Skip DOHSTR
shortpop	C=DAT0	A		Zlength
		D0=D0+	5
		A=0	W		Initialize high nibbles
		C=C-CON	B,7
		GONC	shortpop#
		D0=D0+	1
		RTNSC			CS: Z is zero

shortpop#	P=C	0
		A=DAT0	WP		Pop mantissa
		CD0EX
		C+P+1			Skip mantissa
		CD0EX
		P=	0
		C=DAT0	S		Pop sign
shortpop=	D0=D0+	1
		RTNCC			CC: Z is nonzero

**********************************************************************
* Desc:		Univariate test on polynomial
* Entry:	D0 = ->Q
* Exit:		CS: Is univariate
*		CC: Not univariate
* Modifies:	A[A] C[A] D0 sUNIVAR
* Stack:	0
**********************************************************************

sUNIVAR		EQU 5		Flag to indicate plain univariate test

UNIVAR?		ST=1	sUNIVAR		Flag plain univariate test
		GOTO	unitest

**********************************************************************
* Desc:		Univariate and short coefficient test on polynomial
* Entry:	D0 = ->Q
* Exit:		CS: Is univariate and short
*		CC: Not
* Modifies:	A[A] C[A] D0 sUNIVAR
* Stack:	0
**********************************************************************

SUNIVAR?	ST=0	sUNIVAR		Flag coefficient bound test

unitest		A=DAT0	A
		LC(5)	=DOLIST
		?A#C	A
		RTNYES			CS - non-list is univariate
		D0=D0+	5
-		A=DAT0	A
		LC(5)	=SEMI		If we reach SEMI
		?A=C	A
		RTNYES			then P is sunivariate
		LC(4)	=DOHSTR		If there is an embedded object
		?A#C	A
		GOYES	notunivar	then P is not sunivariate
		D0=D0+	5
		A=DAT0	A		Zlen
		CD0EX
		C=C+A	A
		CD0EX
		?ST=1	sUNIVAR		Ignore coefficient test?
		GOYES	-		Yes
		LC(5)	5+15
		?A<=C	A
		GOYES	-
notunivar	RTNCC			CC - not univariate

**********************************************************************
* Desc:		Substract/add small integers with overflow checks
* Entry:	A[W] B[S] = signed integer X
*		C[W] D[S] = signed integer Y
* Output:	A[W] C[S] = signed integer X+Y or X-Y
*		CS if overflow, CC otherwise
* Modifies:	A[W] C[S] D[S]
* Stack:	0
**********************************************************************

SHORT-		D=-D-1	S	Negate Y

SHORT+		CDEX	S
		?C#B	S
		GOYES	+	Handle different signs
		CDEX	S
		A=A+C	W	X+Y
		RTNC		CS if overflow
-		C=B	S	Return X sign as X+Y sign
		RTNCC
+		CDEX	S
		A=A-C	W
		GONC	-	Substracted correctly - done
		A=-A	W	Fix to absolute value
		C=D	S	Return Y sign
		RTNCC
**********************************************************************
* Desc:		Multiply small integers with overflow checks
* Entry:	A[W] B[S] = signed integer X
*		C[W] D[S] = signed integer Y
* Output:	A[W] C[S] = signed integer X*Y
* Modifies:	A[W] B[W] C[W] D[S]
* Stack:	0
**********************************************************************

SHORT*		CDEX	S		Calculate result sign
		C=C+B	S
		GONC	+
		C=0	S
+		CDEX	S		D[S] = result sign
		B=0	W		result = 0
short*loop	SB=0
		CSRB			y /= 2
		?SB=0
		GOYES	+
		B=B+A	W		result += x
		RTNC			CS: Overflow
+		A=A+A	W		x *= 2
		RTNC			CS: Overflow
		?C#0	B		\
		GOYES	short*loop	 Faster than using only the [W] test
		?C#0	W
		GOYES	short*loop	/
		A=B	W		A[W]=|X*Y|
		C=D	S		C[S]=sgn(X*Y)
		RTNCC			CC: Valid result


**********************************************************************
* Desc:		Output signed small integer (trimmed)
* Entry:	A[W] C[S] = signed integer
*		D1 = ->output
* Exit:		A[W] C[S] unchanged
*		D1 = ->output tail
*		CRY clear
* Modifies:	C[1..6] D1 P=0
* Stack:	0
**********************************************************************

SHORTOUT	P=	0		Safety opcode
		LC(5)	=DOHSTR		Output prolog
		DAT1=C	A
		D1=D1+	5
		?A=0	W
		GOYES	shortout0

		P=	15		Trimming loop
-		?A#0	P
		GOYES	+
		P=P-1
		GONC	-
+		C=0	A		A is nonzero
		C=P	0
		C=C+CON	B,7
		DAT1=C	A		output length
		D1=D1+	5
		DAT1=A	WP		output mantissa
		CD1EX
		C+P+1
		CD1EX
		P=	0
		DAT1=C	S		output sign
		D1=D1+	1
		RTNCC

shortout0	LC(6)	6
		DAT1=C	6
		D1=D1+	6
		RTNCC
**********************************************************************
* Desc:		Trash topmost object in tempob area
* Entry:	RPLRAM
* Exit:		RPLRAM'
**********************************************************************
?TrashTop	?ST=0	sTRASH		Optional entry which obeys
		RTNYES			the global trash flag
TrashTop	D0=(5)	=aTEMPTOP
		A=DAT0	A
		D0=A
		A=DAT0	A		A[A] = ->top of tempob area
		A=A-CON	A,5		A[A] = ->link1
		D0=A
		C=DAT0	A		C[A] = link1
		A=A-C	A		A[A] = ->link2
		D0=A
		D0=D0+	5		D0 = ->top of tempob (desired)
		GOVLNG	=recover	Trash topmost object

**********************************************************************
* Desc:		Generate abort error if ON-key has been pressed
* Entry:	RPLCPU
* Alters:	A[A]
**********************************************************************
AttnAbort?	CD0EX
		D0=(5)	=aATTNFLG
		A=DAT0	A		A[A] = ->ATTNFLG
		D0=A
		A=DAT0	A		A[A] = ATTNFLG
		CD0EX
		?A=0	A
		RTNYES
		A=0	A		0 = ABORT error
                CD0EX
	        DAT0=A  A               ATTNFLG = 0
                CD0EX
		GOVLNG	=Errjmp
**********************************************************************
* Desc:		Shrink allocated memory to contain only Q
* Entry:	R0[A] = ->Q
*		C[A] = ->Qtail
* Exit:		GETPTR and A[A]=R0[A] = ->Q
**********************************************************************
ShrinkQ		D0=C			D0 = ->Qtail
		A=R0	A		A[A] = ->Q
		C=C-A	A		C[A] = Qsize
		C=C+CON	A,6
		DAT0=C	A		Fix link
		D0=D0+	5		Skip link
		GOSBVL	=recover	Shrink allocated memory
		A=R0	A		A[A] = ->Q
		GOVLNG	=GETPTR
**********************************************************************
doslow*		GOSBVL	=ROOM		C[A] = free mem
		LA(5)	400		Minimum total required
		?C>A	A
		GOYES	doslowmem

slowmulretry	GOSBVL	=DOGARBAGE
*		ST=1	sGARB		DOGARBAGE sets this
		GOTO	doslow*

doslowmem	ASRB.F	A		200
		C=C-A	A		room-200
		GOSBVL	=GETTEMP	D0=->slot	D1=->slotend
		AD1EX
		R4=A.F	A		R4[A]=->stack
		AD0EX
		R3=A.F	A		->output

		GOSBVL	=D1=DSKTOP
		C=DAT1	A
		D1=D1+	5
		A=DAT1	A
		D0=A			->Q1
		D1=C			->Q2

		GOSUB	QMUL		A[A] = ->result	R3[A]=->result end

QMULexit	R0=A	A		R0[A] = ->Q
		C=R3	A		C[A] = ->Qtail
		?A#C	A
		GOYES	+
		LCZ0			on n'a rien ecrit! Donc res=0
		D1=A
		P=	10
		DAT1=C	WP		ecrit 0
		P=	0
		D1=D1+	11		ajuste D1
		CD1EX
+		GOSUBL	ShrinkQ
		D1=D1+	5		Drop Q2
		D=D+1	A
		GOVLNG	=OverWrALoop	Overwrite Q1 & exit


* Trash allocated memory first so it won't corrupt memory

QMULretry	GOSUBL	TrashTop
		GOTO	slowmulretry

**********************************************************************
* Desc:		Multiply Q1 and Q2 to output
* Entry:	D0  = ->Q1
*		D1  = ->Q2
*		R3[A] = ->output
*		R4[A] = ->stack
* Exit:		D0    = ->Q1tail
*		D1    = ->Q2tail
*		A[A]  = ->output	(start of result)
*		R3[A] = ->output end	(end of result)
*		R4[A] = ->stack		(same as input)
**********************************************************************

qmulerr		GOTO	QMULretry

* General multiplication entry, saves pointers & dispatches to subtypes
* Push[A] and Pop[A] are not used for speed.

QMUL		A=R4.F	A		->stack
		C=R3.F	A		->output
		A=A-C	A		free mem
		GOC	qmulerr		Shouldn't happen - but just in case
		LC(5)	3*5		Need 3 levels
		?A<C	A
		GOYES	qmulerr

		A=R4.F	A		->stack
		AD0EX
		D0=D0-	5		Save RSTK1
		C=RSTK
		DAT0=C	A
		D0=D0-	5		Save RSTK2
		C=RSTK
		DAT0=C	A
		D0=D0-	5		Save ->output (result address)
		C=R3.F	A
		DAT0=C	A
		AD0EX
		R4=A.F	A		->stack'
		GOSUB	QMULdispatch	Dispatch
		A=R4.F	A		->stack'
		AD0EX
		C=DAT0	A		Restore ->output (result address)
		B=C	A
		D0=D0+	5
		C=DAT0	A		Restore RSTK2
		RSTK=C
		D0=D0+	5
		C=DAT0	A		Restore RSTK1
		D0=D0+	5
		AD0EX
		R4=A.F	A		->stack'
		A=B	A		->output (result address)
		PC=C			*RETURN*

* Note that only 2 RSTK levels are saved, and one is replaced by
* the QMULdispatch return address. This implies that QMUL can be called
* recursively from one of the dispatchees or one of their subroutines,
* but not subroutines subroutine or deeper.

* Dispatch based on types

QMULdispatch	A=DAT1	A		prolog2
		B=A	A
		A=DAT0	A		prolog1
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	qmulz?
		?B=C	A
		GOYES	qmul?z
		LC(5)	=DOCOL
		?A=C	A
		GOYES	qmulc?
		?B=C	A
		GOYES	qmulqc
		GOTO	MULQQ		q*q
qmulz?		?B=C	A
		GOYES	qmulzz		z*z
		LC(5)	=DOCOL
		?B=C	A
		GOYES	mulzc		z*c
		GOLONG	MULZQ		z*q
qmulzz		GOLONG	MULZZ
qmulqc		GOLONG	MULQC		q*c
qmulcq		GOLONG	MULCQ		c*q
qmul?z		LC(5)	=DOCOL
		?A=C	A		
		GOYES	mulcz		c*z
		GOLONG	MULQZ		q*z
qmulc?		?B#C	A
		GOYES	qmulcq
qmulcc		GOSUB	QMULCC		c*c
		RTN
mulzc		GOTO	MULZC
mulcz		GOTO	MULCZ

**********************************************************************
* Multiplication C*C
* Utilise la pile pour sauvegarder re/im
**********************************************************************
QMULCC		A=R3.F	A		-> ouput
		GOSUB	Push[A]
		D0=D0+	5		-> c0.im
		A=D0
		GOSUB	Push[A]
		D1=D1+	5		-> c1.im
		A=D1
		GOSUB	Push[A]
		D1=D1+	5		-> skip prolog c1.im
		A=D1
		C=DAT1	A		-> longueur c1.im
		A=A+C	A
		D1=A			-> c1.re
		GOSUBL	MULZZ		c0.im*c1.re
		A=R4.F	A
		D1=A			-> stk1
		A=DAT1	A		-> c1.im
		D1=A
		GOSUBL	MULZZ		c0.re*c1.im
		A=R4.F	A		
		D0=A
		D0=D0+	10		-> niveau 3 de la pile
		C=DAT0	A
		D0=C			-> c0.im*c1.re
		D0=D0+	5		skip prolog
		A=D0
		C=DAT0	A		-> C=longueur de c0.im*c1.re
		D0=D0-	5
		A=A+C	A
		D1=A			-> c0.re*c1.im
		D1=D1+	5
		A=DAT1	A		-> A=longueur de c0.re*c1.im
		D1=D1-	5
		C=A+C	A
		C=C+CON	A,15
		GOSUB	Ensure[C]
		ST=0	sQSUB
		GOSUBL	ZADD		output= hxs1 hxs2 result.im
		GOSUB	Pop[A]		c1.im
		D1=A
		GOSUB	Pop[A]		c0.im
		D0=A
		GOSUBL	MULZZ
		GOSUBL	MULZZ		output=hxs1 hxs2 result.im im*im re*re
		D0=D0+	5
		D1=D1+	5		skip SEMI finaux
		GOSUB	Pop[A]		A=debut output
		AD0EX
		GOSUB	Push[A]		sauvegarde de D0 final
		AD1EX
		GOSUB	Push[A]		D1 final
		A=D0
		GOSUB	Push[A]		debut output
		GOSUB	skip2hxs
		D0=D0+	5		skip result.im
		A=D0
		C=DAT0	A
		A=A+C	A
		D0=A			
		D1=A			D1 -> im*im
		D0=D0+	5		skip im*im
		A=D0
		C=DAT0	A		C=longueur im*im
		A=A+C	A
		D0=A			D0 -> re*re
		D0=D0+	5
		A=DAT0	A
		D0=D0-	5
		C=A+C	A		somme des longueurs
		C=C+CON	A,15
		GOSUB	Ensure[C]
		ST=1	sQSUB
		ST=0	sQSWAP
		GOSUBL	ZADD
		ST=0	sQSUB
		GOSUB	Pop[A]
		D1=A			debut output
		D0=A			
		GOSUB	skip2hxs
		D0=D0+	5
		A=DAT0	A
		LC(5)	6
		ST=1	sTRIM
		?A=C	A
		GOYES	QMULCCim0
		D0=D0-	5
		ST=0	sTRIM
		LC(5)	=DOCOL
		DAT1=C	A		D0 -> res.im, D1 -> output, A =long.
		D1=D1+	5
		C=A	A
		C=C+CON	A,5		prologue+longueur
		GOSBVL	=MOVEDOWN
		GOTO	QMULCC1		D0 -> im*im, D1 -> output'
QMULCCim0	A=D0
		A=A+C	A
		D0=A
QMULCC1		GOSUB	skip2hxs
		D0=D0+	5
		C=DAT0	A
		D0=D0-	5
		C=C+CON	A,5
		GOSBVL	=MOVEDOWN
		?ST=1	sTRIM
		GOYES	+
		LC(5)	=SEMI
		DAT1=C	A
		D1=D1+	5		D1= output'
+		ST=0	sTRIM
		AD1EX
		R3=A.F	A		R3= output'
		GOSUB	Pop[A]
		D1=A			D1'
		GOSUB	Pop[A]
		D0=A			D0'
		RTN

* saute 2 entiers longs a partir de D0
skip2hxs	D0=D0+	5		skip hxs1
		A=D0
		C=DAT0	A
		A=A+C	A
		D0=A
		D0=D0+	5		skip hxs2
		A=D0
		C=DAT0	A
		A=A+C	A
		D0=A
		RTN

MULCZ		ST=1	sQSWAP*
		AD0EX			
		AD1EX
		AD0EX
		GOTO	MULZC1
tomulz0q	GOLONG	mulz0q
tomulz1q	GOLONG	mulz1q
tomulz-1q	GOLONG	mulz-1q
MULZC		ST=0	sQSWAP*
MULZC1		D0=D0+	5
		A=DAT0	7		Z1 length & first 2 nibbles
		D0=D0-	5
		C=A	W
		LCHEX	000006		Z0 body
		?A=C	W
		GOYES	tomulz0q	Z0 * Q ==> Z0
		LCHEX	0100007
		?A=C	W
		GOYES	tomulz1q	Z1 * Q ==> Q
		LCHEX	F100007
		?A=C	W
		GOYES	tomulz-1q	Z-1 * Q ==> -Q
		P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		LA(5)	=DOCOL
		DAT1=A	A		Write DOCOL
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		D1=D1+	5		Skip DOCOL
		CD0EX			Save ->Z0
		RSTK=C
		CD0EX
		GOSUB	MULZZ
		C=RSTK			Restore ->Z0
		D0=C
		GOSUB	MULZZ
		P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		LA(5)	=SEMI
		DAT1=A	A		Write SEMI
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		GOLONG	mulzqexit

**********************************************************************
* Desc:		Multiply Q1*Q2
* Algorithm:
*	1) Traverse Q1, saving elements and length
*	2) Traverse Q2, saving elements and length
*	3) Init double loop
*	4) Do the common double loop
*
*	FOR J = 0 TO (LEN1+LEN2-2)
*		Element[J] = 0
*		FOR I = MAX[0,J-LEN2+1] TO MIN[J,LEN1-1]
*			Element[J] += Q1[I] * Q2[J-I]
*		NEXT I
*	NEXT J
*
*	Saved to the stack:
*
*	X[1] X[2] ... X[LEN1]
*	Y[1] Y[2] ... Y[LEN2]
*	END1 END2
*	LEN1 LEN2
*	J JSTOP
*	ELEMENT
*	I ISTOP
*
*	Future speed improvement:
*		Z1+Z2 backaddition can be done in place.
*		==> Q1+Z2 backaddition can be done in place.
*
**********************************************************************
MULQQ		GOSUB	TraverseQ
		R0=A.F	A		LEN1
		R2=C.F	A		END1
		AD1EX
		D0=A
		GOSUB	TraverseQ
		R1=A.F	A		LEN2
		CR2EX.F	A		R2[A] = END2
		A=C	A
		GOSUB	Push[A]		END1
		A=R2.F	A
		GOSUB	Push[A]		END2
		A=R0.F	A
		GOSUB	Push[A]		LEN1
		A=R1.F	A
		GOSUB	Push[A]		LEN2
		A=0	A
		GOSUB	Push[A]		J
		A=R0.F	A		LEN1
		C=R1.F	A		LEN2
		A=A+C	A		LEN1 + LEN2
		A=A-1	A		LEN1 + LEN2 - 1
		A=A-1	A		LEN1 + LEN2 - 2
		GOSUB	Push[A]		JSTOP

		P=	5
		GOSUB	Ensure[P]
		A=R3.F	A		->output
		AD1EX
		LC(5)	=DOLIST
		DAT1=C	A
		D1=D1+	5
		AD1EX
		R3=A.F	A		->output'

* Do things in register for as long as possible, then step into
* the slower second loop which does the multiplications
* and back additions in memory. This often provides a drastic
* speedup since the overhead in stack saves is quite significant.

mulqqloop	A=R3.F	A		->element
		GOSUB	Push[A]
		LC(5)	5+5+16+1+10	Make sure there's room for
		GOSUB	Ensure[C]	result if it fits into register
		A=0	W		(+10 for I and ISTOP)
		R0=A	W		R0[W]R1[S] = signed result = 0 now
		R1=A.F	S
		ST=1	sQMULREG	Flag result in registers

		A=R4.F	A		->stack
		D1=A
		D1=D1+	10		->J (stack)
		C=DAT1	A
		D=C	A		J
		D1=D1+	10		->LEN1
		C=DAT1	A
		B=C	A		LEN1
		D1=D1-	5		->LEN2
		A=DAT1	A		LEN2

* I = MAX[0,J-LEN2+1]

		C=D	A		J
		C=C+1	A		J+1
		C=C-A	A		J-LEN2+1
		GONC	indexok
		C=0	A
indexok		A=C	A
		GOSUB	Push[A]

* ISTOP = MIN[J,LEN1-1]

		C=B	A		LEN1
		C=C-1	A		LEN1-1
		?C<=D	A
		GOYES	istopok
		C=D	A		J
istopok		A=C	A
		GOSUB	Push[A]

*	X[1] X[2] ... X[LEN1]
*	Y[1] Y[2] ... Y[LEN2]
*	END1 END2
*	LEN1 LEN2
*	J JSTOP
*	ELEMENT
*	I ISTOP
*
*	X[I]   = STACK[8+LEN2+LEN1-I]
*	Y[J-I] = STACK[8+LEN2-J+I)]

mulqqresloop	A=R4.F	A
		D0=A			->stack
		D0=D0+	5
		A=DAT0	A		I
		D0=D0+	15
		D0=D0+	5
		C=DAT0	A		LEN2
		C=C-A	A		LEN2-I
		D0=D0+	5
		A=DAT0	A		LEN1
		A=A+C	A		LEN1+LEN2-I
		A=A+CON	A,8		8+LEN1+LEN2I
		C=R4.F	A
		C=C+A	A
		A=A+A	A
		A=A+A	A
		C=C+A	A
		D0=C
		C=DAT0	A
		D0=C			->X[I]

		A=R4.F	A
		D1=A
		D1=D1+	5
		A=DAT1	A		I
		D1=D1+	15
		C=DAT1	A		J
		A=A-C	A		I-J
		D1=D1+	5
		C=DAT1	A		LEN2
		A=A+C	A		LEN2-J+I
		A=A+CON	A,8		8+LEN2-J+I
		C=R4.F	A
		C=C+A	A
		A=A+A	A
		A=A+A	A
		C=C+A	A
		D1=C
		C=DAT1	A
		D1=C			->Y[J-I]

* If not in register multiplication then use old memory code
* Else try to get new temporary result in registers.
* If fails then setup new mulqqresloop pass with old memory code.

		?ST=1	sQMULREG
		GOYES	mulqqresreg
		GOTO	mulqqresmem

* First save D0 & D1 so we don't have to jump all the way back to
* mulqqresloop if overflow occurs. This benefits especially
* multivariate multiplications.

mulqqresreg	AD0EX
		R1=A.F	A
		D0=A
		CD1EX
		R2=C.F	A
		D1=C

* Faster code for doing the math in registers

		GOSUBL	SHORTPOPCK?
		GOC	mulqqregfail	* Change to memory code *
		B=A	W		B[W]=mantissa1
		D=C	S		D[S]=sign1
		CD1EX
		D0=C
		GOSUBL	SHORTPOPCK?
		GOC	mulqqregfail	* Change to memory code *
		CBEX	W		AB=int1	CD=int2
		GOSUBL	SHORT*		AC=int1*int2
		GOC	mulqqregfail	* Change to memory code *
		B=C	S		AB=int1*int2
		C=R1.F	S
		D=C	S
		C=R0	W		CD=result
		GOSUBL	SHORT+
		GOC	mulqqregfail	* Change to memory code *
		R0=A	W
		R1=C.F	S		R0R1=result'
		GOTO	mulqqresnext

* Overflow! Output current result and try again

mulqqregfail	ST=0	sQMULREG	No more in registers
		C=R3.F	A
		D1=C			->output
		A=R0	W
		C=R1.F	S		AC = current result
		GOSUBL	SHORTOUT	Free memory was verified earlier
		CD1EX
		R3=C.F	A		->output'
		A=R1.F	A
		D0=A
		C=R2.F	A
		D1=C			Now we can just fall through
		
* Slower code for doing the math in memory

mulqqresmem	GOSUB	QMUL		A[A]=->result
		ST=0	sQMULREG	Must have this one due to recursion!
		D1=A			->result
		A=R4.F	A		->stack
		D0=A
		D0=D0+	10
		A=DAT0	A
		D0=A			->element

		C=R3.F	A		->output
		GOSBVL	=CSLW5
		C=R3.F	A
		R3=C			->output ->output
		C=C-A	A		size of Q1 and Q2
		GOSUB	Ensure[C]
		GOSUBL	QADD		R3[A]=->output tail

		C=R4.F	A		->stack
		D1=C
		D1=D1+	10
		C=DAT1	A
		D1=C			->element

		A=R3
		C=A	A		->output tail
		GOSBVL	=ASRW5
		D0=A			->output
		C=C-A	A		output size
		GOSBVL	=MOVEDOWN
		CD1EX
		R3=C.F	A		->output'

mulqqresnext	A=R4.F	A
		D0=A			->stack
		C=DAT0	A		istop
		D0=D0+	5
		A=DAT0	A		I
		A=A+1	A		I++
		DAT0=A	A
		?A>C	A
		GOYES	mulqqresok
		GOTO	mulqqresloop	Loop until ISTOP

* Now if we managed to do it all in registers we have to output
* the result - otherwise the result is already in place

mulqqresok	?ST=0	sQMULREG
		GOYES	mulqqresokmem
		C=R3.F	A
		D1=C			->output
		A=R0	W
		C=R1.F	S		AC = result
		GOSUBL	SHORTOUT
		CD1EX
		R3=C.F	A		->output'

mulqqresokmem	D0=D0+	10
		AD0EX
		R4=A.F	A		->stack' (popped ELEMENT I ISTOP)
		D0=A
		C=DAT0	A		JSTOP
		D0=D0+	5
		A=DAT0	A		J
		A=A+1	A		J++
		DAT0=A	A
		?A>C	A
		GOYES	mulqqloopok
		GOTO	mulqqloop

* Finish Q*Q loop ; drop stack & output SEMI
		
mulqqloopok	D0=D0+	5
		C=DAT0	A		LEN2
		D0=D0+	5
		A=DAT0	A		LEN1
		C=C+A	A		LEN1+LEN2
		D0=D0+	5
		A=DAT0	A		END2
		D1=A
		D0=D0+	5
		A=DAT0	A		END1
		AD0EX
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A
		A=A+CON	A,5
		R4=A.F	A		->stack'

		A=R3.F	A		->output
		AD1EX
		LC(5)	=SEMI		Memory exists due to stack pops
		DAT1=C	A
		D1=D1+	5
		AD1EX
		R3=A.F	A		->output'
		RTN

**********************************************************************
* Desc:		Traverse polynomial in D0, save element addresses
*		and return polynomial degree
* Entry:	D0    = ->P
*		R3[A] = ->output
*		R4[A] = ->stack
* Output:	A[A] = degree
*		C[A] = ->Ptail
**********************************************************************
TraverseQ	D0=D0+	5		Skip DOLIST
		D=0	A		complevel = 0
		B=0	A		degree = 0
travelQloop	A=DAT0	A
		LC(5)	=SEMI
		?A=C	A
		GOYES	travelS
		?D#0	A
		GOYES	travelQ10
		B=B+1	A		degree++
		AD0EX
		D0=A
		GOSUB	Push[A]
travelQ10	A=DAT0	A
		D0=D0+	5
		LC(5)	=DOLIST
		?A=C	A
		GOYES	travelL
		LC(5)	=DOCOL
		?A=C	A
		GOYES	travelL
		C=DAT0	A		Zlen
		AD0EX
		A=A+C	A
		AD0EX
		GONC	travelQloop
travelL		D=D+1	A		complevel++
		GONC	travelQloop
travelS		D0=D0+	5
		D=D-1	A
		GONC	travelQloop
		CD0EX			->Ptail
		A=B	A		degree
		RTNCC
**********************************************************************
* Desc:		Ensure memory exists between ->output and ->stack
* Input:	C[A] = need
* Alters:	C[A]
**********************************************************************

Ensure[P]	C=0	A
		CPEX	0
Ensure[C]	AR3EX.F	A
		C=A+C	A		->output end
		AR3EX.F	A
		AR4EX.F	A
		?C>A	A
		GOYES	ensure00	CS if ->output end > ->stack
ensure00	AR4EX.F	A
		RTNNC
		GOTO	QMULretry	Try again after GC

**********************************************************************
* Desc:		Multiplication stack push
* Entry:	A[A] = push address
*		R3[A] = ->output	(current output pointer)
*		R4[A] = ->stack		(address of topmost stack level)
* Modifies:	C[A] R4[A]
* Errors:	If new level would overwrite something below ->output
*		QMUL is restarted after forcing a GC
**********************************************************************

Push[A]		AR4EX.F	A		A[A]=->stack	R4[A]=input
		A=A-CON	A,5		->stack'
		C=R3.F	A		->output
		?A<C	A
		GOYES	StackErr	Not enough memory
		AD0EX
		C=R4.F	A		input
		DAT0=C	A
		AD0EX
		AR4EX.F	A		A[A]=input	R4[A]=->stack'
		RTNCC
StackErr	GOTO	QMULretry	Try again after GC

**********************************************************************
* Desc:		Multiplication stack pop
* Entry:	R3[A] = ->output	(current output pointer)
*		R4[A] = ->stack		(address of topmost stack level)
* Exit:		A[A] = addr
* Modifies:	R4[A]
**********************************************************************

Pop[A]		CR4EX.F	A		C[A]=->stack	R4[A]=C[A]
		CD0EX
		A=DAT0	A		A[A]=pop
		D0=D0+	5		->stack'
		CD0EX
		CR4EX.F	A		C[A]=C[A]	R4[A]=->stack'
		RTNCC


**********************************************************************
* Multiplication C*Q
* D0=@C, D1=@Q
**********************************************************************
tomulcq.cz	GOTO	mulcq.cz
MULCQ		ST=0	sQSWAP*		No swap done
mulcqentry	B=0	A		complevel
mulcqloop	A=DAT1	A
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	tomulcq.cz
		LC(5)	=DOCOL
		?A=C	A
		GOYES	mulcq.cc
		P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		DAT1=A	A		Write DOLIST/SEMI
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		B=B+1	A		complevel++
		D1=D1+	5		Skip DOLIST/SEMI
		LC(5)	=DOLIST
		?A=C	A
		GOYES	mulcqloop
		B=B-1	A
		B=B-1	A		complevel--
		?B#0	A
		GOYES	mulcqloop
		D0=D0+	10		skip docol+dohxs
		C=DAT0	A		im[c]1len
		AD0EX
		A=A+C	A		->im[c]1tail
		AD0EX
		D0=D0+	5
		C=DAT0	A		re[c]1len
		AD0EX
		A=A+C	A		->re[c]1tail
		AD0EX
		D0=D0+	5		skip semi
		?ST=0	sQSWAP*		No swap done?
		GOYES	+		Yep - done
		AD0EX			No - restore order
		AD1EX
		AD0EX
+		RTN
mulcq.cc	C=B	A		Save complevel
		RSTK=C
		CD0EX			Save ->Z1
		RSTK=C
		CD0EX
		GOSUB	QMULCC
		C=RSTK			Restore ->Z1
		D0=C
		C=RSTK			Restore complevel
		B=C	A
		GOTO	mulcqloop
mulcq.cz	D1=D1+	5
		A=DAT1	A
		D1=D1-	5
		LC(5)	6
		?A#C	A
		GOYES	mulcq.czn0
		P=	11
		GOSUB	Ensure[P]
		A=DAT1	11		Z0
		D1=D1+	11
		C=R3.F	A
		CD1EX
		DAT1=A	11
		D1=D1+	11
		CD1EX
		R3=C.F	A
		GOTO	mulcqloop
mulcq.czn0	P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		LA(5)	=DOCOL
		DAT1=A	A		Write DOCOL
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		C=B	A		Save complevel
		RSTK=C
		CD0EX			Save ->C0
		RSTK=C
		CD0EX
		CD1EX			Save -> Z1
		RSTK=C
		CD1EX
		D0=D0+	5		Skip DOCOL in C1
		GOSUB	MULZZ
		C=RSTK			Restore ->Z1
		D1=C
		GOSUB	MULZZ
		C=RSTK
		D0=C			Restore -> C0
		C=RSTK			Restore complevel
		B=C	A
		P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		LA(5)	=SEMI
		DAT1=A	A		Write SEMI
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		GOTO	mulcqloop

MULQC		ST=1	sQSWAP*		Flag swapped order
		AD0EX
		AD1EX
		AD0EX
		GOTO	mulcqentry	And do the reverse multiplication

**********************************************************************
* Desc:		Multiply Z1*Q2
* Algorithm:
*	1) Check special cases for fast code
*	2) Multiply Q2 element by element to output
* Notes:
*	One could easily use the stack approach but it would just create
*	unnecessary overhead by requiring the stack saves.
**********************************************************************

gomulz0q	GOTO	mulz0q
gomulz1q	GOTO	mulz1q
gomulz-1q	GOTO	mulz-1q

MULZQ		ST=0	sQSWAP*		No swap done
mulzqentry	D0=D0+	5
		A=DAT0	7		Z1 length & first 2 nibbles
		D0=D0-	5
		C=A	W
		LCHEX	000006		Z0 body
		?A=C	W
		GOYES	gomulz0q	Z0 * Q ==> Z0
		LCHEX	0100007
		?A=C	W
		GOYES	gomulz1q	Z1 * Q ==> Q
		LCHEX	F100007
		?A=C	W
		GOYES	gomulz-1q	Z-1 * Q ==> -Q
		B=0	A		complevel
mulzqloop	A=DAT1	A
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	mulzq.zz
		LC(5)	=DOCOL
		?A=C	A
		GOYES	mulzq.zc
		P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		DAT1=A	A		Write DOLIST/SEMI
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		B=B+1	A		complevel++
		D1=D1+	5		Skip DOLIST/SEMI
		LC(5)	=DOLIST
		?A=C	A
		GOYES	mulzqloop
		B=B-1	A
		B=B-1	A		complevel--
		?B#0	A
		GOYES	mulzqloop
		D0=D0+	5
		C=DAT0	A		Z1len
		AD0EX
		A=A+C	A		->Z1tail
		AD0EX
mulzqexit	?ST=0	sQSWAP*		No swap done?
		GOYES	+		Yep - done
		AD0EX			No - restore order
		AD1EX
		AD0EX
+		RTNCC
mulzq.zz	C=B	A		Save complevel
		RSTK=C
		CD0EX			Save ->Z1
		RSTK=C
		CD0EX
		GOSUB	MULZZ
		C=RSTK			Restore ->Z1
		D0=C
		C=RSTK			Restore complevel
		B=C	A
		GOTO	mulzqloop
mulzq.zc	P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		DAT1=A	A		Write DOCOL
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		D1=D1+	5		Skip DOCOL
		C=B	A		Save complevel
		RSTK=C
		CD0EX			Save ->Z0
		RSTK=C
		CD0EX
		GOSUB	MULZZ
		C=RSTK			Restore ->Z0
		D0=C
		RSTK=C			Resave -> Z0
		GOSUB	MULZZ
		C=RSTK			Restore ->Z0
		D0=C
		C=RSTK			Restore complevel
		B=C	A
		D1=D1+	5		skip SEMI
		P=	5
		GOSUB	Ensure[P]
		C=R3.F	A		->output
		CD1EX
		LA(5)	=SEMI
		DAT1=A	A		Write SEMI
		D1=D1+	5
		CD1EX
		R3=C.F	A		->output'
		GOTO	mulzqloop
		

*  Z0*Q2 ; Skip both and output Z0
mulz0q		GOSUBL	QSKIPD1
		P=	11
		GOSUB	Ensure[P]
		A=DAT0	11		Z0
		D0=D0+	11
		C=R3.F	A
		CD1EX
		DAT1=A	11
		D1=D1+	11
		CD1EX
		R3=C.F	A
		GOTO	mulzqexit

* Z1*Q2 ; Skip both and output Q2
mulz1q		D0=D0+	12		Skip Z1
		CD1EX
		B=C	A		->Q2
		CD1EX
		GOSUBL	QSKIPD1		->Q2tail
		CD1EX
		C=C-B	A		Q2size
		CBEX	A		B[A]=Q2size
		D1=C
		C=B	A
		GOSUB	Ensure[C]
		C=R3.F	A
		CD1EX
		CD0EX
		CBEX	A
		GOSBVL	=MOVEDOWN
		C=B	A
		CD0EX
		CD1EX
		R3=C.F	A
		GOTO	mulzqexit

* -Z1*Q2 ; Skip both and output -Q2
mulz-1q		C=R3.F	A		->output
		RSTK=C
		GOSUB	mulz1q		Output Q2
		C=RSTK
		CD0EX
		B=C	A		->Z1tail
		GOSUBL	QNEG
		C=B	A
		D0=C			->Z1tail
		GOTO	mulzqexit

**********************************************************************
* Desc:		Multiply Q1*Z2
*	1) Multiply Q1 element by element to output
**********************************************************************

MULQZ		ST=1	sQSWAP*		Flag swapped order
		AD0EX
		AD1EX
		AD0EX
		GOTO	mulzqentry	And do the reverse multiplication

**********************************************************************
* Desc:		Multiply Z1*Z2
* Algorithm:
*	1) Check sizes, ensure sufficient memory
*	2) If either Z is zero then output Z0 and return
*	3) If multiplication result fits into register then
*	   so do the integers - multiply in registers & return
*	4) Do slow multiplication in segments
*
* In:	D0	->Z1		Out:	D0	->Z1tail
*	D1	->Z2			D1	->Z2tail
*	R3[A]	->output		R3[A]	->output' (tail)
*	R4[A]	->stack			R4[A]	->stack
*
* Alters:	D0 D1 A[W] B[W] C[W] D[S,A] R0[A] R1[A] R2[A] R3[A]
*
* Stack levels:	2 (Data address storage in slow * loop)
*
* Warning:	Due to a bug in the HP interrupt system the interrupt
*		system will use *3* RSTK levels if the keyboard gets
*		filled and beep is enabled. The original MULZZ used
*		4 RSTK levels and was thus very prone to RSTK
*		overflows.
*		==> Made BMUL inline code
*		==> Made R2[A] to serve as an extra pointer
*		==> Only 2 RSTK levels used
**********************************************************************

mulzzerr	GOLONG	QMULretry	Insufficient memory - retry

MULZZ		D0=D0+	5		->Z1len
		D1=D1+	5		->Z2len
		A=DAT0	A		Z1len
		C=DAT1	A
		D0=D0-	5
		D1=D1-	5
		A=A+C	A		Z1len+Z2len
		LC(5)	10+50		+ 2 prologs & safety
		C=C+A	A		needed memory (max)

		A=R3.F	A
		B=A	A		->output
		A=R4.F	A		->stack
		A=A-B	A		free memory
		?A<C	A
		GOYES	mulzzerr


* Special entry to avoid memory checks (R4 becomes free)

MULZZentry	D0=D0+	5
		D1=D1+	5
		A=DAT0	A		Z1len
		C=DAT1	A		Z2len
		A=A-CON	A,6		nibs1 (sign not included)
		C=C-CON	A,6		nibs2 (sign not included)

* Now check if either Z is zero

		?A#0	A
		GOYES	mulz1#0

mulzz0skp	C=DAT0	A		Skip Z1
		AD0EX
		A=A+C	A
		AD0EX
		C=DAT1	A		Skip Z2
		AD1EX
		A=A+C	A
		AD1EX
mulzz0		A=R3.F	A		->output
		AD1EX
		LCZ0
		DAT1=C	11
		D1=D1+	11
		AD1EX
		R3=A.F	A		->output'
		RTNCC

mulz1#0		?C=0	A
		GOYES	mulzz0skp

* Neither Z was zero - check for short multiplication

		R0=A.F	A		nibs1
		R1=C.F	A		nibs2
		A=A+C	A		nibs1 + nibs2
		A=0	P
		?A#0	A
		GOYES	MULZZslow	14+1 is allowed, 15+1 is not

** Fast register multiplication

MULZZfast	GOSUBL	shortpopd1	A[W]=mantissa2	C[S]=sign2
		B=A	W		B[W]=mantissa2
		D=C	S				D[S]=sign2
		GOSUBL	shortpop	A[W]=mantissa1	C[S]=sign1
		D=D+C	S		calculate result sign
		GONC	+
		D=0	S
+		GOSUBL	BMULB		A[W]=C[W] = A*B
		C=D	S		C[S] = sign
		CD1EX
		CR3EX.F	A		->output
		D1=C
		GOSUBL	SHORTOUT
		CD1EX
		CR3EX.F	A		->output'
		CD1EX
		RTN

** Slow Z multiplication for long integers in 8-nibble chunks

MULZZslow

* Determine sign of result

		A=DAT0	A		Z1len
		CD0EX
		A=A+C	A
		A=A-1	A
		D0=A
		A=DAT0	S		Z1sign
		D0=C			->Z1len

		A=DAT1	A		Z2len
		CD1EX
		A=A+C	A
		A=A-1	A
		D1=A
		C=DAT1	S		Z2sign
		D1=C			->Z1len

		C=C+A	S		[00 0F F0 FF] --> [0 F F E]
		GONC	mulzzsgnok
		C=0	S		[00 0F F0 FF] --> [0 F F 0]
mulzzsgnok	D=C	S		D[S] = Zsign

* Initialize output

		A=R0			nibs1
		C=R1			nibs2
		A=A+C	A
		LC(5)	10+2+1+20	prolog+len+extra2+sign +safety
		C=C+A	A		need
		A=R3.F	A		->output
		AD1EX
		B=A	A		->Z2len
		C=0	S		Output a non-zero stop mark just
		C=C+1	S		in case we have an abnormal zero
		DAT1=C	S		in multiplication
		D1=D1+	1
		GOSBVL	=WIPEOUT
		A=B	A
		D1=A			->Z2len

* Now determine loop counters for doing recursive multiplication
* with max 8-nibble units.
*
* For each 8 nibbles in the first integer
*	Multiply each 8 nibbles in the second one and
*	add the result to the proper place in output
*	Uses an 8 nibble carry

		D0=D0+	5		->Z1mantissa
		D1=D1+	5		->Z2mantissa
		CD1EX
		R2=C.F	A		->Z2mantissa
		CD1EX
		C=R3.F	A		->output
		C=C+CON	A,10		->Zbody
		RSTK=C			->output start

* Multiply 8 nibbles from D0 with remainder of D1 to output

ZMULloop1	C=RSTK
		RSTK=C			->output start
		RSTK=C			->output slider
		C=R1.F	A
		D=C	A		nibs2
		B=0	W		No carry

ZMULloop2	P=	8-1
		D=D-CON	A,8		Try using 8 nibs of Z2
		GONC	zmul10
		C=D	B		Not that much left, use what's left
		C=C+CON	B,7
		P=C	0
		D=0	A		No more nibbles left
zmul10		A=0	W
		A=DAT1	WP		A=Vj (block j of Z2)
		CD1EX
		C+P+1			->next block of Z2
		CD1EX

		C=R0.F	A		nibs1
		P=	8-1
		C=C-CON	A,8		Try using 8 nibs of Z1
		GONC	zmul20
		C=C+CON	B,7		Not that much left, use what's left
		P=C	0
zmul20		ABEX	W		A[8-15]=carry	B[W]=Vj
		C=0	W
		C=DAT0	WP		C=Ui (block i of Z1)
		P=	0

* Compute A=Ui*Vj+carry.

		ASR	W
		ASR	W
		ASR	W
		ASR	W
		ASR	W
		ASR	W
		ASR	W
		ASR	W		A[0-7]=carry
zmul30		SB=0
		CSRB
		?SB=0
		GOYES	zmul40
		A=A+B	W
zmul40		B=B+B	W
		?C#0	W
		GOYES	zmul30

* Add the multiplication result to target

		C=RSTK
		CD1EX
		RSTK=C			->next block of Z2
		C=0	W
		C=DAT1	8		C=Wi+j  (block i+j of result)
		C=C+A	W		C=Ui+Vj+carry+Wi+j  (<2^16)
		?D=0	A
		GOYES	ZMULlpnext	Done with inner loop
* write block result and repeat inner loop
		DAT1=C	8		write new Wi+j
		B=C	W		B[8-15]=carry
		D1=D1+	8		Next target block
		C=RSTK
		CD1EX
		RSTK=C			->output slider
		GOTO	ZMULloop2
* end inner loop and update D0 pointer & output start location
ZMULlpnext	DAT1=C	W		write new Wi+j and final carry
		D1=D1+	16		->output tail
		C=RSTK			->drop ->Z2 tail
		C=RSTK			->old output start
		A=C	A
		A=A+CON	A,8		->new output start
		C=R2.F	A		->mantissa2
		CD1EX			D1 = ->mantissa2
		ACEX	A		A  = ->output tail
		RSTK=C			->new output tail
		C=R0.F	A
		C=C-CON	A,8		nibs1--
		GOC	zmuldone
		?C=0	A
		GOYES	zmuldone	done if there were <= 8 nibs
		R0=C.F	A
		D0=D0+	8
		GOTO	ZMULloop1

zmuldone	D1=A			->output tail
		C=R0.F	A		nibs1
		P=C	0
		CD0EX
		C+P+1			Skips sign too
		CD0EX
		P=	0
		C=RSTK			drop ->output start
		C=R2.F	A		->mantissa2
		CD1EX
		D1=D1-	5
		A=DAT1	A		Z2len
		CD1EX
		C=C+A	A		->Z2tail
		D=C	A		->Z2tail

* Now scan backwards until non-zero nibble

zmulstriplp	D1=D1-	1
		A=DAT1	S
		?A=0	S
		GOYES	zmulstriplp
		D1=D1+	1
		C=D	S		Output sign
		DAT1=C	S
		D1=D1+	1
* Now check what we got
		AD1EX
		D1=A			->output'
		C=R3.F	A		->output
		A=A-C	A		size
		LC(5)	10
		?A<=C	A
		GOYES	zmuliszero	Output zero for too small results
		C=R3.F	A		(Meaning we had an unnormalized zero)
		CD1EX
		R3=C.F	A		->output'
		LC(5)	=DOHSTR
		DAT1=C	A
		D1=D1+	5
		A=A-CON	A,5
		DAT1=A	A
		C=D	A
		D1=C			->Z2tail
		RTNCC
zmuliszero	C=D	A
		D1=C			->Z2tail
		GOTO	mulzz0		Output Z0
**********************************************************************
* Desc:		Multiply small integers with carry
* Entry:	A[W]    = multiplicand
*		B[W]    = multiplier
*		C[8-15] = carry
* Exit:		A[W] = C[W] = result
* Modifies:	A[W] B[W] C[W]
* Stack:	0
**********************************************************************

BMULCRY		CSR	W
		CSR	W
		CSR	W
		CSR	W
		CSR	W
		CSR	W
		CSR	W
		CSR	W		C[0-7]=carry
		GOTO	bmulnow		Jump to common code

**********************************************************************
* Desc:		Multiply small integers with no overflow checks
* Entry:	A[W] = multiplicand
*		C[W] = multiplier
* Exit:		A[W] = C[W] = result
* Modifies:	A[W] B[W] C[W]
* Stack:	0
**********************************************************************

BMUL		B=C	W
BMULB		C=0	W
bmulnow		?A<B	W		Get smaller to A[W] for speed
		GOYES	+
		ABEX	W
+		SB=0
bmulloop	ASRB
		?SB=0
		GOYES	+
		SB=0
		C=C+B	W
+		B=B+B	W
		?A#0	B
		GOYES	bmulloop
		?A#0	W
		GOYES	bmulloop
		A=C	W
		RTNCC



**********************************************************************
* Desc:		Push Z to data stack safely
* Entry:	A[W] mantissa
*		C[S] sign
* Uses:		IRAMBUFF to save during GC
*		A,B,C,D,D0,D1 sGARB
* Note:		This can safely be called from a subroutine, but not deeper.
**********************************************************************

PushZ0		LC(5)	11
		GOSBVL	=GETTEMP
		LCZ0
		DAT0=C	11
		AD0EX
		GOVLNG	=GPPushA

PushN		C=0	S		Special entry to push positive
PushZ		?A=0	W
		GOYES	PushZ0
		P=	0
-		P=P-1
		?A=0	P
		GOYES	-
		D0=(5)	(=IRAM@)-4
		C=DAT0	A
		D0=C
		D0=(4)	#100		IRAMBUFF on SX and GX
		DAT0=C	S		sign
		D0=D0+	1
		DAT0=A	W		mantissa
		C=0	A
		CPEX	0		nibbles-1
		C=C+CON	A,12		Z size
		GOSBVL	=GETTEMP	C[A]=size  D0=->ob	D1=->obend
		B=C	A		Z size
		CD0EX
		D0=(5)	(=IRAM@)-4
		A=DAT0	A
		D0=A
		D0=(4)	#100		IRAMBUFF on SX and GX
		C=DAT0	S		sign
		D0=D0+	1
		A=DAT0	W		mantissa
		D0=C			->ob
		D1=D1-	1
		DAT1=C	S		Write sign
		LC(5)	=DOHSTR
		DAT0=C	A		Write prolog
		D0=D0+	5
		C=B	A		Z size
		C=C-CON	A,5
		DAT0=C	A		Write length
		D0=D0+	5
		C=C-CON	A,7
		P=C	0
		DAT0=A	WP		Write mantissa
		P=	0
		D0=D0-	10
		AD0EX
		GOVLNG	=GPPushA

PushZ1		LC(5)	12
		GOSBVL	=GETTEMP
		LCZ1
		DAT0=C	12
		AD0EX
		GOVLNG	=GPPushA

RPL
*******************************************************************
ASSEMBLE

* Desc:		FastGcd? tries to calculate GCD[Z1,Z2] in registers
*		If success then pushes GCD & TRUE, else FALSE

FastGcd?	GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A			->Z2
		GOSUBL	SHORTPOP?
		GOC	fastgcdfail
		?A=0	W
		GOYES	fastgcddrop1	GCD[any,0] = any
		B=A	W		B[W] = Z2

		D1=D1+	5
		A=DAT1	A
		D0=A			->Z1
		GOSUBL	SHORTPOP?
		GONC	fastgcdnow

fastgcdfail	GOVLNG	=GPPushFLoop	( Z1 Z2 --> Z1 Z2 FALSE )
fastgcddrop1	GOVLNG	=GPOverWrTLp	( Z1 0 --> Z1 TRUE )
fastgcddrop2	GOSBVL	=GETPTR		( 0 Z2 --> Z2 TRUE )
		A=DAT1	A
		D1=D1+	5
fastgcdtrue	DAT1=A	A
		D1=D1-	5
		GOVLNG	=OverWrTLoop

fastgcdnow	?A=0	W		GCD[0,any] = any
		GOYES	fastgcddrop2
		C=B	W

* Suspect: SHORTGCD should be better

-		GOSUBL	toBDIV		B[W]=remainder	C[W]=divisor
		A=C	W		divisor
		C=B	W		remainder
		?C#0	W
		GOYES	-

		GOSUBL	PushN		Push Z
		A=DAT1	A		Overwrite 2nd stack level with Z
		D1=D1+	10
		D=D+1	A
		GONC	fastgcdtrue
RPL
**********************************************************************
* Desc:		Calculate number of bits used in Z
* Stack:	( Z --> Z #bits )
**********************************************************************
NULLNAME ZBits
CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A			->Z
		GOSUB	BitCount
		GOVLNG	=PUSH#ALOOP

* Input:	D0   ->Z
* Output:	A[A] #bits

BitCount	D0=D0+	5
		A=DAT0	A		Zlen
		CD0EX
		C=C+A	A
		D0=C
		A=A-CON	A,6		nibbles in mantissa
		?A=0	A
		RTNYES			If zero then zero bits too
		A=A+A	A
		A=A+A	A
		D0=D0-	2
		C=DAT0	B
-		C=C+C	P		Decrease unused high bits
		RTNC			Done when high bit is found
		A=A-1	A
		GONC	-
ENDCODE

**********************************************************************
* Desc:		Test if a bit in Z is set
* Stack:	( Z #bit --> Z flag )
* Note:		Count starts from zero, as opposed to ZBits
**********************************************************************
NULLNAME ZBit?
CODE
		GOSBVL	=POP#		A[A] = #bit
		GOSBVL	=SAVPTR
		C=DAT1	A		C[A] = ->Z
		GOSUB	BitTest
		GOVLNG	=GPPushT/FLp	TRUE if bit is set


* Provide subroutine for other programs
* Output:	A[A] = bit
*		C[A] = ->Z
* Output:	CS if bit is set

BitTest		D1=C			->Z
		LC(1)	3
		C=C&A	A		C[0] = lowbits
		P=C	0
		CD1EX			->Z
		ASRB.F	A
		ASRB.F	A
		C=C+A	A
		D1=C
		D1=D1+	10		->nibble to test
		A=DAT1	B
		LCHEX	1248
		P=C	3
		C=P	0
		P=	0
		A=A&C	A
		?A#0	P
		RTNYES
		RTN
ENDCODE
**********************************************************************
* Desc:		Modular power.		Z = Zb^Zp (mod Zn)
* Stack:	( Zb Zp Zn --> Z' )
* Notes:	Zp power, not system binary!
*
*	This is the main bottle-neck of most algorithms involving
*	primes. For example Pollard's p-1 factorization with the
*	first 1000 primes would require calculating
*
*		2^lcm(1..7919) mod N
*
*	In practise this is done in steps of maybe 50, but still
*	gives a clear indication of the time required in the bad cases.
*		The LCM takes 1414.5 bytes as a Z
*		Calculating gcd(n,2^z-1) would provide a very simple
*		factorization program..
*
*	Another example is the BRabin subroutine, which simply had to
*	be limited to a smaller base-set to reduce execution time for
*	very long integers.
*
**********************************************************************
NULLNAME ModPow
::

* Special case ^0

  OVER QIsZero? casedrop
	:: 2DROP HXS 2 10 ;		( --> Z1 )

* Normalize to 0 <= Zb < Zn

  ROTOVER				( Zp Zn Zb Zn )
  QMODSYMext				( Zp Zn Zb' )

* Special case ^1

  UNROTSWAP				( Zb Zn Zp )
  DupZIsOne? case2DROP			( --> Zb )

* Logarithmic multiplication loop in assembly follows
* The code expects all arguments to be normalized.

* ( Zb Zn Zp --> Zb^Zp mod Zn )
  CODE
		GOSBVL	=SAVPTR

		GOSUB	D1->Zn
		D1=D1+	5
		A=DAT1	A
		A=A+CON	A,5		Zn size
		R1=A	A		= slot size

		A=A+A	A		Slots:	1 for result R
		A=A+A	A			1 for multiplier P
		A=A+A	A			2 for *   2 for /	= 6
		LC(5)	400		Chicken
		C=C+A	A
		GOSBVL	=MAKE$N

* Count number of bits in the power

		A=DAT1	A		->Zp
		D0=A		
		GOSUBL	BitCount	A[A] = #bits
		C=A	A

* Initialize variable pointers

*	00	#bit	(loop index)
*	+5	#bits	(loop stop value)
*	+5	->R	(result)
*	+5	->P	(multiplier)
*	+5	->MUL	(temporary product)
*	+5	->DIV	(temporary division)

		GOSUB	D0->BIT
		A=0	A		Start from zero
		DAT0=A	A
		D0=D0+	5
		DAT0=C	A		End at #bits
		D0=D0+	5
		A=R1	A
		B=A	A		slot size
		A=R0	A		->$work
		A=A+CON	A,10
		DAT0=A	A		->R
		AD0EX
		LCZ1			Init R = 1
		DAT0=C	12
		AD0EX
		D0=D0+	5
		A=A+B	A
		DAT0=A	A		->P
		D0=D0+	5
		A=A+B	A
		DAT0=A	A		->MUL
		D0=D0+	5
		A=A+B	A
		A=A+B	A
		DAT0=A	A		->DIV

* Init P to be Zb

		GOSBVL	=D1=DSKTOP
		D1=D1+	10
		C=DAT1	A		->Zb
		GOSUB	D0->P
		D0=C			->Zb
		D1=A			->P
		GOSUB	CopyZ

* The main loop

MODPOWLOOP	GOSUB	D0->BIT
		A=DAT0	A		#bit
		GOSBVL	=D1=DSKTOP
		C=DAT1	A		->Zp
		GOSUBL	BitTest		CS if bit is set
		GONC	MODPOWNEXT

		GOSUB	D0->MUL		R = R*P mod N
		R3=A	A		->output
		GOSUB	D0->P
		D1=A
		GOSUB	D0->R
		GOSUBL	MULZZentry
		GOSUB	MODZn

		GOSUB	D0->R		Target = ->R
		D1=A
		GOSUB	CopyRem		Copy remainder to ->R

MODPOWNEXT	GOSUB	D0->BIT
		A=DAT0	A		#bit
		A=A+1	A		#bit++
		DAT0=A	A
		D0=D0+	5
		C=DAT0	A		#bits
		?A=C	A
		GOYES	MODPOWFINISH

		GOSUB	D0->MUL		P = P^2 mod N
		R3=A			->output
		GOSUB	D0->P
		D1=A
		GOSUBL	MULZZentry
		GOSUB	MODZn

		GOSUB	D0->P		Target = ->P
		D1=A
		GOSUB	CopyRem		Copy remainder to ->P

		GOTO	MODPOWLOOP

MODPOWFINISH	GOSUB	D0->R		->result
		D0=A
		A=A-CON	A,10
		R0=A			->$work
		GOSBVL	=SKIPOB		->result tail
		GOSBVL	=Shrink$	remove extra work memory
		GOSBVL	=GETPTR
		D1=D1+	10		Drop Zn and Zp
		D=D+1	A
		D=D+1	A

		A=R0	A		->$work
		A=A+CON	A,10		->result
		GOVLNG	=OverWrALoop	Overwrite ->Zb with ->Zr
		
****************
MODZn		GOSUB	D0->DIV
		R0=A	A		->output
		GOSUB	D0->MUL
		GOSUB	D1->Zn
		GOLONG	toZQUO
****************
CopyRem		GOSUB	D0->DIV		->quotient
		D0=D0+	5
		C=DAT0	A		quotient size
		AD0EX
		A=A+C	A		->quotient tail
		AD0EX
		D0=D0+	6		->remainder
CopyZ		D0=D0+	5
		C=DAT0	A
		D0=D0-	5
		C=C+CON	A,5
		GOVLNG	=MOVEDOWN
****************
D1->Zn		GOSBVL	=D1=DSKTOP
		D1=D1+	5		->stack level 2
		C=DAT1	A
		D1=C			->Zn
		RTN
****************
D0->DIV		GOSUB	D0->BIT		+25 from #bit
		D0=D0+	5
		GONC	+

D0->MUL		GOSUB	D0->BIT		+20 from #bit
+		D0=D0+	10
		GONC	+

D0->R		GOSUB	D0->BIT		+10 from #bit
+		D0=D0+	10
		GONC	+

D0->P		GOSUB	D0->BIT		+15 from #bit
		D0=D0+	15
+		A=DAT0	A
		D0=A
		RTN

D0->BIT		D0=(5)	(=IRAM@)-4
		A=DAT0	A
		D0=A
		D0=(4)	#100		#70100 or #80100 (in IRAMBUFF)
		RTN

  ENDCODE

;
**********************************************************************


*	* Logarithmic loop
*	
*	  ROTSWAP				( Zn Zb Zp )
*	  HXS 2 10 SWAP				( Zn Zb R Zp )  
*	
*	  ZBits					( Zn Zb R Zp #bits )
*	
*	  ZERO_DO (DO)				( Zn Zb R Zp )
*		INDEX@ ZBit?			( Zn Zb R Zp set? )
*		IT
*		::				( Zn Zb R Zp )
*		  SWAP3PICK RMULText		( Zn Zb Zp R' )
*		  4PICK DIVext SWAPDROPSWAP	( Zn Zb R'' Zp )
*		;
*		ISTOP-INDEX #1<> IT		( Square Zb if more to go )
*		::
*		  ROTDUP RMULText			( Zn R Zp Zb' )
*		  4PICK DIVext SWAPDROP UNROT	( Zn Zb' R Zp )
*		;
*	  LOOP
*	
*	  DROP UNROT2DROP
*	;
************************************************************************  

***********************************************************************
NULLNAME GCDHEUext
::
( A B )
PPZ ROT PPZ ROT
( B A a b )
2DUP GCDext 5ROLL 5ROLL
( a b Zgcd B' A' )
LISTMAXext 
{ BlankDA1 "GCDHeu, depth" OVER DO>STR &$ DISPROW1 } User1IT
FOUR #< AND NOTcasedrop :: SWAP FALSE ;
( a b c B' A' bm )   
ROT LISTMAXext
( a b c A' bm B' am flag depth )   
FOUR #< AND NOTcasedrop :: SWAPDROP FALSE ;
( a b c A bm B am )
ROT ZMINext ZABSext
( c A B m )
HXS 2 20 RMULText HXS 2 20 RADDext		( a b c A B 2m+2 )
FIVE SWAP					( a b c A B k z )
BEGIN
	{	"try -" 3PICK UNCOERCE DO>STR &$
                ", z=" &$ OVER DO>STR &$ DISPROW2
		}
	User1IT
	?ATTNQUIT
	4PICKOVER
	( a b c A B k z A z )

LABEL horn#ext!
::	SWAP
**********************************************************************
* Desc:		Attempts to evaluate Pn at X1=Z using fast
*		register arithmetic.
* Stack:	( Z Pn --> Z Pn FALSE / Pn[Z] TRUE )
* Notes:	Fails if
*		- Pn is not sunivariate
*		- Z is polynomial after all
*		- Z size is too big for register
*		- Any overflow occurs during horner evaluation
**********************************************************************
NULLNAME PEvalFast?
CODE
		GOSBVL	=SAVPTR

		C=DAT1	A		->P
		D0=C
		GOSUBL	SUNIVAR?	CS if sunivariate
		GONC	phornfail	Not sunivariate - fail

		C=DAT1	A		->P
		D1=D1+	5
		A=DAT1	A		->Z
		D1=C			->P
		D0=A			->Z

		A=DAT0	A		Check Z is really Z
		LC(5)	=DOHSTR
		?A#C	A
		GOYES	phornfail
		D0=D0+	5		Check if Z seems small enough
		A=DAT0	A
		LC(5)	5+7+1		Allow 7 nibble mantissa
		?A<=C	A		(reasonable for quadratic)
		GOYES	+		Short enough - try PEval

phornfail	GOVLNG	=GPPushFLoop	Failed to eval - simply continue

+		D0=D0-	5		->Z
		GOSUBL	SHORTPOP	A[W] C[S] = X

		R0=A	W		|Z|
		R1=C	S		Zsign

		B=0	W		result mantissa
		D=0	S		result sign
		D1=D1+	5		->first coefficient

phornloop	GOSUBL	SHORTPOPD1	A[W] C[S] = Z	CS if zero
		GOC	phornnext	No need to add Z0 to result
		CBEX	W		B[S] = Zsign	C[W]=result
		GOSUBL	SHORT+		A[W] C[S] = result
		GOC	phornfail	Overflow - failure
		B=A	W
		D=C	S		Save result
phornnext	A=DAT1	A		We're done if last coefficient
		LC(5)	=SEMI		was just added
		?A=C	A
		GOYES	phorndone

		A=B	W		A[W] = result
		C=R1.F	S
		CDEX	S		D[S] = Zsign
		B=C	S		B[S] = result sign
		C=R0	W		C[W] = Z
		GOSUBL	SHORT*		A[W] C[S] = result'
		GOC	phornfail	Overflow - failure
		B=A	W
		D=C	S		Save result
		GOTO	phornloop

phorndone	A=B	W		A[W] = result
		C=D	S		C[S] = result sign
		GOSUBL	PushZ		Push the result
		A=DAT1	A
		D1=D1+	10		DROP2
		D=D+1	A
		D=D+1	A
		DAT1=A	A		Return result
		GOVLNG	=PushTLoop	And TRUE to indicate result
ENDCODE
	?SEMI
	FIVE NEXTCOMPOB NcaseTYPEERR
	( r, list, pos, resultat )
	LABEL horn2#ext!
	::	4UNROLL NEXTCOMPOB NOTcase2DROP
		5ROLL 5PICK CODE
	GOLONG	tormult
	ENDCODE
		CODE
	GOLONG	radd
	ENDCODE
		CODE
	LC(5)	5	( rdrop )
	B=B-C	A
	D=D+1	A
horn2	A=PC
	LC(5)	(horn2#ext!)-(*)
hornfin	A=A+C	A
	PC=(A)
	ENDCODE
		;
	; ( end horn#ext!) 


	( a b c A B k z Az )
	4PICK 3PICK
	( a b c A B k z Az B z )
	CODE
horn1	A=PC
	LC(5)	(horn#ext!)-(*)
	GOTO	hornfin
	ENDCODE
	( a b c A B k z Az Bz )
	::
	CODE
	GOLONG	gcd
	ENDCODE
	OVER

**************************************
NULLNAME PZadic
::
  ZERO ROT				( Z 0 A )
  BEGIN					( gi-1 .. g0 Z i Ai )
  	SWAP#1+SWAP			( gi-1 .. g0 Z i+1 Ai )
  	DUP 4PICK			( gi-1 .. g0 Z i+1 Ai Ai Z )
NULLNAME QMODSYMext
( Q, Z -> Q mod Z )
*:: SHALT ( test )
CODE
* teste si on peut effectuer des SHORTMOD
qmodsym		GOSUBL	toModPrepare	D0 = ->Q	R4[W] = Zn / ->Zn
		?ST=1	sSHORTMOD
		GOYES	QMODZ
		GOSBVL	=GETPTR
qmodlong	D1=D1+	5
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOHSTR
		?A#C	A
		GOYES	pzadic1
pzhstr		A=PC
		LC(5)	(pzhstr!)-(*)
pzadfin		A=A+C	A
		PC=(A)
pzadic1		LC(5)	=DOLIST
		?A#C	A
		GOYES	pzadic2
		A=PC
		LC(5)	(pzlist!)-(*)
		GOTO	pzadfin
pzadic2		A=PC
		LC(5)	(pzseco!)-(*)
		GOTO	pzadfin

* Allocate memory for the output polynomial

QMODZ		ST=1	sALG48
		GOSUBL	QSIZE		C[A] = obsize
		?ST=1	sALG48
		GOYES	+
		LA(5)	=SETSIZEERR
		PC=(A)
+		GOSBVL	=GETTEMP
		AD0EX
		R0=A	A		R0[A] = ->Q'
		GOSBVL	=D1=DSKTOP
		D1=D1+	5
		C=DAT1	A		C[A] = ->Q
		D0=C			->input
		D1=A			->output
		C=0	A
		R2=C.F	A		trim level mis a 0
		ST=0	sTRIM
-		R1=C.F	A		R1[A] = composite depth
PMODZLOOP	A=DAT0	A
		LC(5)	=DOHSTR
		?A=C	A
		GOYES	todozmodz
		LC(5)	=DOCOL
		?A#C	A
		GOYES	domodlstsemi
		GOTO	docmodz
todozmodz	GOTO	dozmodz
* rajouter un cas particulier pour les complexes car :: HXS ; est invalide
domodlstsemi	DAT1=A	A		Output DOLIST/SEMI/DOCOL
		D0=D0+	5
		D1=D1+	5
		LC(5)	=SEMI
		?A=C	A
		GOYES	domodsemi
domodlist	ST=1	sTRIM
		C=R2.F	A		trim complevel
		C=C+1	A
		R2=C.F	A
		C=R1.F	A
		C=C+1	A		depth++
		GONC	-

domodsemi	?ST=0	sTRIM
		GOYES	domodsemi+
		D1=D1-	10		erase DOLIST/DOCOL+SEMI
		C=R2.F	A
		C=C-1	A
		R2=C.F	A
		?C#0	A
		GOYES	domodsemi+
		ST=0	sTRIM
		LCZ0
		DAT1=C	11
		D1=D1+	11
domodsemi+	C=R1.F	A
		C=C-1	A		depth--
pmodztest	?C=0	A
		GOYES	pmodzend
		GOTO	-

pmodzend	CD1EX			C[A] = ->Qtail
		A=R0.F	A
pmodznot0	GOSUBL	ShrinkQ
		D1=D1+	5
		D=D+1	A
		GOVLNG	=OverWrALoop

dozmodz		C=R4	W		C[W] = Zn
		GOSUBL	toZMODSHORT
dozmodz1	?A#0	W
		GOYES	dozmznotrim
		?ST=1	sTRIM
		GOYES	dozmztrim
		
dozmznotrim	C=0	A		trim level = 0
		R2=C.F	A
		ST=0	sTRIM
		C=D	S		A[W]C[S] = Zinv
		GOSUBL	SHORTOUT
dozmztrim	C=R1.F	A
		GOTO	pmodztest

docmodz		DAT1=A	A		
		D0=D0+	5		write DOCOL
		D1=D1+	5
		C=0	S
		?ST=1	sTRIM
		GOYES	docmodz1
		C=C+1	S
docmodz1	R2=C.F	S		R2[S] flag pour trim en cours
		ST=1	sTRIM
		C=R4	W
		GOSUBL	toZMODSHORT
		?A#0	W
		GOYES	docmodz2
		D1=D1-	5		erase DOCOL
		GOTO	docmodz3
docmodz2	C=0	A		write im
		R2=C.F	A
		ST=0	sTRIM
		C=D	S
		GOSUBL	SHORTOUT
docmodz3	C=R4	W
		GOSUBL	toZMODSHORT
		D0=D0+	5		skip SEMI
		?ST=1	sTRIM
		GOYES	docmodz4	
		C=D	S		im!=0, write re
		GOSUBL	SHORTOUT
		LC(5)	=SEMI		write SEMI
		DAT1=C	A
		D1=D1+	5
		GOTO	dozmztrim	-> loop
docmodz4	C=R2.F	S		im=0, restaure sTRIM
		?C=0	S		C=0[S] si sTRIM etait a 1
		GOYES	docmodz5
		ST=0	sTRIM
docmodz5	GOTO	dozmodz1
ENDCODE					( gi-1 .. g0 Z i+1 Ai gi' )
*; ( end QMODSYM : test )
  	DUP 4PICK			( gi-1 .. g0 Z i+1 Ai gi gi i+1 )
	#4+ UNROLL			( gi gi-1 .. g0 Z i+1 Ai gi )
	RSUBext				( gi gi-1 .. g0 Z i+1 Ai-gi )
	3PICK ZQUOText			( gi gi-1 .. g0 Z i+1 Ai+1' )
	DUP HXS 1 0 EQUAL		( gi gi-1 .. g0 Z i+1 Ai+1 flag )
  UNTIL
  DROPSWAPDROP				( gi .. g0 i+1 )
( gi .. g0 i+1 )
	NULLNAME CKMkP
	::
	DUP#1= NOTcase {}N
	DROP DUPTYPELIST?
	case ONE{}N
	; ( end CKMkP )
( G )
; ( end PZadic )
************************************

	( a b c A B k z G )
	NOTLISTcase :: 3DROP 2RDROP TRUE ;	( return a, b, c, A, B, TRUE )

*	****************************************
	NULLNAME PPZ
	::
	( p -> p/pgcd, pgcd des scalaires de p )
	NOTLISTcase :: HXS 2 10 SWAP ;
	( liste )
	HXS 1 0
	OVERSWAP
	( liste, liste, pgcd )
	( obj, pgcd -> pgcd )
	CODE
* test si pgcd = #1 -> swapdrop
ppz	C=DAT1	A
	CD1EX
	A=DAT1	W
	CD1EX
	LCZ1
	P=	11
	?A#C	WP
	GOYES	ppznot1
ppzswdrp	P=	0
	LA(5)	=SWAPDROP
	PC=(A)
ppznot1	P=	0
	D1=D1+	5
	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	D1=D1-	5
	LC(5)	=DOLIST
	?A#C	A
	GOYES	ppzgcd
** obj est une liste, si elle est vide, 	-> swapdrop
*	P=	5
*	LC(5)	=SEMI
*	P=	9
*	?A=C	WP
*	GOYES	ppzswdrp
*	P=	0
	A=PC
	LC(5)	(ppzl!)-(*)
	A=A+C	A
	PC=(A)
* si obj n'est pas une liste -> gcd
ppzgcd	GOLONG	gcd
	ENDCODE
	( liste, pgcd )
	DUPUNROT
	CODE
	GOLONG	tolopd
	ENDCODE SWAP
	;  ( end PPZ )
*	***************************************

		( a b c A B k z G' g )
		DROP
		( a b c, A, B, k, z, G' )
		5PICK OVER DIVISIBLE?  
		NOTcase2DROP			( exit with a b c A B  )
		( a b c, A, B, k, z, G', A/G' )
		5PICK 3PICK DIVISIBLE? 
		NOTcase 3DROP			( exit with a b c A B )
		( a b c, A, B, k, z, G', A/G', B/G' )
		8UNROLL 8UNROLL
		( a b A/G', B/G', c, A, B, k, z, G' )
		6ROLL
	CODE
	GOLONG	tormult
	ENDCODE
		( a b A/G', B/G', A, B, k, z, c*G' )
		7UNROLL 4DROP 2RDROP TRUE
		( return a b c*G', A/G', B/G', TRUE )
		;
	SWAP#1-					( a b c A B z k-1 )
	DUP#0<>
   WHILE
	SWAP					( a b c A B k-1 z )
	HXS 6 240210 RMULText			( a b c A B k-1 z'=z*73794 )
	HXS 5 38960 ZQUOText			( a b c A B k-1 z''=z'/27011 )
   REPEAT
   2DROP FALSE				( a b c A B FALSE = failure )
;
******************************
LABEL ppzl!
* obj est une liste: on appelle gcd(carcomp(liste),pgcd) puis ppz avec cdrcomp
::
( liste, pgcd )
SWAPINCOMP
get1 SWAP
ZERO_DO	(DO)
	( o1, ..., on, pgcd )
	CODE
	GOLONG	ppz
	ENDCODE
	( o1, ..., on-1, pgcd )
	LOOP
;
*********************************
********************************
LABEL pzseco!
( a  z -> a mod z )
::
SWAP INCOMPDROP
( z, i, r )
3PICK
CODE
	GOLONG	pzhstr
ENDCODE
( z, i, r mod z )
SWAPROT
CODE
	GOLONG	pzhstr
ENDCODE
( r mod z, i mod z )
SWAP
CODE
	GOLONG	irxc
ENDCODE
;

LABEL pzhstr!
::
( a z -> a mod z )
SWAPOVER		( M A M )
ZMODext			( M R )
DUPROT OVER ZIsNeg?	( R R M sflag )
ITE RADDext RSUBext	( R -sign[R]*[M-|R|] )
ZMINext			( Z )
;

LABEL pzlist!
::
( l z -> l mod z )
SWAPINCOMP get1 SWAPDUP
ZERO_DO	(DO)
	( o1, ..., on, z, #n )
	get1
	( o2, ..., on, z, #n, o1 )
	3PICK
	CODE
		GOLONG	qmodlong
	ENDCODE
	( o2, ..., on, z, #n, o1 mod z )
	UNROT
	LOOP
( o1, ..., on, z, #n )
SWAPDROP
CODE
		GOLONG	newtrimmeta
ENDCODE
;
*****************************************************
NULLNAME REPLINText
LABEL replint!
::
OVER
( inf, sup, func, t^2, int, t^2 )
DUPTYPESYMB? NOTcase2drop :: ' x\.S_ALGEBRAIC FIVE SYMBN ;
( inf, sup, func, t^2, int, t^2 )
( ici il faudrait determiner la liste des idnt, eliminer )
( celles qui sont dans la fonction et demander a l'utilisateur )
( la nouvelle variable d'integration )
' TYPEIDNT? Find1stTrue
( inf, sup, func, t^2, int, [ t, true | false ] )
NcaseTYPEERR
ROTSWAP
( inf, sup, func, int, t^2, t )
OVER' ID  ' x= EvalNoCK SWAP 
( inf, sup, func, int, t^2, 't^2=Bidon', t )
ISOLext 
( inf, sup, func, int, t^2, t, sqrt[Bidon] )
' ID  2DUP
( inf, sup, func, int, t^2, t, sqrt[Bidon], Bidon, sqrt[Bidon], Bidon )
TEN ROLL MEVALext
( sup, func, int, t^2, t, sqrt[Bidon], Bidon, newinf )
8UNROLL 7ROLL MEVALext
( newinf, func, int, t^2, t, newsup )
5UNROLL DUP4UNROLL DERIVext
( newinf, newsup, func, t, int, d[t^2]/dt )
4ROLL x*ext UNROTDROP ' x\.S_ALGEBRAIC FIVE SYMBN
;
*********************************************************
NULLNAME x/ext
LABEL x/ext!
::
num#1=case DROP
2DUPSWAP symcomp INNERCOMP get1 symcomp INNERCOMP 
( symb1, symb2, meta1, meta2 )
get1 #+ ' x/ SWAP#1+ SYMBN
( symb1, symb2, symb1/symb2 )
DUP' x? EQUALPOSCOMP #0<> case :: 3DROP ?ext ;
UNROT
( symb, symb1, symb2 )
* si symb2=0 et symb1=0 undef, si symb2=0 et symb1<>0 -> infini
num#0=case ::	DROPSWAPDROP
		( symb1 )
		num#0=case :: DROP ?ext ;
		DROP INFINIext
		;
* symb2 non nul, si symb1=0 alors 0
SWAP
( symb, symb2, symb1 )
num#0=case UNROT2DROP
SWAPROT
( symb1, symb2, symb )
SPECIALext
( symb1, symb2, [ symb, #0 | #arg1, #arg2 ] )
DUP#0=csedrp UNROT2DROP
( symb1, symb2, #arg1, #arg2 )
* arg1 ou/et arg2 infini, aucun des deux n'est nul
* si arg1 et arg2 infinis -> undef
OVER FIVE #< OVER FIVE #< ANDcase :: 4DROP ?ext ;
( symb1, symb2, #arg1, #arg2 )
* un seul arg infini
OVER FOUR #>case :: 4DROP HXS 1 0 ;
* arg1 infini, arg2 fini non nul
ROTDROP
( symb1, #arg1, #arg2 )
3PICK LENCOMP #2<> case2DROP
( symb1, #arg1, #arg2 )
#5= caseDROP
( symb1, #arg1 )
SWAPDROP 
#1=case SYMBOL x\9F xNEG ;
SYMBOL x\9F xNEGNEG ;	
;
****************************************************
NULLNAME TESTINFINI
::
DUPTYPESYMB? NOTcase :: DUP' x\9F EQUAL NOTcaseFALSE symcomp TRUE ;
DUP' x\9F EQUALPOSCOMP #0<>
;
**************************************************
NULLNAME SERIESext
::
( expression, [X=a ou X], [entier] )
( l'entier qui indique l'ordre des developpements )
( son signe indique s'il s'agit d'une limite directionnelle )
( mettre un entier # pour une limite bidirectionnelle )
( on peut aussi ecrire X=a+0 ou X=a-0 qui a la priorite )
* lecture des arguments
positifflag SetUserFlag
complexflag ClrUserFlag
DEPTH DUP#0=case SETTYPEERR
#1= IT RCLVX
::	CK&DISPATCH1
	real	::	DUP %ABSCOERCE SWAP %0> ITE TWO ONE ;
	hxs	::	HXS># ZERO ;
	idnt	::	FOUR ZERO ;
	symb	::	FOUR ZERO ;
	;
CK4NOLASTWD
UNROT TWO #MAX TWENTY #MIN 
( expression, type de limite: 0=bi, 1=-, 2=+ ;  X=a, ordre )
SWAP
::	idntlamcase %0
	DUPTYPESYMB? NcaseSIZEERR
	EXPR> EQ: x= SWAP %2 EQUAL AND NcaseTYPEERR
	( expr, type, ordre, X, a )
	( changement de variable X=a+X si a non infini )
	::	DUPTYPESYMB? NOTcaseFALSE
		DUP CARCOMP ' x\9F EQUAL 
		NOTcase 
		::	DUP EXPR>
			( ..., type, ordre, X, a, o1, ..., on, %n, op )
			SWAP COERCE ROTOVER #2=
			( o1, ..., op, #n, on, #n=2? )
			NOTcasedrop :: NDROP FALSE ;
			%0 EQUAL NOTcase :: NDROP FALSE ;
			( ..., type, ordre, X, a, o1, op, #2 )
			DROPDUP EQ: x+ 
			( ..., type, ordre, X, a, o1, op, op=x+? )
			casedrop :: SWAPDROP 4ROLLDROP TWO 4UNROLL FALSE ;
			EQ: x-
			( ..., type, ordre, X, a, o1, op=x-? )
			NOTcase DROPFALSE
			SWAPDROP 4ROLLDROP ONE 4UNROLL FALSE
			;
		( expression, type de limite, ordre, X, a )
		4ROLLDROP 4ROLL 
		( ordre, X, a, expression )
		3PICK %1 OVER NDXFext MEVALext
		( ordre, X, a, expression )
		4UNROLL  
		( expression, ordre, X, a  )
		DUPLENCOMP #2<>
		ITE	ZERO ( infini ou -+ infini )
			:: DUPTWO NTHCOMPDROP EQ: xNEG ITE ONE TWO ;
		4UNROLL TRUE
		( expr, type, ordre, X, a )
		;
	( expression, type de limite, ordre, X, a, flag )
	?SEMI
	num0=case NOP
	2DUP OVER x+ext 
	( expression, type limite, ordre, X, a, X, a+X )
	7ROLL UNROT MEVALext
	( type de limite, ordre, X, a, expression )
	5UNROLL
	;
( expression, type, ordre, X, a )
5UNROLL STOVX
( a, expression, ordre, type )
ZERO
{ LAM LIMTYPE LAM LIMORDRE LAM LIMOK } BIND
( a, symb )
VXLVARext DUP SLVARext MEVALext
NULL$ ' ID ERABLEMSG STO
{	
	xTAN xXROOT 
	xSINH xCOSH xTANH xASINH xACOSH xATANH xACOS 
	}
{	
	::	DUP xSINext SWAP xCOSext NDXFext ;
	XROOT2ext 
	SINH2EXPext COSH2EXPext TANH2EXPext ASINH2LNext 
	ACOSH2LNext ATANH2LNext 
	:: SYMBOL x\pi %2 x/ ; SWAP xASINext x-ext ;
	}
MEVALext
{ x^ }
{ ::	POW2EXPLNext TSIMP2ext ; }
MEVALext

LABEL limit!
* symb -> 
* DL-l, reste-l, num-l/deno-l, equiv.-l, lim., lvar, flag
* lim. = { symf direction }
::
{ xINV }
{ :: ( xINV ) %1 SWAP' x/ EvalNoCK ;  }
MEVALext

RCLVX EQUALcasedro 
::	HXS 1 0 HXS 2 10 2DUPSWAP TWO{}N DUP4UNROLL
	%0 LAM LIMTYPE DUP#0= ITE_DROP :: #1= ITE "-" "+" >TAG ;
	RCLVX ONE{}N TRUE 
	;
( 1ere etape: LVARXNX et appel recursif )
CODE
lvarxnx2	A=PC
		LC(5)	(lvarxnx2!)-(*)
limbr10		A=A+C	A
		PC=(A)
ENDCODE
( symb, lvarnx, lvarx )
DUPNULL{}?
case2drop 
::	( obj )
	DUP HXS 1 0 HXS 2 10 ROTDUP NULL{} TRUE
	;
( lvarx ->  lvarx, liste de DL, reste )
DUPINCOMP DUP #1-SWAP
ZERO_DO	(DO)
	( ..., var1, ..., varn, #n-1 )
	get1
	::	idntlamcase :: %0 TWO{}N SWAP ;
		( -> var1 est un symbolique )
		DUP INNERDUP 3PICK EQ: xINV
		( var1, o1, ..., on-1, op, #n, #n, ?op=inv )
		ITE	:: ROTSWAP #1+UNROLL SWAPDROP #2- ;
			:: ROTSWAP #1+UNROLL #1- ;
		SYMBNext
		CODE
limit		A=PC
		LC(5)	(limit!)-(*)
		GOTO	limbr10
		ENDCODE
* symb, lvarnx, var2, ..., varn, #n-1, var1, op, DL-l, rest-l, num-l/deno-l, equiv.-l, lim., lvar, ok?
		NOTcase2drop 
		::	ExitAtLOOP 5DROP SWAP  
			;
		7ROLL
* test du type d'operateur: 
* DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar, op -> DL/equiv, reste relatif, ok?
		CODE
		GOLONG	limop
		ENDCODE
* symb, lvarnx, var2, ..., varn, #n-1, var1, DL1, reste relatif, ok?
		?SKIP ExitAtLOOP
		TWO{}N SWAPDROPSWAP
* ..., var2, ..., varn, { DL1 reste1 }, #n-1
		;
	LOOP
( symb, lvarnx, lvarx, DL1, ..., DLn, #n-1 )
LAM LIMOK 
#0<> case ::	NDROP 3DROP %0 %1 ?ext DUP NULL{} FALSE 
		( symb, 0, 0, 0, 0, #0, false  )
		( DL-l, reste-l, num-l/deno-l, equiv.-l, lim., lvar, flag )
		;
( symb, lvarnx, lvarx, DL1, ..., DLn, #n-1 )
#1+ {}N
( symb, lvarnx, lvarx, lDLeqre )
3PICK 
' :: %0 TWO{}N ; 1LAMBIND LISTSECOext ABND
&COMP 4UNROLL
( lDLeqre_nx, symb, lvarnx, lvarx )
SWAP &COMP 
( lDLeqre_nx, symb, lvarxnx )
ROT TSIMP2ext
( symb, lvarxnx, lDLeqre_nx )
CODE
	GOLONG lvarxnx2
ENDCODE
( symb, lvar_orig, lDLeqre_nx, lDLvarnx, lDLvarx )
* reordonner lvarx
CODE
	A=PC
	LC(5)	(sort!)-(*)
	GOTO	limbr10
ENDCODE
( symb, lvar_orig, lDLeqre_nx, lDLvarnx, lDLvarx )
DUPLENCOMP 1LAMBIND SWAP &COMP 
( symb, lvar_orig, lDLeqre_nx, lDLvarxnx )
VXXLext
( symb, lvar_orig, lvar, lDL-liste )
* calcul des equivalents des DL: { DL reste } -> { DL reste DL/equiv equiv }
INNERDUP #1-SWAP
ZERO_DO 
	get1
	INNERCOMP #2= NcaseSIZEERR
	OVER 
	( DL, reste, DL )
	1GETLAM
	CODE
limequfr	A=PC
		LC(5)	(limequfr!)-(*)
		A=A+C	A
		PC=(A)
	ENDCODE
	( DL, reste, DL/equiv, equiv, { % % % } )
	DROP FOUR {}N
	SWAPLOOP
#1+ {}N
( symb, lvar_orig, lvar, lDL-liste )
1GETABND 4UNROLL
* sorte de VXXL su symb: mais on remplace les variables de symb en fonction
* de leur position dans lvar_orig par le DL-liste de la variable en fonction
* de lvar
4NULLLAM{} BIND
( symb : lam1= lDL-liste, lam2= lvar, lam3=lvar_orig, lam4= # )

LABEL limstep1!
::
* symb ->  
* { DL-l, reste-l, num-l/deno-l, equiv.-l }, flag
3GETLAM OVER EQUALPOSCOMP
DUP#0=
NOTcase 
:: 	( symb, # )
	1GETLAM ROTDROPSWAP NTHCOMPDROP TRUE
	;
DROP DUPTYPESYMB? 
( obj, ?symb )
ITE :: DUPLENCOMP #1= ; TRUE
case 
::	( % )
	VXXL1ext HXS 1 0 HXS 2 10 3PICK FOUR {}N
	real_intflag TestUserFlag caseTRUE
	SIXTEEN ' LAM LIMOK STO FALSE
	;	
DUP EXPR>
( symb, o1, ..., on, %n, op )
SWAP COERCE DUPUNROT #2+UNROLL
( symb, op, o1, ..., on, #n )
* preparation des arguments
DUP#1- TRUE ROT
ZERO_DO (DO)
	( symb, #op, o1, ..., on, #n-1, flag )
	::	DUP NOTcase ExitAtLOOP
		DROP get1
		CODE
limstep1	A=PC
		LC(5)	(limstep1!)-(*)
limstepbr	A=A+C	A
		PC=(A)
		ENDCODE
		( symb, #op, o2, ..., on, #n-1, DL1, flag )
		ROTSWAP
		( symb, #op, o2, ..., on, DL1, #n-1, flag )
		;
	LOOP
( symb, #op, o2, ..., on, DL1, #n-1, flag )
NOTcase ::	#2+ NDROP FALSE 
		( symb, flag )
		;
#1+ get1
( symb, DL1, ..., DLn, #n, op )
CODE
	A=DAT1	A
	LC(5)	=x+
	?A#C	A
	GOYES	limst1
	A=PC
	LC(5)	(lim+!)-(*)
limst0	A=A+C	A
	PC=(A)
limst1	LC(5)	=x*
	?A#C	A
	GOYES	limst2
	A=PC
	LC(5)	(lim*!)-(*)
	GOTO	limst0
limst2	LC(5)	=x/
	?A#C	A
	GOYES	limst3
	A=PC
	LC(5)	(lim/!)-(*)
	GOTO	limst0
limst3	LC(5)	=x-
	?A#C	A
	GOYES	limst4
	A=PC
	LC(5)	(lim-!)-(*)
	GOTO	limst0
limst4	LC(5)	=x^
	?A#C	A
	GOYES	limst5
	A=PC
	LC(5)	(limpow!)-(*)
	GOTO	limst0
limst5	LC(5)	=xNEG
	?A#C	A
	GOYES	limst6
	A=PC
	LC(5)	(limNEG!)-(*)
	GOTO	limst0
limst6	LC(5)	=xSQ
	?A#C	A
	GOYES	limst7
	A=PC
	LC(5)	(limSQ!)-(*)
	GOTO	limst0
limst7	LC(5)	=xINV
	?A#C	A
	GOYES	limst8
	A=PC
	LC(5)	(limINV!)-(*)
	GOTO	limst0
limst8	A=PC
	LC(5)	(liminvop!)-(*)
	GOTO	limst0
ENDCODE
( symb, DL, true ou symb, ?, false )
DUP ITE ROTDROP SWAPDROP
; ( end limstep1! )

( symb, false ou DL, true )
NOTcase :: %0 %1 3PICK LAM LIMOK 2GETLAM ABND FALSE ;
INCOMPDROP
( DL-l, reste-l, num-l/deno-l, equiv-l )
4GETLAM 2GETLAM 3PICK
CODE
limlim		A=PC
		LC(5)	(limlim!)-(*)
		GOTO	limstepbr
ENDCODE
( DL-l, reste-l, num-/deno-l, equiv-l, equiv-l, lvar, lim )
ABND
SWAPTRUE
* DL-l, reste-l, num-l/deno-l, equiv.-l, lim., lvar, flag
; ( end limit! )

( a, DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar, flag )
?SKIP ::	"Error " LAM LIMOK UNCOERCE DO>STR &$
		DUP' ID ERABLEMSG STO
		FlashWarning
		;
ABND
( a, DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar )
TRUE TSIMP3ext
SWAP 6UNROLL 
( a, lim, DL-l, reste-l, num-l/deno-l, equiv-l, lvar )
* reecriture de num-l/deno-l en divisant chaque es de la liste num par deno-l
ROT FXNDext DUPTYPELIST? IT CARCOMP RESOROMP RDIVext LOP1ext
DUPTYPELIST? ?SKIP ONE{}N UNROT
( a, lim, DL-l, reste-l, num-l/deno-l, equiv-l, lvar )
internalflag ClrUserFlag
TRUE ?SEMI

************************************
* FIN DU PROGRAMME PRINCIPAL
************************************

***********************
* routines de limstep1!
***********************
LABEL limlim!
::
* #, lvar, equiv-l -> lvar, lim
CODE
varcomp3	A=PC
		LC(5)	(varcomp3!)-(*)
varbr		A=A+C	A
		PC=(A)
ENDCODE
FOUR #/ 
( #, lvar, lim-l, #reste, #quotient )
5UNROLL
DUP#0=
ITE_DROP ::	{ %0 SYMBOL x\9F ; SYMBOL x? ; }
		ROTDROPSWAP NTHCOMPDROP
		; 
( #quotient, #, lvar, lim-l )
ROT DUP#0= ITE_DROP :: ZERO_DO (DO) ONE{}N LOOP ;
( #quotient, lvar, lim-l )
OVER
CODE
limvalobj	A=PC
		LC(5)	(limvalobj!)-(*)
		GOTO	varbr
ENDCODE
( #quotient, lvar, lim )
::	( #quotient, lvar, lim )
	num0=case 
	::	ROTDUP #2= caseDROP
		( lvar, lim, # )
		#0=ITE "+" "-" >TAG
		;
	ROT SYMBOL x\9F ; 3PICK EQUALNOTcase DROP
	( lvar, lim, # )
	TWO EQUALcasedro NOP
	' xNEGNEG ' xNEG 
	ROT #0=ITE DROP SWAPDROP >TCOMP
	;
( lvar, lim )
; ( end limlim! )




LABEL limcmpl!
( reste-1-l, reste-2-l -> reste-l )
::	
2DUP EQUALcase DROP
num0case DROP
SWAP num0case DROP
SWAP2DUP RDIVext
( reste-1, reste-2, o-l )
4GETLAM 2GETLAM ROT
CODE
	GOLONG	varcomp3
ENDCODE
4UNROLL3DROP
( #, n/d, e, lvar, num-l/deno-l1, equiv-l1, reste-1, reste-2, # )
* #= 0 pour borne, 1 pour 0, 2 pour infini
FOUR #/ DROP #2= ITE_DROP SWAPDROP
; ( end limcmpl! )


LABEL limequfr!
( n/d, # -> n/d-l, equiv, % )
::
DUP#0=csedrp ::	HXS 2 10 SWAP %0 ;
SWAP FXNDext 3PICK
( n, d )
CODE
limequ	A=PC
	LC(5)	(limequ!)-(*)
	A=A+C	A
	PC=(A)
ENDCODE
( #, n, deno-l trimmed, deno-equiv-l, { # # # } )
4ROLL 5ROLL
CODE
	GOTO	limequ
ENDCODE
( deno-l, deno-equiv-l, deno-#, num-l, num-equiv-l, num-# )
4ROLL
( num-{ # # # }, deno-{ # # # } -> { % % % } )
SWAPINCOMP get1 INNERCOMP get1
( n1, ..., nk, d1, .., dk, #k, #k )
ZERO_DO (DO)
	get1 UNCOERCE ROT UNCOERCE %- OVER #1+UNROLL
	LOOP
{}N
( deno-l, deno-equiv-l, num-l, num-equiv-l, % )
SWAP4ROLL RDIVext
( deno-l, num-l, %, equiv )
ROT 4ROLL RDIVext
( %, equiv, n/d )
SWAPROT
( n/d, equiv, % )
; ( end limequfr! )

LABEL limequ!
* liste, # ->  liste / liste-equiv-l, liste-equiv-l, { # # # } )
::	
OVER
NOTLISTcase 
::	DROP HXS 2 10 UNROT 
	( 1, equiv, # )
	OVER HXS 1 0 EQUAL ITE MINUSONE ZERO
	SWAP NDUPN {}N 
	;
( liste, #, liste )
NULL{} SWAPROT
ZERO_DO 
	( liste, { # # # }, equiv-l )
	CODE
	GOLONG	limval
	ENDCODE
	( liste, { # # # }, equiv-l, # )
	ROTSWAP >TCOMP
	SWAPLOOP
( liste, { # # # }, equiv-l' )
OVER LENCOMP ZERO_DO (DO) ONE{}N LOOP
OVER INNERCOMP
HXS 2 10 SWAP
ZERO_DO	(DO)
	HXS 1 0 ROT NDUPN #1+ {}N
	LOOP
RMULText
( liste, { # # # }, equiv-l )
ROTOVER RDIVext
( { # # # }, equiv-l, liste/liste-equiv-l )
UNROTSWAP
; ( end limequ! )

*******************************
* operateurs rationnels
*****************************
* DL1, ..., DLn, #n, op -> DL, flag 
* DL = { DL-l reste-l num-l/deno-l equiv-l }
LABEL lim+!
LABEL lim-!
::
SWAPDROP
( DL1, DL2, op )
UNROTSWAP
INCOMPDROP SWAPDROP RMULText 
( op {DL2} DL1 reste_absolu1 )
ROT INCOMPDROP SWAPDROP RMULText
( op DL1 r1 DL2 r2 )
ROT
CODE
	GOLONG	limcmpl
ENDCODE
( op DL1 DL2 r )
4UNROLLROT EQ: x+ ITE RADDext RSUBext
( r DL )
* si DL=0, alors Insufficient order error
num#0=case 
::	SWAPDROPDUP HXS 2 10 OVER FOUR {}N 
	TEN ' LAM LIMOK STO
	FALSE
	;
( r DL )
DUP 4GETLAM
CODE
	GOLONG	limequfr
ENDCODE
( r_absolu DL nd e { # } )
DROP 4ROLLOVER RDIVext
( DL nd e r_relatif )
UNROT FOUR {}N TRUE
; ( end lim+/- )

LABEL limNEG!
::
2DROP INCOMPDROP 
( DL r nd e )
RNEGext 4ROLL RNEGext 4UNROLL
( -DL r nd -e )
FOUR {}N TRUE
; ( end limneg! )

LABEL limpow!
::
2DROP
INCOMPDROP 4UNROLL TRIMOBJext HXS 2 10 EQUAL 
( o1, equiv2, DL2, r2, ?n2=1 )
NOTcasedrop 2DROPFALSE
TRIMOBJext HXS 1 0 EQUAL
( o1, equiv2, DL2, ?r2=0 )
NOTcase 2DROPFALSE
DROP TRIMOBJext DUPTYPEHSTR? NOTcase DROPFALSE
( o1, puissance entiere )
Z2Rext SWAPOVER %0<
ITE ::	ONE ' xINV 
	LABEL limINV!
	::
	2DROP { HXS 2 10 HXS 1 0 HXS 2 10 HXS 2 10 } SWAP TWO ' x/
		LABEL lim/!
		::	
		2DROP INCOMPDROP 5ROLL INCOMPDROP
		( DL2 r2 nd2 e2 DL1 r1 nd1 e1 )
		5ROLL RDIVext 
		( DL2 r2 nd2 DL1 r1 nd1 e )
		ROT 6ROLL
		CODE
		GOTO	limcmpl
		ENDCODE
		( DL2 nd2 DL1 nd1 e r )
		4ROLLDROP 5ROLL DROP
		( nd2 nd1 e r )
		ROT 4ROLL
		( e r nd1 nd2 )
		4GETLAM
		LABEL divpc!
		::
		( reste, nd1, nd2, # )
* division en puissance croissantes: reste, n, d, # -> reste, n, d, flag
		UNROT RDIVext FXNDext 
		ROTOVER TYPELIST? NOTcasedrop TRUE
		( reste-l,  num-l, deno-l, # )
* determine la profondeur courante et l'ordre pour le prochain DL
			LABEL limprof!
			::
			ROT 
			num0case :: UNROTDROP ZERO LAM LIMORDRE TRUE ;
			( reste, deno, #, num )
			UNROT 4PICK SWAP
			( reste, num, deno, reste, # )
		CODE
		GOLONG	limequfr
		ENDCODE
			UNROT2DROP
			( reste-l, num-l, deno-l, { % % % } )
			ZEROSWAP
			BEGIN
				( num-l, deno-l, #prof, { %%% } )
				DUP CARCOMP %0=
			WHILE
				CDRCOMP SWAP#1+SWAP 
				( num-l, deno-l, #prof, { %%% } )
				4ROLL 
				DUPTYPELIST? IT :: DUPLENCOMP NTHCOMPDROP ; 
				4ROLL
				DUPTYPELIST? IT :: DUPLENCOMP NTHCOMPDROP ; 
				2SWAP
			REPEAT
			( reste-l, num-l, deno-l, #prof, { %%% } )
			CARCOMP DUP %0> NOTcaseFALSE COERCE
			( reste-l, num-l, deno-l, #prof, #ordre )
			LAM LIMORDRE 2DUP #1+ #<
			( r-l, num-l, den-l, #prof, #ordre, #limor, flag )
			casedrop TRUE
			( reste-l, num-l, deno-l, #prof, #ordre, #limor )
			DUPUNROT 
			#>case 
			::	( reste-l, num-l, deno-l, #prof, #limor )
				5ROLL DROP 
				HXS 2 10 HXS 1 0 3PICK #1+ NDUPN #1+ {}N 
				5UNROLL TRUE
				;
			5ROLL
			( num-l, deno-l, #prof, #limordre, reste-l )
			FXNDext SWAPDROP
			( num-l, deno-l, #prof, #limordre, deno-l )
			HXS 2 10 SWAP NDXFext 
			HXS 1 0 3PICK #1+ NDUPN #1+ {}N
			5UNROLL TRUE
			; ( end limprof! )
		( reste-l, num-l, deno-l, #prof, #ordre, flag )
		NOTcase2drop FALSE
		2SWAP
		( reste-l, #prof, #ordre, num-l, deno-l )
		NULLNAME DIVPCext
*		LABEL divpc1!
		::
			( #ordre, num-l, deno-l -> num-l, deno-l )
			DUPTYPELIST? ITE INNERCOMP ONE reversym {}N 3PICK RRDMext
			( reste-l, #prof, #ordre, num-l, deno-l )
			SWAP DUPTYPELIST? ITE INNERCOMP ONE reversym {}N 
			3PICK #2* RRDMext
			SWAP DIVext DROP INNERCOMP reversym TRIM{}Next
			( reste-l, #prof, #ordre, quotient-l )
			DUP DENOLCMext DUPROT LOPMext TRIMOBJext
			( reste-l, #prof, #ordre, denolcm, quotient-l*denolcm )
			ROTDROPSWAP ONE{}Next
			;
		( reste-l, #prof, num-l, deno-l )
		ROT
		( reste-l, num-l, deno-l, #prof )
		LABEL limprofend!
		( num, deno, #prof -> num, deno )
		::
			DUP#0=csDROP
			ZERO_DO (DO)
				SWAP ONE{}N SWAP ONE{}N
				LOOP
			;
		TRUE
		; ( end divpc! )
		( e r n d flag )
		NOTcasedrop FalseFalse
		RDIVext
		( e r nd )
		ROT2DUP RMULText
		( r nd e DL )
		4UNROLL FOUR {}N TRUE
		( DL r nd e true )
		; ( end lim/! )
	; ( end limINV )
	;
	TRUE
( puissance, DL, flag )
NOTcasedrop FALSE
INCOMPDROP
( %, DL, r, nd, e )
4ROLL 5PICK RPext
( %, r, nd, e, DL )
2SWAP
( %, e, DL, r, nd )
5PICK RPext 4ROLL 5ROLL RPext
( DL r nd e )
FOUR {}N TRUE
; ( end limpower )

LABEL limSQ!
::	
2DROP DUPTWO 'x*
	LABEL lim*!
	::	
	2DROP INCOMPDROP 5ROLL INCOMPDROP
	( DL2 r2 nd2 e2 DL1 r1 nd1 e1 )
	5ROLL RMULText 7UNROLL
	( e DL2 r2 nd2 DL1 r1 nd1 )
	4ROLL RMULText 6UNROLL
	( nd e DL2 r2 DL1 r1 )
	ROT
	CODE
limcmpl	A=PC
	LC(5)	(limcmpl!)-(*)
	A=A+C	A
	PC=(A)
	ENDCODE
	5UNROLL
	( r nd e DL2 DL1 )
	RMULText 4UNROLL FOUR {}N TRUE
	( DL r nd e true )
	;
; ( end limsq! )



************************************
* operateurs ln, exp, sin, cos, etc.
************************************
* reste , DL-l, num-l/deno-l, equiv, lim, lvar, operateur -> DL, reste, flag
* pour les operateurs courants ln, exp, ... ( attention le reste est relatif )

* Note pour les DL non asymptotiques
* si x_0 = 0, f(x(1+r))= [\sigma _{k=k_0} ^{k_0+n} f[k](0) x^k ](1+r)
* ou n est tel que x^n =O(r) [ si r=0, on prend n=LIMORDRE er r=x^n ]
* si x_0 est non nul et f(x_0) non nul, r reste constant avec le choix
* de n ci-dessus
* si f(x_0) est nul, il faut changer r en r/e ou e est l'equivalent de x
* et on se ramene au 1er cas avec f[k](x_0) au lieu de f[k](0)
* en pratique, on a les cas particuliers suivants:
* ln: x_0=1, k_0=1
* sin: x_0 = n \pi (n \neq 0), k_0=1 (diviser r par e)
* sin: x_0 = 0, k_0=1 
* cos: x_0 = (n+1/2)*pi, k_0=1 (diviser r par e)
* atan: x_0 = 0, k_0=1
* Pour les DL asymptotiques

LABEL liminvln!
::
* operateur INV[LN]
LABEL limln!
* operateur LN
::
DROPSWAP
( DL-l, reste-l, num-l/deno-l, equiv-l, lvar, lim )
6ROLL DROP
* tester si la limite est negative -> erreur
( reste-l, num-l/deno-l, equiv-l, lvar, lim )
POSITIFext SWAPDROP
( reste-l, num-l/deno-l, equiv-l, lvar, flag )
NOTcase :: NINE ' LAM LIMOK STO 4DROP ?ext %0 FALSE ;
( reste-l, num-l/deno-l, equiv-l, lvar )
ROT HXS 2 10 RSUBext
( reste-l, equiv-l, lvar, num-l/deno-l )
4ROLLSWAP 
( equiv-l, lvar, reste-l,  num-l/deno-l )

LABEL lprof!
::
* lvar, reste-l, num-l/deno-l -> 
* #varx, #prof, #ordre, lvar, new reste-l, num-l/deno-l 
	FXNDext
	( lvar, reste-l,  num-l, deno-l )
* detecte la 1ere var ne contenant pas x
	4PICK DUP
	LABEL lim#varx!
	::	( lvar, lvar -> #varx )
		RCLVX 
		' ::	OVER TYPESYMB? NOTcase EQUALNOT
			EQUALPOSCOMP #0=
			;
		POSCOMP
		DUP#0=csedrp LENCOMP
		SWAPDROP #1-
		; ( end lim#varx! )
	( lvar, reste-l,  num-l, deno-l, #varx )
	DUP 6UNROLL
	CODE
limprof		A=PC
		LC(5)	(limprof!)-(*)
		A=A+C	A
		PC=(A)
	ENDCODE
	( #varx, lvar, reste-l, num-l, deno-l, #prof, #ordre, flag )
	?SKIP :: EIGHT ' LAM LIMOK STO ;
	6UNROLL 6UNROLL NDXFext
	( #varx, #prof, #ordre, lvar, new reste-l, num-l/deno-l )
	; ( end lprof! )

( equiv-l, #varx, #prof, #ordre, lvar, new reste-l, num-l/deno-l )
LAM LIMOK #0<> 
case ::	7DROP ?ext %0 FALSE 
	( ln, reste, ok? )
	;
( equiv-l, #varx, #prof, #ordre, lvar, new reste-l, num-l/deno-l )
SWAP3PICK
CODE
	GOLONG	limvalobj
ENDCODE
UNROT
( equiv-l, #varx, #prof, #ordre, new reste, lvar, num-l/deno-l )
7ROLL
* a faire: si equiv-l=1 alors chercher la valuation de num-l/deno-l 
* pour augmenter limordre
UNROT
( #varx, #prof, #ordre, reste relatif, equiv-l, lvar, num-l/deno-l )

* developpement de Taylor du ln applique a X 
( X -> X-X^2/2... )
5ROLL DUP1LAMBIND
LABEL hornln!
::	
HXS 1 0 HXS 2 1F ROT
#1+_ONE_DO	
	( c0, ..., ck, +- 1 )
	RNEGext DUPINDEX@ ZUNCOERCE NDXFext
	SWAPLOOP
DROP
;
( X, c0, ..., cn )
1GETABND
LABEL limhorn!
::	
	( X, c0, ..., cn, #n )
	DUP#0=csedrp SWAPDROP
	#1+
	( X, c0, ..., cn, #n+1 )
	DUP#1+ NDUP METADENOLCM
	( a0, ..., an, #n+1, lcm )
	ROTOVER RMULText
	( a0, ..., an-1, #n+1, lcm, an*lcm )
	ROT#1+ get1 SWAP#1-
	( a0, ..., an-1, lcm, res, X, #n+1 )
	ONE_DO	
		( a0, ..., an-1, lcm, res, X )
		DUPUNROT RMULText 
		( a0, ..., an-1, lcm, X, res*X )
		FXNDext SWAP ISTOP@ #1-
		LABEL lrdm!
		::	
		OVER TYPELIST? NOTcaseDROP
		#1+ OVER LENCOMP 2DUP#< 
		( liste, entier+1, longueur de liste , ?entier+1<longueur de liste)
		NOTcase2DROP
		( si liste trop longue: on supprime a gauche )
		DUPROT #-+1 SWAP SUBCOMP TRIMOBJext
		; ( end lrdm! )
		SWAP RDIVext
		( a0, ..., an-1, lcm, X, res*X )
		4ROLL 4PICK RMULText RADDext
		( a0, ..., an-2, lcm, X, res*X )
		SWAPLOOP
	( lcm, res, X )
	DROPSWAP RDIVext
	;
( #varx, #prof, reste, equiv-l, lvar, l-ln[1+X] )
* ajustement de la profondeur
FXNDext 6ROLL
CODE
limprofend	A=PC
		LC(5)	(limprofend!)-(*)
		A=A+C	A
		PC=(A)
ENDCODE
NDXFext
* fin du dvpt de Taylor
( #varx, reste, equiv-l, lvar, l-ln[1+X] )
ROT ZEROSWAP 4PICK
( #varx, reste, lvar, l-ln[1+X], equiv-l, lvar )
VAL2ext
( #varx, reste, lvar, l-ln[1+X], equiv )
LABEL lnobj!
::
( obj -> ln[obj], taille: taille est aussi equiv[ln(equiv]] si obj = equiv )
CODE
simp1	A=PC
	LC(5)	(simp1!)-(*)
	A=A+C	A
	PC=(A)
ENDCODE
' ::	( LAM4 op=x*)
	( symb, o1,..., on-1, #n )
	#1- pZpargSWAPUn
	( symb, meta1, meta2 )
	SYMBNext
	OVER#2+UNROL SYMBNext
	( symb, symb1, symb2 )
	ROTDROP 
	( symb1, symb2 )
	DUPTYPEREAL? IT :: DUP %0< NOT?SEMI RNEGext SWAP RNEGext ; 
	2GETEVAL
	( symb1, log2, taille2 )
	ROT 2GETEVAL
	( log2, taille2, log1, taille1 )
	4ROLLROT x+ext
	( taille2, taille1, log )
	UNROT
	CODE
limmax	A=PC
	LC(5)	(limmax!)-(*)
	A=A+C	A
	PC=(A)
	ENDCODE
	;
' ::	( LAM3: op=x^ )
	( symb, o1,..., on-1, #n )
	#1- pZpargSWAPUn
	( meta, meta-exposant)
	#1= NcaseSIZEERR
	( meta, exposant )
	OVER#2+UNROL SYMBNext
	ROTDROP 2GETEVAL
	( exposant, log, equiv )
	UNROTOVER x*ext UNROT x*ext
	( log, taille )
	;
' ::	( LAM2: obj -> logarithme, taille  )
	idntlamcase :: LN2ext DUP ;
	DUPTYPESYMB? 
	NOTcase :: xLNext HSECO2RCext num0=case %0 %1 ;
	DUPINCOMP SWAP
	( symb, o1, ..., on-1, #n, on )
	{ x* 4GETLAM x^ 3GETLAM x/ 1GETLAM }
	EQLookup case :: EVAL EVAL ;
	( symb, o1, ..., on-1, #n, on )
	DROP#1- NDROP
	( symb ) 
	LN2ext DUP
	;
' ::	( LAM1: op=x/ )
	( symb, o1,..., on-1, #n )
	#1- pZpargSWAPUn
	( symb, meta1, meta2 )
	SYMBNext
	OVER#2+UNROL SYMBNext
	( symb, symb1, symb2 )
	ROTDROP
	( symb1, symb2 ) 
	DUPTYPEREAL? IT :: DUP %0< NOT?SEMI RNEGext SWAP RNEGext SWAP ; 
	2GETEVAL
	( symb1, log2, taille2 )
	ROT 2GETEVAL 
	( log2, taille2, log1, taille1 )
	4ROLLROT x-ext
	( taille2, taille1, log )
	UNROT
	CODE
	GOLONG	limmax
	ENDCODE
	( log, taille )
	;
4NULLLAM{} BIND
2GETEVAL
ABND
; ( end lnobj! )
( #varx, reste, lvar, ln[1+X]-l, ln[equiv], taille )
DUP %0 EQUAL ITE
::	DROPOVER 
	( #varx, reste, lvar, ln[1+X]-l, ln[equiv], ln[1+X]-l )
	6ROLL
* a revoir
	CODE
	GOLONG	limequfr
	ENDCODE
	( reste, lvar, ln[1+X]-l, ln[equiv], o, taille-l, o )
	DROPSWAPDROP ZEROSWAP
	5PICK VAL2ext
	;
::	6ROLL DROP ;
( reste, lvar, ln[1+X], ln[equiv], taille ou X^[valuation] )
5ROLL SWAP x/ext
( lvar, ln[1+X], ln[equiv], nouveau reste )
* simplification du nouveau reste
LABEL simp1!
::
CODE
	GOLONG	lvarxnx2
ENDCODE
SWAP &COMP VXXLext ZEROSWAP ROT VAL2ext 
;
( lvar, ln[1+X], ln[equiv], nouveau reste )
4UNROLL
( reste, lvar, ln[1+X], ln[equiv] )
UNROTSWAP
( reste, ln[equiv], ln[1+X], lvar )
* methode de Horner
SWAP FXNDext 
( lvar, num-l, deno-l )
DUPTYPELIST? IT CARCOMP 
OVER TYPELIST? ITE >HCOMP :: SWAP TWO{}N ; ONESWAP 3PICK CDRCOMP VAL2ext
( lvar, { deno num-l } )
INNERCOMP #1- reversym DUP #3+ ROLL CARCOMP 1LAMBIND 
( deno, a0, .., an, #n+1)
::	DUP#1= casedrop ABND
	( a0, ..., an, #n+1 )
	ONE_DO	(DO)
		1GETLAM 
		x*ext x+ext
		LOOP
	ABND
	;
( deno, a0, .., an, #n+1)
SWAP RDIVext
* fin de la methode de Horner
( reste, ln[equiv], ln[1+X] )
x+ext SWAPTRUE
( ln, reste, ok? )
; ( fin de limln! )
%1 4ROLL NDXFext UNROT
( ln, reste, ?ok )
; ( fin de liminvln! )


LABEL limexp!
::
* DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur 
* -> DL, reste, flag
CODE
limdl	A=PC
	LC(5)	(limdl!)-(*)
limdlbr	A=A+C	A
	PC=(A)
ENDCODE
caseTRUE
CODE
limdlinf	A=PC
		LC(5)	(limdlinf!)-(*)
		GOTO	limdlbr
ENDCODE
( ?-inf, { a# ... a0 }, deno-l, lim, lvar, X, reste-l )
LAM LIMOK #0<> case :: 7DROP %0 %0 FALSE ;
LABEL hornexp!
* lim, lvar, X-l, reste-l -> lvar, DL, reste-l
::	( lim, lvar, X, reste-l ) 
	4UNROLLROT DUPTYPETAG? IT STRIPTAGS UNROT
	( reste-l, lim, lvar, X )
	num0case :: DROPSWAP xEXPext ROT ;
	( reste-l, lim, lvar, X )
	4ROLLSWAP
	( lim, lvar, reste-l, num-l/deno-l )
	CODE
lprof	A=PC
	LC(5)	(lprof!)-(*)
	A=A+C	A
	PC=(A)
	ENDCODE
	( lim, #varx, #prof, #ordre, lvar, new reste-l, num-l/deno-l )
	HXS 2 10 DUP 6ROLL DUP1LAMBIND
	#1+_ONE_DO  	
		( c0, ..., ck, k! )
		INDEX@ ZUNCOERCE RMULText HXS 2 10 OVER NDXFext
		SWAPLOOP
	DROP
	( lim, #varx, #prof, lvar, reste-l, X, c0, ..., ck ) 
	1GETABND
	CODE
limhorn		A=PC
		LC(5)	(limhorn!)-(*)
limbr40		A=A+C	A
		PC=(A)
	ENDCODE
	( lim, #varx, #prof, lvar,  reste-l, f[x_0+X]-f[x_0]-l )
	FXNDext 5ROLL
	CODE
		GOLONG	limprofend
	ENDCODE
	NDXFext
	( lim, #varx, lvar, reste-l,  f[x_0+X]-f[x_0]-l )
	4ROLLDROP
	( lim, lvar,  reste-l, f[x_0+X]-f[x_0]-l )
	3PICK
	CODE
		GOLONG	limvalobj
	ENDCODE
	( lim, lvar, reste-l, f[x_0+X]-f[x_0] )
	4ROLL xEXPext x*ext
	( lvar, reste-l, f[x_0+X]-f[x_0] )
	SWAP
	( lvar, DL, reste-l )
	;
( ?-inf, { a# ... a0 }, deno-l, lvar, DL, reste-l )
6UNROLL 2SWAP 5PICK ?SKIP RNEGext RDIVext
( reste-l , ?-inf, lvar, DL, partie -> infini-liste )
3PICK
CODE
	GOLONG	limvalobj
ENDCODE
xEXPext
( reste-l , ?-inf, lvar, DL, partie -> infini )
4ROLL ITE x*ext NDXFext
( reste-l, lvar, exp )
UNROT
CODE
	GOLONG	limvalobj
ENDCODE
( DL, reste )
TRUE
; ( end limexp! )

LABEL limsin!
LABEL limcos!
::
* DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur 
* -> DL, reste, flag
CODE
	GOLONG	limdl
ENDCODE
caseTRUE
( DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur )
DUP1LAMBIND
CODE
	GOLONG	limdlinf
ENDCODE
1GETABND
( ?-inf, { a# ... a0 }, deno-l, lim, lvar, X, reste-l, operateur )
8ROLL DROP 7ROLL 7ROLL RDIVext
( lim, lvar, X, reste-l, operateur, partie infinie liste )
5PICK
CODE
	GOLONG	limvalobj
ENDCODE
( lim, lvar, X, reste-l, operateur, partie infinie )
6ROLL x+ext 5UNROLL
EQ: xCOS
ITE
	LABEL horncos!
	::	( COS )
		( lim, lvar, X, reste-l )
		SWAP
		( lim, lvar, reste-l, X )
		num0case :: DROPROT xCOSext SWAP ;
* si cos[x_0]=0, rajouter 1 a l'ordre du DL a effectuer
		4PICK xCOSext DUP 5UNROLL
		( lim, cos[lim], lvar, reste-l, X, cos[lim] )
		%0 EQUAL
		( lim, cos[lim], lvar, reste-l, X, ?=0 )
		CODE
		A=PC
		LC(5)	(limsc0!)-(*)
		A=A+C	A
		PC=(A)
		ENDCODE
		( lim, cos[lim], r-l, lvar, X, sin-l, cos-l ) 
		2OVER ROT 8ROLL 
		( lim, r-l, lvar, X, sin-l, lvar, X, cos-l, cos[limit] )
		CODE
		GOLONG	limsc1
		ENDCODE
		( lim, r-l, lvar, X, sin-l, cos[limit]*cos[X] )
		UNROT 4PICK UNROT 7ROLL xSINext 
		( r-l, lvar, sin[limit]*cos[X], lvar, X, sin-l, sin[limit] )
		CODE
		GOLONG	limsc1
		ENDCODE
		x-ext
		( r-l, lvar, cos[limit]*cos[X]-sin[limit]*sin[X] )
		ABND ROT
		( lvar, DL, r-l )
		;
	LABEL hornsin!
	::	( SIN )
		( lim, lvar, X, reste-l )
		SWAP
		( lim, lvar, reste-l, X )
		num0case :: DROPROT xSINext SWAP ;
* si cos[x_0]=0, rajouter 1 a l'ordre du DL a effectuer
		4PICK xSINext DUP 5UNROLL
		( lim, sin[lim], lvar, reste-l, X, sin[lim] )
		%0 EQUAL
		( lim, sin[lim], lvar, reste-l, X, ?=0 )
		LABEL limsc0!
		::
		( lvar, reste-l, X, ?=0 )
		4UNROLL
		( ?X=0, lvar, reste-l, X )
		CODE
		GOLONG	lprof
		ENDCODE
		( ?X=0, #varx, #prof, #ordre, lvar, new reste-l, X )
		6ROLL DROP ROTSWAP
		( ?X=0, #varx, #prof, #ordre, r-l, lvar, X )
		HXS 2 10 HXS 1 0 2DUPSWAP DUP 
		( ?X=0, #prof, #ordre, r-l, lvar, X, 1, 0, 0, 1, 1 )
		NINE ROLL ELEVEN ROLL IT #1+ DUP1LAMBIND
		( #prof, r-l, lvar, X, 1, 0; 0, 1, 1!, # )
		DUPTWO #<case :: 2DROP TWO{}N UNROT TWO{}N 6ROLL 1PUTLAM ;
		ONE_DO	(DO)
			( cos, sin, k! )
			INDEX@ #1+ ZUNCOERCE RMULText
			( cos, sin, +-k! )
			INDEX@ TWO #/ DROP #0= DUPUNROT ?SKIP RNEGext
			( cos, sin, flag, +-k! )
			HXS 2 10 OVER x/ext
			( cos, sin, flag, +-k!, +-1/k! )
			3PICK ITE	UNROT
					:: INDEX@ #4+ UNROLL ;
			HXS 1 0 
			ROT ITE	:: INDEX@ #3+ UNROLL ;
				SWAP
			LOOP
		DROP 1GETLAM #1+ {}N
		1GETABND #1+ DUPUNROT #2+UNROLL {}N
		( #prof, r-l, lvar, X, sin-l, cos-l )
		6ROLL 1LAMBIND
		( r-l, lvar, X, sin-l, cos-l )
		;
		( end limsc0! )
		( lim, sin[lim], r-l, lvar, X, sin-l, cos-l ) 
		2OVER ROT 8ROLL
		( lim, r-l, lvar, X, sin-l, lvar, X, cos-l, sin[limit] )
		LABEL limsc1!
		::	num0case 4UNROLL3DROP
			4UNROLL
			( sin[lim], lvar, X, cos-l )
			INNERCOMP #1-
			CODE
		GOLONG	limhorn
			ENDCODE
			( sin[lim], lvar, cos[X] )
			FXNDext 1GETLAM
			CODE
		GOLONG	limprofend
			ENDCODE
			NDXFext
			( sin[lim], lvar, cos[X] )
			SWAP
			CODE
		GOLONG	limvalobj
			ENDCODE
			x*ext
			;
		( lim, r-l, lvar, X, sin-l, sin[limit]*cos[X] )
		UNROT 4PICK UNROT 7ROLL xCOSext 
		( r-l, lvar, sin[limit]*cos[X], lvar, X, sin-l, cos[limit] )
		CODE
limsc1		A=PC
		LC(5)	(limsc1!)-(*)
		A=A+C	A
		PC=(A)
		ENDCODE
		x+ext
		( r-l, lvar, sin[limit]*cos[X]+cos[limit]*sin[X] )
		ABND
		ROT
		( lvar, DL, r-l )
		;
( lvar, DL, r-l )
ROT
CODE
	GOLONG	limvalobj
ENDCODE
TRUE
( DL, reste, flag )
; ( end limsin/limcos )

LABEL limatan!
::
( DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur )
CODE
	GOLONG	limdl
ENDCODE
caseTRUE
( DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur )
( x -> 1/x )
DROPSWAP
CODE
	A=PC
	LC(5)	(infsign!)-(*)
atanbr	A=A+C	A
	PC=(A)
ENDCODE
( DL-l, reste-l , num-l/deno-l, equiv-l, lvar, ?-+ )
SYMBOL x\pi %2 x/ ; SWAP IT RNEGext
( DL-l, reste-l , num-l/deno-l, equiv-l, lvar, +/-pi/2 )
6ROLL DROP
( reste-l , num-l/deno-l, equiv-l, lvar, +/-pi/2 )
5ROLL 5ROLL
( equiv-l, lvar, +/-pi/2, reste-l, num-l/deno-l )
FXNDext SWAP 
( equiv-l, lvar, +/-pi/2, reste-l, deno-l, num-l )
5PICK LVARXNXext 4UNROLL3DROP LENCOMP
CODE
divpc	A=PC
	LC(5)	(divpc!)-(*)
	GOTO	atanbr	
ENDCODE
( equiv-l, lvar, +/-pi/2, reste-l, num-l, deno-l, flag )
NOTcase ::	3DROP UNROT2DROP FALSE 
		( DL, reste, flag )
		ONE ' LAM LIMOK STO
		;
( equiv-l, lvar, +/-pi/2, reste-l, num-l/deno-l )
RDIVext %0 5ROLL ROT 
( equiv-l, +/-pi/2, reste-l, lim=0, lvar, num-l/deno-l )
6ROLL RDIVext 4ROLL
	LABEL hornatan!
	::	( ATAN )
		( lim, lvar, X-l, reste-l )
		LABEL limatas
		::
			SWAP
			( lim, lvar, reste-l, X )
			num0case :: DROPROT xATANext SWAP ;
		CODE
		GOLONG	lprof
		ENDCODE
			( lim, #varx, #prof, #ordre, lvar, new reste-l, X )
* si lim=0, rajouter 1 a l'ordre du DL a effectuer
			6ROLL DROP
			( lim, #prof, #ordre, lvar, new reste-l, X )
			4ROLL 6PICK %0 EQUAL ?SKIP #1-
			( lim, #varx, #prof, lvar, new reste-l, X, #ordre )
			HXS 2 10 HXS 1 0 3PICK #2* NDUPN #1+ {}N
			( lim, #prof, lvar, new reste-l, X, #ordre, num )
			;
		7PICK 6PICK VXXLext SWAPDROP
		( lim, #prof, lvar, new reste-l, X, #ordre, num, lim-l )
		DUPDUP RMULText HXS 2 10 RADDext SWAP HXS 2 2F RMULText
		( lim, #prof, lvar, new reste-l, X, #ordre, num, 1+l^2, -2l )
		HXS 2 10 HXS 1 0 6ROLL TWO 2DUP#< IT 2DROP00 #- NDUPN #3+ {}N
		( lim, #prof, lvar, reste-l, X, num, [X-lim]^2 )
		DIVext DROP INNERCOMP reversym {}N
		( lim, #prof, lvar, reste-l, X, dl )
		INTEGRext 
		( lim, #prof, lvar, reste-l, X, dl )
		SWAP FXNDext 6ROLL
		CODE
		GOLONG	limprofend
		ENDCODE
		( lim, lvar, reste-l, dl, X-n, X-d )
		RDIVext
		SWAPINCOMP reversym #1-
		CODE
		GOLONG	limhorn
		ENDCODE
		( lim, lvar, reste-l, dl )
		3PICK
		CODE
		GOLONG	limvalobj
		ENDCODE
		4ROLL xATANext x+ext SWAP
		( lvar, DL, reste-l )
		;
( +/-pi/2, lvar, DL, reste-l )
ROT
CODE
	GOLONG	limvalobj
ENDCODE 
UNROT x-ext SWAPTRUE
( DL, reste, flag )
; ( end limatan )

LABEL limasin!
::
( DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur )
CODE
	GOLONG	limdl
ENDCODE
caseTRUE
( DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur )
5DROP FALSE 
TWO ' LAM LIMOK STO
* erreur: asin non defini en +/- infini
; ( end limasin )

LABEL limsqrt!
::
( DL-l, reste-l , num-l/deno-l, equiv-l, lim, lvar, operateur )
DROPSWAPDROP 5ROLL DROP
( reste-l , num-l/deno-l, equiv-l, lvar )
2SWAP HXS 2 10 RSUBext SYMBOL HXS 2 10 HXS 2 20 x/ ;
LABEL limbeta!
::
( equiv-l, lvar, reste-l , num-l/deno-l, alpha )
LABEL limalpha!
::	
( lvar, reste-l, num-l/deno-l-1=X, alpha )
4UNROLL
( alpha,  lvar, reste-l, num-l/deno-l-1=X )
num0case ::	( alpha, lvar, reste-l, num-l/deno-l-1=X )
		DROP HXS 2 10
		( alpha, lvar, reste-l, DL[ 1+ num-l/deno-l-1 ]^alpha-l )
		;
CODE
	GOLONG	lprof
ENDCODE
( alpha, #varx, #prof, #ordre, lvar, new reste-l, X )
HXS 2 10 8PICK 6ROLL DUP1LAMBIND
( alpha, #varx, #prof, #ordre, lvar, new reste-l, X, 1, mult, #ordre )
#1+_ONE_DO (DO)
	( ck, mult )
	2DUP RMULText
	( ck, mult, ck*mult )
	INDEX@ ZUNCOERCE RDIVext
	( ck, mult, ck+1=ck*mult/k )
	SWAP HXS 2 10 RSUBext
	LOOP
DROP 1GETABND
CODE
	GOLONG	limhorn
ENDCODE
( alpha, #varx, #prof,  lvar, new reste-l, DL )
FXNDext 5ROLL
CODE
	GOLONG	limprofend
ENDCODE
RDIVext
4ROLL DROP
( alpha, lvar, new reste-l, DL-l )
; ( end limalpha! )
( equiv-l, alpha, lvar, new reste-l, DL-l )
3PICK
CODE
	GOLONG	limvalobj
ENDCODE
( equiv-l, alpha, lvar, new reste-l, DL )
5ROLL 4PICK
CODE
	GOLONG	limvalobj
ENDCODE
( alpha, lvar, new reste-l, DL, equiv )
* xLNext ( remplacer par lnobj? )
CODE
lnobj	A=PC
	LC(5)	(lnobj!)-(*)
limbr1	A=A+C	A
	PC=(A)
ENDCODE
DROP
5ROLL RMULText xEXPext ZEROSWAP NULL{} VAL2ext x*ext
( lvar, reste-l, equiv^alpha*DL[ 1+ num-l/deno-l-1 ]^alpha )
; ( end limbeta! )
SWAPROT
CODE
	GOLONG	limvalobj
ENDCODE
TRUE
( DL, reste, true )
; ( end limsqrt! )

LABEL limabs!
::
* DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar, operateur -> 
* DL, reste, TRUE
DROPSWAP POSITIFext
( DL-l, reste-l, num-l/deno-l, equiv-l, lvar, lim, flag )
* attention: si la limite est nulle non signee
SWAP num0=case :: 5DROP ELEVEN ' LAM LIMOK STO FALSE ;
DROP 2SWAP 2DROP 2SWAP
( lvar, flag, DL-l, reste-l )
ROT ?SKIP :: RNEGext SWAP RNEGext SWAP ;
( lvar, DL-l, reste-l )
SWAP3PICK
CODE
	GOLONG	limvalobj
ENDCODE
( lvar, reste-l, DL )
SWAPROT
CODE
	GOLONG	limvalobj
ENDCODE
TRUE
;

LABEL limdl!
* DL reguliers de la forme f(x_0+x) avec x_0 fini 
* si x_0 non nul et f(x_0)=0, r -> r/e
::
* DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar, operateur -> 
* DL, reste, TRUE
* ou DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar, operateur, FALSE
3PICK
::	DUPTYPESYMB? NOTcasedrop TRUE
	CARCOMP ' x\9F EQUALNOT
* a rajouter un eventuel test d'egalite avec ?
	;
NOTcaseFALSE
( DL-l, reste-l, num-l/deno-l, equiv-l, lim, lvar, operateur )
7UNROLL 4UNROLL
( operateur, DL-l, reste-l, lvar, num-l/deno-l, equiv-l, lim )
DUPTYPETAG? IT STRIPTAGS DUP 5UNROLL 
( operateur, DL-l, reste-l, lim, lvar, num-l/deno-l, equiv-l, lim )
::	num0=case :: 3DROP 4ROLL ;
* test si f(x_0)=0, dans ce cas r -> r/e (car f'(x_0) non nul pour sin, cos )
	{ xCOS xSIN } NINE PICK ' EQ POSCOMP
	( operateur, DL-l, reste-l, lim, lvar, num-l/deno-l, equiv-l, lim, # )
	DUP#0= ITE_DROP
	::	OVER SYMBOL x\pi %2 x/ ; NDXFext SIMP1ext
		( operateur, DL-l, r-l, lim, lvar, n/d-l, e-l, lim, #, 2*l/pi )
		dREALNcase 2DROP
		%2 %MOD SWAP #1= ITE %1 %0 %=
		( operateur, DL-l, r-l, lim, lvar, n/d-l, e-l, lim, ? 2*l/pi mod 2=% )
		NOT?SEMI
		6ROLL 4PICK RDIVext 6UNROLL
		;
	DROPSWAPDROP 
	( op, DL-l, reste-l, lim, lvar, equiv-l )
	5ROLL SWAP RSUBext
	;
( operateur, reste-l, lim, lvar, X )
4ROLL 5ROLL
( lim, lvar, X-l, reste-l, operateur )
* liste de liste a 2 elements: operateur a appliquer a la limite
* et prog: lim, lvar,X-l, reste-l -> lvar, DL, reste-l
CODE
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		LC(5)	=xEXP
		?A#C	A
		GOYES	limdlbr1
		A=PC
		LC(5)	(hornexp!)-(*)
horndlbr	A=A+C	A
		PC=(A)
limdlbr1	LC(5)	=xCOS
		?A#C	A
		GOYES	limdlbr2
		A=PC
		LC(5)	(horncos!)-(*)
		GOTO	horndlbr
limdlbr2	LC(5)	=xSIN
		?A#C	A
		GOYES	limdlbr3
		A=PC
		LC(5)	(hornsin!)-(*)
		GOTO	horndlbr
limdlbr3	LC(5)	=xATAN
		?A#C	A
		GOYES	limdlbr4
		A=PC
		LC(5)	(hornatan!)-(*)
		GOTO	horndlbr
limdlbr4	LC(5)	=xASIN
		?A#C	A
		GOYES	limdlerr
		A=PC
		LC(5)	(hornasin!)-(*)
		GOTO	horndlbr
limdlerr	LA(5)	=SETSIZEERR
		PC=(A)
ENDCODE
( lvar, DL, reste-l  )
ROT
CODE
	GOLONG	limvalobj
ENDCODE
( DL, reste )
TRUE
; ( end limdl )

LABEL hornasin!
::	( ASIN )
( lim, lvar, X-l, reste-l )
ROTSWAP 
( lim, X-l, lvar, reste-l )
4PICK 3PICK VXXLext SWAPDROP
( lim, X-l, lvar, reste-l, lim-l )
DUPDUP RMULText HXS 2 10
EQUALcase
::	( lim=+/-1 )
	( lim, X-l, lvar, reste-l, lim-l )
	HXS 2 20 RDIVext HXS 1 0 TWO{}N
	( lim, X-l, lvar, reste-l, num/deno-1 )
	SYMBOL HXS 2 1F HXS 2 20 x/ ;
	( lim, X-l, lvar, reste-l, num-l/deno-l-1=X, alpha )
	CODE
limalpha	A=PC
		LC(5)	(limalpha!)-(*)
		A=A+C	A
		PC=(A)
	ENDCODE
	( lim, X-l, alpha, lvar, reste-l, DL[ 1+ num-l/deno-l-1 ]^alpha-l )
* version speciale de INTEGRext: toutes les puissances sont decalees de -1/2
	FXNDext SWAP
	INNERCOMP #1+DUP
	ONE_DO (DO)
		SWAPINDEX@ ZUNCOERCE SYMBOL HXS 2 1F HXS 2 20 x/ ;
		RADDext
		RESOROMP RDIVext LOPAext OVER UNROLL
		LOOP
	HXS 1 0 SWAP {}N
	SWAP RESOROMP RDIVext LOP1ext
	( lim, X-l, alpha, lvar, reste-l, DL[ 1+ num-l/deno-l-1 ]^alpha-l )
	5PICK SWAPINCOMP reversym #1-
	CODE
		GOLONG	limhorn
	ENDCODE
	( lim, X-l, alpha, lvar, reste-l, DL-l )
	3PICK
	CODE
		GOLONG	limvalobj
	ENDCODE
	( lim, X-l, alpha, lvar, reste-l, DL )
* multiplier par ( X/equ[X] )^alpha-l
* puis selon lim par (-/+ 2 equ[X])^alpha
	6UNROLL 4ROLL 3PICK DUP
	CODE
		A=PC
		LC(5)	(lim#varx!)-(*)
limasinbr	A=A+C	A
		PC=(A)
	ENDCODE
	( DL, lim, alpha, lvar, reste-l, X-l, #varx )
	CODE
		GOLONG	limequfr
	ENDCODE
	DROP
	( DL, lim, alpha, lvar, reste-l, X-l/equiv, equiv-l )
	6ROLL HXS 2 2F RMULText RMULText
	5UNROLL HXS 2 10 RSUBext 4ROLL
	( DL, l*2*equiv-l, lvar, reste-l, X-l/equiv-1, alpha )
	CODE
		A=PC
		LC(5)	(limbeta!)-(*)
		GOTO	limasinbr
	ENDCODE
	( DL, lvar, reste-l, equiv^alpha*DL[ 1+ num-l/deno-l-1 ]^alpha )
	4ROLL RMULText SWAP
	( lvar, DL, reste-l )
	;	
( lim, X-l, lvar, reste-l, lim-l )
HXS 2 10 OVERDUP RMULText RSUBext
( lim, X-l, lvar, reste-l, l, 1-l^2 )
HXS 2 1F  
( lim, X-l, lvar, reste-l, l, 1-l^2, -1 )
ROT HXS 2 2F RMULText
( lim, X-l, lvar, reste-l, 1-l^2, -1, -2l )
HXS 1 0 THREE{}N OVER RDIVext
( lim, X-l, lvar, reste-l, 1-l^2, num-l/deno-l-1 )
SWAP 4UNROLL SYMBOL HXS 2 1F HXS 2 20 x/ ;
( lim, X-l, 1-l^2, lvar, reste-l, num-l/deno-l-1, alpha )
CODE
		GOLONG	limalpha
ENDCODE
( lim, X-l, 1-l^2, alpha, lvar, reste-l, DL[ 1+ num-l/deno-l-1 ]^alpha-l )
FXNDext SWAP INTEGRext
SWAP RESOROMP RDIVext LOP1ext
( lim, X-l, 1-l^2, alpha, lvar, reste-l, DL[ 1+ num-l/deno-l-1 ]^alpha-l )
6ROLL SWAPINCOMP reversym #1-
CODE
		GOLONG	limhorn
ENDCODE
( lim, 1-l^2, alpha, lvar, reste-l, DL-l )
3PICK
CODE
		GOLONG	limvalobj
ENDCODE
5ROLL 4PICK
CODE
		GOLONG	limvalobj
ENDCODE
( lim, lvar, reste-l, DL-l, 1-l^2 )
*		xLNext ( remplacer par lnobj? )
CODE
		GOLONG	lnobj
ENDCODE
DROP
5ROLL x*ext xEXPext ZEROSWAP NULL{} VAL2ext x*ext
( lim, lvar, reste-l, DL-l )
4ROLL xASINext HSECO2RCext x+ext SWAP
( lvar, DL, reste-l )
; ( end hornasin! )


LABEL limdlinf!
::
* DL-l, reste-l , num-l/deno-l, equiv-l, lim=+/-infini, lvar, operateur
* -> ?-inf, { a# ... a0 }, deno-l, lim, lvar, X, reste-l
ROTSWAP
EQ: xEXP
IT
LABEL infsign!
::	( DL-l, reste-l , num-l/deno-l, equiv-l, lvar, lim )
	INNER#1= 
	casedrop ::	THREE ' LAM LIMOK STO TRUE
			;
	( DL-l, reste-l , num-l/deno-l, equiv-l, lvar, x\9F, xNEGNEG ou xNEG )
	SWAPDROP EQ: xNEG
	( DL-l, reste-l , num-l/deno-l, equiv-l, lvar, ?-infini )
	;
2SWAP 2DROP
( DL-l, reste-l, lvar, ?-infini )
SWAPROT DUP4UNROLL
( DL-l, ?-infini, lvar, reste-l )
5ROLL
( ?-infini, reste-l, lvar, reste-l, num-l/deno-l )
CODE
	GOLONG	lprof
ENDCODE
( ?-infini, r-l, #varx, #prof, #ordre, lvar, new-reste-l, num-l/deno-l  )
::	8ROLL num0case ROTDROPSWAP
	DROP
	;
( ?-infini, #varx, #prof, #ordre, lvar, reste-l, num-l/deno-l  )
6ROLL 6PICK #- 6UNROLL
( ?-infini, #var-#prof, #prof, #ordre, lvar, reste-l, num-l/deno-l  )
DUP FXNDext SWAPDROP 7PICK
( ?-infini, #varx-#prof, #prof, #ordre, lvar, reste-l, num-l/deno-l, deno-l, #var-#prof )
CODE
	GOLONG	limequ
ENDCODE
( ?-infini, #varx-#prof, #prof, #ordre, lvar, reste-l, num-l/deno-l, deno-l trimmed, deno-equiv-l, { # # # }  )
ROTDROP CARCOMP 2DUP HXS 2 10 HXS 1 0 ROT NDUPN #1+ {}N RDIVext 
( ?-infini, #varx-#prof, #prof, #ordre, lvar, reste-l, num-l/deno-l, deno-equiv-l, #valuation, coeff  )
::	( enleve 1 profondeur a coeff )
	FXNDext
	SWAP DUPTYPELIST? IT CARCOMP
	SWAP DUPTYPELIST? IT CARCOMP
	RDIVext
	;
( ?-infini, #varx-#prof, #prof, #ordre, lvar, reste-l, num-l/deno-l, deno-equiv-l, #valuation, coeff  )
* reajuste le reste
5ROLL 4ROLL 8PICK
CODE
	GOLONG	limprofend
ENDCODE
RDIVext
( ?-infini, #varx-#prof, #prof, #ordre, lvar, num-l/deno-l, #val, coeff, reste-l  )
6ROLL DROP
( ?-infini, #varx-#prof, #prof, lvar, num-l/deno-l, #val, coeff, reste-l )
4ROLL FXNDext
( ?-infini, #varx-#prof, #prof, lvar, #val, coeff, reste-l, num-l, deno-l  )
4ROLL 5ROLL 4ROLL
( ?-infini, #varx-#prof, #prof, lvar, reste-l, deno-l, coeff-l, #val, num-l )
DUPTYPELIST? ITE INNERCOMP ONE get1
( ..., deno-l, coeff-l, an, ..., a0, #n+1, #val )
DUP#1+ #2+PICK
( ...,  deno-l, coeff-l, an, ..., a0, #n+1, #val, a#val )
3PICK #4+ ROLL
( ...,  deno-l, an, ..., a0, #n+1, #val, a#val, coeff-l )
* teste si a#val/coeff-l -> infini: sinon, a#val va dans la partie bornee
RDIVext 3PICK #6+ PICK ( lvar ) 4PICK #8+ PICK ( #prof )
#1+ MINUSONE SUBCOMP CDRCOMP ( lvar tronquee )
4PICK #9+ PICK #1- ( #varx-#prof-1 )
SWAPROT
( ..., deno-l, an, ..., a0, #n+1, #val, #, lvar, coeff-l/a#val )
CODE
	GOLONG	varcomp3
ENDCODE
(  ..., deno-l, an, ..., a0, #n+1, #val, #, lvar, o-liste, #  )
4UNROLL3DROP FOUR #/ DROP #2=
(  ...,  deno-l, an, ..., a0, #n+1, #val, ?a#val trop grand )
SWAPDUP 1LAMBIND OVER IT #1+
(  ...,  deno-l, an, ..., a0, #n+1, ?a#val trop grand, # )
SWAP3PICK #3+ UNROLL
( ..., deno-l, ?a#val trop grand, an, ..., a0, #n+1, # )
DUPUNROT 
:: 2DUP#> 
   NOTcase :: ( ..., deno-l, ?a#val trop grand, an, ..., a0, #, #n+1, # ) 
	      DROPSWAPDROP {}N HXS 1 0 
	      ;
   #-
   (  ..., deno-l, ?a#val trop grand, an, ..., a0, #, #n+1-# )
   OVER#2+UNROL {}N TRIMOBJext OVER#2+UNROL {}N TRIMOBJext
   ;
(  ..., deno-l, ?a#val, { a# ... a0 }, { an ... } )
ROT IT :: HXS 1 0 OVER TYPELIST? ITE >TCOMP TWO{}N ; 
(  ..., deno-l, { a# ... a0 }, { an ... } )
ROT DUPDUP
( ?-infini, #varx-#prof, #prof, lvar, reste-l, { a# ... a0 }, { an ... }, deno-l, deno, deno )
::	DUPTYPELIST? NOTcasedrop ABND
	LENCOMP 1GETABND #- ONESWAP SUBCOMP
	;
( ?-infini, #varx-#prof, #prof, lvar, reste-l, { a# ... a0 }, { an ... }, deno-l, deno-stripped )
ROTSWAP RDIVext
( ?-infini, #varx-#prof, #prof, lvar, reste-l, { a# ... a0 }, deno-l, partie bornee )
7ROLL 6ROLL 3PICK
( ?-infini, #prof, reste-l, { a# ... a0 }, deno-l, bornee, #, lvar, partie bornee )
* #, lvar, equiv-l -> #, lvar, lim-l, #
CODE
	GOLONG	varcomp3
ENDCODE
FOUR #/ DROP #1= IT :: DROP HXS 1 0 ;
ROTDROP
( ?-infini, #prof, reste-l, { a# ... a0 }, deno-l, bornee, lvar, lim-l )
ROTOVER RSUBext
( ?-infini, #prof, reste-l, { a# ... a0 }, deno-l, lvar, lim-l, borne-lim )
ROT 6UNROLL
( ?-infini, #prof, lvar, reste-l, { a# ... a0 }, deno-l, lim-l, borne-lim )
FIVE
ZERO_DO	(DO)
	5ROLL FXNDext 8PICK
	CODE
	GOLONG	limprofend
	ENDCODE
	RDIVext
	LOOP
( ?-infini, #prof, lvar, reste-l, { a# ... a0 }, deno-l, lim-l, X=borne-lim )
7ROLL DROP
( ?-infini, lvar, reste-l, { a# ... a0 }, deno-l, lim-l, X=borne-lim )
ZERO ROT 7PICK VAL2ext
( ?-infini, lvar, reste-l, { a# ... a0 }, deno-l, X, lim )
6ROLL ROT 6ROLL
; ( end limdlinf )

LABEL limre!
LABEL limim!
LABEL limconj!
LABEL liminvop!
::
DO>STR ": op. non valide" &$ DO$EXIT
;

****************************
* ROUTINES DE COMPARAISON
****************************
LABEL limmax!
::
2DUP EQUALcase DROP
2DUP

LABEL limcomp!
* comparaison d'objets: o1, o2 -> flag
* Attention: les variables doivent etre valides 
* i.e. inv[ln] et exp tendant vers 0 
::
SWAP num#0=case 2DROPFALSE
SWAP num#0=case :: 2DROP TRUE ;
LABEL varcomp2!
* o1, o2 -> #varx, lvar, equiv de o1/o2-l, #
* # = 0 si o1/o2 -> limite finie donnee par equiv de o1/o2-l 
* # = 1 si le numerateur est negligeable devant deno
* # = 2 si le deno est negligeable devant le num
::
' x/ EvalNoCK 
CODE
	GOLONG	lvarxnx2
ENDCODE
( o1/o2, lvarnx, lvarx )
LABEL sort!
::
' 
LABEL varcomp!
( var1, var2 -> flag )
::	2DUP EQUAL case2drop TRUE
	2DUP
	CODE
var%		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOIDNT
		?A#C	A
		GOYES	var%1
var%2		LA(5)	=THREE
		DAT1=A	A
varloop		GOVLNG	=Loop
var%1		LC(5)	=DOLAM
		?A=C	A
		GOYES	var%2
		A=PC
		LC(5)	(var%symb!)-(*)
limbranch	A=A+C	A
		PC=(A)
	ENDCODE
	SWAP
	CODE
		GOTO	var%
	ENDCODE
	( var1, var2, #var2, #var1 )
	2DUP#= NOTcase :: #> UNROT2DROP ; 
	( type 0, 1 et 4: pas de comparaison possible )
	#0= case2drop DROPTRUE
	DUP FOUR #= case2drop DROPTRUE
	DUP#1= case2drop DROPTRUE
	( type 2: enlever les ln et rappeler limcomp )
	#2= 
	case ::	( var1=inv[ln], var2=inv[ln] )
		DUPLENCOMP #2- ONESWAP SUBCOMP
		SWAP DUPLENCOMP #2- ONESWAP SUBCOMP
		SWAP
		CODE
limcomp		A=PC
		LC(5)	(limcomp!)-(*)
limbr20		A=A+C	A
		PC=(A)
		ENDCODE
		;
	( type 3: prendre les ln des 2 membres, chercher la lim de la diff )
	xLNext SWAP xLNext x-ext 
	CODE
	GOLONG	limit
	ENDCODE
	( DL-l, reste-l, DL/equiv-l, equiv-l., lim., lvar, flag )	
	NOTcase :: 6DROP FOUR ' LAM LIMOK STO TRUE ;
	DROP 5UNROLL 4DROP
	SYMBOL x\9F ; EQUALcasedro :: FALSE FIVE ' LAM LIMOK STO ;
	SYMBOL x\9F xNEGNEG ; EQUALcasedro FALSE
	SYMBOL x\9F xNEG ; EQUALcasedro TRUE
	POSITIFext SWAPDROP
	; ( end varcomp! )
SortList
; ( fin de sort! )

( o1/o2, lvarnx, lvarx )
DUPLENCOMP 4UNROLL SWAP &COMP VXXLext

LABEL varcomp3!
::
( #profondeur, lvar, o1/o2-l )
ZERO 1LAMBIND
* 1GETLAM contient ZERO pour + borne, ONE pour 0+ , TWO pour +infini
* FOUR pour - borne, FIVE pour 0-, SIX pour -infini
* EIGHT pour borne (signe indetermine), NINE pour 0, TEN pour infini
* THREE pour undef
3PICK
::	
DUP#0=csedrp 
	::	DUP FXNDext 
		num0case :: 2DROP TWO 1PUTLAM ;
		DROP num0case :: DROPONE 1PUTLAM ;
		DROP
		;
#1+_ONE_DO 
	   ( #, lvar, o-liste )
	   FXNDext
	   CODE
limval		A=PC
		LC(5)	(limval!)-(*)
		GOTO	limbranch
	   ENDCODE
	   ROT
	   ( #, lvar, deno-ak, deno-#k, num )
	   CODE
		GOTO	limval
	   ENDCODE
	   ( #, lvar, deno-ak, deno-#k, num-ak, num-#k )
	   SWAP 4ROLL NDXFext UNROT
	   ( #, lvar, obj-liste, deno-#k, num-#k )
	   4PICK INDEX@ NTHCOMPDROP
	   CODE
var%9	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	LC(5)	=DOIDNT
	?A#C	A
	GOYES	var%10
	LA(5)	=FOUR
	DAT1=A	A
	GOTO	varloop
var%10	GOTO	var%
	   ENDCODE
	   ( type #4=idnt, #3=exp, #2=ln, #0 borne, #1 undef )
	   ( #, lvar, o-liste, deno-#k, num-#k, type )
	   DUP4UNROLL
	   ( #, lvar, o-liste, type, deno-#k, num-#k, type )
	   ::	ONE #>case
		::	( var -> 0: compter les zeros finaux lvar, o-liste )
			( lvar, o-liste, type, deno-#k, num-#k )
			2DUP#= case2DROP
			::	( ajuste le signe )
				1GETLAM SEVEN #> ?SEMI
				2DUP #- TWO #/ DROP #0=?SEMI
				3PICK
				( #4 regarder la direction, #3: 0+, #2 0+ )
				( num-#, deno-#, type -> num-#, deno-# )
				THREE EQUALcasedro NOP
				TWO EQUALcasedro NOP
				FOUR #= NOT?SEMI
				LAM LIMTYPE ( 0: bi, 1: -; 2: + )
				DUP #2= caseDROP
				#0=ITE :: 1GETLAM THREE #AND EIGHT #+ ; 
				       :: 1GETLAM FOUR 2DUP#> ITE #- #+ ;
				1PUTLAM
				;
			( lvar, o-liste, type, deno-#k, num-#k )
			1GETLAM THREE #AND #0= NOTcase2DROP
			#> ITE TWO ONE 1GETLAM #+ 1PUTLAM
			;
		( #, lvar, o-liste, type, deno-#k, num-#k )
		( type: #0 borne, #1 undef )
		2DROP ONE EQUALcasedro
		::	( undef: sans espoir )
			DUP SIX ' LAM LIMOK STO THREE 1PUTLAM ExitAtLOOP
			;
		( #, lvar, o-liste, type )
		( la variable est bornee: si -> 0, ca continue a -> 0 )
		1GETLAM THREE #AND #1=case :: NINE 1PUTLAM ;
		( #0: borne par 1, regarder si on peut faire qqchose? )
		SEVEN ' LAM LIMOK STO THREE 1PUTLAM ExitAtLOOP
		;
	( lvar, objet, type )
	DROPLOOP
;
( #, lvar, o-liste )
::	1GETLAM SEVEN #>case 1GETLAM
	POSITIFext case 1GETLAM
	1GETLAM FOUR #< 1GETLAM FOUR ROT ITE #+ #-
	;
( #, lvar, o-liste, # )
ABND
; ( fin de varcomp3! )

; ( fin de varcomp2! )
4UNROLL3DROP FOUR #/ DROP #0=

; ( fin de limcomp! )

ITE_DROP SWAPDROP
; ( fin de limmax! )


LABEL limvalobj!
::
( obj, lvar -> symb )
SWAP 
* TRIMOBJext 
ZERO SWAPROT VAL2ext
;

* renvoie 3 pour exp, 2 pour inv[ln], 1 pour sin/cos
LABEL var%symb!
::
DUPTYPESYMB? NcaseTYPEERR
DUPLENCOMP NTHCOMPDROP
DUPEQ: xEXP casedrop THREE
DUPEQ: xINV casedrop TWO
DUPEQ: xSIN casedrop ZERO
EQ: xCOS ITE ZERO ONE
;

* obj -> 1er element, degre
*LABEL limdegre!
*::	NOTLISTcase ZERO DUP CARCOMP SWAP LENCOMP 
*	; 

* obj -> coeff, valuation
LABEL limval!
::	num#0=case :: LAM LIMORDRE #1+ ;
	NOTLISTcase ZERO
	INNERCOMP
	ZERO_DO (DO)
		( on-1, ..., ok )
		::	num#0=case DROP
			ISTOP-INDEX #1- DUPUNROT #2+UNROLL NDROP 
			INDEX@ ExitAtLOOP
			( ok, #k )
			;
		LOOP
	;
( end limval! )

LABEL equiv!
( liste, lequiv -> equiv, ordre )
::
%1 OVER LENCOMP  
ZERO_DO (DO)
	( liste, lequiv, equiv )
	OVERINDEX@ NTHCOMPDROP
	4ROLL
	CODE
	GOLONG	limval
	ENDCODE
	( lequiv, equiv, equiv-k, an, # )
	INDEX@ DUP#0= IT DUP1LAMBIND
	SWAP 5UNROLL x^ext x*ext
	LOOP
UNROT2DROP 1GETABND
; ( end equiv! )


* branchement en fonction de l'operateur
ASSEMBLE
limop		A=DAT1	A
		LC(5)	=xEXP
		?A#C	A
		GOYES	lim1
		A=PC
		LC(5)	(limexp!)-(*)
limbr11		A=A+C	A
		PC=(A)
lim1		LC(5)	=xINV		( pour inv[ln] )
		?A#C	A
		GOYES	lim2
		A=PC
		LC(5)	(liminvln!)-(*)
		GOTO	limbr11
lim2		LC(5)	=xSIN
		?A#C	A
		GOYES	lim3
		A=PC
		LC(5)	(limsin!)-(*)
		GOTO	limbr11
lim3		LC(5)	=xCOS
		?A#C	A
		GOYES	lim5
		A=PC
		LC(5)	(limcos!)-(*)
		GOTO	limbr11
lim5		LC(5)	=xASIN
		?A#C	A
		GOYES	lim6
		A=PC
		LC(5)	(limasin!)-(*)
		GOTO	limbr11
lim6		LC(5)	=xLN
		?A#C	A
		GOYES	lim10
		A=PC
		LC(5)	(limln!)-(*)
		GOTO	limbr11
lim10		LC(5)	=xATAN
		?A#C	A
		GOYES	lim11
		A=PC
		LC(5)	(limatan!)-(*)
		GOTO	limbr11
lim11		LC(5)	=x\v/
		?A#C	A
		GOYES	lim15
		A=PC
		LC(5)	(limsqrt!)-(*)
		GOTO	limbr11
lim15		LC(5)	=xRE
		?A#C	A
		GOYES	lim16
		A=PC
		LC(5)	(limre!)-(*)
		GOTO	limbr11
lim16		LC(5)	=xIM
		?A#C	A
		GOYES	lim17
		A=PC
		LC(5)	(limim!)-(*)
		GOTO	limbr11
lim17		LC(5)	=xCONJ
		?A#C	A
		GOYES	lim18
		A=PC
		LC(5)	(limconj!)-(*)
		GOTO	limbr11
lim18		LC(5)	=xABS
		?A#C	A
		GOYES	lim19
		A=PC
		LC(5)	(limabs!)-(*)
		GOTO	limbr11
lim19		A=PC
		LC(5)	(liminvop!)-(*)
		GOTO	limbr11
RPL

LABEL lvarxnx2!
( obj -> obj, lvarx, lvarnx  )
::
LISTOPext DUPLENCOMP ONESWAP #2- SUBCOMP  LVARXNX2ext ROTDROP
;


; ( end SERIES )

****************************************************
****************************************************
****************************************************
NULLNAME RCLVX
::
CONTEXT@ HOMEDIR ' ID VX DUP@
( rrp, vx, obj, TRUE | rrp, vx, false )
::     NOT?SEMI
       ( rrp, vx, obj )
       DUPTYPEIDNT? NOTcaseDROP
       RDROP SWAPDROPSWAP CONTEXT!
       ;
( rrp, vx )
'IDX DUPROT STO SWAP CONTEXT!
;
****************************************************
NULLNAME STOVX
::
CONTEXT@ SWAP HOMEDIR ' ID VX STO CONTEXT!
;
*************************************************
NULLNAME RCLMODULO
::
CONTEXT@ HOMEDIR ' ID MODULO DUP@
( rrp, modulo, obj, TRUE | rrp, modulo, false )
::     NOT?SEMI
       ( rrp, modulo, obj )
       VXXL1ext DUPTYPEHSTR? NOTcaseDROP
       RDROP SWAPDROPSWAP CONTEXT!
       ;
( rrp, modulo )
HXS 2 20 DUPROT STO SWAP CONTEXT!
;
***********************************************
NULLNAME RCLEPS
::
CONTEXT@ HOMEDIR ' ID EPS DUP@
( rrp, epsilon, obj, TRUE | rrp, epsilon, false )
::     NOT?SEMI
       ( rrp, epsilon, obj )
       DUPTYPEREAL? NOTcaseDROP
       num0=case DROP
       RDROP %ABS SWAPDROPSWAP CONTEXT!
       ;
( rrp, modulo )
% 0.0000000001 DUPROT STO SWAP CONTEXT!
;
*******************************************
*NULLNAME ALG48FCTR
*:: 
*DROP' :: ROMPTR 38D 21 ROMPTR 38D E9 ; TOTEMPOB EVAL 
*;
****************************************
NULLNAME LIDNTLVAR
( { symb }, lidnt -> { symb }, lidnt, lvar )
* place lidnt en tete de lvar
::
( { symb }, lidnt )
SWAP LVARext
( lidnt, { symb }, lvar )
ROTDUP
( {symb }, lvar, lidnt, newlvar )
ROT INNERCOMP get1 SWAP
ZERO_DO (DO)
	( {symb}, lidnt, o1, .., ok, newlvar )
	SWAP apndvarlst
	LOOP
( { symb }, lidnt, lvar )
;
*****************************************
